<img src="https://github.com/qojulia/QuantumOptics.jl-website/blob/master/src/images/logo.png" alt="QuantumOptics.jl" width="400">

#

![CI](https://github.com/qojulia/QuantumOpticsBase.jl/workflows/CI/badge.svg) [![Test coverage status on codecov][codecov-img]][codecov-url] [![Stable documentation][docs-img]][docs-url]

**QuantumOpticsBase.jl** provides the base functionality for **QuantumOptics.jl**. For the main project, see https://github.com/qojulia/QuantumOptics.jl or the website of the @qojulia organization http://qojulia.org. 

Specifically, **QuantumOpticsBase.jl** implements basic types such as different bases, states and operators defined on these bases, and fundamental operations (such as multiplication) on these states/operators.

## Discussion and Help

For questions, support, and discussions about QuantumOpticsBase.jl, please use the [GitHub issue tracker](https://github.com/qojulia/QuantumOptics.jl/issues) for bug reports and feature requests. For general discussions and help, visit the [Julia Discourse forum under the quantum topic](https://discourse.julialang.org/c/domain/quantum/52). You can also join the `#quantum-optics` channel on the [Julia Slack](https://julialang.org/slack/) for real-time discussions.

## Office Hours

Office hours are held every Friday from 12:30 – 1:30 PM Eastern Time via [Zoom](https://umass-amherst.zoom.us/j/95986275946?pwd=6h7Wbai1bXIai0XQsatNRWaVbQlTDr.1). Before joining, make sure to check the [Julia community events calendar](https://julialang.org/community/#events) to confirm whether office hours are happening, rescheduled, or canceled for the week. Feel free to bring any questions or suggestions!

[codecov-url]: https://codecov.io/gh/qojulia/QuantumOpticsBase.jl
[codecov-img]: https://codecov.io/gh/qojulia/QuantumOpticsBase.jl/branch/master/graph/badge.svg


[docs-url]: https://qojulia.github.io/QuantumOpticsBase.jl/latest
[docs-img]: https://img.shields.io/badge/docs-latest-blue.svg

[version-url]: https://github.com/qojulia/QuantumOpticsBase.jl/releases
[version-img]: https://img.shields.io/github/release/qojulia/QuantumOpticsBase.jl.svg

The workloads in `scenarios.jl` are run by [`QuantumSavory/julia-precompile-benchmark@v3`](https://github.com/QuantumSavory/julia-precompile-benchmark); the action owns dependency isolation, measurement, and summarization. For a local comparison, download the matching v3.0.0 tool bundle and run it from this repository:

```sh
gh release download v3.0.0 --repo QuantumSavory/julia-precompile-benchmark --pattern julia-precompile-benchmark-v3.0.0.tar.gz
tar -xzf julia-precompile-benchmark-v3.0.0.tar.gz
julia-precompile-benchmark-v3.0.0/run.sh benchmark/precompile/scenarios.jl /tmp/precompile-results base=/path/to/base head=/path/to/head
```

@testitem "test_time_dependent_operators" begin
using Test
using QuantumOpticsBase
using LinearAlgebra, Random
using QuantumInterface: nsubsystems

function api_test(op)
    for func in (basis, length, size, tr, normalize, normalize!, identityoperator, one, eltype)
        func(copy(op))
    end
    if nsubsystems(op)>1
        for func in (ptrace,)
            func(copy(op), [1])
        end
    end
end

@testset "time-dependent operators" begin
    QOB = QuantumOpticsBase

    subop = randoperator(FockBasis(1))
    op = LazyTensor(FockBasis(1) ⊗ FockBasis(3), 1, subop)
    @test QOB.static_operator(op) === op
    @test set_time!(op, 1.0) === op
    @test_throws ArgumentError current_time(op)
    @test QOB.is_const(op)

    op = dense(op)

    o = TimeDependentSum(ComplexF64, (t->2.0*cos(t))=>op)
    @test !QOB.is_const(o)
    @test TimeDependentSum(o) === o
    subo = TimeDependentSum(ComplexF64, 2.0=>subop)
    @test QOB.suboperators(o)[1] == op
    @test QOB.suboperators(QOB.static_operator(o))[1] == op

    api_test(op)
    api_test(o)
    api_test(subo)

    psi = randstate(basis(o))
    for f in (expect, variance)
        for s in (psi, op)
            @test f(o, s) ≈ f(2op, s)
            @test f(1, subo, s) ≈ f(1, 2subop, s)
            @test f([1], subo, s) ≈ f([1], 2subop, s)
        end
    end

    set_time!(o, 0.5)
    o_copy = copy(o)
    @test o_copy == o
    @test isequal(o_copy, o)

    set_time!(o, 1.0)
    @test current_time(o) == 1.0
    @test current_time(o_copy) == 0.5
    @test o_copy != o
    @test !isequal(o_copy, o)
    @test QOB.static_operator(o) != QOB.static_operator(o_copy)

    ls = LazySum(o)
    @test !QOB.is_const(ls)
    set_time!(ls, 0.0)
    @test current_time(o) == 0.0

    api_test(ls)

    tdls = TimeDependentSum([1.0+0im], ls; init_time=1.0)
    @test current_time(o) == 1.0

    api_test(tdls)

    o = TimeDependentSum(ComplexF64, FockBasis(2), FockBasis(3))
    @test length(QOB.suboperators(o)) == 0
    psi = randstate(FockBasis(3))
    @test norm(o(1.1) * psi) == 0.0
    @test basis(o(1.1) * psi) == FockBasis(2)
    @test o + o == o
    @test (o * o')(0.0) == TimeDependentSum(ComplexF64, FockBasis(2), FockBasis(2))
    @test (o')(0.0) == TimeDependentSum(ComplexF64, FockBasis(3), FockBasis(2))
    @test 2o == o
    @test dense(o) == o
    @test sparse(o) == o

    @test o(0.0) != o(1.0)

    o = TimeDependentSum(ComplexF64, FockBasis(2), FockBasis(2))
    b = FockBasis(2) ⊗ FockBasis(3)

    n = number(FockBasis(2))
    a = randoperator(FockBasis(2))

    f1, f2 = 1.0im, t->t*3.0
    t = randn()

    o_t1 = TimeDependentSum(f1, a)
    @test QOB.is_const(o_t1)
    @test QOB.eval_coefficients(o_t1, t) == [f1]
    @test o + o_t1 == o_t1
    @test o - o_t1 == -o_t1
    @test iszero(dense(QOB.static_operator(o * o_t1)))

    #o_t1_comp = embed_lazy(FockBasis(2) ⊗ GenericBasis(2), 1, o_t1)
    #@test QOB.eval_coefficients(o_t1_comp, t) == [f1]
    #@test isa(QOB.suboperators(o_t1_comp)[1], LazyTensor)

    o_t1_comp2 = embed(FockBasis(2) ⊗ GenericBasis(2), 1, o_t1)
    @test QOB.eval_coefficients(o_t1_comp2, t) == [f1]
    @test isa(QOB.suboperators(o_t1_comp2)[1], SparseOpType)

    o_t1_comp2_ = embed(FockBasis(2) ⊗ GenericBasis(2), [1], o_t1)
    @test o_t1_comp2 == o_t1_comp2_

    o_t = TimeDependentSum([f1, f2], [a,n])
    @test !QOB.is_const(o_t)

    @test (@inferred QOB.eval_coefficients(o_t, t)) == [1.0im, t*3.0]

    # function-call interface
    @test QOB.static_operator(o_t(t)).factors == [1.0im, t*3.0 + 0.0im]
    @test all(QOB.static_operator(o_t(t)).operators .== (a, n))

    o_t_tup = TimeDependentSum(Tuple, o_t)
    @test QOB.static_operator(o_t_tup(t)).factors == [1.0im, t*3.0 + 0.0im]
    @test all(QOB.static_operator(o_t_tup(t)).operators .== (a, n))
    if VERSION.minor == 11 # issue #178 https://github.com/qojulia/QuantumOpticsBase.jl/issues/178
        @test_broken (@allocated set_time!(o_t_tup, t)) == 0
    else
        @test (@allocated set_time!(o_t_tup, t)) == 0
    end

    o_t2 = TimeDependentSum(f1=>a, f2=>n)
    @test o_t(t) == o_t2(t)

    o_t_ = dense(o_t)
    @test all(isa(o, DenseOpType) for o in QOB.suboperators(o_t_))
    @test o_t_.coefficients == o_t.coefficients

    o_t_ = sparse(o_t)
    @test all(isa(o, SparseOpType) for o in QOB.suboperators(o_t_))
    @test o_t_.coefficients == o_t.coefficients

    o_t_ = dagger(o_t)
    @test all(isa(o.data, Adjoint) for o in QOB.suboperators(o_t_))
    @test QOB.eval_coefficients(o_t_, t) == conj.(QOB.eval_coefficients(o_t, t))

    b = randoperator(FockBasis(2))
    o2_t = TimeDependentSum([t->cos(t), t->t/3.0], [b, n])

    # operations
    o_res = o_t(0.0) + o2_t(0.0)
    @test isa(o_res, TimeDependentSum)
    @test QOB.eval_coefficients(o_res, t) == ComplexF64[1.0im, t*3.0, cos(t), t/3.0]
    @test all(QOB.suboperators(o_res) .== (a, n, b, n))

    o_res = o_t - o2_t
    @test isa(o_res, TimeDependentSum)
    @test QOB.eval_coefficients(o_res, t) == ComplexF64[1.0im, t*3.0, -cos(t), -t/3.0]
    @test all(QOB.suboperators(o_res) .== (a, n, b, n))

    o_res = -o_t
    @test isa(o_res, TimeDependentSum)
    @test QOB.eval_coefficients(o_res, t) == [-1.0im, -t*3.0]
    @test all(QOB.suboperators(o_res) .== (a, n))

    o_res = a + o2_t
    @test isa(o_res, TimeDependentSum)
    @test QOB.eval_coefficients(o_res, t) == ComplexF64[1.0, cos(t), t/3.0]
    @test all(QOB.suboperators(o_res) .== (a, b, n))

    o_res = a - o2_t
    @test isa(o_res, TimeDependentSum)
    @test QOB.eval_coefficients(o_res, t) == ComplexF64[1.0, -cos(t), -t/3.0]
    @test all(QOB.suboperators(o_res) .== (a, b, n))

    o_res = LazySum(a, n) + o2_t
    @test isa(o_res, TimeDependentSum)
    @test QOB.eval_coefficients(o_res, t) == ComplexF64[1.0, 1.0, cos(t), t/3.0]
    @test all(QOB.suboperators(o_res) .== (a, n, b, n))

    fac = randn(ComplexF64)
    o_res = fac * o2_t
    @test isa(o_res, TimeDependentSum)
    @test [QOB.eval_coefficients(o_res, t)...] ≈ [fac*cos(t), fac*t/3.0] rtol=1e-10
    @test all(QOB.suboperators(o_res) .== (b, n))

    fac = randn(ComplexF64)
    o_res = o2_t / fac
    @test isa(o_res, TimeDependentSum)
    @test [QOB.eval_coefficients(o_res, t)...] ≈ [cos(t)/fac, t/3.0/fac] rtol=1e-10
    @test all(QOB.suboperators(o_res) .== (b, n))

    o_res = o_t * o2_t
    @test isa(o_res, TimeDependentSum)
    @test [QOB.eval_coefficients(o_res, t)...] ≈ [(c1*c2 for (c1,c2) in Iterators.product(QOB.eval_coefficients(o_t, t), QOB.eval_coefficients(o2_t, t)))...] rtol=1e-10
    @test dense(QOB.static_operator(o_res(t))).data ≈ (dense(QOB.static_operator(o_t(t))) * dense(QOB.static_operator(o2_t(t)))).data rtol=1e-10

    V = identityoperator(basis(o_t), GenericBasis(length(basis(o_t))))
    o_res = o_t * V
    @test isa(o_res, TimeDependentSum)
    @test [QOB.eval_coefficients(o_res, t)...] ≈ [QOB.eval_coefficients(o_t, t)...] rtol=1e-10
    @test dense(QOB.static_operator(o_res(t))).data ≈ dense(QOB.static_operator(o_t(t))).data rtol=1e-10

    # combinations with other operator types
    ls = LazySum(ComplexF64, basis(o_t), basis(o_t))
    ro = randoperator(basis(o_t))
    for op in (+, -, *)
        @test dense(QOB.static_operator(op(o_t(0.0), ls))) == dense(op(QOB.static_operator(o_t(0.0)), ls))
        @test dense(QOB.static_operator(op(o_t(0.0), ro))) == dense(op(QOB.static_operator(o_t(0.0)), ro))
        @test dense(QOB.static_operator(op(ls, o_t(0.0)))) == dense(op(ls, QOB.static_operator(o_t(0.0))))
        @test dense(QOB.static_operator(op(ro, o_t(0.0)))) == dense(op(ro, QOB.static_operator(o_t(0.0))))
    end

    # mul!
    for input in (randoperator(basis(o_t)), randstate(basis(o_t)))
        out = mul!(copy(input), o_t, input)
        out2 = mul!(copy(input), QOB.static_operator(o_t), input)
        @test out == out2
    end
    for input in (randoperator(basis(o_t)), randstate(basis(o_t))')
        out = mul!(copy(input), input, o_t)
        out2 = mul!(copy(input), input, QOB.static_operator(o_t))
        @test out == out2
    end

    # test eval_coefficients independently
    coeffs = (1.0, cos, 2.0, 1.0im)
    coeffs_at_0 = (1.0, 1.0, 2.0, 1.0im)
    for i in 1:4
        @test @inferred QOB.eval_coefficients(ComplexF64, coeffs[1:i], 0.0) == ComplexF64.(coeffs_at_0[1:i])
    end
end

@testset "time-dependent operators: Shifts, restrictions, and stretchs" begin
    QOB = QuantumOpticsBase

    b = FockBasis(1)
    op = TimeDependentSum((1.0, identity), (number(b), destroy(b)))
    op_shift = time_shift(op, 10.0)
    @test @inferred QOB.eval_coefficients(op_shift, 0.0) == (1.0, -10.0)
    @test @inferred QOB.eval_coefficients(op_shift, 10.0) == (1.0, 0.0)
    @test @inferred QOB.eval_coefficients(op_shift, 20.0) == (1.0, 10.0)

    op_block_shift = time_restrict(op_shift, 5.0, 15.0)
    @test @inferred QOB.eval_coefficients(op_block_shift, 4.9) == (0.0, 0.0)
    @test @inferred QOB.eval_coefficients(op_block_shift, 5.0) == (1.0, -5.0)
    @test @inferred QOB.eval_coefficients(op_block_shift, 20.0) == (0.0, 0.0)

    op_stretch_block_shift = time_stretch(op_block_shift, 2.0)
    @test @inferred QOB.eval_coefficients(op_stretch_block_shift, 9.9) == (0.0, 0.0)
    @test @inferred QOB.eval_coefficients(op_stretch_block_shift, 10.0) == (1.0, -5.0)
    @test @inferred QOB.eval_coefficients(op_stretch_block_shift, 30.0-√eps()) == (1.0, 5.0-0.5*√eps())
    @test @inferred QOB.eval_coefficients(op_stretch_block_shift, 30.0) == (0.0, 0.0)

    op_block = time_restrict(op, 15.0)
    @test @inferred QOB.eval_coefficients(op_block, -1.0) == (0.0, 0.0)
    @test @inferred QOB.eval_coefficients(op_block, 5.0) == (1.0, 5.0)
    @test @inferred QOB.eval_coefficients(op_block, 20.0) == (0.0, 0.0)

    op_stretch = time_stretch(op, 2.0)
    @test @inferred QOB.eval_coefficients(op_stretch, 5.0) == (1.0, 2.5)
end
end

import Adapt

"""
    LazyKet(b, kets)

Lazy implementation of a tensor product of kets.

The subkets are stored in the `kets` field.
The main purpose of such a ket are simple computations for large product states, such as expectation values.
It's used to compute numeric initial states in QuantumCumulants.jl (see QuantumCumulants.initial_values).
"""
mutable struct LazyKet{B,T} <: AbstractKet{B,T}
    basis::B
    kets::T
    function LazyKet(b::B, kets::T) where {B<:CompositeBasis,T<:Tuple}
        N = length(b.bases)
        for n=1:N
            @assert isa(kets[n], Ket)
            @assert kets[n].basis == b.bases[n]
        end
        new{B,T}(b, kets)
    end
end
function LazyKet(b::CompositeBasis, kets::Vector)
    return LazyKet(b,Tuple(kets))
end

Base.eltype(ket::LazyKet) = Base.promote_type(eltype.(ket.kets)...)

Base.isequal(x::LazyKet, y::LazyKet) = isequal(x.basis, y.basis) && isequal(x.kets, y.kets)
Base.:(==)(x::LazyKet, y::LazyKet) = (x.basis == y.basis) && (x.kets == y.kets)

# conversion to dense
Ket(ket::LazyKet) = ⊗(ket.kets...)

# no lazy bras for now
dagger(x::LazyKet) = throw(MethodError(dagger, "dagger not implemented for LazyKet: LazyBra is currently not implemented at all!")) # TODO this should probably be an error hint instead

# tensor with other kets
function tensor(x::LazyKet, y::Ket)
    return LazyKet(x.basis ⊗ y.basis, (x.kets..., y))
end
function tensor(x::Ket, y::LazyKet)
    return LazyKet(x.basis ⊗ y.basis, (x, y.kets...))
end
function tensor(x::LazyKet, y::LazyKet)
    return LazyKet(x.basis ⊗ y.basis, (x.kets..., y.kets...))
end

# norms
norm(state::LazyKet) = prod(norm.(state.kets))
function normalize!(state::LazyKet)
    for ket in state.kets
        normalize!(ket)
    end
    return state
end
function normalize(state::LazyKet)
    y = deepcopy(state)
    normalize!(y)
    return y
end

# expect
function expect(op::LazyTensor{B, B}, state::LazyKet{B}) where B <: Basis
    check_samebases(op); check_samebases(op.basis_l, state.basis)
    ops = op.operators
    inds = op.indices
    kets = state.kets

    T = promote_type(eltype(op), eltype(state))
    exp_val = convert(T, op.factor)

    # loop over all operators and match with corresponding kets
    for (i, op_) in enumerate(op.operators)
        exp_val *= expect(op_, kets[inds[i]])
    end

    # loop over remaining kets and just add the norm (should be one for normalized ones, but hey, who knows..)
    for i in 1:length(kets)
        if i ∉ inds
            exp_val *= dot(kets[i].data, kets[i].data)
        end
    end

    return exp_val
end

function expect(op::LazyProduct{B,B}, state::LazyKet{B}) where B <: Basis
    check_samebases(op); check_samebases(op.basis_l, state.basis)

    tmp_state1 = deepcopy(state)
    tmp_state2 = deepcopy(state)
    for i = length(op.operators):-1:1
        mul!(tmp_state2, op.operators[i], tmp_state1)
        for j = 1:length(state.kets)
            copyto!(tmp_state1.kets[j].data, tmp_state2.kets[j].data)
        end
    end

    T = promote_type(eltype(op), eltype(state))
    exp_val = convert(T, op.factor)
    for i = 1:length(state.kets)
        exp_val *= dot(state.kets[i].data, tmp_state2.kets[i].data)
    end

    return exp_val
end

function expect(op::LazySum{B,B}, state::LazyKet{B}) where B <: Basis
    check_samebases(op); check_samebases(op.basis_l, state.basis)

    T = promote_type(eltype(op), eltype(state))
    exp_val = zero(T)
    for (factor, sub_op) in zip(op.factors, op.operators)
        exp_val += factor * expect(sub_op, state)
    end
   
    return exp_val
end


# mul! with lazytensor -- needed to compute lazyproduct averages (since ⟨op1 * op2⟩ doesn't factorize)
# this mul! is the only one that really makes sense
function mul!(y::LazyKet{BL}, op::LazyOperator{BL,BR}, x::LazyKet{BR}) where {BL, BR}
    T = promote_type(eltype(y), eltype(op), eltype(x))
    mul!(y, op, x, one(T), zero(T))
end
function mul!(y::LazyKet{BL}, op::LazyTensor{BL, BR}, x::LazyKet{BR}, alpha, beta) where {BL, BR}
    iszero(beta) || throw("Error: cannot perform muladd operation on LazyKets since addition is not implemented. Convert them to dense kets using Ket(x) in order to perform muladd operations.")

    iszero(alpha) && (_zero_op_mul!(y.kets[1].data, beta); return y)

    missing_index_allowed = samebases(op)
    (length(y.basis.bases) == length(x.basis.bases)) || throw(IncompatibleBases())

    for i in 1:length(y.kets)
        if i ∈ op.indices
            mul!(y.kets[i], op.operators[i], x.kets[i])
        else
            missing_index_allowed || throw("Can't multiply a LazyOperator with a Ket when there's missing indices and the bases are different.
                A missing index is equivalent to applying an identity operator, but that's not possible when mapping from one basis to another!")
            
            copyto!(y.kets[i].data, x.kets[i].data)
        end
    end

    rmul!(y.kets[1].data, op.factor * alpha)
    return y
end

# GPU adaptation
Adapt.adapt_structure(to, x::LazyKet) = LazyKet(x.basis, [Adapt.adapt(to, ket) for ket in x.kets])

module QuantumOpticsBase

using SparseArrays, LinearAlgebra, LRUCache, Strided, UnsafeArrays, FillArrays
import LinearAlgebra: mul!, rmul!
import RecursiveArrayTools

import QuantumInterface: dagger, directsum, ⊕, dm, embed, nsubsystems, expect, identityoperator, identitysuperoperator,
        permutesystems, projector, ptrace, reduced, tensor, ⊗, variance, apply!, basis, AbstractSuperOperator

# metrics
import QuantumInterface: entropy_vn, fidelity, logarithmic_negativity

# index helpers
import QuantumInterface: complement, remove, shiftremove, reducedindices!, check_indices, check_sortedindices, check_embed_indices

export Basis, GenericBasis, CompositeBasis, basis,
        tensor, ⊗, permutesystems, @samebases,
        #states
                StateVector, Bra, Ket, basisstate, sparsebasisstate, norm,
                dagger, normalize, normalize!,
        #operators
                AbstractOperator, DataOperator, expect, variance,
                identityoperator, ptrace, reduced, embed, dense, tr, sparse,
        #operators_dense
                Operator, DenseOperator, DenseOpType, projector, dm,
        #operators_sparse
                SparseOperator, diagonaloperator, SparseOpType, EyeOpType,
        #operators_lazysum
                LazySum,
        #operators_lazyproduct
                LazyProduct,
        #operators_lazytensor
                LazyTensor, lazytensor_use_cache, lazytensor_clear_cache,
                lazytensor_cachesize, lazytensor_disable_cache, lazytensor_enable_cache,
        #states_lazyket
                LazyKet,
        #time_dependent_operators
                AbstractTimeDependentOperator, TimeDependentSum, set_time!,
                current_time, time_shift, time_stretch, time_restrict, static_operator,
        #superoperators
                SuperOperator, DenseSuperOperator, DenseSuperOpType,
                SparseSuperOperator, SparseSuperOpType, spre, spost, sprepost, liouvillian,
                identitysuperoperator,
        #fock
                FockBasis, number, destroy, create,
                fockstate, coherentstate, coherentstate!,
                displace, displace_analytical, displace_analytical!,
                squeeze,
        # charge
                ChargeBasis, ShiftedChargeBasis, chargestate, chargeop, expiφ, cosφ, sinφ,
        randstate, randoperator, thermalstate, coherentthermalstate, phase_average, passive_state,
        randstate_haar, randunitary_haar,
        #spin
                SpinBasis, sigmax, sigmay, sigmaz, sigmap, sigmam, spinup, spindown,
        #subspace
                SubspaceBasis, projector, sparseprojector,
        #particle
                PositionBasis, MomentumBasis, samplepoints, spacing, gaussianstate,
                position, momentum, potentialoperator, transform,
        #nlevel
                NLevelBasis, transition, nlevelstate, paulix, pauliz, pauliy,
        #manybody
                ManyBodyBasis, FermionBitstring, fermionstates, bosonstates,
                manybodyoperator, onebodyexpect,
        #metrics
                tracenorm, tracenorm_h, tracenorm_nh,
                tracedistance, tracedistance_h, tracedistance_nh,
                entropy_vn, entropy_renyi, fidelity, ptranspose, PPT,
                negativity, logarithmic_negativity, entanglement_entropy,
        PauliBasis, PauliTransferMatrix, DensePauliTransferMatrix,
                ChiMatrix, DenseChiMatrix, avg_gate_fidelity,
        SumBasis, directsum, ⊕, LazyDirectSum, getblock, setblock!,
        qfunc, wigner, coherentspinstate, qfuncsu2, wignersu2
        #apply
                apply!

include("bases.jl")
include("states.jl")
include("operators.jl")
include("operators_dense.jl")
include("sparsematrix.jl")
include("operators_sparse.jl")
include("operators_lazysum.jl")
include("operators_lazyproduct.jl")
include("operators_lazytensor.jl")
include("time_dependent_operator.jl")
include("states_lazyket.jl")
include("superoperators.jl")
include("spin.jl")
include("fock.jl")
include("charge.jl")
include("state_definitions.jl")
include("subspace.jl")
include("particle.jl")
include("nlevel.jl")
include("manybody.jl")
include("transformations.jl")
include("pauli.jl")
include("metrics.jl")
include("spinors.jl")
include("phasespace.jl")
include("printing.jl")
include("apply.jl")

end # module

"""
    SubspaceBasis(basisstates)

A basis describing a subspace embedded a higher dimensional Hilbert space.
"""
struct SubspaceBasis{S,B,T,H,UT} <: Basis
    shape::S
    superbasis::B
    basisstates::Vector{T}
    basisstates_hash::UT
    function SubspaceBasis{S,B,T,H,UT}(shape::S,superbasis::B,basisstates::Vector{T},basisstates_hash::UT) where {S,B,T,H,UT}
        new(shape,superbasis,basisstates,basisstates_hash)
    end
end
function SubspaceBasis(superbasis::B, basisstates::Vector{T}) where {B,T}
    for state = basisstates
        if state.basis != superbasis
            throw(ArgumentError("The basis of the basisstates has to be the superbasis."))
        end
    end
    H = hash(hash.([hash.(x.data) for x=basisstates]))
    shape = Int[length(basisstates)]
    SubspaceBasis{typeof(shape),B,T,H,typeof(H)}(shape, superbasis, basisstates, H)
end
SubspaceBasis(basisstates::Vector{T}) where T = SubspaceBasis(basisstates[1].basis, basisstates)

==(b1::SubspaceBasis, b2::SubspaceBasis) = b1.superbasis==b2.superbasis && b1.basisstates_hash==b2.basisstates_hash


proj(u::Ket, v::Ket) = dagger(v)*u/(dagger(u)*u)*u

"""
    orthonormalize(b::SubspaceBasis)

Orthonormalize the basis states of the given [`SubspaceBasis`](@ref)

A modified Gram-Schmidt process is used.
"""
function orthonormalize(b::SubspaceBasis)
    V = b.basisstates
    U = eltype(V)[]
    for (k, v)=enumerate(V)
        u = copy(v)
        for i=1:k-1
            u -= proj(U[i], u)
        end
        normalize!(u)
        push!(U, u)
    end
    return SubspaceBasis(U)
end


"""
    projector([T,] b1, b2)

Projection operator between subspaces and superspaces or between two subspaces.
"""
function projector(::Type{T}, b1::SubspaceBasis, b2::SubspaceBasis) where T
    if b1.superbasis != b2.superbasis
        throw(ArgumentError("Both subspace bases have to have the same superbasis."))
    end
    T1 = projector(T, b1, b1.superbasis)
    T2 = projector(T, b2.superbasis, b2)
    return T1*T2
end
function projector(b1::SubspaceBasis, b2::SubspaceBasis)
    if b1.superbasis != b2.superbasis
        throw(ArgumentError("Both subspace bases have to have the same superbasis."))
    end
    T1 = projector(b1, b1.superbasis)
    T2 = projector(b2.superbasis, b2)
    return T1*T2
end

function projector(::Type{T}, b1::SubspaceBasis, b2::Basis) where T
    if b1.superbasis != b2
        throw(ArgumentError("Second basis has to be the superbasis of the first one."))
    end
    data = zeros(T, length(b1), length(b2))
    for (i, state) = enumerate(b1.basisstates)
        data[i,:] = state.data'
    end
    return Operator(b1, b2, data)
end
function projector(b1::SubspaceBasis, b2::Basis)
    T = promote_type(eltype.(b1.basisstates)...)
    return projector(T, b1, b2)
end

function projector(::Type{T}, b1::Basis, b2::SubspaceBasis) where T
    if b1 != b2.superbasis
        throw(ArgumentError("First basis has to be the superbasis of the second one."))
    end
    data = zeros(T, length(b1), length(b2))
    for (i, state) = enumerate(b2.basisstates)
        data[:,i] = state.data
    end
    return Operator(b1, b2, data)
end
function projector(b1::Basis, b2::SubspaceBasis)
    T = promote_type(eltype.(b2.basisstates)...)
    return projector(T, b1, b2)
end

"""
    sparseprojector([T,] b1, b2)

Sparse version of [`projector`](@ref).
"""
function sparseprojector(::Type{T}, b1::SubspaceBasis, b2::SubspaceBasis) where T
    if b1.superbasis != b2.superbasis
        throw(ArgumentError("Both subspace bases have to have the same superbasis."))
    end
    T1 = sparseprojector(T, b1, b1.superbasis)
    T2 = sparseprojector(T, b2.superbasis, b2)
    return T1*T2
end
function sparseprojector(b1::SubspaceBasis, b2::SubspaceBasis)
    if b1.superbasis != b2.superbasis
        throw(ArgumentError("Both subspace bases have to have the same superbasis."))
    end
    T1 = sparseprojector(b1, b1.superbasis)
    T2 = sparseprojector(b2.superbasis, b2)
    return T1*T2
end

function sparseprojector(::Type{T}, b1::SubspaceBasis, b2::Basis) where T
    if b1.superbasis != b2
        throw(ArgumentError("Second basis has to be the superbasis of the first one."))
    end
    data = spzeros(T, length(b1), length(b2))
    for (i, state) = enumerate(b1.basisstates)
        data[i,:] = state.data'
    end
    return Operator(b1, b2, data)
end
function sparseprojector(b1::SubspaceBasis, b2::Basis)
    T = promote_type(eltype.(b1.basisstates)...)
    return sparseprojector(T, b1, b2)
end

function sparseprojector(::Type{T}, b1::Basis, b2::SubspaceBasis) where T
    if b1 != b2.superbasis
        throw(ArgumentError("First basis has to be the superbasis of the second one."))
    end
    data = spzeros(T, length(b1), length(b2))
    for (i, state) = enumerate(b2.basisstates)
        data[:,i] = state.data
    end
    return Operator(b1, b2, data)
end
function sparseprojector(b1::Basis, b2::SubspaceBasis)
    T = promote_type(eltype.(b2.basisstates)...)
    return sparseprojector(T, b1, b2)
end

@testitem "test_state_definitions" begin
using Test
using QuantumOpticsBase
using Random

@testset "state_definitions" begin

n=30
b=FockBasis(n)
omega=40.3
T=2.3756
r=thermalstate(omega*number(b),T)
for k=1:n-1
    @test isapprox(r.data[k+1,k+1]/r.data[k,k],exp(-omega/T))
end
S=entropy_vn(r)
z=sum(exp.(-[0:n;]*omega))
s=expect(omega*number(b),r)/T+log(z)
isapprox(S,s)

alpha=rand()+im*rand()
r=coherentthermalstate(b,omega*number(b),T,alpha)
@test isapprox(expect(number(b),r),abs(alpha)^2+1/(exp(omega/T)-1), atol=1e-14)
@test isapprox(expect(destroy(b),r),alpha, atol=1e-14)
@test isapprox(entropy_vn(r),S, atol=1e-14)

rp=phase_average(r)
@test isapprox(expect(number(b),rp),abs(alpha)^2+1/(exp(omega/T)-1), atol=1e-14)
@test isapprox(expect(destroy(b),rp),0, atol=1e-14)
for k=1:n
    @test isapprox(rp.data[k,k],r.data[k,k], atol=1e-14)
end

rpas=passive_state(r)
for k=1:n-1
    @test real(rpas.data[k+1,k+1])<real(rpas.data[k,k])
end
@test isapprox(expect(number(b),rpas),1/(exp(omega/T)-1), atol=1e-14)
@test isapprox(expect(destroy(b),rpas),0, atol=1e-14)
@test isapprox(entropy_vn(rpas),S, atol=1e-14)

Random.seed!(0)

for n in 1:5:50
    b = FockBasis(n)
    @test isapprox(norm(randstate_haar(b)), 1, atol=1e-8)
    U = randunitary_haar(b)
    @test isapprox(dagger(U)*U, identityoperator(b), atol=1e-8)
end

end # testset
end

@testitem "test_abstractdata" begin
using QuantumOpticsBase
using Test
using LinearAlgebra
import LinearAlgebra: mul!
using Random
import Base: ==, -

# Implement custom type with AbstractArray interface
mutable struct TestData{T,N,X} <: AbstractArray{T,N}
    x::X
    function TestData(x::X) where X
        x_ = convert(Matrix{ComplexF64}, x)
        new{ComplexF64,length(axes(x)),typeof(x_)}(x_)
    end
end
Base.size(A::TestData) = size(A.x)
Base.getindex(A::TestData, inds...) = getindex(A.x, inds...)
Base.setindex!(A::TestData, val, inds...) = setindex!(A.x, val, inds...)
Base.isapprox(A::TestData,B::TestData,args...;kwargs...) = isapprox(A.x,B.x,args...;kwargs...)

# Additional methods
Base.copy(A::TestData) = TestData(copy(A.x))
Base.kron(A::TestData,B::TestData) = TestData(kron(A.x,B.x))
# -(A::TestData) = TestData(-A.x)

# Auxiliary functions
function randtestoperator(args...)
    op_ = randoperator(args...)
    return Operator(op_.basis_l,op_.basis_r,TestData(copy(op_.data)))
end

D(a::DataOperator,b::DataOperator,tol=1e-14) = isapprox(a.data,b.data,atol=tol)
D(a::StateVector,b::StateVector,tol=1e-14) = isapprox(a.data,b.data,atol=tol)
D(a::AbstractOperator,b::AbstractOperator,tol=1e-12) = (tol > abs(tracedistance_nh(dense(a), dense(b))))

@testset "abstract-data" begin

Random.seed!(0)

b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(1)
b3b = GenericBasis(5)

b_l = b1a⊗b2a⊗b3a
b_r = b1b⊗b2b⊗b3b

# Test creation
@test_throws DimensionMismatch Operator(b1a, TestData([1 1 1; 1 1 1]))
@test_throws DimensionMismatch Operator(b1a, b1b, TestData([1 1; 1 1; 1 1]))
op1 = Operator(b1a, b1b, TestData([1 1 1; 1 1 1]))
op2 = Operator(b1b, b1a, TestData([1 1; 1 1; 1 1]))
op3 = op1*op2
@test op1 == dagger(op2)

# Test ' shorthand
@test dagger(op2) == op2'
@test transpose(op2) == conj(op2')

# Test copy
op1 = randtestoperator(b1a)
op2 = copy(op1)
@test op1.data == op2.data
@test !(op1.data === op2.data)
op2.data[1,1] = complex(10.)
@test op1.data[1,1] != op2.data[1,1]


# Arithmetic operations
# =====================
op_zero = DenseOperator(b_l, b_r)
op1 = randtestoperator(b_l, b_r)
op2 = randtestoperator(b_l, b_r)
op3 = randtestoperator(b_l, b_r)

x1 = Ket(b_r, rand(ComplexF64, length(b_r)))
x2 = Ket(b_r, rand(ComplexF64, length(b_r)))

xbra1 = Bra(b_l, rand(ComplexF64, length(b_l)))
xbra2 = Bra(b_l, rand(ComplexF64, length(b_l)))

# Addition
@test_throws DimensionMismatch op1 + dagger(op2)
@test D(op1 + op_zero, op1)
@test D(op1 + op2, op2 + op1)
@test D(op1 + (op2 + op3), (op1 + op2) + op3)

# Subtraction
@test_throws DimensionMismatch op1 - dagger(op2)
@test D(op1-op_zero, op1)
@test D(op1-op2, op1 + (-op2))
@test D(op1-op2, op1 + (-1*op2))
@test D(op1-op2-op3, op1-(op2+op3))

# Test multiplication
@test_throws DimensionMismatch op1*op2
@test D(op1*(x1 + 0.3*x2), op1*x1 + 0.3*op1*x2, 1e-12)
@test D((op1+op2)*(x1+0.3*x2), op1*x1 + 0.3*op1*x2 + op2*x1 + 0.3*op2*x2, 1e-12)

@test D((xbra1+0.3*xbra2)*op1, xbra1*op1 + 0.3*xbra2*op1)
@test D((xbra1+0.3*xbra2)*(op1+op2), xbra1*op1 + 0.3*xbra2*op1 + xbra1*op2 + 0.3*xbra2*op2)

@test D(op1*dagger(0.3*op2), 0.3*dagger(op2*dagger(op1)))
@test D((op1 + op2)*dagger(0.3*op3), 0.3*op1*dagger(op3) + 0.3*op2*dagger(op3), 1e-12)
@test D(0.3*(op1*dagger(op2)), op1*(0.3*dagger(op2)))

tmp = copy(op1)
conj!(tmp)
@test tmp == conj(op1) && conj(tmp.data) == op1.data

# Internal layout
b1 = GenericBasis(2)
b2 = GenericBasis(3)
b3 = GenericBasis(4)
op1 = randtestoperator(b1, b2)
op2 = randtestoperator(b2, b3)
x1 = randstate(b2)
d1 = op1.data
d2 = op2.data
v = x1.data
@test (op1*x1).data ≈ [d1[1,1]*v[1] + d1[1,2]*v[2] + d1[1,3]*v[3], d1[2,1]*v[1] + d1[2,2]*v[2] + d1[2,3]*v[3]]
@test (op1*op2).data[2,3] ≈ d1[2,1]*d2[1,3] + d1[2,2]*d2[2,3] + d1[2,3]*d2[3,3]

# Test division
@test D(op1/7, (1/7)*op1)

# Tensor product
# ==============
op1a = randtestoperator(b1a, b1b)
op1b = randtestoperator(b1a, b1b)
op2a = randtestoperator(b2a, b2b)
op2b = randtestoperator(b2a, b2b)
op3a = randtestoperator(b3a, b3b)
op123 = op1a ⊗ op2a ⊗ op3a
@test isa(op123.data,TestData)
@test op123.basis_l == b_l
@test op123.basis_r == b_r

# Associativity
@test D((op1a ⊗ op2a) ⊗ op3a, op1a ⊗ (op2a ⊗ op3a))

# Linearity
@test D(op1a ⊗ (0.3*op2a), 0.3*(op1a ⊗ op2a))
@test D((0.3*op1a) ⊗ op2a, 0.3*(op1a ⊗ op2a))

# Distributivity
@test D(op1a ⊗ (op2a + op2b), op1a ⊗ op2a + op1a ⊗ op2b)
@test D((op2a + op2b) ⊗ op3a, op2a ⊗ op3a + op2b ⊗ op3a)

# Mixed-product property
@test D((op1a ⊗ op2a) * dagger(op1b ⊗ op2b), (op1a*dagger(op1b)) ⊗ (op2a*dagger(op2b)))

# Transpose
@test D(dagger(op1a ⊗ op2a), dagger(op1a) ⊗ dagger(op2a))
@test D(dagger(op1a ⊗ op2a), dagger(op1a) ⊗ dagger(op2a))

# Internal layout
a = Ket(b1a, rand(ComplexF64, length(b1a)))
b = Ket(b2b, rand(ComplexF64, length(b2b)))
ab = a ⊗ dagger(b)
@test ab.data[2,3] == a.data[2]*conj(b.data[3])
@test ab.data[2,1] == a.data[2]*conj(b.data[1])

shape = tuple(op123.basis_l.shape..., op123.basis_r.shape...)
idx = LinearIndices(shape)[2, 1, 1, 3, 4, 5]
@test op123.data[idx] == op1a.data[2,3]*op2a.data[1,4]*op3a.data[1,5]
@test reshape(op123.data, shape...)[2, 1, 1, 3, 4, 5] == op1a.data[2,3]*op2a.data[1,4]*op3a.data[1,5]

idx = LinearIndices(shape)[2, 1, 1, 1, 3, 4]
@test op123.data[idx] == op1a.data[2,1]*op2a.data[1,3]*op3a.data[1,4]
@test reshape(op123.data, shape...)[2, 1, 1, 1, 3, 4] == op1a.data[2,1]*op2a.data[1,3]*op3a.data[1,4]


# Test tr and normalize
op = Operator(GenericBasis(3), TestData([1 3 2;5 2 2;-1 2 5]))
@test 8 == tr(op)
op_normalized = normalize(op)
@test 8 == tr(op)
@test 1 == tr(op_normalized)
op_copy = deepcopy(op)
normalize!(op_copy)
@test tr(op) != tr(op_copy)
@test 1 ≈ tr(op_copy)
@test op === normalize!(op)

# Test partial tr of operators
b1 = GenericBasis(3)
b2 = GenericBasis(5)
b3 = GenericBasis(7)
op1 = randtestoperator(b1)
op2 = randtestoperator(b2)
op3 = randtestoperator(b3)
op123 = op1 ⊗ op2 ⊗ op3

@test D(op1⊗op2*tr(op3), ptrace(op123, 3))
@test D(op1⊗op3*tr(op2), ptrace(op123, 2))
@test D(op2⊗op3*tr(op1), ptrace(op123, 1))

@test D(op1*tr(op2)*tr(op3), ptrace(op123, [2,3]))
@test D(op2*tr(op1)*tr(op3), ptrace(op123, [1,3]))
@test D(op3*tr(op1)*tr(op2), ptrace(op123, [1,2]))

@test_throws ArgumentError ptrace(op123, [1,2,3])
x = randtestoperator(b1, b1⊗b2)
@test_throws ArgumentError ptrace(x, [1])
x = randtestoperator(b1⊗b1⊗b2, b1⊗b2)
@test_throws ArgumentError ptrace(x, [1, 2])
x = randtestoperator(b1⊗b2)
@test_throws ArgumentError ptrace(x, [1, 2])
x = randtestoperator(b1⊗b2, b2⊗b1)
@test_throws ArgumentError ptrace(x, [1])

op1 = randtestoperator(b1, b2)
op2 = randtestoperator(b3)

@test D(op1*tr(op2), ptrace(op1⊗op2, 2))

# Test expect
b1 = GenericBasis(3)
b2 = GenericBasis(5)
b3 = GenericBasis(7)
op1 = randtestoperator(b1)
op2 = randtestoperator(b2)
op3 = randtestoperator(b3)
op123 = op1 ⊗ op2 ⊗ op3
b_l = b1 ⊗ b2 ⊗ b3

state = randstate(b_l)
@test expect(op123, state) ≈ dagger(state)*op123*state
@test expect(1, op1, state) ≈ expect(op1, ptrace(state, [2, 3]))
@test expect(2, op2, state) ≈ expect(op2, ptrace(state, [1, 3]))
@test expect(3, op3, state) ≈ expect(op3, ptrace(state, [1, 2]))

state = randtestoperator(b_l)
@test expect(op123, state) ≈ tr(op123*state)
@test expect(1, op1, state) ≈ expect(op1, ptrace(state, [2, 3]))
@test expect(2, op2, state) ≈ expect(op2, ptrace(state, [1, 3]))
@test expect(3, op3, state) ≈ expect(op3, ptrace(state, [1, 2]))

# Permute systems
op1 = randtestoperator(b1a, b1b)
op2 = randtestoperator(b2a, b2b)
op3 = randtestoperator(b3a, b3b)
op123 = op1⊗op2⊗op3

op132 = op1⊗op3⊗op2
@test D(permutesystems(op123, [1, 3, 2]), op132)

op213 = op2⊗op1⊗op3
@test D(permutesystems(op123, [2, 1, 3]), op213)

op231 = op2⊗op3⊗op1
@test D(permutesystems(op123, [2, 3, 1]), op231)

op312 = op3⊗op1⊗op2
@test D(permutesystems(op123, [3, 1, 2]), op312)

op321 = op3⊗op2⊗op1
@test D(permutesystems(op123, [3, 2, 1]), op321)


# Test projector
xket = normalize(Ket(b_l, rand(ComplexF64, length(b_l))))
yket = normalize(Ket(b_l, rand(ComplexF64, length(b_l))))
xbra = dagger(xket)
ybra = dagger(yket)

@test D(projector(xket)*xket, xket)
@test D(xbra*projector(xket), xbra)
@test D(projector(xbra)*xket, xket)
@test D(xbra*projector(xbra), xbra)
@test D(ybra*projector(yket, xbra), xbra)
@test D(projector(yket, xbra)*xket, yket)

# Test gemv
b1 = GenericBasis(3)
b2 = GenericBasis(5)
op = randtestoperator(b1, b2)
xket = randstate(b2)
xbra = dagger(randstate(b1))
rket = randstate(b1)
rbra = dagger(randstate(b2))
alpha = complex(0.7, 1.5)
beta = complex(0.3, 2.1)
@test isa(op.data, TestData)

rket_ = deepcopy(rket)
QuantumOpticsBase.mul!(rket_,op,xket,complex(1.0),complex(0.))
@test D(rket_, op*xket)

@test isa(op.data, TestData)
rket_ = deepcopy(rket)
QuantumOpticsBase.mul!(rket_,op,xket,alpha,beta)
@test D(rket_, alpha*op*xket + beta*rket)

rbra_ = deepcopy(rbra)
QuantumOpticsBase.mul!(rbra_,xbra,op,complex(1.0),complex(0.))
@test D(rbra_, xbra*op)

rbra_ = deepcopy(rbra)
QuantumOpticsBase.mul!(rbra_,xbra,op,alpha,beta)
@test D(rbra_, alpha*xbra*op + beta*rbra)

# Test gemm
b1 = GenericBasis(37)
b2 = GenericBasis(53)
b3 = GenericBasis(41)
op1 = randtestoperator(b1, b2)
op2 = randtestoperator(b2, b3)
r = randtestoperator(b1, b3)
alpha = complex(0.7, 1.5)
beta = complex(0.3, 2.1)

r_ = deepcopy(r)
QuantumOpticsBase.mul!(r_,op1,op2,complex(1.0),complex(0.))
@test D(r_, op1*op2)

r_ = deepcopy(r)
QuantumOpticsBase.mul!(r_,op1,op2,alpha,beta)
@test D(r_, alpha*op1*op2 + beta*r, 1e-12)

# Test Hermitian
bspin = SpinBasis(1//2)
bnlevel = NLevelBasis(2)
@test ishermitian(Operator(bspin, bspin, TestData([1.0 im; -im 2.0]))) == true
@test ishermitian(Operator(bspin, bnlevel, TestData([1.0 im; -im 2.0]))) == false

# Test broadcasting
op1_ = copy(op1)
@test isa(op1_.data, TestData)
op1 .= 2*op1
@test op1 == op1_ .+ op1_
op1 .= op1_
@test op1 == op1_
op1 .= op1_ .+ 3 * op1_
@test op1 == 4*op1_
@test_throws DimensionMismatch op1 .= op2
bf = FockBasis(3)
op3 = randtestoperator(bf)
@test_throws QuantumOpticsBase.IncompatibleBases op1 .+ op3

####################
# Test lazy tensor #
b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(6)
b3b = GenericBasis(5)

b_l = b1a⊗b2a⊗b3a
b_r = b1b⊗b2b⊗b3b

op1 = randtestoperator(b1a, b1b)
op2 = randtestoperator(b2a, b2b)
op3 = randtestoperator(b3a, b3b)

# Test creation
@test_throws AssertionError LazyTensor(b_l, b_r, [1], (randtestoperator(b1a),))
@test_throws AssertionError LazyTensor(b_l, b_r, [1, 2], (op1,))
@test_throws AssertionError LazyTensor(b_l, b_r, [1, 2], (op1, sparse(randtestoperator(b_l, b_l))))
@test_throws AssertionError LazyTensor(b_l, b_r, [1, 2], (randtestoperator(b_r, b_r), sparse(op2)))

# @test LazyTensor(b_l, b_r, [2, 1], [op2, op1]) == LazyTensor(b_l, b_r, [1, 2], [op1, op2])
x = randtestoperator(b2a)
@test LazyTensor(b_l, 2, x) == LazyTensor(b_l, b_l, [2], (x,))

# Test copy
x = 2*LazyTensor(b_l, b_r, [1,2], (randtestoperator(b1a, b1b), sparse(randtestoperator(b2a, b2b))))
x_ = copy(x)
@test x == x_
@test !(x === x_)
x_.operators[1].data[1,1] = complex(10.)
@test x.operators[1].data[1,1] != x_.operators[1].data[1,1]
x_.factor = 3.
@test x_.factor != x.factor
x_.indices[2] = 100
@test x_.indices != x.indices


# Test dense & sparse
I2 = identityoperator(b2a, b2b)
x = LazyTensor(b_l, b_r, [1, 3], (op1, sparse(op3)), 0.3)
@test D(0.3*op1⊗dense(I2)⊗op3, dense(x))
@test D(0.3*sparse(op1)⊗I2⊗sparse(op3), sparse(x))

# Test suboperators
@test QuantumOpticsBase.suboperator(x, 1) == op1
@test QuantumOpticsBase.suboperator(x, 3) == sparse(op3)
@test QuantumOpticsBase.suboperators(x, [1, 3]) == [op1, sparse(op3)]


# Arithmetic operations
subop1 = randtestoperator(b1a, b1b)
subop2 = randtestoperator(b2a, b2b)
subop3 = randtestoperator(b3a, b3b)
I1 = dense(identityoperator(b1a, b1b))
I2 = dense(identityoperator(b2a, b2b))
I3 = dense(identityoperator(b3a, b3b))
op1 = LazyTensor(b_l, b_r, [1, 3], (subop1, sparse(subop3)), 0.1)
op1_ = 0.1*subop1 ⊗ I2 ⊗ subop3
op2 = LazyTensor(b_l, b_r, [2, 3], (sparse(subop2), subop3), 0.7)
op2_ = 0.7*I1 ⊗ subop2 ⊗ subop3
op3 = 0.3*LazyTensor(b_l, b_r, 3, subop3)
op3_ = 0.3*I1 ⊗ I2 ⊗ subop3

x1 = Ket(b_r, rand(ComplexF64, length(b_r)))
x2 = Ket(b_r, rand(ComplexF64, length(b_r)))
xbra1 = Bra(b_l, rand(ComplexF64, length(b_l)))
xbra2 = Bra(b_l, rand(ComplexF64, length(b_l)))

# Addition
@test D(-op1_, -op1, 1e-12)

# Test multiplication
@test_throws DimensionMismatch op1*op2
@test D(op1*(x1 + 0.3*x2), op1_*(x1 + 0.3*x2))
@test D((xbra1 + 0.3*xbra2)*op1, (xbra1 + 0.3*xbra2)*op1_)
@test D(op1*x1 + 0.3*op1*x2, op1_*x1 + 0.3*op1_*x2)
@test D(dagger(x1)*dagger(0.3*op2), dagger(x1)*dagger(0.3*op2_))
@test D(op1_*dagger(0.3*op2), op1_*dagger(0.3*op2_))
@test D(dagger(0.3*op2)*op1_, dagger(0.3*op2_)*op1_)
@test D(dagger(0.3*op2)*op1, dagger(0.3*op2_)*op1_)


#####################
# Test lazy product #
op1a = randtestoperator(b_l, b_r)
op1b = randtestoperator(b_r, b_l)
op2a = randtestoperator(b_l, b_r)
op2b = randtestoperator(b_r, b_l)
op3a = randtestoperator(b_l, b_l)
op1 = LazyProduct([op1a, sparse(op1b)])*0.1
op1_ = 0.1*(op1a*op1b)
op2 = LazyProduct([sparse(op2a), op2b], 0.3)
op2_ = 0.3*(op2a*op2b)
op3 = LazyProduct(op3a)
op3_ = op3a

x1 = Ket(b_l, rand(ComplexF64, length(b_l)))
x2 = Ket(b_l, rand(ComplexF64, length(b_l)))
xbra1 = Bra(b_l, rand(ComplexF64, length(b_l)))
xbra2 = Bra(b_l, rand(ComplexF64, length(b_l)))

# Addition
@test D(2.1*op1 + 0.3*op2, 2.1*op1_+0.3*op2_)
@test D(-op1_, -op1)

# Test multiplication
@test_throws DimensionMismatch op1a*op1a
@test D(op1*(x1 + 0.3*x2), op1_*(x1 + 0.3*x2), 1e-11)
@test D((xbra1 + 0.3*xbra2)*op1, (xbra1 + 0.3*xbra2)*op1_, 1e-11)
@test D(op1*x1 + 0.3*op1*x2, op1_*x1 + 0.3*op1_*x2, 1e-11)
@test D(dagger(x1)*dagger(0.3*op2), dagger(x1)*dagger(0.3*op2_), 1e-11)
@test 0.3*LazyProduct(op1, sparse(op2)) == LazyProduct([op1, sparse(op2)], 0.3)
@test 0.3*LazyProduct(op1)*LazyProduct(sparse(op2)) == LazyProduct([op1, sparse(op2)], 0.3)


# Test gemv
op1 = randtestoperator(b_l, b_r)
op2 = randtestoperator(b_r, b_l)
op3 = randtestoperator(b_l, b_r)
op = LazyProduct([op1, sparse(op2), op3], 0.2)
op_ = 0.2*op1*op2*op3
tmp = 0.2*prod(dense.([op1*op2*op3]))

state = Ket(b_r, rand(ComplexF64, length(b_r)))
result_ = Ket(b_l, rand(ComplexF64, length(b_l)))
result = copy(result_)
QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
@test D(result, op_*state, 1e-11)

result = copy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,op,state,alpha,beta)
@test D(result, alpha*op_*state + beta*result_, 1e-9)

state = Bra(b_l, rand(ComplexF64, length(b_l)))
result_ = Bra(b_r, rand(ComplexF64, length(b_r)))
result = copy(result_)
QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
@test D(result, state*op_, 1e-9)

result = copy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,state,op,alpha,beta)
@test D(result, alpha*state*op_ + beta*result_, 1e-9)

# Test gemm
op1 = randtestoperator(b_l, b_r)
op2 = randtestoperator(b_r, b_l)
op3 = randtestoperator(b_l, b_r)
op = LazyProduct([op1, sparse(op2), op3], 0.2)
op_ = 0.2*op1*op2*op3

state = randtestoperator(b_r, b_r)
result_ = randtestoperator(b_l, b_r)
result = copy(result_)
result.data[1] = 1
result.data[1] != result_.data[1] || error("")
QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
@test D(result, op_*state, 1e-9)

result = copy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,op,state,alpha,beta)
@test D(result, alpha*op_*state + beta*result_, 1e-9)

state = randtestoperator(b_l, b_l)
result_ = randtestoperator(b_l, b_r)
result = copy(result_)
QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
@test D(result, state*op_, 1e-9)

result = copy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,state,op,alpha,beta)
@test D(result, alpha*state*op_ + beta*result_, 1e-9)

end # testset
end

import QuantumInterface: AbstractSuperOperator
import FastExpm: fastExpm
import Adapt

"""
    SuperOperator <: AbstractSuperOperator

SuperOperator stored as representation, e.g. as a Matrix.
"""
mutable struct SuperOperator{B1,B2,T} <: AbstractSuperOperator{B1,B2}
    basis_l::B1
    basis_r::B2
    data::T
    function SuperOperator{BL,BR,T}(basis_l::BL, basis_r::BR, data::T) where {BL,BR,T}
        if (length(basis_l) != 2 || length(basis_r) != 2 ||
            length(basis_l[1])*length(basis_l[2]) != size(data, 1) ||
            length(basis_r[1])*length(basis_r[2]) != size(data, 2))
            throw(DimensionMismatch("Tried to assign data of size $(size(data)) to Hilbert spaces of sizes $(length.(basis_l)), $(length.(basis_r))"))
        end
        new(basis_l, basis_r, data)
    end
end
SuperOperator{BL,BR}(b1::BL,b2::BR,data::T) where {BL,BR,T} = SuperOperator{BL,BR,T}(b1,b2,data)
SuperOperator(b1::BL,b2::BR,data::T) where {BL,BR,T} = SuperOperator{BL,BR,T}(b1,b2,data)
SuperOperator(b,data) = SuperOperator(b,b,data)

const DenseSuperOpType{BL,BR} = SuperOperator{BL,BR,<:Matrix}
const SparseSuperOpType{BL,BR} = SuperOperator{BL,BR,<:SparseMatrixCSC}

"""
    DenseSuperOperator(b1[, b2, data])
    DenseSuperOperator([T=ComplexF64,], b1[, b2])

SuperOperator stored as dense matrix.
"""
DenseSuperOperator(basis_l,basis_r,data) = SuperOperator(basis_l, basis_r, Matrix(data))
function DenseSuperOperator(::Type{T}, basis_l, basis_r) where T
    Nl = length(basis_l[1])*length(basis_l[2])
    Nr = length(basis_r[1])*length(basis_r[2])
    data = zeros(T, Nl, Nr)
    DenseSuperOperator(basis_l, basis_r, data)
end
DenseSuperOperator(basis_l, basis_r) = DenseSuperOperator(ComplexF64, basis_l, basis_r)
DenseSuperOperator(::Type{T}, b) where T = DenseSuperOperator(T, b, b)
DenseSuperOperator(b) = DenseSuperOperator(b,b)


"""
    SparseSuperOperator(b1[, b2, data])
    SparseSuperOperator([T=ComplexF64,], b1[, b2])

SuperOperator stored as sparse matrix.
"""
SparseSuperOperator(basis_l, basis_r, data) = SuperOperator(basis_l, basis_r, sparse(data))

function SparseSuperOperator(::Type{T}, basis_l, basis_r) where T
    Nl = length(basis_l[1])*length(basis_l[2])
    Nr = length(basis_r[1])*length(basis_r[2])
    data = spzeros(T, Nl, Nr)
    SparseSuperOperator(basis_l, basis_r, data)
end
SparseSuperOperator(basis_l, basis_r) = SparseSuperOperator(ComplexF64, basis_l, basis_r)
SparseSuperOperator(::Type{T}, b) where T = SparseSuperOperator(T, b, b)
SparseSuperOperator(b) = DenseSuperOperator(b,b)

Base.copy(a::T) where {T<:SuperOperator} = T(a.basis_l, a.basis_r, copy(a.data))

dense(a::SuperOperator) = DenseSuperOperator(a.basis_l, a.basis_r, a.data)
sparse(a::SuperOperator) = SuperOperator(a.basis_l, a.basis_r, sparse(a.data))

==(a::SuperOperator{B1,B2}, b::SuperOperator{B1,B2}) where {B1,B2} = (samebases(a,b) && a.data == b.data)
==(a::SuperOperator, b::SuperOperator) = false

Base.length(a::SuperOperator) = length(a.basis_l[1])*length(a.basis_l[2])*length(a.basis_r[1])*length(a.basis_r[2])
samebases(a::SuperOperator, b::SuperOperator) = samebases(a.basis_l[1], b.basis_l[1]) && samebases(a.basis_l[2], b.basis_l[2]) &&
                                                      samebases(a.basis_r[1], b.basis_r[1]) && samebases(a.basis_r[2], b.basis_r[2])
multiplicable(a::SuperOperator, b::SuperOperator) = multiplicable(a.basis_r[1], b.basis_l[1]) && multiplicable(a.basis_r[2], b.basis_l[2])
multiplicable(a::SuperOperator, b::AbstractOperator) = multiplicable(a.basis_r[1], b.basis_l) && multiplicable(a.basis_r[2], b.basis_r)


# Arithmetic operations
function *(a::SuperOperator{B1,B2}, b::Operator{BL,BR}) where {BL,BR,B1,B2<:Tuple{BL,BR}}
    data = a.data*reshape(b.data, length(b.data))
    return Operator(a.basis_l[1], a.basis_l[2], reshape(data, length(a.basis_l[1]), length(a.basis_l[2])))
end

function *(a::SuperOperator{B1,B2}, b::SuperOperator{B2,B3}) where {B1,B2,B3}
    return SuperOperator{B1,B3}(a.basis_l, b.basis_r, a.data*b.data)
end

*(a::SuperOperator, b::Number) = SuperOperator(a.basis_l, a.basis_r, a.data*b)
*(a::Number, b::SuperOperator) = b*a

/(a::SuperOperator, b::Number) = SuperOperator(a.basis_l, a.basis_r, a.data ./ b)

+(a::SuperOperator{B1,B2}, b::SuperOperator{B1,B2}) where {B1,B2} = SuperOperator{B1,B2}(a.basis_l, a.basis_r, a.data+b.data)
+(a::SuperOperator, b::SuperOperator) = throw(IncompatibleBases())

-(a::SuperOperator{B1,B2}, b::SuperOperator{B1,B2}) where {B1,B2} = SuperOperator{B1,B2}(a.basis_l, a.basis_r, a.data-b.data)
-(a::SuperOperator) = SuperOperator(a.basis_l, a.basis_r, -a.data)
-(a::SuperOperator, b::SuperOperator) = throw(IncompatibleBases())

identitysuperoperator(b::Basis) =
    SuperOperator((b,b), (b,b), Eye{ComplexF64}(length(b)^2))

identitysuperoperator(op::DenseSuperOpType) = 
    SuperOperator(op.basis_l, op.basis_r, Matrix(one(eltype(op.data))I, size(op.data)))

identitysuperoperator(op::SparseSuperOpType) = 
    SuperOperator(op.basis_l, op.basis_r, sparse(one(eltype(op.data))I, size(op.data)))

dagger(x::DenseSuperOpType) = SuperOperator(x.basis_r, x.basis_l, copy(adjoint(x.data)))
dagger(x::SparseSuperOpType) = SuperOperator(x.basis_r, x.basis_l, sparse(adjoint(x.data)))


"""
    spre(op)

Create a super-operator equivalent for right side operator multiplication.

For operators ``A``, ``B`` the relation

```math
    \\mathrm{spre}(A) B = A B
```

holds. `op` can be a dense or a sparse operator.
"""
function spre(op::AbstractOperator)
    if !samebases(op.basis_l, op.basis_r)
        throw(ArgumentError("It's not clear what spre of a non-square operator should be. See issue #113"))
    end
    SuperOperator((op.basis_l, op.basis_l), (op.basis_r, op.basis_r), tensor(op, identityoperator(op)).data)
end

"""
    spost(op)

Create a super-operator equivalent for left side operator multiplication.

For operators ``A``, ``B`` the relation

```math
    \\mathrm{spost}(A) B = B A
```

holds. `op` can be a dense or a sparse operator.
"""
function spost(op::AbstractOperator)
    if !samebases(op.basis_l, op.basis_r)
        throw(ArgumentError("It's not clear what spost of a non-square operator should be. See issue #113"))
    end
    SuperOperator((op.basis_r, op.basis_r), (op.basis_l, op.basis_l), kron(permutedims(op.data), identityoperator(op).data))
end

"""
    sprepost(op)

Create a super-operator equivalent for left and right side operator multiplication.

For operators ``A``, ``B``, ``C`` the relation

```math
    \\mathrm{sprepost}(A, B) C = A C B
```

holds. `A` ond `B` can be dense or a sparse operators.
"""
sprepost(A::AbstractOperator, B::AbstractOperator) = SuperOperator((A.basis_l, B.basis_r), (A.basis_r, B.basis_l), kron(permutedims(B.data), A.data))

function _check_input(H::AbstractOperator{B1,B2}, J::Vector, Jdagger::Vector, rates) where {B1,B2}
    for j=J
        @assert isa(j, AbstractOperator{B1,B2})
    end
    for j=Jdagger
        @assert isa(j, AbstractOperator{B1,B2})
    end
    @assert length(J)==length(Jdagger)
    if isa(rates, Matrix{<:Number})
        @assert size(rates, 1) == size(rates, 2) == length(J)
    elseif isa(rates, Vector{<:Number})
        @assert length(rates) == length(J)
    end
end


"""
    liouvillian(H, J; rates, Jdagger)

Create a super-operator equivalent to the master equation so that ``\\dot ρ = S ρ``.

The super-operator ``S`` is defined by

```math
S ρ = -\\frac{i}{ħ} [H, ρ] + \\sum_i J_i ρ J_i^† - \\frac{1}{2} J_i^† J_i ρ - \\frac{1}{2} ρ J_i^† J_i
```

# Arguments
* `H`: Hamiltonian.
* `J`: Vector containing the jump operators.
* `rates`: Vector or matrix specifying the coefficients for the jump operators.
* `Jdagger`: Vector containing the hermitian conjugates of the jump operators. If they
             are not given they are calculated automatically.
"""
function liouvillian(H, J; rates=ones(length(J)), Jdagger=dagger.(J))
    _check_input(H, J, Jdagger, rates)
    L = spre(-1im*H) + spost(1im*H)
    if isa(rates, AbstractMatrix)
        for i=1:length(J), j=1:length(J)
            jdagger_j = rates[i,j]/2*Jdagger[j]*J[i]
            L -= spre(jdagger_j) + spost(jdagger_j)
            L += spre(rates[i,j]*J[i]) * spost(Jdagger[j])
        end
    elseif isa(rates, AbstractVector)
        for i=1:length(J)
            jdagger_j = rates[i]/2*Jdagger[i]*J[i]
            L -= spre(jdagger_j) + spost(jdagger_j)
            L += spre(rates[i]*J[i]) * spost(Jdagger[i])
        end
    end
    return L
end

"""
    exp(op::DenseSuperOperator)

Superoperator exponential which can, for example, be used to calculate time evolutions.
Uses LinearAlgebra's `Base.exp`.

If you only need the result of the exponential acting on an operator,
consider using much faster implicit methods that do not calculate the entire exponential.
"""
Base.exp(op::DenseSuperOpType) = DenseSuperOperator(op.basis_l, op.basis_r, exp(op.data))

"""
    exp(op::SparseSuperOperator; opts...)

Superoperator exponential which can, for example, be used to calculate time evolutions.
Uses [`FastExpm.jl.jl`](https://github.com/fmentink/FastExpm.jl) which will return a sparse
or dense operator depending on which is more efficient.
All optional arguments are passed to `fastExpm` and can be used to specify tolerances.

If you only need the result of the exponential acting on an operator,
consider using much faster implicit methods that do not calculate the entire exponential.
"""
function Base.exp(op::SparseSuperOpType; opts...)
    if iszero(op)
        return identitysuperoperator(op)
    else
        return SuperOperator(op.basis_l, op.basis_r, fastExpm(op.data; opts...))
    end
end

# Array-like functions
Base.zero(A::SuperOperator) = SuperOperator(A.basis_l, A.basis_r, zero(A.data))
Base.size(A::SuperOperator) = size(A.data)
@inline Base.axes(A::SuperOperator) = axes(A.data)
Base.ndims(A::SuperOperator) = 2
Base.ndims(::Type{<:SuperOperator}) = 2

# Broadcasting
Base.broadcastable(A::SuperOperator) = A

# Custom broadcasting styles
struct SuperOperatorStyle{BL,BR} <: Broadcast.BroadcastStyle end
# struct DenseSuperOperatorStyle{BL,BR} <: SuperOperatorStyle{BL,BR} end
# struct SparseSuperOperatorStyle{BL,BR} <: SuperOperatorStyle{BL,BR} end

# Style precedence rules
Broadcast.BroadcastStyle(::Type{<:SuperOperator{BL,BR}}) where {BL,BR} = SuperOperatorStyle{BL,BR}()
# Broadcast.BroadcastStyle(::Type{<:SparseSuperOperator{BL,BR}}) where {BL,BR} = SparseSuperOperatorStyle{BL,BR}()
# Broadcast.BroadcastStyle(::DenseSuperOperatorStyle{B1,B2}, ::SparseSuperOperatorStyle{B1,B2}) where {B1,B2} = DenseSuperOperatorStyle{B1,B2}()
# Broadcast.BroadcastStyle(::DenseSuperOperatorStyle{B1,B2}, ::DenseSuperOperatorStyle{B3,B4}) where {B1,B2,B3,B4} = throw(IncompatibleBases())
# Broadcast.BroadcastStyle(::SparseSuperOperatorStyle{B1,B2}, ::SparseSuperOperatorStyle{B3,B4}) where {B1,B2,B3,B4} = throw(IncompatibleBases())
# Broadcast.BroadcastStyle(::DenseSuperOperatorStyle{B1,B2}, ::SparseSuperOperatorStyle{B3,B4}) where {B1,B2,B3,B4} = throw(IncompatibleBases())

# Out-of-place broadcasting
@inline function Base.copy(bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {BL,BR,Style<:SuperOperatorStyle{BL,BR},Axes,F,Args<:Tuple}
    bcf = Broadcast.flatten(bc)
    bl,br = find_basis(bcf.args)
    bc_ = Broadcasted_restrict_f(bcf.f, bcf.args, axes(bcf))
    return SuperOperator{BL,BR}(bl, br, copy(bc_))
end
# @inline function Base.copy(bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {BL,BR,Style<:SparseSuperOperatorStyle{BL,BR},Axes,F,Args<:Tuple}
#     bcf = Broadcast.flatten(bc)
#     bl,br = find_basis(bcf.args)
#     bc_ = Broadcasted_restrict_f(bcf.f, bcf.args, axes(bcf))
#     return SuperOperator{BL,BR}(bl, br, copy(bc_))
# end
find_basis(a::SuperOperator, rest) = (a.basis_l, a.basis_r)

const BasicMathFunc = Union{typeof(+),typeof(-),typeof(*),typeof(/)}
function Broadcasted_restrict_f(f::BasicMathFunc, args::Tuple{Vararg{<:SuperOperator}}, axes)
    args_ = Tuple(a.data for a=args)
    return Broadcast.Broadcasted(f, args_, axes)
end

# In-place broadcasting
@inline function Base.copyto!(dest::SuperOperator{BL,BR}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {BL,BR,Style<:SuperOperatorStyle{BL,BR},Axes,F,Args}
    axes(dest) == axes(bc) || Base.Broadcast.throwdm(axes(dest), axes(bc))
    # Performance optimization: broadcast!(identity, dest, A) is equivalent to copyto!(dest, A) if indices match
    if bc.f === identity && isa(bc.args, Tuple{<:SuperOperator{BL,BR}}) # only a single input argument to broadcast!
        A = bc.args[1]
        if axes(dest) == axes(A)
            return copyto!(dest, A)
        end
    end
    # Get the underlying data fields of operators and broadcast them as arrays
    bcf = Broadcast.flatten(bc)
    bc_ = Broadcasted_restrict_f(bcf.f, bcf.args, axes(bcf))
    copyto!(dest.data, bc_)
    return dest
end
@inline Base.copyto!(A::SuperOperator{BL,BR},B::SuperOperator{BL,BR}) where {BL,BR} = (copyto!(A.data,B.data); A)
@inline function Base.copyto!(dest::SuperOperator{B1,B2}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {
        B1,B2,B3,
        B4,Style<:SuperOperatorStyle{B3,B4},Axes,F,Args
        }
    throw(IncompatibleBases())
end

"""
    ChoiState <: AbstractSuperOperator

Superoperator represented as a choi state.
"""
mutable struct ChoiState{B1,B2,T} <: AbstractSuperOperator{B1,B2}
    basis_l::B1
    basis_r::B2
    data::T
    function ChoiState{BL,BR,T}(basis_l::BL, basis_r::BR, data::T) where {BL,BR,T}
        if (length(basis_l) != 2 || length(basis_r) != 2 ||
            length(basis_l[1])*length(basis_l[2]) != size(data, 1) ||
            length(basis_r[1])*length(basis_r[2]) != size(data, 2))
            throw(DimensionMismatch("Tried to assign data of size $(size(data)) to Hilbert spaces of sizes $(length.(basis_l)), $(length.(basis_r))"))
        end
        new(basis_l, basis_r, data)
    end
end
ChoiState(b1::BL, b2::BR, data::T) where {BL,BR,T} = ChoiState{BL,BR,T}(b1, b2, data)

dense(a::ChoiState) = ChoiState(a.basis_l, a.basis_r, Matrix(a.data))
sparse(a::ChoiState) = ChoiState(a.basis_l, a.basis_r, sparse(a.data))
dagger(a::ChoiState) = ChoiState(dagger(SuperOperator(a)))
*(a::ChoiState, b::ChoiState) = ChoiState(SuperOperator(a)*SuperOperator(b))
*(a::ChoiState, b::Operator) = SuperOperator(a)*b
==(a::ChoiState, b::ChoiState) = (SuperOperator(a) == SuperOperator(b))

# reshape swaps within systems due to colum major ordering
# https://docs.qojulia.org/quantumobjects/operators/#tensor_order
function _super_choi((l1, l2), (r1, r2), data)
    data = Base.ReshapedArray(data, map(length, (l2, l1, r2, r1)), ())
    (l1, l2), (r1, r2) = (r2, l2), (r1, l1)
    data = PermutedDimsArray(data, (1, 3, 2, 4))
    data = Base.ReshapedArray(data, map(length, (l1⊗l2, r1⊗r2)), ())
    return (l1, l2), (r1, r2), copy(data)
end

ChoiState(op::SuperOperator) = ChoiState(_super_choi(op.basis_l, op.basis_r, op.data)...)
SuperOperator(op::ChoiState) = SuperOperator(_super_choi(op.basis_l, op.basis_r, op.data)...)

*(a::ChoiState, b::SuperOperator) = SuperOperator(a)*b
*(a::SuperOperator, b::ChoiState) = a*SuperOperator(b)

# GPU adaptation
Adapt.adapt_structure(to, x::SuperOperator) = SuperOperator(x.basis_l, x.basis_r, Adapt.adapt(to, x.data))

import Base: ==, +, -, *, /, ^, length, one, exp, conj, conj!, transpose
import LinearAlgebra: tr, ishermitian
import SparseArrays: sparse
import QuantumInterface: AbstractOperator, AbstractKet

"""
Abstract type for operators with a data field.

This is an abstract type for operators that have a direct matrix representation
stored in their `.data` field.
"""
abstract type DataOperator{BL,BR} <: AbstractOperator{BL,BR} end


# Common error messages
using QuantumInterface: arithmetic_binary_error, arithmetic_unary_error, addnumbererror


"""
    embed(basis1[, basis2], indices::Vector, op::AbstractOperator)

Embed operator acting on a joint Hilbert space where missing indices are filled up with identity operators.
"""
function embed(basis_l::CompositeBasis, basis_r::CompositeBasis,
               indices, op::T) where T<:DataOperator
    N = length(basis_l.bases)
    @assert length(basis_r.bases) == N

    reduce(tensor, basis_l.bases[indices]) == op.basis_l || throw(IncompatibleBases())
    reduce(tensor, basis_r.bases[indices]) == op.basis_r || throw(IncompatibleBases())

    index_order = [idx for idx in 1:length(basis_l.bases) if idx ∉ indices]
    all_operators = AbstractOperator[identityoperator(T, eltype(op), basis_l.bases[i], basis_r.bases[i]) for i in index_order]

    for idx in indices
        pushfirst!(index_order, idx)
    end
    push!(all_operators, op)

    check_indices(N, indices)

    # Create the operator.
    permuted_op = tensor(all_operators...)

    # Reorient the matrix to act in the correctly ordered basis.
    # Get the dimensions necessary for index permuting.
    dims_l = [b.shape[1] for b in basis_l.bases]
    dims_r = [b.shape[1] for b in basis_r.bases]

    # Get the order of indices to use in the first reshape. Julia indices go in
    # reverse order.
    expand_order = index_order[end:-1:1]
    # Get the dimensions associated with those indices.
    expand_dims_l = dims_l[expand_order]
    expand_dims_r = dims_r[expand_order]

    # Prepare the permutation to the correctly ordered basis.
    perm_order_l = [indexin(idx, expand_order)[1] for idx in 1:length(dims_l)]
    perm_order_r = [indexin(idx, expand_order)[1] for idx in 1:length(dims_r)]

    # Perform the index expansion, the permutation, and the index collapse.
    M = (reshape(permuted_op.data, tuple([expand_dims_l; expand_dims_r]...)) |>
         x -> permutedims(x, [perm_order_l; perm_order_r .+ length(dims_l)]) |>
         x -> sparse(reshape(x, (prod(dims_l), prod(dims_r)))))

    # Create operator with proper data and bases
    constructor = Base.typename(T)
    unpermuted_op = constructor.wrapper(basis_l, basis_r, M)

    return unpermuted_op
end

function embed(basis_l::CompositeBasis, basis_r::CompositeBasis,
                index::Integer, op::T) where T<:DataOperator

    N = length(basis_l.bases)

    # Check stuff
    @assert N==length(basis_r.bases)
    basis_l.bases[index] == op.basis_l || throw(IncompatibleBases())
    basis_r.bases[index] == op.basis_r || throw(IncompatibleBases())
    check_indices(N, index)

    # Build data
    Tnum = eltype(op)
    data = similar(sparse(op.data),1,1)
    data[1] = one(Tnum)
    i = N
    while i > 0
        if i == index
            data = kron(data, op.data)
            i -= length(index)
        else
            bl = basis_l.bases[i]
            br = basis_r.bases[i]
            id = SparseMatrixCSC{Tnum}(I, length(bl), length(br))
            data = kron(data, id)
            i -= 1
        end
    end

    return Operator(basis_l, basis_r, data)
end

"""
    expect(op, state)

Expectation value of the given operator `op` for the specified `state`.

`state` can either be a (density) operator or a ket.
"""
expect(op::AbstractOperator{B,B}, state::Ket{B}) where B = dot(state.data, (op * state).data)

# TODO upstream this one
# expect(op::AbstractOperator{B,B}, state::AbstractKet{B}) where B = norm(op * state) ^ 2

function expect(indices, op::AbstractOperator{B,B}, state::Ket{B2}) where {B,B2<:CompositeBasis}
    N = length(state.basis.shape)
    indices_ = complement(N, indices)
    expect(op, ptrace(state, indices_))
end

expect(index::Integer, op::AbstractOperator{B,B}, state::Ket{B2}) where {B,B2<:CompositeBasis} = expect([index], op, state)

"""
    variance(op, state)

Variance of the given operator `op` for the specified `state`.

`state` can either be a (density) operator or a ket.
"""
function variance(op::AbstractOperator{B,B}, state::Ket{B}) where B
    x = op*state
    state.data'*(op*x).data - (state.data'*x.data)^2
end

function variance(indices, op::AbstractOperator{B,B}, state::Ket{BC}) where {B,BC<:CompositeBasis}
    N = length(state.basis.shape)
    indices_ = complement(N, indices)
    variance(op, ptrace(state, indices_))
end

variance(index::Integer, op::AbstractOperator{B,B}, state::Ket{BC}) where {B,BC<:CompositeBasis} = variance([index], op, state)

# Helper functions to check validity of arguments
function check_ptrace_arguments(a::AbstractOperator, indices)
    if !isa(a.basis_l, CompositeBasis) || !isa(a.basis_r, CompositeBasis)
        throw(ArgumentError("Partial trace can only be applied onto operators with composite bases."))
    end
    rank = length(a.basis_l.shape)
    if rank != length(a.basis_r.shape)
        throw(ArgumentError("Partial trace can only be applied onto operators wich have the same number of subsystems in the left basis and right basis."))
    end
    if rank == length(indices)
        throw(ArgumentError("Partial trace can't be used to trace out all subsystems - use tr() instead."))
    end
    check_indices(length(a.basis_l.shape), indices)
    for i=indices
        if a.basis_l.shape[i] != a.basis_r.shape[i]
            throw(ArgumentError("Partial trace can only be applied onto subsystems that have the same left and right dimension."))
        end
    end
end
function check_ptrace_arguments(a::StateVector, indices)
    if length(basis(a).shape) == length(indices)
        throw(ArgumentError("Partial trace can't be used to trace out all subsystems - use tr() instead."))
    end
    check_indices(length(basis(a).shape), indices)
end

multiplicable(a::AbstractOperator, b::Ket) = multiplicable(a.basis_r, b.basis)
multiplicable(a::Bra, b::AbstractOperator) = multiplicable(a.basis, b.basis_l)

function is_apply_shortcircuit(state, indices, operation)
    if nsubsystems(state) == 1
        basis(state)==basis(operation) || throw(ArgumentError("`apply!` failed due to incompatible bases of the state and the operation attempted to be applied on it"))
    end
    basis(state)==basis(operation) || return false
    j = 1
    for i in indices
        i == j || return false
        j+=1
    end
    return j-1 == length(indices)
end

function apply!(state::Ket, indices, operation::Operator)
    op = is_apply_shortcircuit(state, indices, operation) ? operation : embed(basis(state), indices, operation)
    state.data = (op*state).data
    state
end

function apply!(state::Operator, indices, operation::Operator)
    op = is_apply_shortcircuit(state, indices, operation) ? operation : embed(basis(state), indices, operation)
    state.data = (op*state*op').data
    state
end

function apply!(state::Ket, indices, operation::T) where {T<:AbstractSuperOperator}
    apply!(dm(state), indices, operation)
end

function apply!(state::Operator, indices, operation::T) where {T<:AbstractSuperOperator}
    if is_apply_shortcircuit(state, indices, operation)
        state.data = (operation*state).data
        return state
    else
        error("`apply!` does not yet support embedding superoperators acting only on a subsystem of the given state")
    end
end

@testitem "test_apply" begin
using QuantumOpticsBase
using QuantumInterface
using Test
using QuantumOpticsBase: apply!

@testset "apply" begin

_b2 = SpinBasis(1//2)
_l0 = spinup(_b2)
_l1 = spindown(_b2)
_x = sigmax(_b2)
_y = sigmay(_b2)
_z = sigmaz(_b2)

@test apply!(_l0⊗_l1, 1, _x) ≈ _l1⊗_l1
@test apply!(_x, 1, _y) ≈ _x

# Test Operator with IncompatibleBases
_l01 = _l0⊗_l1
op = projector(_l0, _l01')
@test_throws QuantumInterface.IncompatibleBases apply!(_l0, 1, op)
@test_throws QuantumInterface.IncompatibleBases apply!(_x, 1, op)

# Test SuperOperator
bf1 = FockBasis(1)
sOp = spre(create(bf1))
st = coherentstate(bf1, 1.4)
@test apply!(st, 1, sOp).data ≈ (sOp*projector(st)).data

# Test SuperOperator with IncompatibleBases
bf2 = FockBasis(2)
op = create(bf2)
sOp2 = spre(op)
@test_throws ArgumentError apply!(st, 1, sOp2)

# test CNOT₂₋₁
CNOT = DenseOperator(_b2⊗_b2, Complex.([1 0 0 0; 0 0 0 1; 0 0 1 0; 0 1 0 0]))
@test QuantumOpticsBase.apply!(_l0⊗_l1, [2,1], CNOT) ≈ _l1⊗_l1

# test operator permutation with 3 qubits/operators for apply!
@test QuantumOpticsBase.apply!(_l0⊗_l1⊗_l0, [2,3,1], _x⊗_y⊗_z) ≈ (_z*_l0)⊗(_x*_l1)⊗(_y*_l0)
@test QuantumOpticsBase.apply!(_x⊗_y⊗_z, [2,3,1], _x⊗_y⊗_z) ≈ (_z⊗_x⊗_y)*(_x⊗_y⊗_z)*(_z⊗_x⊗_y)'

i = identityoperator(_y)
@test QuantumOpticsBase.apply!(_x⊗_y⊗_z, [2,3], _y⊗_z) ≈ (i⊗_y⊗_z)*(_x⊗_y⊗_z)*(i⊗_y⊗_z)'

# 3-qubit/operator errors when called for applying superoperator
sOp1 = spre(create(bf1))
st1 = coherentstate(bf1, 1.4)
st2 = coherentstate(bf1, 0.3)
@test_broken apply!(st1⊗st2, [1], sOp1)

end #testset
end

using QuantumInterface: SumBasis
import Adapt

"""
    directsum(x::Ket, y::Ket)

Construct a spinor via the [`directsum`](@ref) of two [`Ket`](@ref)s.
The result is a [`Ket`](@ref) with data given by `[x.data;y.data]` and its
basis given by the corresponding [`SumBasis`](@ref).
**NOTE**: The resulting state is not normalized!
"""
directsum(x::Ket, y::Ket) = Ket(directsum(x.basis, y.basis), [x.data; y.data])

"""
    getblock(x::Ket{<:SumBasis}, i)

For a [`Ket`](@ref) defined on a [`SumBasis`](@ref), get the state as it is defined
on the ith sub-basis.
"""
function getblock(x::Ket{B}, i) where B<:SumBasis
    b_i = x.basis.bases[i]
    inds = cumsum([0;length.(x.basis.bases[1:i])...])
    return Ket(b_i, x.data[inds[i]+1:inds[i+1]])
end

"""
    setblock!(x::Ket{<:SumBasis}, val::Ket, i)

Set the data of `x` on the ith sub-basis equal to the data of `val`.
"""
function setblock!(x::Ket{B}, val::Ket, i) where B<:SumBasis
    check_samebases(x.basis.bases[i], val)
    inds = cumsum([0;length.(x.basis.bases[1:i])...])
    x.data[inds[i]+1:inds[i+1]].data .= val.data
    return x
end

"""
    directsum(x::DataOperator, y::DataOperator)

Compute the direct sum of two operators. The result is an operator on the
corresponding [`SumBasis`](@ref).
"""
function directsum(a::DataOperator, b::DataOperator)
    dType = promote_type(eltype(a),eltype(b))
    data = zeros(dType, size(a,1)+size(b,1), size(a,2)+size(b,2))
    data[1:size(a,1),1:size(a,2)] = a.data
    data[size(a,1)+1:end, size(a,2)+1:end] = b.data
    return Operator(directsum(a.basis_l, b.basis_l), directsum(a.basis_r, b.basis_r), data)
end
function directsum(a::SparseOpType, b::SparseOpType)
    dType = promote_type(eltype(a),eltype(b))
    data = spzeros(dType, size(a,1)::Int+size(b,1)::Int, size(a,2)::Int+size(b,2)::Int)
    data[1:size(a,1)::Int,1:size(a,2)::Int] = a.data
    data[size(a,1)::Int+1:end, size(a,2)::Int+1:end] = b.data
    return Operator(directsum(a.basis_l, b.basis_l), directsum(a.basis_r, b.basis_r), data)
end

"""
    setblock!(op::DataOperator{<:SumBasis,<:SumBasis}, val::DataOperator, i, j)

Set the data of `op` corresponding to the block `(i,j)` equal to the data of `val`.
"""
function setblock!(op::DataOperator{<:SumBasis,<:SumBasis}, val::DataOperator, i, j)
    (bases_l,bases_r) = op.basis_l.bases, op.basis_r.bases
    check_samebases(bases_l[i], val.basis_l)
    check_samebases(bases_r[j], val.basis_r)
    inds_i = cumsum([0;length.(bases_l[1:i])...])
    inds_j = cumsum([0;length.(bases_r[1:j])...])
    op.data[inds_i[i]+1:inds_i[i+1],inds_j[j]+1:inds_j[j+1]] = val.data
    return op
end

"""
    getblock(op::Operator{<:SumBasis,<:SumBasis}, i, j)

Get the sub-basis operator corresponding to the block `(i,j)` of `op`.
"""
function getblock(op::DataOperator{BL,BR}, i, j) where {BL<:SumBasis,BR<:SumBasis}
    (bases_l,bases_r) = op.basis_l.bases, op.basis_r.bases
    inds_i = cumsum([0;length.(bases_l[1:i])...])
    inds_j = cumsum([0;length.(bases_r[1:j])...])
    data = op.data[inds_i[i]+1:inds_i[i+1],inds_j[j]+1:inds_j[j+1]]
    return Operator(bases_l[i],bases_r[j], data)
end

"""
    embed(basis_l::SumBasis, basis_r::SumBasis,
               index::Integer, operator)

Embed an operator defined on a single subspace specified by the `index` into
a [`SumBasis`](@ref).
"""
function embed(basis_l::SumBasis, basis_r::SumBasis,
               index::Integer, op::T) where T<:DataOperator
    @assert length(basis_r.bases) == length(basis_l.bases)

    basis_l.bases[index] == op.basis_l || throw(IncompatibleBases())
    basis_r.bases[index] == op.basis_r || throw(IncompatibleBases())

    embedded_op = SparseOperator(eltype(op), basis_l, basis_r)
    setblock!(embedded_op, op, index, index)
    return embedded_op
end

"""
    embed(basis_l::SumBasis, basis_r::SumBasis,
                indices, operator)

Embed an operator defined on multiple subspaces specified by the `indices` into
a [`SumBasis`](@ref).
"""
function embed(basis_l::SumBasis, basis_r::SumBasis,
               indices, op::T) where T<:DataOperator
    @assert length(basis_r.bases) == length(basis_l.bases)

    embedded_op = SparseOperator(eltype(op), basis_l, basis_r)
    for i=1:length(indices), j=1:length(indices)
        op_ = getblock(op, i, j)
        setblock!(embedded_op, op_, indices[i], indices[j])
    end
    return embedded_op
end

"""
    embed(basis_l::SumBasis, basis_r::SumBasis,
               indices, operators)

Embed a list of operators on subspaces specified by the `indices` into a
[`SumBasis`](@ref).
"""
function embed(basis_l::SumBasis, basis_r::SumBasis,
               indices, ops::Union{Tuple{Vararg{<:DataOperator}},Vector{<:DataOperator}})
    @assert length(basis_r.bases) == length(basis_l.bases)

    T = mapreduce(eltype, promote_type, ops)
    embedded_op = SparseOperator(T, basis_l, basis_r)
    for k=1:length(ops)
        op = ops[k]
        idx = indices[k]
        if length(idx)==1
            setblock!(embedded_op, op, idx[1], idx[1])
        else
            for i=1:length(idx), j=1:length(idx)
                op_ = getblock(op, i, j)
                setblock!(embedded_op, op_, idx[i], idx[j])
            end
        end
    end
    return embedded_op
end


"""
    LazyDirectSum <: AbstractOperator

Lazy implementation of `directsum`
"""
mutable struct LazyDirectSum{BL,BR,T} <: AbstractOperator{BL,BR}
    basis_l::BL
    basis_r::BR
    operators::T
end

# Methods
LazyDirectSum(op1::AbstractOperator, op2::AbstractOperator) = LazyDirectSum(directsum(op1.basis_l,op2.basis_l),directsum(op1.basis_r,op2.basis_r),(op1,op2))
LazyDirectSum(op1::LazyDirectSum, op2::AbstractOperator) = LazyDirectSum(directsum(op1.basis_l,op2.basis_l),directsum(op1.basis_r,op2.basis_r),(op1.operators...,op2))
LazyDirectSum(op1::AbstractOperator, op2::LazyDirectSum) = LazyDirectSum(directsum(op1.basis_l,op2.basis_l),directsum(op1.basis_r,op2.basis_r),(op1,op2.operators...))
LazyDirectSum(op1::LazyDirectSum, op2::LazyDirectSum) = LazyDirectSum(directsum(op1.basis_l,op2.basis_l),directsum(op1.basis_r,op2.basis_r),(op1.operators...,op2.operators...))
LazyDirectSum(op::AbstractOperator...) = reduce(LazyDirectSum, op)

function Base.:(==)(op1::LazyDirectSum,op2::LazyDirectSum)
    (op1.basis_l == op2.basis_l && op1.basis_r == op2.basis_r) || return false
    length(op1.operators)==length(op2.operators) || return false
    for (o1,o2) = zip(op1.operators,op2.operators)
        (o1 == o2) || return false
    end
    return true
end

# Algebra
dense(x::LazyDirectSum) = directsum(dense.(x.operators)...)
*(op1::LazyDirectSum{B1,B2},op2::LazyDirectSum{B2,B3}) where {B1<:Basis,B2<:Basis,B3<:Basis}= LazyDirectSum(op1.basis_l,op2.basis_r,Tuple(op1.operators[i]*op2.operators[i] for i=1:length(op1.operators)))
-(op::LazyDirectSum) = LazyDirectSum([-op.operators[1];op.operators[2:end]]...)
+(op1::LazyDirectSum{B1,B2},op2::LazyDirectSum{B1,B2}) where {B1<:Basis,B2<:Basis} = LazyDirectSum((op1.operators .+ op2.operators)...)
dagger(op::LazyDirectSum) = LazyDirectSum(op.basis_r, op.basis_l, dagger.(op.operators))
Base.eltype(x::LazyDirectSum) = mapreduce(eltype, promote_type, x.operators)

directsum(op1::AbstractOperator,op2::LazyDirectSum) = LazyDirectSum(op1,op2)
directsum(op1::LazyDirectSum,op2::AbstractOperator) = LazyDirectSum(op1,op2)
directsum(op1::LazyDirectSum,op2::LazyDirectSum) = LazyDirectSum(op1,op2)

# Use lazy sum for FFTOperator
transform(b1::SumBasis,b2::SumBasis; kwargs...) = LazyDirectSum([transform(b1.bases[i],b2.bases[i];kwargs...) for i=1:length(b1.bases)]...)
directsum(op1::FFTOperator, op2::FFTOperator) = LazyDirectSum(op1,op2)

# Lazy embed
function embed(basis_l::SumBasis, basis_r::SumBasis, indices, op::LazyDirectSum)
    bases_l = basis_l.bases
    bases_r = basis_r.bases
    N = length(bases_r)
    @assert length(bases_l)==N

    T = eltype(op)

    function _get_op(i)
        idx = findfirst(isequal(i), indices)
        if idx === nothing
            return SparseOperator(T, bases_l[i], bases_r[i])
        else
            return op.operators[idx]
        end
    end

    ops = Tuple(_get_op(i) for i=1:N)
    return LazyDirectSum(basis_l,basis_r,ops)
end
# TODO: embed for multiple LazyDirectums?

# Fast in-place multiplication
function mul!(result::Ket{B1},M::LazyDirectSum{B1,B2},b::Ket{B2},alpha_,beta_) where {B1,B2}
    alpha = convert(ComplexF64, alpha_)
    beta = convert(ComplexF64, beta_)
    bases_r = b.basis.bases
    bases_l = M.basis_l.bases
    index = cumsum([0;length.(bases_r)...])
    for i=1:length(index)-1
        tmpket = Ket(bases_r[i], b.data[index[i]+1:index[i+1]])
        tmpresult = Ket(bases_l[i], result.data[index[i]+1:index[i+1]])
        mul!(tmpresult,M.operators[i],tmpket,alpha,beta)
        result.data[index[i]+1:index[i+1]] = tmpresult.data
    end
    return result
end
function mul!(result::Bra{B2},b::Bra{B1},M::LazyDirectSum{B1,B2},alpha_,beta_) where {B1,B2}
    alpha = convert(ComplexF64, alpha_)
    beta = convert(ComplexF64, beta_)
    bases_l = b.basis.bases
    bases_r = M.basis_r.bases
    index = cumsum([0;length.(bases_r)...])
    for i=1:length(index)-1
        tmpbra = Bra(bases_l[i], b.data[index[i]+1:index[i+1]])
        tmpresult = Bra(bases_r[i], result.data[index[i]+1:index[i+1]])
        mul!(tmpresult,tmpbra,M.operators[i],alpha,beta)
        result.data[index[i]+1:index[i+1]] = tmpresult.data
    end
    return result
end

# GPU adaptation
Adapt.adapt_structure(to, x::LazyDirectSum) = LazyDirectSum(x.basis_l, x.basis_r, [Adapt.adapt(to, op) for op in x.operators])

import QuantumInterface: FockBasis

"""
    number([T=ComplexF64,] b::FockBasis)

Number operator for the specified Fock space with optional data type `T`.
"""
function number(::Type{T}, b::FockBasis) where T
    diag = T.(b.offset:b.N)
    data = spdiagm(0 => diag)
    SparseOperator(b, data)
end

number(b::FockBasis) = number(ComplexF64, b)


"""
    destroy([T=ComplexF64,] b::FockBasis)

Annihilation operator for the specified Fock space with optional data type `T`.
"""
function destroy(::Type{C}, b::FockBasis) where C
    T = real(C)
    ns = b.offset+1.:b.N
    diag = @. C(sqrt(T(ns)))
    data = spdiagm(1 => diag)
    SparseOperator(b, data)
end

destroy(b::FockBasis) = destroy(ComplexF64, b)


"""
    create([T=ComplexF64,] b::FockBasis)

Creation operator for the specified Fock space with optional data type `T`.
"""
function create(::Type{C}, b::FockBasis) where C
    T = real(C)
    ns = b.offset+1.:b.N
    diag = @. C(sqrt(T(ns)))
    data = spdiagm(-1 => diag)
    SparseOperator(b, data)
end

create(b::FockBasis) = create(ComplexF64, b)


"""
    displace([T=ComplexF64,] b::FockBasis, alpha)

Displacement operator ``D(α)=\\exp{\\left(α\\hat{a}^\\dagger-α^*\\hat{a}\\right)}`` for the specified Fock space with optional data
type `T`, computed as the matrix exponential of finite-dimensional (truncated)
creation and annihilation operators.
"""
function displace(::Type{T}, b::FockBasis, alpha::Number) where T
    alpha = T(alpha)
    exp(dense(alpha * create(T, b) - conj(alpha) * destroy(T, b)))
end

displace(b::FockBasis, alpha::T) where {T <: Number} = displace(ComplexF64, b, alpha)

"""
    squeeze([T=ComplexF64,] b::FockBasis, z)

Squeezing operator ``S(z)=\\exp{\\left(\\frac{z^*\\hat{a}^2-z\\hat{a}^{\\dagger2}}{2}\\right)}`` for the specified Fock space with optional data
type `T`, computed as the matrix exponential of finite-dimensional (truncated)
creation and annihilation operators.
"""
function squeeze(::Type{T}, b::FockBasis, z::Number) where T
    z = T(z)/2
    asq = destroy(T, b)^2
    exp(dense(conj(z) * asq - z * dagger(asq)))
end

squeeze(b::FockBasis, z::T) where {T <: Number} = squeeze(ComplexF64, b, z)

# associated Laguerre polynomial, borrowed from IonSim.jl
function _alaguerre(x::Real, n::Int, k::Int)
    L = 1.0, -x + k + 1
    if n < 2
        return L[n + 1]
    end
    for i in 2:n
        L = L[2], ((k + 2i - 1 - x) * L[2] - (k + i - 1) * L[1]) / i
    end
    return L[2]
end

"""
    displace_analytical(alpha::Number, n::Integer, m::Integer)

Get a specific matrix element of the (analytical) displacement operator in the
Fock basis: `Dmn = ⟨n|D̂(α)|m⟩`. The precision used for computation is based
on the type of `alpha`. If `alpha` is a Float64, ComplexF64, or Int, the computation
will be carried out at double precision.
"""
function displace_analytical(alpha::Number, n::Integer, m::Integer)
    # Borrowed from IonSim.jl.
    if n < m
        return (-1)^isodd(abs(n - m)) * conj(displace_analytical(alpha, m, n))
    end
    alpha = float(alpha) # promote alpha to float
    # compute factorial ratio directly, in float representation, to avoid integer overflow
    s = float(one(real(alpha)))
    for i in (m + 1):n
        s *= i
    end
    ret = sqrt(1 / s) * alpha^(n - m) * exp(-abs2(alpha) / 2.0) * _alaguerre(abs2(alpha), m, n - m)
    if isnan(ret)
        # Handles factorial -> Inf in case of large n-m, and also large abs2(alpha) making _alaguerre() return NaN.
        return 1.0 * (n == m)
    end
    return ret
end

"""
    displace_analytical!(op, alpha::Number)

Overwrite, in place, the matrix elements of the FockBasis operator `op`, so that
it is equal to `displace_analytical(eltype(op), basis(op), alpha)`
"""
function displace_analytical!(op::DataOperator{B,B}, alpha::Number) where {B<:FockBasis}
    b = basis(op)
    ofs = b.offset
    @inbounds for n in 1:size(op.data, 2), m in 1:size(op.data, 1)
          op.data[m, n] = displace_analytical(alpha, m-1 + ofs, n-1 + ofs)
    end
    op
end

"""
    displace_analytical(b::FockBasis, alpha::Number)
    displace_analytical(::Type{T}, b::FockBasis, alpha::Number)

Get the "analytical" displacement operator, whose matrix elements match (up to
numerical imprecision) those of the exact infinite-dimensional displacement
operator. This is different to the result of `displace(..., alpha)`, which
computes the matrix exponential `exp(alpha * a' - conj(alpha) * a)` using
finite-dimensional (truncated) creation and annihilation operators `a'` and `a`.
"""
function displace_analytical(::Type{T}, b::FockBasis, alpha::Number) where T
    displace_analytical!(DenseOperator(T, b), alpha)
end

displace_analytical(b::FockBasis, alpha::Number) = displace_analytical(ComplexF64, b::FockBasis, alpha::Number)


"""
    fockstate([T=ComplexF64,] b::FockBasis, n)

Fock state ``|n⟩`` for the specified Fock space.
"""
function fockstate(::Type{T}, b::FockBasis, n::Integer) where T
    @assert b.offset <= n <= b.N
    basisstate(T, b, n+1-b.offset)
end
fockstate(b, n) = fockstate(ComplexF64, b, n)

"""
    coherentstate([T=ComplexF64,] b::FockBasis, alpha)

Coherent state ``|α⟩`` for the specified Fock space.
"""
function coherentstate(::Type{T}, b::FockBasis, alpha::Number) where T
    result = Ket(T, b)
    coherentstate!(result, b, alpha)
    return result
end
coherentstate(b, alpha) = coherentstate(ComplexF64, b, alpha)

"""
    coherentstate!(ket::Ket, b::FockBasis, alpha)

Inplace creation of coherent state ``|α⟩`` for the specified Fock space.
"""
function coherentstate!(ket::Ket, b::FockBasis, alpha::Number)
    C = eltype(ket)
    T = real(C)
    alpha = C(alpha)
    data = ket.data
    data[1] = exp(-abs2(alpha)/2)

    # Compute coefficient up to offset
    offset = b.offset
    @inbounds for n=1:offset
        data[1] *= alpha/sqrt(T(n))
    end

    # Write coefficients to state
    @inbounds for n=1:b.N-offset
        data[n+1] = data[n]*alpha/sqrt(T(n+offset))
    end

    return ket
end

@testitem "test_sparsematrix" begin
using Test
using QuantumOpticsBase
using SparseArrays, LinearAlgebra

const SparseMatrix = SparseMatrixCSC{ComplexF64, Int}


@testset "sparsematrix" begin

# Set up test matrices
A = rand(ComplexF64, 5, 5)
A_sp = sparse(A)

B = Matrix{ComplexF64}(I, 5, 5)
B_sp = sparse(ComplexF64(1)*I, 5, 5)

C = rand(ComplexF64, 3, 3)
C[2,:] .= 0
C_sp = sparse(C)

R_sp = A_sp + B_sp
R = A + B


# Test arithmetic
@test 0 ≈ norm(Matrix(R_sp) - R)
@test 0 ≈ norm(Matrix(ComplexF64(0.5,0)*A_sp) - 0.5*A)
@test 0 ≈ norm(Matrix(A_sp/2) - A/2)
@test 0 ≈ norm(Matrix(A_sp*B_sp) - A*B)

# Test kronecker product
@test 0 ≈ norm(Matrix(kron(A_sp, C_sp)) - kron(A, C))
@test 0 ≈ norm(Matrix(kron(A_sp, B_sp)) - kron(A, B))

end # testset
end

using Documenter
using AnythingLLMDocs
using QuantumInterface
using QuantumOpticsBase

pages = [
        "index.md",
        "api.md"
    ]

doc_modules = [QuantumOpticsBase, QuantumInterface]

api_base="https://anythingllm.krastanov.org/api/v1"
anythingllm_assets = integrate_anythingllm(
    "QuantumOpticsBase",
    doc_modules,
    @__DIR__,
    api_base;
    repo = "github.com/qojulia/QuantumOpticsBase.jl.git",
    options = EmbedOptions(),
)

makedocs(
    sitename = "QuantumOpticsBase.jl",
    modules = doc_modules,
    pages = pages,
    format = Documenter.HTML(assets = anythingllm_assets),
    checkdocs=:exports
    )

deploydocs(
    repo = "github.com/qojulia/QuantumOpticsBase.jl.git",
    )

module QuantumOpticsBaseMakieExt

import QuantumOpticsBase
import QuantumOpticsBase: Ket, blochsphereplot, blochsphereplot!, blochsphereplot_axis
import Makie
using Makie: Figure, @recipe, Attributes, Axis3
using Makie: surface!, arrows3d!, lines!, text!, meshscatter!
using Makie: Point3f, Vec3f

@recipe(BlochSpherePlot, state) do scene
    Attributes(
        arrowcolor    = :red,
        spherecolor   = :lightblue,
        spherealpha   = 0.15,
        showwireframe = true,
        showaxes      = true,
        showlabels    = true,
        labelsize     = 18,
        shaftradius   = 0.018,
        tipradius     = 0.050,
        tiplength     = 0.10,
    )
end

function Makie.plot!(p::BlochSpherePlot)
    state_obs = p[1]

    blochvec = Makie.@lift begin
        s = $state_obs
        length(s.data) == 2 ||
            error("BlochSphere requires a 2-level (spin-1/2) state")
        α, β = s.data
        Vec3f(
            Float32(2 * real(conj(α) * β)),
            Float32(2 * imag(conj(α) * β)),
            Float32(abs2(α) - abs2(β)),
        )
    end

    let npts = 200
        θ = LinRange(0f0, 2f0π, npts)
        φ = LinRange(0f0, Float32(π), npts)
        xs = Float32[cos(t) * sin(q) for t in θ, q in φ]
        ys = Float32[sin(t) * sin(q) for t in θ, q in φ]
        zs = Float32[cos(q)          for _  in θ, q in φ]
        c  = Makie.to_color(p[:spherecolor][])
        α  = Float32(p[:spherealpha][])
        rgba = Makie.RGBAf(c.r, c.g, c.b, α)
        surface!(p, xs, ys, zs;
            color        = fill(rgba, npts, npts),
            transparency = true,
        )
    end

    if p[:showwireframe][]
        ncirc = 120
        θc = LinRange(0f0, 2f0π, ncirc)
        for pts in (
            [Point3f( cos(t),  sin(t), 0f0) for t in θc],
            [Point3f( cos(t), 0f0, sin(t)) for t in θc],
            [Point3f(0f0, cos(t), sin(t)) for t in θc],
        )
            lines!(p, pts; color = (:black, 0.70), linewidth = 1.2)
        end
    end

    if p[:showaxes][]
        r = 1.18f0
        for (a, b) in (
            (Point3f(-r, 0, 0), Point3f(r, 0, 0)),
            (Point3f(0, -r, 0), Point3f(0, r, 0)),
            (Point3f(0, 0, -r), Point3f(0, 0, r)),
        )
            lines!(p, [a, b]; color = :black, linewidth = 1, linestyle = :dash)
        end
    end

    arrows3d!(p,
        [Point3f(0, 0, 0)],
        Makie.@lift([$blochvec]);
        shaftradius = p[:shaftradius],
        tipradius   = p[:tipradius],
        tiplength   = p[:tiplength],
        color       = p[:arrowcolor],
    )

    meshscatter!(p,
        Makie.@lift([Point3f($blochvec)]);
        color      = p[:arrowcolor],
        markersize = 0.06,
    )

    if p[:showlabels][]
        ls  = p[:labelsize][]
        off = 1.40f0
        for (pos, lbl, align) in (
            (Point3f( 0f0,   0f0,  off), "|0⟩",  (:center, :bottom)),
            (Point3f( 0f0,   0f0, -off), "|1⟩",  (:center, :top   )),
            (Point3f( off,   0f0,  0f0), "|+⟩",  (:left,   :center)),
            (Point3f(-off,   0f0,  0f0), "|-⟩",  (:right,  :center)),
            (Point3f( 0f0,   off,  0f0), "|+i⟩", (:left,   :center)),
            (Point3f( 0f0,  -off,  0f0), "|-i⟩", (:right,  :center)),
        )
            text!(p, pos; text = lbl, fontsize = ls, align = align)
        end
    end

    return p
end


function QuantumOpticsBase.blochsphereplot_axis(ax::Makie.AbstractAxis, state; limits=1.6, kwargs...)
    ax.perspectiveness = 0f0
    lim = Float32(limits)
    Makie.limits!(ax, -lim, lim, -lim, lim, -lim, lim)
    blochsphereplot!(ax, state; kwargs...)
end

function QuantumOpticsBase.blochsphereplot_axis(state; limits=1.6, kwargs...)
    fig = Figure(size = (700, 700))
    ax  = Axis3(fig[1, 1];
        aspect   = :data,
        viewmode = :fit,
        perspectiveness = 0f0,
        xticksvisible      = false,
        yticksvisible      = false,
        zticksvisible      = false,
        xticklabelsvisible = false,
        yticklabelsvisible = false,
        zticklabelsvisible = false,
        xlabelvisible      = false,
        ylabelvisible      = false,
        zlabelvisible      = false,
        xspinesvisible     = false,
        yspinesvisible     = false,
        zspinesvisible     = false,
        xgridvisible       = false,
        ygridvisible       = false,
        zgridvisible       = false,
        xypanelvisible     = false,
        xzpanelvisible     = false,
        yzpanelvisible     = false,
    )
    plt = QuantumOpticsBase.blochsphereplot_axis(ax, state; limits, kwargs...)
    return fig, ax, plt
end

end # module

@testitem "test_jet" tags = [:jet] begin
using Test
using QuantumOpticsBase
using JET

@testset "jet" begin
    JET.test_package(QuantumOpticsBase, target_modules = (QuantumOpticsBase,))
end # testset
end

@testitem "OpenCL" tags = [:opencl] begin

    include("implementation/test_platform.jl")

    import pocl_jll
    using OpenCL: CLArray, cl
    const AT = CLArray

    const can_run = try
        length(cl.platforms()) > 0 && any(
            length(cl.devices(platform)) > 0 for platform in cl.platforms()
        )
    catch
        false
    end

    @testset "Device availability" begin
        @test can_run
    end

    if can_run
        synchronize() = cl.finish(cl.queue())
        test_platform(AT, synchronize)
    else
        @info "Skipping OpenCL tests - no devices available"
    end

end

"""
    ChargeBasis(ncut) <: Basis

Basis spanning `-ncut, ..., ncut` charge states, which are the fourier modes
(irreducible representations) of a continuous U(1) degree of freedom, truncated
at `ncut`.

The charge basis is a natural representation for circuit-QED elements such as
the "transmon", which has a hamiltonian of the form
```julia
b = ChargeBasis(ncut)
H = 4E_C * (n_g * identityoperator(b) + chargeop(b))^2 - E_J * cosφ(b)
```
with energies periodic in the charge offset `n_g`.
See e.g. https://arxiv.org/abs/2005.12667.
"""
struct ChargeBasis{T} <: Basis
    shape::Vector{T}
    dim::T
    ncut::T
    function ChargeBasis(ncut::T) where {T}
        if ncut < 0
            throw(DimensionMismatch())
        end
        dim = 2 * ncut + 1
        new{T}([dim], dim, ncut)
    end
end

Base.:(==)(b1::ChargeBasis, b2::ChargeBasis) = (b1.ncut == b2.ncut)

"""
    ShiftedChargeBasis(nmin, nmax) <: Basis

Basis spanning `nmin, ..., nmax` charge states. See [`ChargeBasis`](@ref).
"""
struct ShiftedChargeBasis{T} <: Basis
    shape::Vector{T}
    dim::T
    nmin::T
    nmax::T
    function ShiftedChargeBasis(nmin::T, nmax::T) where {T}
        if nmax <= nmin
            throw(DimensionMismatch())
        end
        dim = nmax - nmin + 1
        new{T}([dim], dim, nmin, nmax)
    end
end

Base.:(==)(b1::ShiftedChargeBasis, b2::ShiftedChargeBasis) =
    (b1.nmin == b2.nmin && b1.nmax == b2.nmax)

"""
    chargestate([T=ComplexF64,] b::ChargeBasis, n)
    chargestate([T=ComplexF64,] b::ShiftedChargeBasis, n)

Charge state ``|n⟩`` for given [`ChargeBasis`](@ref) or [`ShiftedChargeBasis`](@ref).
"""
chargestate(::Type{T}, b::ChargeBasis, n::Integer) where {T} =
    basisstate(T, b, n + b.ncut + 1)

chargestate(::Type{T}, b::ShiftedChargeBasis, n::Integer) where {T} =
    basisstate(T, b, n - b.nmin + 1)

chargestate(b, n) = chargestate(ComplexF64, b, n)

"""
    chargeop([T=ComplexF64,] b::ChargeBasis)
    chargeop([T=ComplexF64,] b::ShiftedChargeBasis)

Return diagonal charge operator ``N`` for given [`ChargeBasis`](@ref) or
[`ShiftedChargeBasis`](@ref).
"""
function chargeop(::Type{T}, b::ChargeBasis) where {T}
    data = spdiagm(T.(-b.ncut:1:b.ncut))
    return SparseOperator(b, b, data)
end

function chargeop(::Type{T}, b::ShiftedChargeBasis) where {T}
    data = spdiagm(T.(b.nmin:1:b.nmax))
    return SparseOperator(b, b, data)
end

chargeop(b) = chargeop(ComplexF64, b)

"""
    expiφ([T=ComplexF64,] b::ChargeBasis, k=1)
    expiφ([T=ComplexF64,] b::ShiftedChargeBasis, k=1)

Return operator ``\\exp(i k φ)`` for given [`ChargeBasis`](@ref) or
[`ShiftedChargeBasis`](@ref), representing the continous U(1) degree of
freedom conjugate to the charge. This is a "shift" operator that shifts
the charge by `k`.
"""
function expiφ(::Type{T}, b::ChargeBasis; k=1) where {T}
    if abs(k) > 2 * b.ncut
        data = spzeros(T, b.dim, b.dim)
    else
        v = ones(T, b.dim - abs(k))
        data = spdiagm(-k => v)
    end
    return SparseOperator(b, b, data)
end

function expiφ(::Type{T}, b::ShiftedChargeBasis; k=1) where {T}
    if abs(k) > b.dim - 1
        data = spzeros(T, b.dim, b.dim)
    else
        v = ones(T, b.dim - abs(k))
        data = spdiagm(-k => v)
    end
    return SparseOperator(b, b, data)
end

expiφ(b; kwargs...) = expiφ(ComplexF64, b; kwargs...)

"""
    cosφ([T=ComplexF64,] b::ChargeBasis; k=1)
    cosφ([T=ComplexF64,] b::ShiftedChargeBasis; k=1)

Return operator ``\\cos(k φ)`` for given charge basis. See [`expiφ`](@ref).
"""
function cosφ(::Type{T}, b::Union{ChargeBasis,ShiftedChargeBasis}; k=1) where {T}
    d = expiφ(b; k=k)
    return (d + d') / 2
end

cosφ(b; kwargs...) = cosφ(ComplexF64, b; kwargs...)

"""
    sinφ([T=ComplexF64,] b::ChargeBasis; k=1)
    sinφ([T=ComplexF64,] b::ShiftedChargeBasis; k=1)

Return operator ``\\sin(k φ)`` for given charge basis. See [`expiφ`](@ref).
"""
function sinφ(::Type{T}, b::Union{ChargeBasis,ShiftedChargeBasis}; k=1) where {T}
    d = expiφ(b; k=k)
    return (d - d') / 2im
end

sinφ(b; kwargs...) = sinφ(ComplexF64, b; kwargs...)

@testitem "test_sciml_broadcast_interfaces" begin
using Test
using QuantumOptics
using OrdinaryDiffEq

@testset "sciml interface" begin

# ket ODE problem
ℋ = SpinBasis(1//2)
↓ = spindown(ℋ)
t₀, t₁ = (0.0, pi)
σx = sigmax(ℋ)
iσx = im*σx
schrod!(dψ, ψ, p, t) = QuantumOptics.mul!(dψ, iσx, ψ)

ix = iσx.data
schrod_data!(dψ,ψ,p,t) = QuantumOptics.mul!(dψ, ix, ψ)
u0 = (↓).data

prob! = ODEProblem(schrod!, ↓, (t₀, t₁))
prob_data! = ODEProblem(schrod_data!, u0, (t₀, t₁))
sol = solve(prob!, DP5(); reltol = 1.0e-8, abstol = 1.0e-10, save_everystep=false)
sol_data = solve(prob_data!, DP5(); reltol = 1.0e-8, abstol = 1.0e-10, save_everystep=false)

@test sol[end].data ≈ sol_data[end] 

# dense operator ODE problem
σ₋ = sigmam(ℋ)
σ₊ = σ₋'
mhalfσ₊σ₋ = -σ₊*σ₋/2
ρ0 = dm(↓)
tmp = zero(ρ0)
function lind!(dρ,ρ,p,t)
	QuantumOptics.mul!(tmp, ρ, σ₊)
	QuantumOptics.mul!(dρ, σ₋, ρ)
	QuantumOptics.mul!(dρ,    ρ, mhalfσ₊σ₋, true, true)
	QuantumOptics.mul!(dρ, mhalfσ₊σ₋,    ρ, true, true)
	QuantumOptics.mul!(dρ,  iσx,    ρ, -ComplexF64(1),   ComplexF64(1))
	QuantumOptics.mul!(dρ,    ρ,  iσx,  true,   true)
	return dρ
end
m0 = ρ0.data
σ₋d = σ₋.data
σ₊d = σ₊.data
mhalfσ₊σ₋d = mhalfσ₊σ₋.data
tmpd = zero(m0)
function lind_data!(dρ,ρ,p,t)
    QuantumOptics.mul!(tmpd, ρ, σ₊d)
    QuantumOptics.mul!(dρ, σ₋d, ρ)
    QuantumOptics.mul!(dρ,  ρ, mhalfσ₊σ₋d, true, true)
    QuantumOptics.mul!(dρ, mhalfσ₊σ₋d, ρ, true, true)
    QuantumOptics.mul!(dρ,  ix,  ρ, -ComplexF64(1),   ComplexF64(1))
    QuantumOptics.mul!(dρ,  ρ,  ix,  true,   true)
    return dρ
end

prob! = ODEProblem(lind!, ρ0, (t₀, t₁))
prob_data! = ODEProblem(lind_data!, m0, (t₀, t₁))
sol = solve(prob!, DP5(); reltol = 1.0e-8, abstol = 1.0e-10, save_everystep=false)
sol_data = solve(prob_data!, DP5(); reltol = 1.0e-8, abstol = 1.0e-10, save_everystep=false)

@test sol[end].data ≈ sol_data[end]

end
end

import QuantumInterface
import Base: isequal, ==, +, -, *, /, Broadcast
import Adapt
using Base.Cartesian

"""
    Operator{BL,BR,T} <: DataOperator{BL,BR}

Operator type that stores the representation of an operator on the Hilbert spaces
given by `BL` and `BR` (e.g. a Matrix).
"""
mutable struct Operator{BL,BR,T} <: DataOperator{BL,BR}
    basis_l::BL
    basis_r::BR
    data::T
    function Operator{BL,BR,T}(basis_l::BL,basis_r::BR,data::T) where {BL,BR,T}
        (length.((basis_l,basis_r))==size(data)) || throw(DimensionMismatch("Tried to assign data of size $(size(data)) to bases of length $(length(basis_l)) and $(length(basis_r))!"))
        new(basis_l,basis_r,data)
    end
end
Operator{BL,BR}(basis_l::BL,basis_r::BR,data::T) where {BL,BR,T} = Operator{BL,BR,T}(basis_l,basis_r,data)
Operator(basis_l::BL,basis_r::BR,data::T) where {BL,BR,T} = Operator{BL,BR,T}(basis_l,basis_r,data)
Operator(b::Basis,data) = Operator(b,b,data)
Operator(qet1::Ket, qetva::Ket...) = Operator(qet1.basis, GenericBasis(length(qetva)+1), qet1, qetva...)
Operator(basis_r::Basis,qet1::Ket,qetva::Ket...) = Operator(qet1.basis, basis_r, qet1, qetva...)
Operator(basis_l::BL,basis_r::BR,qet1::Ket,qetva::Ket...) where {BL,BR} = Operator{BL,BR}(basis_l, basis_r, hcat(qet1.data, getfield.(qetva,:data)...))
Operator(qets::AbstractVector{<:Ket}) = Operator(first(qets).basis, GenericBasis(length(qets)), qets)
Operator(basis_r::Basis,qets::AbstractVector{<:Ket}) = Operator(first(qets).basis, basis_r, qets)
Operator(basis_l::BL,basis_r::BR,qets::AbstractVector{<:Ket}) where {BL,BR} = Operator{BL,BR}(basis_l, basis_r, reduce(hcat, getfield.(qets, :data)))

QuantumInterface.traceout!(s::QuantumOpticsBase.Operator, i) = QuantumInterface.ptrace(s,i)

Base.zero(op::Operator) = Operator(op.basis_l,op.basis_r,zero(op.data))
Base.eltype(op::Operator) = eltype(op.data)
Base.eltype(::Type{T}) where {BL,BR,D,T<:Operator{BL,BR,D}} = eltype(D)
Base.size(op::Operator) = size(op.data)
Base.size(op::Operator, d::Int) = size(op.data, d)
function Base.convert(::Type{Operator{BL,BR,T}}, op::Operator{BL,BR,S}) where {BL,BR,T,S}
    if T==S
        return op
    else
        return Operator{BL,BR,T}(op.basis_l, op.basis_r, convert(T, op.data))
    end
end

# Convert data to CuArray with cu(::Operator)
Adapt.adapt_structure(to, x::Operator) = Operator(x.basis_l, x.basis_r, Adapt.adapt(to, x.data))

const DenseOpPureType{BL,BR} = Operator{BL,BR,<:Matrix}
const DenseOpAdjType{BL,BR} = Operator{BL,BR,<:Adjoint{<:Number,<:Matrix}}
const DenseOpType{BL,BR} = Union{DenseOpPureType{BL,BR},DenseOpAdjType{BL,BR}}
const AdjointOperator{BL,BR} = Operator{BL,BR,<:Adjoint}

"""
    DenseOperator(b1[, b2, data])

Dense array implementation of Operator. Converts any given data to a dense `Matrix`.
"""
DenseOperator(basis_l::Basis,basis_r::Basis,data::T) where T = Operator(basis_l,basis_r,Matrix(data))
DenseOperator(basis_l::Basis,basis_r::Basis,data::Matrix) = Operator(basis_l,basis_r,data)
DenseOperator(b::Basis, data) = DenseOperator(b, b, data)
DenseOperator(::Type{T},b1::Basis,b2::Basis) where T = Operator(b1,b2,zeros(T,length(b1),length(b2)))
DenseOperator(::Type{T},b::Basis) where T = Operator(b,b,zeros(T,length(b),length(b)))
DenseOperator(b1::Basis, b2::Basis) = DenseOperator(ComplexF64, b1, b2)
DenseOperator(b::Basis) = DenseOperator(ComplexF64, b)
DenseOperator(op::DataOperator) = DenseOperator(op.basis_l,op.basis_r,Matrix(op.data))

Base.copy(x::Operator) = Operator(x.basis_l, x.basis_r, copy(x.data))

"""
    dense(op::AbstractOperator)

Convert an arbitrary Operator into a [`DenseOperator`](@ref).
"""
dense(x::AbstractOperator) = DenseOperator(x)

isequal(x::DataOperator{BL,BR}, y::DataOperator{BL,BR}) where {BL,BR} = (samebases(x,y) && isequal(x.data, y.data))
==(x::DataOperator{BL,BR}, y::DataOperator{BL,BR}) where {BL,BR} = (samebases(x,y) && x.data==y.data)
==(x::DataOperator, y::DataOperator) = false
Base.isapprox(x::DataOperator{BL,BR}, y::DataOperator{BL,BR}; kwargs...) where {BL,BR} = (samebases(x,y) && isapprox(x.data, y.data; kwargs...))
Base.isapprox(x::DataOperator, y::DataOperator; kwargs...) = false

# Arithmetic operations
+(a::Operator{BL,BR}, b::Operator{BL,BR}) where {BL,BR} = Operator(a.basis_l, a.basis_r, a.data+b.data)
+(a::Operator, b::Operator) = throw(IncompatibleBases())

-(a::Operator) = Operator(a.basis_l, a.basis_r, -a.data)
-(a::Operator{BL,BR}, b::Operator{BL,BR}) where {BL,BR} = Operator(a.basis_l, a.basis_r, a.data-b.data)
-(a::Operator, b::Operator) = throw(IncompatibleBases())

*(a::Operator{BL,BR}, b::Ket{BR}) where {BL,BR} = Ket{BL}(a.basis_l, a.data*b.data)
*(a::DataOperator, b::Ket) = throw(IncompatibleBases())
*(a::Bra{BL}, b::Operator{BL,BR}) where {BL,BR} = Bra{BR}(b.basis_r, transpose(b.data)*a.data)
*(a::Bra, b::DataOperator) = throw(IncompatibleBases())
*(a::Operator{B1,B2}, b::Operator{B2,B3}) where {B1,B2,B3} = Operator(a.basis_l, b.basis_r, a.data*b.data)
*(a::DataOperator, b::DataOperator) = throw(IncompatibleBases())
*(a::DataOperator{B1, B2}, b::Operator{B2, B3, T}) where {B1, B2, B3, T} = error("no `*` method defined for DataOperator subtype $(typeof(a))") # defined to avoid method ambiguity
*(a::Operator{B1, B2, T}, b::DataOperator{B2, B3}) where {B1, B2, B3, T} = error("no `*` method defined for DataOperator subtype $(typeof(b))") # defined to avoid method ambiguity
*(a::Operator, b::Number) = Operator(a.basis_l, a.basis_r, b*a.data)
*(a::Number, b::Operator) = Operator(b.basis_l, b.basis_r, a*b.data)
function *(op1::AbstractOperator{B1,B2}, op2::Operator{B2,B3,T}) where {B1,B2,B3,T}
    result = Operator{B1,B3}(op1.basis_l, op2.basis_r, similar(_parent(op2.data),promote_type(eltype(op1),eltype(op2)),length(op1.basis_l),length(op2.basis_r)))
    mul!(result,op1,op2)
    return result
end
function *(op1::Operator{B1,B2,T}, op2::AbstractOperator{B2,B3}) where {B1,B2,B3,T}
    result = Operator{B1,B3}(op1.basis_l, op2.basis_r, similar(_parent(op1.data),promote_type(eltype(op1),eltype(op2)),length(op1.basis_l),length(op2.basis_r)))
    mul!(result,op1,op2)
    return result
end
function *(op::AbstractOperator{BL,BR}, psi::Ket{BR,T}) where {BL,BR,T}
    result = Ket{BL,T}(op.basis_l,similar(psi.data,length(op.basis_l)))
    mul!(result,op,psi)
    return result
end
function *(psi::Bra{BL,T}, op::AbstractOperator{BL,BR}) where {BL,BR,T}
    result = Bra{BR,T}(op.basis_r, similar(psi.data,length(op.basis_r)))
    mul!(result,psi,op)
    return result
end

_parent(x::T, x_parent::T) where T = x
_parent(x, x_parent) = _parent(x_parent, parent(x_parent))
_parent(x) = _parent(x, parent(x))

/(a::Operator, b::Number) = Operator(a.basis_l, a.basis_r, a.data ./ b)

dagger(x::Operator) = Operator(x.basis_r,x.basis_l,adjoint(x.data))
transpose(x::Operator) = Operator(x.basis_r,x.basis_l,transpose(x.data))
ishermitian(A::DataOperator) = false
ishermitian(A::DataOperator{B,B}) where B = ishermitian(A.data)
Base.collect(A::Operator) = Operator(A.basis_l, A.basis_r, collect(A.data))

tensor(a::Operator, b::Operator) = Operator(tensor(a.basis_l, b.basis_l), tensor(a.basis_r, b.basis_r), kron(b.data, a.data))

conj(a::Operator) = Operator(a.basis_l, a.basis_r, conj(a.data))
conj!(a::Operator) = (conj!(a.data); a)


"""
    tensor(x::Ket, y::Bra)

Outer product ``|x⟩⟨y|`` of the given states.
"""
tensor(a::Ket, b::Bra) = Operator(a.basis, b.basis, reshape(kron(b.data, a.data), length(a.basis), length(b.basis)))

"""
    tensor(a::AbstractOperator, b::Bra)
    tensor(a::Bra, b::AbstractOperator)
    tensor(a::AbstractOperator, b::Ket)
    tensor(a::Ket, b::AbstractOperator)

Products of operators and state vectors ``a ⊗ <b|``. The result is an isometry
in case the operator is unitary and state is normalized.
"""
function tensor(a::AbstractOperator, b::Bra)
    # upgrade the bra to an operator that projects onto a dim-1 space
    # NOTE: copy() works around non-sparse-preserving kron in case b.data is a SparseVector.
    b_op = Operator(GenericBasis(1), basis(b), copy(reshape(b.data, (1,:))))
    ab_op = tensor(a, b_op)
    # squeeze out the trivial dimension
    Operator(a.basis_l, ab_op.basis_r, ab_op.data)
end

function tensor(a::Bra, b::AbstractOperator)
    # upgrade the bra to an operator that projects onto a dim-1 space
    a_op = Operator(GenericBasis(1), basis(a), copy(reshape(a.data, (1,:))))
    ab_op = tensor(a_op, b)
    # squeeze out the trivial dimension
    Operator(b.basis_l, ab_op.basis_r, ab_op.data)
end

function tensor(a::AbstractOperator, b::Ket)
    # upgrade the bra to an operator that projects onto a dim-1 space
    b_op = Operator(basis(b), GenericBasis(1), copy(reshape(b.data, (:,1))))
    ab_op = tensor(a, b_op)
    # squeeze out the trivial dimension
    Operator(ab_op.basis_l, a.basis_r, ab_op.data)
end

function tensor(a::Ket, b::AbstractOperator)
    # upgrade the bra to an operator that projects onto a dim-1 space
    a_op = Operator(basis(a), GenericBasis(1), copy(reshape(a.data, (:,1))))
    ab_op = tensor(a_op, b)
    # squeeze out the trivial dimension
    Operator(ab_op.basis_l, b.basis_r, ab_op.data)
end

tr(op::Operator{B,B}) where B = tr(op.data)

function ptrace(a::DataOperator, indices)
    check_ptrace_arguments(a, indices)
    rank = length(a.basis_l.shape)
    result = _ptrace(Val{rank}, a.data, a.basis_l.shape, a.basis_r.shape, indices)
    return Operator(ptrace(a.basis_l, indices), ptrace(a.basis_r, indices), result)
end
ptrace(op::AdjointOperator, indices) = dagger(ptrace(op, indices))

function ptrace(psi::Ket, indices)
    check_ptrace_arguments(psi, indices)
    b = basis(psi)
    b_ = ptrace(b, indices)
    rank = length(b.shape)
    result = _ptrace_ket(Val{rank}, psi.data, b.shape, indices)::Matrix{eltype(psi)}
    return Operator(b_, b_, result)
end

function ptrace(psi::Bra, indices)
    check_ptrace_arguments(psi, indices)
    b = basis(psi)
    b_ = ptrace(b, indices)
    rank = length(b.shape)
    result = _ptrace_bra(Val{rank}, psi.data, b.shape, indices)::Matrix{eltype(psi)}
    return Operator(b_, b_, result)
end

normalize!(op::Operator) = (rmul!(op.data, 1.0/tr(op)); op)

function expect(op::DataOperator{B,B}, state::Ket{B}) where B
    dot(state.data, op.data, state.data)
end

function expect(op::DataOperator{B1,B2}, state::DataOperator{B2,B2}) where {B1,B2}
    check_samebases(op, state)
    result = zero(promote_type(eltype(op),eltype(state)))
    @inbounds for i=1:size(op.data, 1), j=1:size(op.data,2)
        result += op.data[i,j]*state.data[j,i]
    end
    result
end

"""
    exp(op::DenseOpType)

Operator exponential used, for example, to calculate displacement operators.
Uses LinearAlgebra's `Base.exp`.

If you only need the result of the exponential acting on a vector,
consider using much faster implicit methods that do not calculate the entire exponential.
"""
function exp(op::T) where {B,T<:DenseOpType{B,B}}
    return DenseOperator(op.basis_l, op.basis_r, exp(op.data))
end

function permutesystems(a::Operator{B1,B2}, perm) where {B1<:CompositeBasis,B2<:CompositeBasis}
    @assert length(a.basis_l.bases) == length(a.basis_r.bases) == length(perm)
    @assert isperm(perm)
    data = Base.ReshapedArray(a.data, (a.basis_l.shape..., a.basis_r.shape...), ())
    data = PermutedDimsArray(data, [perm; perm .+ length(perm)])
    data = Base.ReshapedArray(data, (length(a.basis_l), length(a.basis_r)), ())
    return Operator(permutesystems(a.basis_l, perm), permutesystems(a.basis_r, perm), copy(data))
end
permutesystems(a::AdjointOperator{B1,B2}, perm) where {B1<:CompositeBasis,B2<:CompositeBasis} = dagger(permutesystems(dagger(a),perm))

identityoperator(::Type{S}, ::Type{T}, b1::Basis, b2::Basis) where {S<:DenseOpType,T<:Number} =
    Operator(b1, b2, Matrix{T}(I, length(b1), length(b2)))

"""
    projector(a::Ket, b::Bra)

Projection operator ``|a⟩⟨b|``.
"""
projector(a::Ket, b::Bra) = tensor(a, b)
"""
    projector(a::Ket)

Projection operator ``|a⟩⟨a|``.
"""
projector(a::Ket) = Operator(a.basis, a.data*a.data')
"""
    projector(a::Bra)

Projection operator ``|a⟩⟨a|``.
"""
projector(a::Bra) = projector(a')

"""
    dm(a::StateVector)

Create density matrix ``|a⟩⟨a|``. Same as `projector(a)`.
"""
dm(x::Ket) = tensor(x, dagger(x))
dm(x::Bra) = tensor(dagger(x), x)


# Partial trace implementation for dense operators.
function _strides(shape)
    N = length(shape)
    S = zeros(eltype(shape), N)
    S[1] = 1
    for m=2:N
        S[m] = S[m-1]*shape[m-1]
    end
    return S
end

function _strides(shape::Ty)::Ty where Ty <: Tuple
    accumulate(*, (1,Base.front(shape)...))
end

# Dense operator version
@generated function _ptrace(::Type{Val{RANK}}, a,
                            shape_l, shape_r,
                            indices) where RANK
    return quote
        a_strides_l = _strides(shape_l)
        result_shape_l = copy(shape_l)
        @inbounds for idx ∈ indices
            result_shape_l[idx] = 1
        end
        result_strides_l = _strides(result_shape_l)
        a_strides_r = _strides(shape_r)
        result_shape_r = copy(shape_r)
        @inbounds for idx ∈ indices
            result_shape_r[idx] = 1
        end
        result_strides_r = _strides(result_shape_r)
        N_result_l = prod(result_shape_l)
        N_result_r = prod(result_shape_r)
        result = zeros(eltype(a), N_result_l, N_result_r)
        @nexprs 1 (d->(Jr_{$RANK}=1;Ir_{$RANK}=1))
        @nloops $RANK ir (d->1:shape_r[d]) (d->(Ir_{d-1}=Ir_d; Jr_{d-1}=Jr_d)) (d->(Ir_d+=a_strides_r[d]; if !(d in indices) Jr_d+=result_strides_r[d] end)) begin
            @nexprs 1 (d->(Jl_{$RANK}=1;Il_{$RANK}=1))
            @nloops $RANK il (k->1:shape_l[k]) (k->(Il_{k-1}=Il_k; Jl_{k-1}=Jl_k; if (k in indices && il_k!=ir_k) Il_k+=a_strides_l[k]; continue end)) (k->(Il_k+=a_strides_l[k]; if !(k in indices) Jl_k+=result_strides_l[k] end)) begin
                result[Jl_0, Jr_0] += a[Il_0, Ir_0]
            end
        end
        return result
    end
end

@generated function _ptrace_ket(::Type{Val{RANK}}, a,
                            shape, indices) where RANK
    return quote
        a_strides = _strides(shape)
        result_shape = copy(shape)
        @inbounds for idx ∈ indices
            result_shape[idx] = 1
        end
        result_strides = _strides(result_shape)
        N_result = prod(result_shape)
        result = zeros(eltype(a), N_result, N_result)
        @nexprs 1 (d->(Jr_{$RANK}=1;Ir_{$RANK}=1))
        @nloops $RANK ir (d->1:shape[d]) (d->(Ir_{d-1}=Ir_d; Jr_{d-1}=Jr_d)) (d->(Ir_d+=a_strides[d]; if !(d in indices) Jr_d+=result_strides[d] end)) begin
            @nexprs 1 (d->(Jl_{$RANK}=1;Il_{$RANK}=1))
            @nloops $RANK il (k->1:shape[k]) (k->(Il_{k-1}=Il_k; Jl_{k-1}=Jl_k; if (k in indices && il_k!=ir_k) Il_k+=a_strides[k]; continue end)) (k->(Il_k+=a_strides[k]; if !(k in indices) Jl_k+=result_strides[k] end)) begin
                result[Jl_0, Jr_0] += a[Il_0]*conj(a[Ir_0])
            end
        end
        return result
    end
end

@generated function _ptrace_bra(::Type{Val{RANK}}, a,
                            shape, indices) where RANK
    return quote
        a_strides = _strides(shape)
        result_shape = copy(shape)
        @inbounds for idx ∈ indices
            result_shape[idx] = 1
        end
        result_strides = _strides(result_shape)
        N_result = prod(result_shape)
        result = zeros(eltype(a), N_result, N_result)
        @nexprs 1 (d->(Jr_{$RANK}=1;Ir_{$RANK}=1))
        @nloops $RANK ir (d->1:shape[d]) (d->(Ir_{d-1}=Ir_d; Jr_{d-1}=Jr_d)) (d->(Ir_d+=a_strides[d]; if !(d in indices) Jr_d+=result_strides[d] end)) begin
            @nexprs 1 (d->(Jl_{$RANK}=1;Il_{$RANK}=1))
            @nloops $RANK il (k->1:shape[k]) (k->(Il_{k-1}=Il_k; Jl_{k-1}=Jl_k; if (k in indices && il_k!=ir_k) Il_k+=a_strides[k]; continue end)) (k->(Il_k+=a_strides[k]; if !(k in indices) Jl_k+=result_strides[k] end)) begin
                result[Jl_0, Jr_0] += conj(a[Il_0])*a[Ir_0]
            end
        end
        return result
    end
end

"""
    mul!(Y::DataOperator,A::AbstractOperator,B::DataOperator,alpha,beta) -> Y
    mul!(Y::StateVector,A::AbstractOperator,B::StateVector,alpha,beta) -> Y

Fast in-place multiplication of operators/state vectors. Updates `Y` as
`Y = alpha*A*B + beta*Y`. In most cases, the call gets forwarded to
Julia's 5-arg mul! implementation on the underlying data.
See also [`LinearAlgebra.mul!`](@ref).
"""
mul!(result::Operator{B1,B3},a::Operator{B1,B2},b::Operator{B2,B3},alpha,beta) where {B1,B2,B3} = (LinearAlgebra.mul!(result.data,a.data,b.data,alpha,beta); result)
mul!(result::Ket{B1},a::Operator{B1,B2},b::Ket{B2},alpha,beta) where {B1,B2} = (LinearAlgebra.mul!(result.data,a.data,b.data,alpha,beta); result)
mul!(result::Bra{B2},a::Bra{B1},b::Operator{B1,B2},alpha,beta) where {B1,B2} = (LinearAlgebra.mul!(result.data,transpose(b.data),a.data,alpha,beta); result)
rmul!(op::Operator, x) = (rmul!(op.data, x); op)

# Multiplication for Operators in terms of their gemv! implementation
function mul!(result::Operator{B1,B3},M::AbstractOperator{B1,B2},b::Operator{B2,B3},alpha,beta) where {B1,B2,B3}
    for i=1:size(b.data, 2)
        bket = Ket(b.basis_l, b.data[:,i])
        resultket = Ket(M.basis_l, result.data[:,i])
        mul!(resultket,M,bket,alpha,beta)
        result.data[:,i] = resultket.data
    end
    return result
end

function mul!(result::Operator{B1,B3},b::Operator{B1,B2},M::AbstractOperator{B2,B3},alpha,beta) where {B1,B2,B3}
    for i=1:size(b.data, 1)
        bbra = Bra(b.basis_r, vec(b.data[i,:]))
        resultbra = Bra(M.basis_r, vec(result.data[i,:]))
        mul!(resultbra,bbra,M,alpha,beta)
        result.data[i,:] = resultbra.data
    end
    return result
end

# Broadcasting
Base.size(A::DataOperator) = size(A.data)
Base.size(A::DataOperator, d) = size(A.data, d)
Base.size(A::DataOperator, d::Int) = size(A.data, d) # defined to avoid method ambiguity
@inline Base.axes(A::DataOperator) = axes(A.data)
Base.broadcastable(A::DataOperator) = A

# Custom broadcasting styles
abstract type DataOperatorStyle{BL,BR} <: Broadcast.BroadcastStyle end
struct OperatorStyle{BL,BR} <: DataOperatorStyle{BL,BR} end

# Style precedence rules
Broadcast.BroadcastStyle(::Type{<:Operator{BL,BR}}) where {BL,BR} = OperatorStyle{BL,BR}()
Broadcast.BroadcastStyle(::OperatorStyle{B1,B2}, ::OperatorStyle{B3,B4}) where {B1,B2,B3,B4} = throw(IncompatibleBases())

# Broadcast with scalars (of use in ODE solvers checking for tolerances, e.g. `.* reltol .+ abstol`)
Broadcast.BroadcastStyle(::T, ::Broadcast.DefaultArrayStyle{0}) where {Bl<:Basis, Br<:Basis, T<:OperatorStyle{Bl,Br}} = T()

# Out-of-place broadcasting
@inline function Base.copy(bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {BL,BR,Style<:OperatorStyle{BL,BR},Axes,F,Args<:Tuple}
    bcf = Broadcast.flatten(bc)
    bl,br = find_basis(bcf.args)
    T = find_dType(bcf)
    data = zeros(T, length(bl), length(br))
    @inbounds @simd for I in eachindex(bcf)
        data[I] = bcf[I]
    end
    return Operator{BL,BR}(bl, br, data)
end

find_basis(a::DataOperator, rest) = (a.basis_l, a.basis_r)
find_dType(a::DataOperator, rest) = eltype(a)
@inline Base.getindex(a::DataOperator, idx) = getindex(a.data, idx)
Base.@propagate_inbounds Base.Broadcast._broadcast_getindex(x::DataOperator, i) = x.data[i]
Base.iterate(a::DataOperator) = iterate(a.data)
Base.iterate(a::DataOperator, idx) = iterate(a.data, idx)

# In-place broadcasting
@inline function Base.copyto!(dest::DataOperator{BL,BR}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {BL,BR,Style<:DataOperatorStyle{BL,BR},Axes,F,Args}
    axes(dest) == axes(bc) || Base.Broadcast.throwdm(axes(dest), axes(bc))
    bc′ = Base.Broadcast.preprocess(dest, bc)
    dest′ = dest.data
    @inbounds @simd for I in eachindex(bc′)
        dest′[I] = bc′[I]
    end
    return dest
end
# same implementation as Base.copyto!(dest::AbstractArray, bc::Broadcasted{<:AbstractArrayStyle{0}}) in https://github.com/JuliaLang/julia/blob/master/base/broadcast.jl
@inline function Base.copyto!(dest::DataOperator{BL,BR}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {BL,BR,Style<:Broadcast.DefaultArrayStyle{0},Axes,F,Args}
    # Typically, we must independently execute bc for every storage location in `dest`, but:
    # IF we're in the common no-op identity case with no nested args (like `dest .= val`),
    if bc.f === identity && bc.args isa Tuple{Any} && Broadcast.isflat(bc)
        # THEN we can just extract the argument and `fill!` the destination with it
        return fill!(dest, bc.args[1][])
    else
        throw(ArgumentError("no fallback implementation has been defined outside of dest .= val."))
    end
end
@inline Base.copyto!(A::DataOperator{BL,BR},B::DataOperator{BL,BR}) where {BL,BR} = (copyto!(A.data,B.data); A)
@inline Base.copyto!(dest::DataOperator{BL,BR}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {BL,BR,Style<:DataOperatorStyle,Axes,F,Args} =
    throw(IncompatibleBases())

# A few more standard interfaces: These do not necessarily make sense for a StateVector, but enable transparent use of DifferentialEquations.jl
Base.eltype(::Type{Operator{Bl,Br,A}}) where {Bl,Br,N,A<:AbstractMatrix{N}} = N # ODE init
Base.any(f::Function, x::Operator; kwargs...) = any(f, x.data; kwargs...) # ODE nan checks
Base.all(f::Function, x::Operator; kwargs...) = all(f, x.data; kwargs...)
Base.fill!(x::Operator, a) = typeof(x)(x.basis_l, x.basis_r, fill!(x.data, a))
Base.ndims(x::Type{Operator{Bl,Br,A}}) where {Bl,Br,N,A<:AbstractMatrix{N}} = ndims(A)
Base.similar(x::Operator, t) = typeof(x)(x.basis_l, x.basis_r, copy(x.data))
RecursiveArrayTools.recursivecopy!(dest::Operator{Bl,Br,A},src::Operator{Bl,Br,A}) where {Bl,Br,A} = copyto!(dest,src) # ODE in-place equations
RecursiveArrayTools.recursivecopy(x::Operator) = copy(x)
RecursiveArrayTools.recursivecopy(x::AbstractArray{T}) where {T<:Operator} = copy(x)
RecursiveArrayTools.recursivefill!(x::Operator, a) = fill!(x, a)

function gemm_sp_dense_small(alpha, M::SparseMatrixCSC, B::AbstractMatrix, result::AbstractMatrix)
    if isone(alpha)
        @inbounds for colindex = 1:M.n
            @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                row = M.rowval[i]
                val = M.nzval[i]
                @inbounds for j=1:size(B, 2)
                    result[row, j] += val*B[colindex, j]
                end
            end
        end
    else
        @inbounds for colindex = 1:M.n
            @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                row = M.rowval[i]
                val = alpha*M.nzval[i]
                @inbounds for j=1:size(B, 2)
                    result[row, j] += val*B[colindex, j]
                end
            end
        end
    end
end

function gemm_sp_dense_big(alpha, M::SparseMatrixCSC, B::AbstractMatrix, result::AbstractMatrix)
    if isone(alpha)
        @inbounds for j=1:size(B, 2)
            @inbounds for colindex = 1:M.n
                m2 = B[colindex, j]
                @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                    row = M.rowval[i]
                    result[row, j] += M.nzval[i]*m2
                end
            end
        end
    else
        @inbounds for j=1:size(B, 2)
            @inbounds for colindex = 1:M.n
                m2 = alpha*B[colindex, j]
                @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                    row = M.rowval[i]
                    result[row, j] += M.nzval[i]*m2
                end
            end
        end
    end
end

function gemm_dense_adj_sp(alpha, B::AbstractMatrix, M::SparseMatrixCSC, result::AbstractMatrix)
    if isone(alpha)
        @inbounds for colindex = 1:M.n
            @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                row = M.rowval[i]
                val = conj(M.nzval[i])
                @inbounds for j=1:size(B, 1)
                    result[j, row] += val*B[j, colindex]
                end
            end
        end
    else
        @inbounds for colindex = 1:M.n
            @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                row = M.rowval[i]
                val = alpha*conj(M.nzval[i])
                @inbounds for j=1:size(B, 1)
                    result[j, row] += val*B[j, colindex]
                end
            end
        end
    end
end

function gemm_adj_sp_dense_small(alpha, M::SparseMatrixCSC, B::AbstractMatrix, result::AbstractMatrix)
    dimB = size(result,2)
    if isone(alpha)
        @inbounds for colindex = 1:M.n
            @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                mi = conj(M.nzval[i])
                mrowvali = M.rowval[i]
                @inbounds for j=1:dimB
                    result[colindex, j] += mi*B[mrowvali, j]
                end
            end
        end
    else
        @inbounds for colindex = 1:M.n
            @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                mi = conj(M.nzval[i])*alpha
                mrowvali = M.rowval[i]
                @inbounds for j=1:dimB
                    result[colindex, j] += mi*B[mrowvali, j]
                end
            end
        end
    end
end


function gemm!(alpha, M::SparseMatrixCSC, B::AbstractMatrix, beta, result::AbstractMatrix)
    size(M, 2) == size(B, 1) || throw(DimensionMismatch())
    size(M, 1) == size(result, 1) || throw(DimensionMismatch())
    size(B, 2) == size(result, 2) || throw(DimensionMismatch())
    if iszero(beta)
        fill!(result, beta)
    elseif !isone(beta)
        rmul!(result, beta)
    end
    if nnz(M) > 550
        gemm_sp_dense_big(alpha, M, B, result)
    else
        gemm_sp_dense_small(alpha, M, B, result)
    end
end

function gemm!(alpha, B::AbstractMatrix, M::SparseMatrixCSC, beta, result::AbstractMatrix)
    size(M, 1) == size(B, 2) || throw(DimensionMismatch())
    size(M, 2) == size(result,2) || throw(DimensionMismatch())
    size(B, 1) == size(result,1) || throw(DimensionMismatch())
    if iszero(beta)
        fill!(result, beta)
    elseif !isone(beta)
        rmul!(result, beta)
    end
    dimB = size(result,1)
    if isone(alpha)
        @inbounds for colindex = 1:M.n
            @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                mi = M.nzval[i]
                mrowvali = M.rowval[i]
                @inbounds for j=1:dimB
                    result[j, colindex] += mi*B[j, mrowvali]
                end
            end
        end
    else
        @inbounds for colindex = 1:M.n
            @inbounds for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                mi = M.nzval[i]*alpha
                mrowvali = M.rowval[i]
                @inbounds for j=1:dimB
                    result[j, colindex] += mi*B[j, mrowvali]
                end
            end
        end
    end
end

function gemm!(alpha, M_::Adjoint{T,<:SparseMatrixCSC{T}}, B::AbstractMatrix, beta, result::AbstractMatrix) where T
    M = M_.parent
    if nnz(M) > 550
        LinearAlgebra.mul!(result, M_, B, alpha, beta)
    else
        size(M_, 2) == size(B, 1) || throw(DimensionMismatch())
        size(M_, 1) == size(result, 1) || throw(DimensionMismatch())
        size(B, 2) == size(result, 2) || throw(DimensionMismatch())
        if iszero(beta)
            fill!(result, beta)
        elseif !isone(beta)
            rmul!(result, beta)
        end
        gemm_adj_sp_dense_small(alpha, M, B, result)
    end
end

function gemm!(alpha, B::AbstractMatrix, M::Adjoint{T,<:SparseMatrixCSC{T}}, beta, result::AbstractMatrix) where T
    size(M, 1) == size(B, 2) || throw(DimensionMismatch())
    size(M, 2) == size(result,2) || throw(DimensionMismatch())
    size(B, 1) == size(result,1) || throw(DimensionMismatch())
    if iszero(beta)
        fill!(result, beta)
    elseif !isone(beta)
        rmul!(result, beta)
    end
    gemm_dense_adj_sp(alpha, B, M.parent, result)
end

function gemm!(alpha, A::Adjoint{T, <:SparseMatrixCSC{T}}, B::Adjoint{S, <:SparseMatrixCSC{S}}, beta, result::AbstractMatrix) where {T,S}
    error("Matrix multiplication between Adjoint{SparseCSC} and SparseCSC matrices is not implemented yet. Submit an issue to the developers.")
end
function gemm!(alpha, A::Adjoint{T, <:SparseMatrixCSC{T}}, B::SparseMatrixCSC, beta, result::AbstractMatrix) where T
    error("Matrix multiplication between Adjoint{SparseCSC} and Adjoint{SparseCSC} matrices is not implemented yet. Submit an issue to the developers.")
end
function gemm!(alpha, A::SparseMatrixCSC, B::Adjoint{T, <:SparseMatrixCSC{T}}, beta, result::AbstractMatrix) where T
    error("Matrix multiplication between SparseCSC and Adjoint{SparseCSC} matrices is not implemented yet. Submit an issue to the developers.")
end
function gemm!(alpha, A::SparseMatrixCSC, B::SparseMatrixCSC, beta, result::AbstractMatrix)
    error("Matrix multiplication between SparseCSC and SparseCSC matrices is not implemented yet. Submit an issue to the developers.")
end

function gemv!(alpha, M::SparseMatrixCSC, v::AbstractVector, beta, result::AbstractVector)
    size(M, 2) == size(v, 1) || throw(DimensionMismatch())
    size(M, 1) == size(result, 1) || throw(DimensionMismatch())

    if iszero(beta)
        fill!(result, beta)
    elseif !isone(beta)
        rmul!(result, beta)
    end
    if isone(alpha)
        @inbounds for colindex = 1:M.n
            vj = v[colindex]
            for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                result[M.rowval[i]] += M.nzval[i]*vj
            end
        end
    else
        @inbounds for colindex = 1:M.n
            vj = alpha*v[colindex]
            for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                result[M.rowval[i]] += M.nzval[i]*vj
            end
        end
    end
end

function gemv!(alpha, v::AbstractVector, M::SparseMatrixCSC, beta, result::AbstractVector)
    size(M, 1) == size(v, 1) || throw(DimensionMismatch())
    size(M, 2) == size(result, 1) || throw(DimensionMismatch())

    if iszero(beta)
        fill!(result, beta)
    elseif !isone(beta)
        rmul!(result, beta)
    end
    if isone(alpha)
        @inbounds for colindex=1:M.n
            for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                result[colindex] += M.nzval[i]*v[M.rowval[i]]
            end
        end
    else
        @inbounds for colindex=1:M.n
            for i=M.colptr[colindex]:M.colptr[colindex+1]-1
                result[colindex] += M.nzval[i]*alpha*v[M.rowval[i]]
            end
        end
    end
end

@testitem "test_operators_dense" begin
using Test
using QuantumOpticsBase
using Random, SparseArrays, LinearAlgebra

@testset "operators-dense" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x1::StateVector, x2::StateVector) = norm(x2-x1)

b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(1)
b3b = GenericBasis(5)

b_l = b1a⊗b2a⊗b3a
b_r = b1b⊗b2b⊗b3b

# Test creation
@test_throws DimensionMismatch DenseOperator(b1a, [1 1 1; 1 1 1])
@test_throws DimensionMismatch DenseOperator(b1a, b1b, [1 1; 1 1; 1 1])
op1 = DenseOperator(b1a, b1b, [1 1 1; 1 1 1])
op2 = DenseOperator(b1b, b1a, [1 1; 1 1; 1 1])
@test op1 == dagger(op2)

@test QuantumOpticsBase.is_const(op1)

## Stacking Kets to make an Operator
### signle basis
ψlist = basisstate.([GenericBasis(4)], 1:2)
@test Operator(ψlist...) == Operator(ψlist) == Operator(ψlist[1].basis, GenericBasis(length(ψlist)), hcat(getfield.(ψlist,:data)...))
@test Operator(FockBasis(length(ψlist)-1), ψlist...) == Operator(FockBasis(length(ψlist)-1), ψlist) == Operator(ψlist[1].basis, FockBasis(length(ψlist)-1),  hcat(getfield.(ψlist,:data)...))
@test Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1), ψlist...) == Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1), ψlist) == Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1),  hcat(getfield.(ψlist,:data)...))
ψlist = vcat(ψlist, basisstate.(Real, [NLevelBasis(prod(ψlist[1].basis.shape))], [1,prod(ψlist[1].basis.shape)]))
@test Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1), ψlist...) == Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1), ψlist) == Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1),  hcat(getfield.(ψlist,:data)...))
### composite basis
ψlist = basisstate.([GenericBasis(4)^2], 1:2)
@test Operator(ψlist...) == Operator(ψlist) == Operator(ψlist[1].basis, GenericBasis(length(ψlist)), hcat(getfield.(ψlist,:data)...))
@test Operator(FockBasis(length(ψlist)-1), ψlist...) == Operator(FockBasis(length(ψlist)-1), ψlist) == Operator(ψlist[1].basis, FockBasis(length(ψlist)-1),  hcat(getfield.(ψlist,:data)...))
@test Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1), ψlist...) == Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1), ψlist) == Operator(NLevelBasis(prod(ψlist[1].basis.shape)), FockBasis(length(ψlist)-1),  hcat(getfield.(ψlist,:data)...))
ψlist2= vcat(ψlist, basisstate.(Float64, [NLevelBasis(prod(ψlist[1].basis.shape))], range(prod(ψlist[1].basis.shape);step=-1,length=length(ψlist))))
@test Operator(NLevelBasis(prod(ψlist2[1].basis.shape)), FockBasis(length(ψlist)-1)^2, ψlist2...) == Operator(NLevelBasis(prod(ψlist2[1].basis.shape)), FockBasis(length(ψlist)-1)^2, ψlist2) == Operator(NLevelBasis(prod(ψlist2[1].basis.shape)), FockBasis(length(ψlist)-1)^2,  hcat(getfield.(ψlist2,:data)...))

# Test ' shorthand
@test dagger(op2) == op2'
@test transpose(op2) == conj(op2')

# Test copy
op1 = randoperator(b1a)
op2 = copy(op1)
@test op1 == op2
@test isequal(op1, op2)
@test op1.data == op2.data
@test !(op1.data === op2.data)
op2.data[1,1] = complex(10.)
@test op1.data[1,1] != op2.data[1,1]


# Arithmetic operations
# =====================
op_zero = DenseOperator(b_l, b_r)
op1 = randoperator(b_l, b_r)
op2 = randoperator(b_l, b_r)
op3 = randoperator(b_l, b_r)

x1 = Ket(b_r, rand(ComplexF64, length(b_r)))
x2 = Ket(b_r, rand(ComplexF64, length(b_r)))

xbra1 = Bra(b_l, rand(ComplexF64, length(b_l)))
xbra2 = Bra(b_l, rand(ComplexF64, length(b_l)))

# Addition
@test_throws DimensionMismatch op1 + dagger(op2)
@test 1e-14 > D(op1 + op_zero, op1)
@test 1e-14 > D(op1 + op2, op2 + op1)
@test 1e-14 > D(op1 + (op2 + op3), (op1 + op2) + op3)

# Subtraction
@test_throws DimensionMismatch op1 - dagger(op2)
@test 1e-14 > D(op1-op_zero, op1)
@test 1e-14 > D(op1-op2, op1 + (-op2))
@test 1e-14 > D(op1-op2, op1 + (-1*op2))
@test 1e-14 > D(op1-op2-op3, op1-(op2+op3))

# Test multiplication
@test_throws DimensionMismatch op1*op2
@test 1e-11 > D(op1*(x1 + 0.3*x2), op1*x1 + 0.3*op1*x2)
@test 1e-11 > D((op1+op2)*(x1+0.3*x2), op1*x1 + 0.3*op1*x2 + op2*x1 + 0.3*op2*x2)

@test 1e-11 > D((xbra1+0.3*xbra2)*op1, xbra1*op1 + 0.3*xbra2*op1)
@test 1e-11 > D((xbra1+0.3*xbra2)*(op1+op2), xbra1*op1 + 0.3*xbra2*op1 + xbra1*op2 + 0.3*xbra2*op2)

@test 1e-12 > D(op1*dagger(0.3*op2), 0.3*dagger(op2*dagger(op1)))
@test 1e-12 > D((op1 + op2)*dagger(0.3*op3), 0.3*op1*dagger(op3) + 0.3*op2*dagger(op3))
@test 1e-12 > D(0.3*(op1*dagger(op2)), op1*(0.3*dagger(op2)))

tmp = copy(op1)
conj!(tmp)
@test tmp == conj(op1) && conj(tmp.data) == op1.data

# Internal layout
b1 = GenericBasis(2)
b2 = GenericBasis(3)
b3 = GenericBasis(4)
op1 = randoperator(b1, b2)
op2 = randoperator(b2, b3)
x1 = randstate(b2)
d1 = op1.data
d2 = op2.data
v = x1.data
@test (op1*x1).data ≈ [d1[1,1]*v[1] + d1[1,2]*v[2] + d1[1,3]*v[3], d1[2,1]*v[1] + d1[2,2]*v[2] + d1[2,3]*v[3]]
@test (op1*op2).data[2,3] ≈ d1[2,1]*d2[1,3] + d1[2,2]*d2[2,3] + d1[2,3]*d2[3,3]

# Test division
@test 1e-14 > D(op1/7, (1/7)*op1)

# Tensor product
# ==============
op1a = randoperator(b1a, b1b)
op1b = randoperator(b1a, b1b)
op2a = randoperator(b2a, b2b)
op2b = randoperator(b2a, b2b)
op3a = randoperator(b3a, b3b)
op123 = op1a ⊗ op2a ⊗ op3a
@test op123.basis_l == b_l
@test op123.basis_r == b_r

# Associativity
@test 1e-13 > D((op1a ⊗ op2a) ⊗ op3a, op1a ⊗ (op2a ⊗ op3a))

# Linearity
@test 1e-13 > D(op1a ⊗ (0.3*op2a), 0.3*(op1a ⊗ op2a))
@test 1e-13 > D((0.3*op1a) ⊗ op2a, 0.3*(op1a ⊗ op2a))

# Distributivity
@test 1e-13 > D(op1a ⊗ (op2a + op2b), op1a ⊗ op2a + op1a ⊗ op2b)
@test 1e-13 > D((op2a + op2b) ⊗ op3a, op2a ⊗ op3a + op2b ⊗ op3a)

# Mixed-product property
@test 1e-13 > D((op1a ⊗ op2a) * dagger(op1b ⊗ op2b), (op1a*dagger(op1b)) ⊗ (op2a*dagger(op2b)))

# Transpose
@test 1e-13 > D(dagger(op1a ⊗ op2a), dagger(op1a) ⊗ dagger(op2a))
@test 1e-13 > D(dagger(op1a ⊗ op2a), dagger(op1a) ⊗ dagger(op2a))

# Internal layout
a = Ket(b1a, rand(ComplexF64, length(b1a)))
b = Ket(b2b, rand(ComplexF64, length(b2b)))
ab = a ⊗ dagger(b)
@test ab.data[2,3] == a.data[2]*conj(b.data[3])
@test ab.data[2,1] == a.data[2]*conj(b.data[1])

shape = tuple(op123.basis_l.shape..., op123.basis_r.shape...)
idx = LinearIndices(shape)[2, 1, 1, 3, 4, 5]
@test op123.data[idx] == op1a.data[2,3]*op2a.data[1,4]*op3a.data[1,5]
@test reshape(op123.data, shape...)[2, 1, 1, 3, 4, 5] == op1a.data[2,3]*op2a.data[1,4]*op3a.data[1,5]

idx = LinearIndices(shape)[2, 1, 1, 1, 3, 4]
@test op123.data[idx] == op1a.data[2,1]*op2a.data[1,3]*op3a.data[1,4]
@test reshape(op123.data, shape...)[2, 1, 1, 1, 3, 4] == op1a.data[2,1]*op2a.data[1,3]*op3a.data[1,4]


# Test identityoperator
x1 = Ket(b_r, rand(ComplexF64, length(b_r)))
x2 = Ket(b_r, rand(ComplexF64, length(b_r)))
xbra1 = Bra(b_l, rand(ComplexF64, length(b_l)))
xbra2 = Bra(b_l, rand(ComplexF64, length(b_l)))

I = identityoperator(DenseOpType, b_r)
@test isa(I, DenseOpType)
@test identityoperator(SparseOpType, b_r) == sparse(I)
@test 1e-11 > D(I*x1, x1)
@test I == identityoperator(DenseOpType, b1b) ⊗ identityoperator(DenseOpType, b2b) ⊗ identityoperator(DenseOpType, b3b)

I = identityoperator(DenseOpType, b_l)
@test isa(I, DenseOpType)
@test identityoperator(SparseOpType, b_l) == sparse(I)
@test 1e-11 > D(xbra1*I, xbra1)
@test I == identityoperator(DenseOpType, b1a) ⊗ identityoperator(DenseOpType, b2a) ⊗ identityoperator(DenseOpType, b3a)

# Test tr and normalize
op = DenseOperator(GenericBasis(3), float.([1 3 2;5 2 2;-1 2 5]))
@test 8 == tr(op)
op_normalized = normalize(op)
@test 8 == tr(op)
@test 1 == tr(op_normalized)
op_copy = deepcopy(op)
normalize!(op_copy)
@test tr(op) != tr(op_copy)
@test 1 ≈ tr(op_copy)
@test op === normalize!(op)

# Test partial tr of state vectors
psi1 = 0.1*randstate(b1a)
psi2 = 0.3*randstate(b2a)
psi3 = 0.7*randstate(b3a)
psi12 = psi1 ⊗ psi2
psi13 = psi1 ⊗ psi3
psi23 = psi2 ⊗ psi3
psi123 = psi1 ⊗ psi2 ⊗ psi3

@test 1e-13 > D(0.1^2*0.3^2*psi3 ⊗ dagger(psi3), ptrace(psi123, [1, 2]))
@test 1e-13 > D(0.1^2*0.7^2*psi2 ⊗ dagger(psi2), ptrace(psi123, [1, 3]))
@test 1e-13 > D(0.3^2*0.7^2*psi1 ⊗ dagger(psi1), ptrace(psi123, [2, 3]))

@test 1e-13 > D(0.1^2*psi23 ⊗ dagger(psi23), ptrace(psi123, 1))
@test 1e-13 > D(0.3^2*psi13 ⊗ dagger(psi13), ptrace(psi123, 2))
@test 1e-13 > D(0.7^2*psi12 ⊗ dagger(psi12), ptrace(psi123, 3))

@test 1e-13 > D(ptrace(psi123, [1, 2]), dagger(ptrace(dagger(psi123), [1, 2])))
@test 1e-13 > D(ptrace(psi123, 3), dagger(ptrace(dagger(psi123), 3)))

@test_throws ArgumentError ptrace(psi123, [1, 2, 3])

@test reduced(psi123, [3]).data == ptrace(psi123, [1, 2]).data

# Test partial tr of operators
b1 = GenericBasis(3)
b2 = GenericBasis(5)
b3 = GenericBasis(7)
op1 = randoperator(b1)
op2 = randoperator(b2)
op3 = randoperator(b3)
op123 = op1 ⊗ op2 ⊗ op3

@test 1e-13 > D(op1⊗op2*tr(op3), ptrace(op123, 3))
@test 1e-13 > D(op1⊗op3*tr(op2), ptrace(op123, 2))
@test 1e-13 > D(op2⊗op3*tr(op1), ptrace(op123, 1))

@test 1e-13 > D(op1*tr(op2)*tr(op3), ptrace(op123, [2,3]))
@test 1e-13 > D(op2*tr(op1)*tr(op3), ptrace(op123, [1,3]))
@test 1e-13 > D(op3*tr(op1)*tr(op2), ptrace(op123, [1,2]))

@test_throws ArgumentError ptrace(op123, [1,2,3])
x = randoperator(b1, b1⊗b2)
@test_throws ArgumentError ptrace(x, [1])
x = randoperator(b1⊗b1⊗b2, b1⊗b2)
@test_throws ArgumentError ptrace(x, [1, 2])
x = randoperator(b1⊗b2)
@test_throws ArgumentError ptrace(x, [1, 2])
x = randoperator(b1⊗b2, b2⊗b1)
@test_throws ArgumentError ptrace(x, [1])

op1 = randoperator(b1, b2)
op2 = randoperator(b3)

@test 1e-13 > D(op1*tr(op2), ptrace(op1⊗op2, 2))

# Test expect
b1 = GenericBasis(3)
b2 = GenericBasis(5)
b3 = GenericBasis(7)
op1 = randoperator(b1)
op2 = randoperator(b2)
op3 = randoperator(b3)
op123 = op1 ⊗ op2 ⊗ op3
b_l = b1 ⊗ b2 ⊗ b3

state = randstate(b_l)
@test expect(op123, state) ≈ dagger(state)*op123*state
@test expect(1, op1, state) ≈ expect(op1, ptrace(state, [2, 3]))
@test expect(2, op2, state) ≈ expect(op2, ptrace(state, [1, 3]))
@test expect(3, op3, state) ≈ expect(op3, ptrace(state, [1, 2]))

state = randoperator(b_l)
@test expect(op123, state) ≈ tr(op123*state)
@test expect(1, op1, state) ≈ expect(op1, ptrace(state, [2, 3]))
@test expect(2, op2, state) ≈ expect(op2, ptrace(state, [1, 3]))
@test expect(3, op3, state) ≈ expect(op3, ptrace(state, [1, 2]))

@test_throws QuantumOpticsBase.IncompatibleBases expect(op2, op1)

# Permute systems
op1 = randoperator(b1a, b1b)
op2 = randoperator(b2a, b2b)
op3 = randoperator(b3a, b3b)
op123 = op1⊗op2⊗op3

op132 = op1⊗op3⊗op2
@test 1e-14 > D(permutesystems(op123, [1, 3, 2]), op132)

op213 = op2⊗op1⊗op3
@test 1e-14 > D(permutesystems(op123, [2, 1, 3]), op213)

op231 = op2⊗op3⊗op1
@test 1e-14 > D(permutesystems(op123, [2, 3, 1]), op231)

op312 = op3⊗op1⊗op2
@test 1e-14 > D(permutesystems(op123, [3, 1, 2]), op312)

op321 = op3⊗op2⊗op1
@test 1e-14 > D(permutesystems(op123, [3, 2, 1]), op321)


# Test projector
xket = normalize(Ket(b_l, rand(ComplexF64, length(b_l))))
yket = normalize(Ket(b_l, rand(ComplexF64, length(b_l))))
xbra = dagger(xket)
ybra = dagger(yket)

@test 1e-13 > D(projector(xket)*xket, xket)
@test 1e-13 > D(xbra*projector(xket), xbra)
@test 1e-13 > D(projector(xbra)*xket, xket)
@test 1e-13 > D(xbra*projector(xbra), xbra)
@test 1e-13 > D(ybra*projector(yket, xbra), xbra)
@test 1e-13 > D(projector(yket, xbra)*xket, yket)

# Test operator exponential
op = randoperator(b1a)
@test 1e-13 > D(op^2, op*op)
@test 1e-13 > D(op^3, op*op*op)
@test 1e-13 > D(op^4, op*op*op*op)

# Test gemv
b1 = GenericBasis(3)
b2 = GenericBasis(5)
op = randoperator(b1, b2)
xket = randstate(b2)
xbra = dagger(randstate(b1))
rket = randstate(b1)
rbra = dagger(randstate(b2))
alpha = complex(0.7, 1.5)
beta = complex(0.3, 2.1)

rket_ = deepcopy(rket)
QuantumOpticsBase.mul!(rket_,op,xket,complex(1.0),complex(0.))
@test 0 ≈ D(rket_, op*xket)

rket_ = deepcopy(rket)
QuantumOpticsBase.mul!(rket_,op,xket,alpha,beta)
@test 1e-13 > D(rket_, alpha*op*xket + beta*rket)

rbra_ = deepcopy(rbra)
QuantumOpticsBase.mul!(rbra_,xbra,op,complex(1.0),complex(0.))
@test 0 ≈ D(rbra_, xbra*op)

rbra_ = deepcopy(rbra)
QuantumOpticsBase.mul!(rbra_,xbra,op,alpha,beta)
@test 1e-13 > D(rbra_, alpha*xbra*op + beta*rbra)

# # Test gemm
b1 = GenericBasis(37)
b2 = GenericBasis(53)
b3 = GenericBasis(41)
op1 = randoperator(b1, b2)
op2 = randoperator(b2, b3)
r = randoperator(b1, b3)
alpha = complex(0.7, 1.5)
beta = complex(0.3, 2.1)

r_ = deepcopy(r)
QuantumOpticsBase.mul!(r_,op1,op2,complex(1.0),complex(0.))
@test 1e-13 > D(r_, op1*op2)

r_ = deepcopy(r)
QuantumOpticsBase.mul!(r_,op1,op2,alpha,beta)
@test 1e-10 > D(r_, alpha*op1*op2 + beta*r)

dat = rand(prod(b_r.shape))
x = Ket(b_r, dat)
y = Bra(b_r, dat)
@test dm(x) == dm(y)

# Test Hermitian
bspin = SpinBasis(1//2)
bnlevel = NLevelBasis(2)
@test ishermitian(DenseOperator(bspin, bspin, [1.0 im; -im 2.0])) == true
@test ishermitian(DenseOperator(bspin, bnlevel, [1.0 im; -im 2.0])) == false

# Test broadcasting
op1_ = copy(op1)
op1 .= 2*op1
@test op1 == op1_ .+ op1_
op1 .= op1_
@test op1 == op1_
op1 .= op1_ .+ 3 * op1_
@test op1 == 4*op1_
@test_throws DimensionMismatch op1 .= op2
bf = FockBasis(3)
op3 = randoperator(bf)
@test_throws QuantumOpticsBase.IncompatibleBases op1 .+ op3
op .= 1.0
@test op == fill!(zero(op), 1.0)
@test_throws ArgumentError op .= 1.0 .+ 1.0

# Dimension mismatches
b1, b2, b3 = NLevelBasis.((2,3,4))  # N is not a type parameter
@test_throws DimensionMismatch mul!(randstate(b1), randoperator(b2), randstate(b3))
@test_throws DimensionMismatch mul!(randstate(b1)', randstate(b3)', randoperator(b2))
@test_throws DimensionMismatch mul!(randoperator(b1), randoperator(b2), randoperator(b3))
@test_throws DimensionMismatch mul!(randoperator(b1), randoperator(b3)', randoperator(b2))

end # testset

@testset "State-operator tensor products" begin
    b = FockBasis(2) ⊗ SpinBasis(1//2) ⊗ GenericBasis(2)
    b1, b2, b3 = b.bases

    o1 = randoperator(b1)
    v1 = randstate(b1)
    p1 = projector(v1)
    o2 = randoperator(b2)
    v2 = randstate(b2)
    p2 = projector(v2)
    o3 = randoperator(b3)
    v3 = randstate(b3)
    p3 = projector(v3)

    @test (v1 ⊗ o2).basis_l == b1 ⊗ b2
    @test (v1 ⊗ o2).basis_r == b2
    @test (v1' ⊗ o2).basis_l == b2
    @test (v1' ⊗ o2).basis_r == b1 ⊗ b2

    @test ((o1 ⊗ v2) * (o1 ⊗ v2')).data ≈ (o1^2 ⊗ p2).data
    @test ((o1 ⊗ v2') * (o1 ⊗ v2)).data ≈ (o1^2).data

    @test ((o1 ⊗ v2 ⊗ o3) * (o1 ⊗ v2' ⊗ o3)).data ≈ (o1^2 ⊗ p2 ⊗ o3^2).data
    @test ((v1 ⊗ o2 ⊗ o3) * (v1' ⊗ o2 ⊗ o3)).data ≈ (p1 ⊗ o2^2 ⊗ o3^2).data
    @test ((v1 ⊗ o2 ⊗ v3) * (v1' ⊗ o2 ⊗ v3')).data ≈ (p1 ⊗ o2^2 ⊗ p3).data
end
end

import Base: position # TODO is it a good idea to abuse the Base namespace for a different use?
using FFTW

"""
    gaussianstate([T=ComplexF64,] b::PositionBasis, x0, p0, sigma)
    gaussianstate([T=ComplexF64,] b::MomentumBasis, x0, p0, sigma)

Create a Gaussian state around `x0` and` p0` with width `sigma`.

In real space the gaussian state is defined as

```math
\\Psi(x) = \\frac{1}{\\pi^{1/4}\\sqrt{\\sigma}}
            e^{i p_0 (x-\\frac{x_0}{2}) - \\frac{(x-x_0)^2}{2 \\sigma^2}}
```

and is connected to the momentum space definition

```math
\\Psi(p) = \\frac{\\sqrt{\\sigma}}{\\pi^{1/4}}
            e^{-i x_0 (p-\\frac{p_0}{2}) - \\frac{1}{2}(p-p_0)^2 \\sigma^2}
```

via a Fourier-transformation

```math
\\Psi(p) = \\frac{1}{\\sqrt{2\\pi}}
            \\int_{-\\infty}^{\\infty} e^{-ipx}\\Psi(x) \\mathrm{d}x
```

The state has the properties

* ``⟨p⟩ = p_0``
* ``⟨x⟩ = x_0``
* ``\\mathrm{Var}(x) = \\frac{σ^2}{2}``
* ``\\mathrm{Var}(p) = \\frac{1}{2 σ^2}``

Due to the numerically necessary discretization additional scaling
factors ``\\sqrt{Δx}`` and ``\\sqrt{Δp}`` are used so that
``\\langle x_i|Ψ\\rangle = \\sqrt{Δ x} Ψ(x_i)`` and ``\\langle p_i|Ψ\\rangle = \\sqrt{Δ p} Ψ(p_i)`` so
that the resulting Ket state is normalized.
"""
function gaussianstate(::Type{T}, b::PositionBasis, x0, p0, sigma) where T
    psi = Ket(T, b)
    dx = spacing(b)
    alpha = 1.0/(pi^(1/4)*sqrt(sigma))*sqrt(dx)
    x = b.xmin
    for i=1:b.N
        psi.data[i] = alpha*exp(1im*p0*(x-x0/2) - (x-x0)^2/(2*sigma^2))
        x += dx
    end
    return psi
end

function gaussianstate(::Type{T}, b::MomentumBasis, x0, p0, sigma) where T
    psi = Ket(T, b)
    dp = spacing(b)
    alpha = sqrt(sigma)/pi^(1/4)*sqrt(dp)
    p = b.pmin
    for i=1:b.N
        psi.data[i] = alpha*exp(-1im*x0*(p-p0/2) - (p-p0)^2/2*sigma^2)
        p += dp
    end
    return psi
end

gaussianstate(b::Basis, x0, p0, sigma) = gaussianstate(ComplexF64, b, x0, p0, sigma)


"""
    spacing(b::PositionBasis)

Difference between two adjacent points of the real space basis.
"""
spacing(b::PositionBasis) = (b.xmax - b.xmin)/b.N
"""
    spacing(b::MomentumBasis)

Momentum difference between two adjacent points of the momentum basis.
"""
spacing(b::MomentumBasis) = (b.pmax - b.pmin)/b.N

"""
    samplepoints(b::PositionBasis)

x values of the real space basis.
"""
samplepoints(b::PositionBasis) = (dx = spacing(b); [b.xmin + i*dx for i=0:b.N-1])
"""
    samplepoints(b::MomentumBasis)

p values of the momentum basis.
"""
samplepoints(b::MomentumBasis) = (dp = spacing(b); [b.pmin + i*dp for i=0:b.N-1])

"""
    position([T=ComplexF64,] b::PositionBasis)

Position operator in real space.
"""
function position(::Type{T}, b::PositionBasis) where T
    d = convert.(T, samplepoints(b))
    return SparseOperator(b, spdiagm(0 => d))
end
position(b::ParticleBasis) = position(ComplexF64, b)

"""
    position([T=ComplexF64,] b:MomentumBasis)

Position operator in momentum space.
"""
function position(::Type{T}, b::MomentumBasis) where T
    b_pos = PositionBasis(b)
    transform(b, b_pos)*dense(position(T, b_pos))*transform(b_pos, b)
end

"""
    momentum([T=ComplexF64,] b:MomentumBasis)

Momentum operator in momentum space.
"""
function momentum(::Type{T}, b::MomentumBasis) where T
    d = convert.(T, samplepoints(b))
    return SparseOperator(b, spdiagm(0=>d))
end
momentum(b::Basis) = momentum(ComplexF64, b)

"""
    momentum([T=ComplexF64,] b::PositionBasis)

Momentum operator in real space.
"""
function momentum(::Type{T}, b::PositionBasis) where T
    b_mom = MomentumBasis(b)
    transform(b, b_mom)*dense(momentum(T,b_mom))*transform(b_mom, b)
end

"""
    potentialoperator([T=Float64,] b::PositionBasis, V(x))

Operator representing a potential ``V(x)`` in real space.
"""
function potentialoperator(::Type{T}, b::PositionBasis, V) where T
    x = convert.(T, samplepoints(b))
    diagonaloperator(b, V.(x))
end
potentialoperator(b::PositionBasis, V) = potentialoperator(Float64, b, V)

"""
    potentialoperator([T=ComplexF64,] b::MomentumBasis, V(x))

Operator representing a potential ``V(x)`` in momentum space.
"""
function potentialoperator(::Type{T}, b::MomentumBasis, V) where T
    b_pos = PositionBasis(b)
    transform(b, b_pos)*dense(potentialoperator(T, b_pos, V))*transform(b_pos, b)
end
potentialoperator(b::Basis, V) = potentialoperator(ComplexF64, b, V)

"""
    potentialoperator([T=Float64,] b::CompositeBasis, V(x, y, z, ...))

Operator representing a potential ``V`` in more than one dimension.

# Arguments
* `b`: Composite basis consisting purely either of `PositionBasis` or
    `MomentumBasis`. Note, that calling this with a composite basis in
    momentum space might consume a large amount of memory.
* `V`: Function describing the potential. ATTENTION: The number of arguments
    accepted by `V` must match the spatial dimension. Furthermore, the order
    of the arguments has to match that of the order of the tensor product of
    bases (e.g. if `b=bx⊗by⊗bz`, then `V(x,y,z)`).
"""
function potentialoperator(::Type{T}, b::CompositeBasis, V) where T
    if isa(b.bases[1], PositionBasis)
        potentialoperator_position(T, b, V)
    elseif isa(b.bases[1], MomentumBasis)
        potentialoperator_momentum(T, b, V)
    else
        throw(IncompatibleBases())
    end
end
function potentialoperator_position(::Type{T}, b::CompositeBasis, V) where T
    for base=b.bases
        @assert isa(base, PositionBasis)
    end

    points = [samplepoints(b1) for b1=b.bases]
    dims = length.(points)
    n = length(b.bases)
    data = Array{T}(undef, dims...)
    @inbounds for i=1:length(data)
        index = Tuple(CartesianIndices(data)[i])
        args = (points[j][index[j]] for j=1:n)
        data[i] = V(args...)
    end

    diagonaloperator(b, data[:])
end
function potentialoperator_momentum(::Type{T}, b::CompositeBasis, V) where T
    bases_pos = []
    for base=b.bases
        @assert isa(base, MomentumBasis)
        push!(bases_pos, PositionBasis(base))
    end
    b_pos = tensor(bases_pos...)
    transform(b, b_pos)*dense(potentialoperator_position(T, b_pos, V))*transform(b_pos, b)
end

"""
    FFTOperator

Abstract type for all implementations of FFT operators.
"""
abstract type FFTOperator{BL, BR, T} <: AbstractOperator{BL,BR} end

Base.eltype(x::FFTOperator) = promote_type(eltype(x.mul_before), eltype(x.mul_after))

"""
    FFTOperators

Operator performing a fast fourier transformation when multiplied with a state
that is a Ket or an Operator.
"""
struct FFTOperators{BL,BR,T,P1,P2,P3,P4} <: FFTOperator{BL, BR, T}
    basis_l::BL
    basis_r::BR
    fft_l!::P1
    fft_r!::P2
    fft_l2!::P3
    fft_r2!::P4
    mul_before::T
    mul_after::T
    function FFTOperators(b1::BL, b2::BR,
        fft_l!::P1,
        fft_r!::P2,
        fft_l2!::P3,
        fft_r2!::P4,
        mul_before::T,
        mul_after::T) where {BL,BR,T,P1,P2,P3,P4}
        new{BL,BR,T,P1,P2,P3,P4}(b1, b2, fft_l!, fft_r!, fft_l2!, fft_r2!, mul_before, mul_after)
    end
end

"""
    FFTKets

Operator that can only perform fast fourier transformations on Kets.
This is much more memory efficient when only working with Kets.
"""
struct FFTKets{BL,BR,T,P1,P2} <: FFTOperator{BL, BR, T}
    basis_l::BL
    basis_r::BR
    fft_l!::P1
    fft_r!::P2
    mul_before::T
    mul_after::T
    function FFTKets(b1::BL, b2::BR,
        fft_l!::P1,
        fft_r!::P2,
        mul_before::T,
        mul_after::T) where {BL,BR, T, P1, P2}
        new{BL, BR, T, P1, P2}(b1, b2, fft_l!, fft_r!, mul_before, mul_after)
    end
end

"""
    transform(b1::MomentumBasis, b2::PositionBasis)
    transform(b1::PositionBasis, b2::MomentumBasis)

Transformation operator between position basis and momentum basis.
"""
function transform(basis_l::MomentumBasis, basis_r::PositionBasis; ket_only=false)
    Lx = (basis_r.xmax - basis_r.xmin)
    dp = spacing(basis_l)
    dx = spacing(basis_r)
    if basis_l.N != basis_r.N || abs(2*pi/dp - Lx)/Lx > 1e-12
        throw(IncompatibleBases())
    end
    mul_before = exp.(-1im*basis_l.pmin*(samplepoints(basis_r) .- basis_r.xmin))
    mul_after = exp.(-1im*basis_r.xmin*samplepoints(basis_l))/sqrt(basis_r.N)
    x = Vector{eltype(mul_before)}(undef, length(basis_r))
    if ket_only
        FFTKets(basis_l, basis_r, plan_bfft!(x), plan_fft!(x), mul_before, mul_after)
    else
        A = Matrix{eltype(mul_before)}(undef, length(basis_r), length(basis_r))
        FFTOperators(basis_l, basis_r, plan_bfft!(x), plan_fft!(x), plan_bfft!(A, 2), plan_fft!(A, 1), mul_before, mul_after)
    end
end

"""
    transform(b1::CompositeBasis, b2::CompositeBasis)

Transformation operator between two composite bases. Each of the bases
has to contain bases of type PositionBasis and the other one a corresponding
MomentumBasis.
"""
function transform(basis_l::PositionBasis, basis_r::MomentumBasis; ket_only=false)
    Lx = (basis_l.xmax - basis_l.xmin)
    dp = spacing(basis_r)
    dx = spacing(basis_l)
    if basis_l.N != basis_r.N || abs(2*pi/dp - Lx)/Lx > 1e-12
        throw(IncompatibleBases())
    end
    mul_before = exp.(1im*basis_l.xmin*(samplepoints(basis_r) .- basis_r.pmin))
    mul_after = exp.(1im*basis_r.pmin*samplepoints(basis_l))/sqrt(basis_r.N)
    x = Vector{eltype(mul_before)}(undef, length(basis_r))
    if ket_only
        FFTKets(basis_l, basis_r, plan_fft!(x), plan_bfft!(x), mul_before, mul_after)
    else
        A = Matrix{eltype(mul_before)}(undef, length(basis_r), length(basis_r))
        FFTOperators(basis_l, basis_r, plan_fft!(x), plan_bfft!(x), plan_fft!(A, 2), plan_bfft!(A, 1), mul_before, mul_after)
    end
end

function transform(basis_l::CompositeBasis, basis_r::CompositeBasis; ket_only=false, index=Int[])
    @assert length(basis_l.bases) == length(basis_r.bases)
    if length(index) == 0
        check_pos = [isa.(basis_l.bases, PositionBasis)...]
        check_mom = [isa.(basis_l.bases, MomentumBasis)...]
        if any(check_pos) && !any(check_mom)
            index = [1:length(basis_l.bases);][check_pos]
        elseif any(check_mom) && !any(check_pos)
            index = [1:length(basis_l.bases);][check_mom]
        else
            throw(IncompatibleBases())
        end
    end
    if all(isa.(basis_l.bases[index], PositionBasis))
        @assert all(isa.(basis_r.bases[index], MomentumBasis))
        transform_xp(basis_l, basis_r, index; ket_only=ket_only)
    elseif all(isa.(basis_l.bases[index], MomentumBasis))
        @assert all(isa.(basis_r.bases[index], PositionBasis))
        transform_px(basis_l, basis_r, index; ket_only=ket_only)
    else
        throw(IncompatibleBases())
    end
end

function transform_xp(basis_l::CompositeBasis, basis_r::CompositeBasis, index; ket_only=false)
    n = length(basis_l.bases)
    Lx = [(b.xmax - b.xmin) for b=basis_l.bases[index]]
    dp = [spacing(b) for b=basis_r.bases[index]]
    dx = [spacing(b) for b=basis_l.bases[index]]
    N = [length(b) for b=basis_l.bases]
    for i=1:n
        if N[i] != length(basis_r.bases[i])
            throw(IncompatibleBases())
        end
    end
    for i=1:length(index)
        if abs(2*pi/dp[i] - Lx[i])/Lx[i] > 1e-12
            throw(IncompatibleBases())
        end
    end

    if index[1] == 1
        mul_before = exp.(1im*basis_l.bases[1].xmin*(samplepoints(basis_r.bases[1]) .- basis_r.bases[1].pmin))
        mul_after = exp.(1im*basis_r.bases[1].pmin*samplepoints(basis_l.bases[1]))/sqrt(basis_r.bases[1].N)
    else
        mul_before = ones(N[1])
        mul_after = ones(N[1])
    end
    for i=2:n
        if any(i .== index)
            mul_before = kron(exp.(1im*basis_l.bases[i].xmin*(samplepoints(basis_r.bases[i]) .- basis_r.bases[i].pmin)), mul_before)
            mul_after = kron(exp.(1im*basis_r.bases[i].pmin*samplepoints(basis_l.bases[i]))/sqrt(basis_r.bases[i].N), mul_after)
        else
            mul_before = kron(ones(N[i]), mul_before)
            mul_after = kron(ones(N[i]), mul_after)
        end
    end
    mul_before = reshape(mul_before, (N...,))
    mul_after = reshape(mul_after, (N...,))

    x = Array{eltype(mul_before)}(undef, N...)
    if ket_only
        FFTKets(basis_l, basis_r, plan_fft!(x, index), plan_bfft!(x, index), mul_before, mul_after)
    else
        A = Array{eltype(mul_before)}(undef, [N; N]...)
        FFTOperators(basis_l, basis_r, plan_fft!(x, index), plan_bfft!(x, index), plan_fft!(A, [n + 1:2n;][index]), plan_bfft!(A, [1:n;][index]), mul_before, mul_after)
    end
end

function transform_px(basis_l::CompositeBasis, basis_r::CompositeBasis, index; ket_only=false)
    n = length(basis_l.bases)
    Lx = [(b.xmax - b.xmin) for b=basis_r.bases[index]]
    dp = [spacing(b) for b=basis_l.bases[index]]
    dx = [spacing(b) for b=basis_r.bases[index]]
    N = [length(b) for b=basis_l.bases]
    for i=1:n
        if N[i] != length(basis_r.bases[i])
            throw(IncompatibleBases())
        end
    end
    for i=1:length(index)
        if abs(2*pi/dp[i] - Lx[i])/Lx[i] > 1e-12
            throw(IncompatibleBases())
        end
    end

    if index[1] == 1
        mul_before = exp.(-1im*basis_l.bases[1].pmin*(samplepoints(basis_r.bases[1]) .- basis_r.bases[1].xmin))
        mul_after = exp.(-1im*basis_r.bases[1].xmin*samplepoints(basis_l.bases[1]))/sqrt(N[1])
    else
        mul_before = ones(N[1])
        mul_after = ones(N[1])
    end
    for i=2:n
        if i in index
            mul_before = kron(exp.(-1im*basis_l.bases[i].pmin*(samplepoints(basis_r.bases[i]) .- basis_r.bases[i].xmin)), mul_before)
            mul_after = kron(exp.(-1im*basis_r.bases[i].xmin*samplepoints(basis_l.bases[i]))/sqrt(N[i]), mul_after)
        else
            mul_before = kron(ones(N[i]), mul_before)
            mul_after = kron(ones(N[i]), mul_after)
        end
    end
    mul_before = reshape(mul_before, (N...,))
    mul_after = reshape(mul_after, (N...,))

    x = Array{eltype(mul_before)}(undef, N...)
    if ket_only
        FFTKets(basis_l, basis_r, plan_bfft!(x, index), plan_fft!(x, index), mul_before, mul_after)
    else
        A = Array{eltype(mul_before)}(undef, [N; N]...)
        FFTOperators(basis_l, basis_r, plan_bfft!(x, index), plan_fft!(x, index), plan_bfft!(A, [n + 1:2n;][index]), plan_fft!(A, [1:n;][index]), mul_before, mul_after)
    end
end

DenseOperator(op::FFTOperator) = op*identityoperator(DenseOpType, op.basis_r)

dagger(op::FFTOperators) = transform(op.basis_r, op.basis_l)
dagger(op::FFTKets) = transform(op.basis_r, op.basis_l; ket_only=true)

tensor(A::FFTOperators, B::FFTOperators) = transform(tensor(A.basis_l, B.basis_l), tensor(A.basis_r, B.basis_r))
tensor(A::FFTKets, B::FFTKets) = transform(tensor(A.basis_l, B.basis_l), tensor(A.basis_r, B.basis_r); ket_only=true)

function mul!(result::Ket{B1},M::FFTOperator{B1,B2},b::Ket{B2},alpha,beta) where {B1,B2}
    N = length(M.basis_r)
    if iszero(beta)
        @inbounds for i=1:N
            result.data[i] = M.mul_before[i] * b.data[i]
        end
        M.fft_r! * reshape(result.data, size(M.mul_before))
        @inbounds for i=1:N
            result.data[i] *= M.mul_after[i] * alpha
        end
    else
        psi_ = Ket(M.basis_l, copy(b.data))
        @inbounds for i=1:N
            psi_.data[i] *= M.mul_before[i]
        end
        M.fft_r! * reshape(psi_.data, size(M.mul_before))
        @inbounds for i=1:N
            result.data[i] = beta*result.data[i] + alpha * psi_.data[i] * M.mul_after[i]
        end
    end
    result
end

function mul!(result::Bra{B2},b::Bra{B1},M::FFTOperator{B1,B2},alpha,beta) where {B1,B2}
    N = length(M.basis_l)
    if iszero(beta)
        @inbounds for i=1:N
            result.data[i] = conj(M.mul_after[i]) * conj(b.data[i])
        end
        M.fft_l! * reshape(result.data, size(M.mul_after))
        @inbounds for i=1:N
            result.data[i] = conj(result.data[i]) * M.mul_before[i] * alpha
        end
    else
        psi_ = Bra(M.basis_r, conj(b.data))
        @inbounds for i=1:N
            psi_.data[i] *= conj(M.mul_after[i])
        end
        M.fft_l! * reshape(psi_.data, size(M.mul_after))
        @inbounds for i=1:N
            result.data[i] = beta*result.data[i] + alpha * conj(psi_.data[i]) * M.mul_before[i]
        end
    end
    result
end

function mul!(result::Operator{B1,B3,T},A::Operator{B1,B2},B::FFTOperators{B2,B3},alpha,beta) where {B1,B2,B3,T}
    if !iszero(beta)
        data = similar(result.data, size(result.data, 1), size(result.data, 2))
    else
        data = result.data
    end
    copyto!(data, A.data)
    @inbounds for j=1:length(B.mul_after), i=1:length(B.mul_after)
        data[i, j] *= B.mul_after[j]
    end
    conj!(data)
    n = size(B.mul_after)
    B.fft_l2! * reshape(data, n..., n...)
    conj!(data)
    N = prod(n)
    @inbounds for j=1:N, i=1:N
        data[i, j] *= B.mul_before[j]
    end
    if !isone(alpha)
        lmul!(alpha, data)
    end
    if !iszero(beta)
        rmul!(result.data, beta)
        result.data += data
    end
    result
end

function mul!(result::Operator{B1,B3,T},A::FFTOperators{B1,B2},B::Operator{B2,B3},alpha,beta) where {B1,B2,B3,T}
    if !iszero(beta)
        data = similar(result.data, size(result.data, 1), size(result.data, 2))
    else
        data = result.data
    end
    copyto!(data, B.data)
    @inbounds for j=1:length(A.mul_before), i=1:length(A.mul_before)
        data[i, j] *= A.mul_before[i]
    end
    n = size(A.mul_before)
    A.fft_r2! * reshape(data, n...,n...)
    N = prod(n)
    @inbounds for j=1:N, i=1:N
        data[i, j] *= A.mul_after[i]
    end
    if !isone(alpha)
        lmul!(alpha, data)
    end
    if !iszero(beta)
        rmul!(result.data, beta)
        result.data += data
    end
    result
end

import QuantumInterface: Basis, basis, GenericBasis, CompositeBasis, ParticleBasis, PositionBasis, MomentumBasis,
    equal_shape, equal_bases, IncompatibleBases, @samebases, samebases, check_samebases,
    multiplicable, check_multiplicable, reduced, ptrace, permutesystems

"""
    randstate([T=ComplexF64,] basis)

Calculate a random normalized ket state.
"""
function randstate(::Type{T}, b::Basis) where T
    psi = Ket(b, rand(T, length(b)))
    normalize!(psi)
    psi
end
randstate(b) = randstate(ComplexF64, b)

"""
    randstate_haar(b::Basis)

Returns a Haar random pure state of dimension `length(b)` by applying a Haar random unitary to a fixed pure state.
"""
function randstate_haar(b::Basis)
    dim = length(b)
    mat = rand(ComplexF64, dim, dim)
    q, r = qr!(mat)
    return Ket(b, q[:,1])
end

"""
    randoperator([T=ComplexF64,] b1[, b2])

Calculate a random unnormalized dense operator.
"""
randoperator(::Type{T}, b1::Basis, b2::Basis) where T = DenseOperator(b1, b2, rand(T, length(b1), length(b2)))
randoperator(b1::Basis, b2::Basis) = randoperator(ComplexF64, b1, b2)
randoperator(::Type{T}, b::Basis) where T = randoperator(T, b, b)
randoperator(b) = randoperator(ComplexF64, b)

"""
    randunitary_haar(b::Basis)

Returns a Haar random unitary matrix of dimension `length(b)`.
"""
function randunitary_haar(b::Basis)
    dim = length(b)
    mat = rand(ComplexF64, dim, dim)
    q, r = qr!(mat)
    d = Diagonal([r[i, i] / abs(r[i, i]) for i in 1:dim])
    data = q * d
    DenseOperator(b, b, data)
end

"""
    thermalstate(H,T)

Thermal state ``exp(-H/T)/Tr[exp(-H/T)]``.
"""
function thermalstate(H,T)
    return normalize(exp(-dense(H)/T))
end

"""
    coherentthermalstate([C=ComplexF64,] basis::FockBasis,H,T,alpha)

Coherent thermal state ``D(α)exp(-H/T)/Tr[exp(-H/T)]D^†(α)``.
"""
function coherentthermalstate(::Type{C},basis::B,H::AbstractOperator{B,B},T,alpha) where {C,B<:FockBasis}
    D = displace(C,basis,alpha)
    return D*thermalstate(H,T)*dagger(D)
end
coherentthermalstate(basis::B,H::AbstractOperator{B,B},T,alpha) where B<:FockBasis = coherentthermalstate(ComplexF64,basis,H,T,alpha)

"""
    phase_average(rho)

Returns the phase-average of ``ρ`` containing only the diagonal elements.
"""
function phase_average(rho)
    return Operator(basis(rho),diagm(0 => diag(rho.data)))
end

"""
    passive_state(rho,IncreasingEigenenergies=true)

Passive state ``π`` of ``ρ``. IncreasingEigenenergies=true means that higher indices correspond to higher energies.
"""
function passive_state(rho,IncreasingEigenenergies=true)
    return DenseOperator(basis(rho),diagm(0 => sort!(abs.(eigvals(rho.data)),rev=IncreasingEigenenergies)))
end

@testitem "test_particle" begin
using Test
using QuantumOpticsBase
using FFTW, LinearAlgebra, Random

@testset "particle" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))

N = 200
xmin = -32.5
xmax = 20.1

basis_position = PositionBasis(xmin, xmax, N)
basis_momentum = MomentumBasis(basis_position)

b2 = PositionBasis(basis_momentum)
@test basis_position.xmax - basis_position.xmin ≈ b2.xmax - b2.xmin
@test basis_position.N == b2.N

# Test Gaussian wave-packet in both bases
x0 = 5.1
p0 = -3.2
sigma = 1.
sigma_x = sigma/sqrt(2)
sigma_p = 1.0/(sigma*sqrt(2))

psi0_bx = gaussianstate(basis_position, x0, p0, sigma)
psi0_bp = gaussianstate(basis_momentum, x0, p0, sigma)

@test 1 ≈ norm(psi0_bx)
@test 1 ≈ norm(psi0_bp)

p_bx = momentum(basis_position)
x_bx = position(basis_position)

@test 1e-10 > D(p_bx, transform(basis_position, basis_momentum)*dense(momentum(basis_momentum))*transform(basis_momentum, basis_position))

p_bp = momentum(basis_momentum)
x_bp = position(basis_momentum)

@test x0 ≈ expect(x_bx, psi0_bx)
@test 0.1 > abs(p0 - expect(p_bx, psi0_bx))
@test p0 ≈ expect(p_bp, psi0_bp)
@test 0.1 > abs(x0 - expect(x_bp, psi0_bp))

@test 1e-13 > abs(variance(x_bx, psi0_bx) - sigma^2/2)
@test 1e-13 > abs(variance(x_bp, psi0_bp) - sigma^2/2)
@test 1e-13 > abs(variance(p_bx, psi0_bx) - 1/(2*sigma^2))
@test 1e-13 > abs(variance(p_bp, psi0_bp) - 1/(2*sigma^2))

# Test potentialoperator
V(x) = x^2
V_bx = potentialoperator(basis_position, V)
V_bp = potentialoperator(basis_momentum, V)

@test expect(V_bp, psi0_bp) ≈ expect(V_bx, psi0_bx)


# Test FFT transformation
function transformation(b1::MomentumBasis, b2::PositionBasis, psi::Ket)
    Lp = (b1.pmax - b1.pmin)
    dx = spacing(b2)
    if b1.N != b2.N || abs(2*pi/dx - Lp)/Lp > 1e-12
        throw(IncompatibleBases())
    end
    N = b1.N
    psi_shifted = exp.(1im*b2.xmin*(samplepoints(b1) .- b1.pmin)).*psi.data
    psi_fft = exp.(1im*b1.pmin*samplepoints(b2)).*ifft(psi_shifted)*sqrt(N)
    return Ket(b2, psi_fft)
end

function transformation(b1::PositionBasis, b2::MomentumBasis, psi::Ket)
    Lx = (b1.xmax - b1.xmin)
    dp = spacing(b2)
    if b1.N != b2.N || abs(2*pi/dp - Lx)/Lx > 1e-12
        throw(IncompatibleBases())
    end
    N = b1.N
    psi_shifted = exp.(-1im*b2.pmin*(samplepoints(b1) .- b1.xmin)).*psi.data
    psi_fft = exp.(-1im*b1.xmin*samplepoints(b2)).*fft(psi_shifted)/sqrt(N)
    return Ket(b2, psi_fft)
end

psi0_bx_fft = transformation(basis_position, basis_momentum, psi0_bx)
psi0_bp_fft = transformation(basis_momentum, basis_position, psi0_bp)

@test 0.1 > abs(x0 - expect(x_bp, psi0_bx_fft))
@test p0 ≈ expect(p_bp, psi0_bx_fft)
@test 0.1 > abs(p0 - expect(p_bx, psi0_bp_fft))
@test x0 ≈ expect(x_bx, psi0_bp_fft)

@test 1e-12 > norm(psi0_bx_fft - psi0_bp)
@test 1e-12 > norm(psi0_bp_fft - psi0_bx)


Tpx = transform(basis_momentum, basis_position)
Txp = transform(basis_position, basis_momentum)
psi0_bx_fft = Tpx*psi0_bx
psi0_bp_fft = Txp*psi0_bp

@test 0.1 > abs(x0 - expect(x_bp, psi0_bx_fft))
@test p0 ≈ expect(p_bp, psi0_bx_fft)
@test 0.1 > abs(p0 - expect(p_bx, psi0_bp_fft))
@test x0 ≈ expect(x_bx, psi0_bp_fft)

@test 1e-12 > norm(psi0_bx_fft - psi0_bp)
@test 1e-12 > norm(psi0_bp_fft - psi0_bx)

@test 1e-12 > norm(dagger(Tpx*psi0_bx) - dagger(psi0_bx)*dagger(Tpx))
@test 1e-12 > norm(dagger(Txp*psi0_bp) - dagger(psi0_bp)*dagger(Txp))

# Test gemv!
psi_ = deepcopy(psi0_bp)
QuantumOpticsBase.mul!(psi_,Tpx,psi0_bx)
@test 1e-12 > norm(psi_ - psi0_bp)
QuantumOpticsBase.mul!(psi_,Tpx,psi0_bx,Complex(1.),Complex(1.))
@test 1e-12 > norm(psi_ - 2*psi0_bp)

psi_ = deepcopy(psi0_bx)
QuantumOpticsBase.mul!(psi_,Txp,psi0_bp)
@test 1e-12 > norm(psi_ - psi0_bx)
QuantumOpticsBase.mul!(psi_,Txp,psi0_bp,Complex(1.),Complex(1.))
@test 1e-12 > norm(psi_ - 2*psi0_bx)


alpha = complex(3.2)
beta = complex(-1.2)
randdata1 = rand(ComplexF64, N)
randdata2 = rand(ComplexF64, N)

state = Ket(basis_position, randdata1)
result_ = Ket(basis_momentum, copy(randdata2))
result0 = alpha*dense(Tpx)*state + beta*result_
QuantumOpticsBase.mul!(result_,Tpx,state,alpha,beta)
@test 1e-11 > norm(result0 - result_)

state = Bra(basis_position, randdata1)
result_ = Bra(basis_momentum, copy(randdata2))
result0 = alpha*state*dense(Txp) + beta*result_
QuantumOpticsBase.mul!(result_,state,Txp,alpha,beta)
@test 1e-11 > norm(result0 - result_)

state = Ket(basis_momentum, randdata1)
result_ = Ket(basis_position, copy(randdata2))
result0 = alpha*dense(Txp)*state + beta*result_
QuantumOpticsBase.mul!(result_,Txp,state,alpha,beta)
@test 1e-11 > norm(result0 - result_)

state = Bra(basis_momentum, randdata1)
result_ = Bra(basis_position, copy(randdata2))
result0 = alpha*state*dense(Tpx) + beta*result_
QuantumOpticsBase.mul!(result_,state,Tpx,alpha,beta)
@test 1e-11 > norm(result0 - result_)


# Test gemm!
rho0_xx = tensor(psi0_bx, dagger(psi0_bx))
rho0_xp = tensor(psi0_bx, dagger(psi0_bp))
rho0_px = tensor(psi0_bp, dagger(psi0_bx))
rho0_pp = tensor(psi0_bp, dagger(psi0_bp))

rho_ = DenseOperator(basis_momentum, basis_position)
QuantumOpticsBase.mul!(rho_,Tpx,rho0_xx)
@test 1e-12 > D(rho_, rho0_px)
@test 1e-12 > D(Tpx*rho0_xx, rho0_px)

rho_ = DenseOperator(basis_position, basis_momentum)
QuantumOpticsBase.mul!(rho_,rho0_xx,Txp)
@test 1e-12 > D(rho_, rho0_xp)
@test 1e-12 > D(rho0_xx*Txp, rho0_xp)

rho_ = DenseOperator(basis_momentum, basis_momentum)
QuantumOpticsBase.mul!(rho_,Tpx,rho0_xp)
@test 1e-12 > D(rho_, rho0_pp)
@test 1e-12 > D(Tpx*rho0_xx*Txp, rho0_pp)

rho_ = DenseOperator(basis_momentum, basis_momentum)
QuantumOpticsBase.mul!(rho_,rho0_px,Txp)
@test 1e-12 > D(rho_, rho0_pp)
@test 1e-12 > D(Txp*rho0_pp*Tpx, rho0_xx)


alpha = complex(3.2)
beta = complex(-1.2)
randdata1 = rand(ComplexF64, N, N)
randdata2 = rand(ComplexF64, N, N)

op = DenseOperator(basis_position, basis_position, randdata1)
result_ = DenseOperator(basis_momentum, basis_position, copy(randdata2))
result0 = alpha*dense(Tpx)*op + beta*result_
QuantumOpticsBase.mul!(result_,Tpx,op,alpha,beta)
@test 1e-11 > D(result0, result_)

result_ = DenseOperator(basis_position, basis_momentum, copy(randdata2))
result0 = alpha*op*dense(Txp) + beta*result_
QuantumOpticsBase.mul!(result_,op,Txp,alpha,beta)
@test 1e-11 > D(result0, result_)

op = DenseOperator(basis_momentum, basis_momentum, randdata1)
result_ = DenseOperator(basis_position, basis_momentum, copy(randdata2))
result0 = alpha*dense(Txp)*op + beta*result_
QuantumOpticsBase.mul!(result_,Txp,op,alpha,beta)
@test 1e-11 > D(result0, result_)

result_ = DenseOperator(basis_momentum, basis_position, copy(randdata2))
result0 = alpha*op*dense(Tpx) + beta*result_
QuantumOpticsBase.mul!(result_,op,Tpx,alpha,beta)
@test 1e-11 > D(result0, result_)



# Test FFT with lazy product
psi_ = deepcopy(psi0_bx)
QuantumOpticsBase.mul!(psi_,LazyProduct(Txp,Tpx),psi0_bx,Complex(1.),Complex(0.))
@test 1e-12 > norm(psi_ - psi0_bx)
@test 1e-12 > norm(Txp*(Tpx*psi0_bx) - psi0_bx)

psi_ = deepcopy(psi0_bx)
id = dense(identityoperator(basis_momentum))
QuantumOpticsBase.mul!(psi_,LazyProduct(Txp,id,Tpx),psi0_bx,Complex(1.),Complex(0.))
@test 1e-12 > norm(psi_ - psi0_bx)
@test 1e-12 > norm(Txp*id*(Tpx*psi0_bx) - psi0_bx)

# Test dense FFT operator
Txp_dense = DenseOperator(Txp)
Tpx_dense = DenseOperator(Tpx)
@test isa(Txp_dense, DenseOpType)
@test isa(Tpx_dense, DenseOpType)
@test 1e-5 > D(Txp_dense*rho0_pp*Tpx_dense, rho0_xx)

# Test FFT in 2D
N = [21, 18]
xmin = [-32.5, -10π]
xmax = [24.1, 9π]

basis_position = [PositionBasis(xmin[i], xmax[i], N[i]) for i=1:2]
basis_momentum = MomentumBasis.(basis_position)

x0 = [5.1, -0.2]
p0 = [-3.2, 1.33]
sigma = [1., 0.9]
sigma_x = sigma./sqrt(2)
sigma_p = 1.0 ./ (sigma.*sqrt(2))

Txp = transform(tensor(basis_position...), tensor(basis_momentum...))
Tpx = transform(tensor(basis_momentum...), tensor(basis_position...))

Txp_sub = [transform(basis_position[i], basis_momentum[i]) for i=1:2]
Tpx_sub = dagger.(Txp_sub)
Txp_dense = dense.(Txp_sub)
Txp_comp = tensor(Txp_dense...)

difference = (dense(Txp) - Txp_comp).data
@test isapprox(difference, zero(difference); atol=1e-12)

psi0_x = [gaussianstate(basis_position[i], x0[i], p0[i], sigma_x[i]) for i=1:2]
psi0_p = [gaussianstate(basis_momentum[i], x0[i], p0[i], sigma_p[i]) for i=1:2]

psi_p_fft = Tpx*tensor(psi0_x...)
psi_p_fft2 = tensor((Tpx_sub.*psi0_x)...)
@test norm(psi_p_fft - psi_p_fft2) < 1e-15

psi_x_fft = Txp*tensor(psi0_p...)
psi_x_fft2 = tensor((Txp_sub.*psi0_p)...)
@test norm(psi_p_fft - psi_p_fft2) < 1e-15

psi_p_fft = dagger(tensor(psi0_x...))*Txp
psi_p_fft2 = tensor((dagger.(psi0_x).*Txp_sub)...)
@test norm(psi_p_fft - psi_p_fft2) < 1e-15

psi_x_fft = dagger(tensor(psi0_p...))*Tpx
psi_x_fft2 = tensor((dagger.(psi0_p).*Tpx_sub)...)
@test norm(psi_p_fft - psi_p_fft2) < 1e-15

difference = (dense(Txp) - identityoperator(DenseOpType, Txp.basis_l)*Txp).data
@test isapprox(difference, zero(difference); atol=1e-12)
@test_throws AssertionError transform(tensor(basis_position...), tensor(basis_position...))
@test_throws QuantumOpticsBase.IncompatibleBases transform(SpinBasis(1//2)^2, SpinBasis(1//2)^2)

@test dense(Txp) == dense(Txp_sub[1] ⊗ Txp_sub[2])

# Test ket only FFTs
Txp = transform(tensor(basis_position...), tensor(basis_momentum...); ket_only=true)
Tpx = transform(tensor(basis_momentum...), tensor(basis_position...); ket_only=true)

Txp_sub = [transform(basis_position[i], basis_momentum[i]; ket_only=true) for i=1:2]
Tpx_sub = dagger.(Txp_sub)

psi_p_fft = Tpx*tensor(psi0_x...)
psi_p_fft2 = tensor((Tpx_sub.*psi0_x)...)
@test norm(psi_p_fft - psi_p_fft2) < 1e-15

psi_x_fft = Txp*tensor(psi0_p...)
psi_x_fft2 = tensor((Txp_sub.*psi0_p)...)
@test norm(psi_p_fft - psi_p_fft2) < 1e-15

psi_p_fft = dagger(tensor(psi0_x...))*Txp
psi_p_fft2 = tensor((dagger.(psi0_x).*Txp_sub)...)
@test norm(psi_p_fft - psi_p_fft2) < 1e-15

psi_x_fft = dagger(tensor(psi0_p...))*Tpx
psi_x_fft2 = tensor((dagger.(psi0_p).*Tpx_sub)...)
@test norm(psi_p_fft - psi_p_fft2) < 1e-15

psi_x_fft = Txp*tensor(psi0_p...)
psi_x_fft2 = tensor(Txp_sub...)*tensor(psi0_p...)
@test norm(psi_x_fft - psi_x_fft2) < 1e-15

# Test composite basis of mixed type
bc = FockBasis(2)
psi_fock = fockstate(FockBasis(2), 1)
psi1 = tensor(psi0_p[1], psi_fock, psi0_p[2])
psi2 = tensor(psi0_x[1], psi_fock, psi0_x[2])

basis_l = tensor(basis_position[1], bc, basis_position[2])
basis_r = tensor(basis_momentum[1], bc, basis_momentum[2])
Txp = transform(basis_l, basis_r; ket_only=true)
Tpx = transform(basis_r, basis_l; ket_only=true)

psi1_fft = Txp*psi1
psi1_fft2 = tensor(Txp_sub[1]*psi0_p[1], psi_fock, Txp_sub[2]*psi0_p[2])
@test norm(psi1_fft - psi1_fft2) < 1e-15

psi2_fft = Tpx*psi2
psi2_fft2 = tensor(Tpx_sub[1]*psi0_x[1], psi_fock, Tpx_sub[2]*psi0_x[2])
@test norm(psi2_fft - psi2_fft2) < 1e-15

Txp = transform(basis_l, basis_r)
Txp_sub = [transform(basis_position[i], basis_momentum[i]) for i=1:2]
difference = (dense(Txp) - tensor(dense(Txp_sub[1]), dense(one(bc)), dense(Txp_sub[2]))).data
@test isapprox(difference, zero(difference); atol=1e-12)

basis_l = tensor(bc, basis_position[1], basis_position[2])
basis_r = tensor(bc, basis_momentum[1], basis_momentum[2])
Txp2 = transform(basis_l, basis_r)
Tpx2 = transform(basis_r, basis_l)
difference = (dense(Txp) - permutesystems(dense(Txp2), [2, 1, 3])).data
@test isapprox(difference, zero(difference); atol=1e-13)
difference = (dense(dagger(Txp)) - permutesystems(dense(Tpx2), [2, 1, 3])).data
@test isapprox(difference, zero(difference); atol=1e-13)

# Test potentialoperator in more than 1D
N = [21, 18]
xmin = [-32.5, -10π]
xmax = [24.1, 9π]

basis_position = [PositionBasis(xmin[i], xmax[i], N[i]) for i=1:2]
basis_momentum = MomentumBasis.(basis_position)

bcomp_pos = tensor(basis_position...)
bcomp_mom = tensor(basis_momentum...)
V(x, y) = sin(x*y) + cos(x)
xsample, ysample = samplepoints.(basis_position)
V_op = diagonaloperator(bcomp_pos, [V(x, y) for y in ysample for x in xsample])
V_op2 = potentialoperator(bcomp_pos, V)
@test V_op == V_op2

basis_position = PositionBasis.(basis_momentum)
bcomp_pos = tensor(basis_position...)
Txp = transform(bcomp_pos, bcomp_mom)
Tpx = transform(bcomp_mom, bcomp_pos)
xsample, ysample = samplepoints.(basis_position)
V_op = Tpx*dense(diagonaloperator(bcomp_pos, [complex(V(x, y)) for y in ysample for x in xsample]))*Txp
V_op2 = potentialoperator(bcomp_mom, V)
@test V_op == V_op2

N = [17, 12, 9]
xmin = [-32.5, -10π, -0.1]
xmax = [24.1, 9π, 22.0]

basis_position = [PositionBasis(xmin[i], xmax[i], N[i]) for i=1:3]
basis_momentum = MomentumBasis.(basis_position)

bcomp_pos = tensor(basis_position...)
bcomp_mom = tensor(basis_momentum...)
V(x, y, z) = exp(-z^2) + sin(x*y) + cos(x)
xsample, ysample, zsample = samplepoints.(basis_position)
V_op = diagonaloperator(bcomp_pos, [V(x, y, z) for z in zsample for y in ysample for x in xsample])
V_op2 = potentialoperator(bcomp_pos, V)
@test V_op == V_op2

# Test error messages
b1 = PositionBasis(-1, 1, 50)
b2 = MomentumBasis(-1, 1, 30)
@test_throws QuantumOpticsBase.IncompatibleBases transform(b1, b2)
@test_throws QuantumOpticsBase.IncompatibleBases transform(b2, b1)

bc1 = b1 ⊗ bc
bc2 = b2 ⊗ bc
@test_throws QuantumOpticsBase.IncompatibleBases transform(bc1, bc2)
@test_throws QuantumOpticsBase.IncompatibleBases transform(bc2, bc1)

b1 = PositionBasis(-1, 1, 50)
b2 = MomentumBasis(-1, 1, 50)
bc1 = b1 ⊗ bc
bc2 = b2 ⊗ bc
@test_throws QuantumOpticsBase.IncompatibleBases transform(bc1, bc2)
@test_throws QuantumOpticsBase.IncompatibleBases transform(bc2, bc1)
@test_throws QuantumOpticsBase.IncompatibleBases transform(bc1, bc2; index=[2])

bc1 = b1 ⊗ b2
bc2 = b1 ⊗ b2
@test_throws QuantumOpticsBase.IncompatibleBases transform(bc1, bc2)
@test_throws QuantumOpticsBase.IncompatibleBases transform(bc2, bc1)

@test_throws QuantumOpticsBase.IncompatibleBases potentialoperator(bc ⊗ bc, V)

end # testset
end

@testitem "test_states" begin
using Test
using QuantumOpticsBase
using LinearAlgebra, Random
using SparseArrays

@testset "states" begin

Random.seed!(0)

D(x1::Number, x2::Number) = abs(x2-x1)
D(x1::StateVector, x2::StateVector) = norm(x2-x1)

b1 = GenericBasis(3)
b2 = GenericBasis(5)
b3 = GenericBasis(7)
b = b1 ⊗ b2

bra = Bra(b)
ket = Ket(b)

# Test creation
@test_throws DimensionMismatch Bra(b, [1, 2])
@test_throws DimensionMismatch Ket(b, [1, 2])
@test 0 ≈ norm(bra)
@test 0 ≈ norm(ket)
@test_throws QuantumOpticsBase.IncompatibleBases bra*Ket(b1)
@test bra == bra
@test length(bra) == length(bra.data) == 15
@test length(ket) == length(ket.data) == 15
@test QuantumOpticsBase.basis(ket) == b
@test QuantumOpticsBase.basis(bra) == b
@test bra != basisstate(b, 1)

# Test copy
psi1 = randstate(b1)
psi2 = copy(psi1)
@test psi1.data == psi2.data
@test !(psi1.data === psi2.data)
psi2.data[1] = complex(10.)
@test psi1.data[1] != psi2.data[1]

# Arithmetic operations
# =====================
bra_b1 = dagger(randstate(b1))
bra_b2 = dagger(randstate(b2))
bra_b3 = randstate(b3)'

ket_b1 = randstate(b1)
ket_b2 = randstate(b2)
ket_b3 = randstate(b3)

# Addition
@test_throws DimensionMismatch bra_b1 + bra_b2
@test_throws DimensionMismatch ket_b1 + ket_b2
@test 1e-14 > D(bra_b1 + Bra(b1), bra_b1)
@test 1e-14 > D(ket_b1 + Ket(b1), ket_b1)
@test 1e-14 > D(bra_b1 + dagger(ket_b1), dagger(ket_b1) + bra_b1)

# Subtraction
@test_throws DimensionMismatch bra_b1 - bra_b2
@test_throws DimensionMismatch ket_b1 - ket_b2
@test 1e-14 > D(bra_b1 - Bra(b1), bra_b1)
@test 1e-14 > D(ket_b1 - Ket(b1), ket_b1)
@test 1e-14 > D(bra_b1 - dagger(ket_b1), -dagger(ket_b1) + bra_b1)

# Multiplication
@test 1e-14 > D(-3*ket_b1, 3*(-ket_b1))
@test 1e-14 > D(0.3*(bra_b1 - dagger(ket_b1)), 0.3*bra_b1 - dagger(0.3*ket_b1))
@test 1e-14 > D(0.3*(bra_b1 - dagger(ket_b1)), bra_b1*0.3 - dagger(ket_b1*0.3))
@test 0 ≈ bra*ket
@test 1e-14 > D((bra_b1 ⊗ bra_b2)*(ket_b1 ⊗ ket_b2), (bra_b1*ket_b1)*(bra_b2*ket_b2))

# Tensor product
@test tensor(ket_b1) == ket_b1
@test 1e-14 > D((ket_b1 ⊗ ket_b2) ⊗ ket_b3, ket_b1 ⊗ (ket_b2 ⊗ ket_b3))
@test 1e-14 > D((bra_b1 ⊗ bra_b2) ⊗ bra_b3, bra_b1 ⊗ (bra_b2 ⊗ bra_b3))

ket_b1b2 = ket_b1 ⊗ ket_b2
shape = (ket_b1b2.basis.shape...,)
idx = LinearIndices(shape)[2, 3]
@test ket_b1b2.data[idx] == ket_b1.data[2]*ket_b2.data[3]
ket_b1b2b3 = ket_b1 ⊗ ket_b2 ⊗ ket_b3
@test ket_b1b2b3 == tensor(ket_b1, ket_b2, ket_b3)
shape = (ket_b1b2b3.basis.shape...,)
idx = LinearIndices(shape)[1, 4, 3]
@test ket_b1b2b3.data[idx] == ket_b1.data[1]*ket_b2.data[4]*ket_b3.data[3]


# Norm
bf = FockBasis(1)
bra = Bra(bf, [3.0im, -4])
ket = Ket(bf, [-4.0im, 3])
@test 5 ≈ norm(bra)
@test 5 ≈ norm(ket)

bra_normalized = normalize(bra)
ket_normalized = normalize(ket)
@test 5 ≈ norm(bra)
@test 5 ≈ norm(ket)
@test 1 ≈ norm(bra_normalized)
@test 1 ≈ norm(ket_normalized)

bra_copy = deepcopy(bra)
ket_copy = deepcopy(ket)
normalize!(bra_copy)
normalize!(ket_copy)
@test 5 ≈ norm(bra)
@test 5 ≈ norm(ket)
@test 1 ≈ norm(bra_copy)
@test 1 ≈ norm(ket_copy)

# Test basis state
b1 = GenericBasis(2)
b2 = GenericBasis(3)
b = b1 ⊗ b2
x1 = basisstate(b1, 2)
x2 = basisstate(b2, 1)

@test norm(x1) == 1
@test x1.data[2] == 1
@test basisstate(b, [2, 1]) == x1 ⊗ x2

# Conversion to sparse
@test length(sparse(x1).data.nzval)==1
@test sparse(x1').data isa SparseVector

# Test permutating systems
b1 = GenericBasis(2)
b2 = GenericBasis(5)
b3 = FockBasis(3)

psi1 = randstate(b1)
psi2 = randstate(b2)
psi3 = randstate(b3)

psi123 = psi1 ⊗ psi2 ⊗ psi3
psi132 = psi1 ⊗ psi3 ⊗ psi2
psi213 = psi2 ⊗ psi1 ⊗ psi3
psi231 = psi2 ⊗ psi3 ⊗ psi1
psi312 = psi3 ⊗ psi1 ⊗ psi2
psi321 = psi3 ⊗ psi2 ⊗ psi1

@test 1e-14 > D(psi132, permutesystems(psi123, [1, 3, 2]))
@test 1e-14 > D(psi213, permutesystems(psi123, [2, 1, 3]))
@test 1e-14 > D(psi231, permutesystems(psi123, [2, 3, 1]))
@test 1e-14 > D(psi312, permutesystems(psi123, [3, 1, 2]))
@test 1e-14 > D(psi321, permutesystems(psi123, [3, 2, 1]))

@test 1e-14 > D(dagger(psi132), permutesystems(dagger(psi123), [1, 3, 2]))
@test 1e-14 > D(dagger(psi213), permutesystems(dagger(psi123), [2, 1, 3]))
@test 1e-14 > D(dagger(psi231), permutesystems(dagger(psi123), [2, 3, 1]))
@test 1e-14 > D(dagger(psi312), permutesystems(dagger(psi123), [3, 1, 2]))
@test 1e-14 > D(dagger(psi321), permutesystems(dagger(psi123), [3, 2, 1]))

# Test Broadcasting
@test_throws QuantumOpticsBase.IncompatibleBases psi123 .= psi132
@test_throws QuantumOpticsBase.IncompatibleBases psi123 .+ psi132
bra123 = dagger(psi123)
bra132 = dagger(psi132)
@test_throws ArgumentError psi123 .+ bra123
@test_throws QuantumOpticsBase.IncompatibleBases bra123 .= bra132
@test_throws QuantumOpticsBase.IncompatibleBases bra123 .+ bra132
psi_ = copy(psi123)
psi_ .+= psi123
@test psi_ == 2*psi123
bra_ = copy(bra123)
bra_ .= 3*bra123
@test bra_ == 3*dagger(psi123)
bra .= 1.0
ket .= 1.0
@test bra == Bra(bf, [1.0 + 0.0im, 1.0 + 0.0im])
@test ket == Ket(bf, [1.0 + 0.0im, 1.0 + 0.0im])
@test_throws ArgumentError bra .= 1.0 .+ 1.0
@test_throws ArgumentError ket .= 1.0 .+ 1.0

end # testset


@testset "LazyKet" begin

Random.seed!(1)

# LazyKet
b1 = SpinBasis(1//2)
b2 = SpinBasis(1)
b = b1⊗b2
ψ1 = spindown(b1)
ψ2 = spinup(b2)
ψ = LazyKet(b, (ψ1,ψ2))
sz = LazyTensor(b,(1, 2),(sigmaz(b1), sigmaz(b2)))
@test expect(sz, ψ) == expect(sigmaz(b1)⊗sigmaz(b2), ψ1⊗ψ2)

@test ψ ⊗ ψ == LazyKet(b ⊗ b, (ψ1, ψ2, ψ1, ψ2))

ψ2 = deepcopy(ψ)
mul!(ψ2, sz, ψ)
@test Ket(ψ2) == dense(sz) * Ket(ψ)

# randomize data
b1 = GenericBasis(4)
b2 = FockBasis(5)
b3 = SpinBasis(1//2)
ψ1 = randstate(b1)
ψ2 = randstate(b2)
ψ3 = randstate(b3)

b = b1⊗b2⊗b3
ψ = LazyKet(b1⊗b2⊗b3, [ψ1, ψ2, ψ3])

op1 = randoperator(b1)
op2 = randoperator(b2)
op3 = randoperator(b3)

op = rand(ComplexF64) * LazyTensor(b, b, (1, 2, 3), (op1, op2, op3))

@test expect(op, ψ) ≈ expect(dense(op), Ket(ψ))

op_sum = rand(ComplexF64) * LazySum(op, op)
@test expect(op_sum, ψ) ≈ expect(op, ψ) * sum(op_sum.factors)

op_prod = rand(ComplexF64) * LazyProduct(op, op)
@test expect(op_prod, ψ) ≈ expect(dense(op)^2, Ket(ψ)) * op_prod.factor

op_nested = rand(ComplexF64) * LazySum(op_prod, op)
@test expect(op_nested, ψ) ≈ expect(dense(op_prod), Ket(ψ)) * op_nested.factors[1] + expect(dense(op), Ket(ψ)) * op_nested.factors[2]

# test lazytensor with missing indices
op = rand(ComplexF64) * LazyTensor(b, b, (1, 3), (op1, op3))
@test expect(op, ψ) ≈ expect(sparse(op), Ket(ψ))

end
end

@testitem "test_embed" begin
using Test
using QuantumOpticsBase
using Random, SparseArrays, LinearAlgebra

struct EmbedFallbackOperator{BL,BR,T} <: DataOperator{BL,BR}
    basis_l::BL
    basis_r::BR
    data::T
end
Base.eltype(op::EmbedFallbackOperator) = eltype(op.data)

struct EmbedEquivalentBasisA <: Basis
    shape::Vector{Int}
end
struct EmbedEquivalentBasisB <: Basis
    shape::Vector{Int}
end
Base.:(==)(left::EmbedEquivalentBasisA, right::EmbedEquivalentBasisB) =
    left.shape == right.shape
Base.:(==)(left::EmbedEquivalentBasisB, right::EmbedEquivalentBasisA) = right == left

@testset "embed" begin

Random.seed!(0)

# Set up operators
spinbasis = SpinBasis(1//2)

b1 = NLevelBasis(3)
b2 = SpinBasis(1//2)
b3 = FockBasis(2)

I1 = dense(identityoperator(b1))
I2 = dense(identityoperator(b2))
I3 = dense(identityoperator(b3))

b = b1 ⊗ b2 ⊗ b3

op1 = DenseOperator(b1, b1, rand(ComplexF64, length(b1), length(b1)))
op2 = DenseOperator(b2, b2, rand(ComplexF64, length(b2), length(b2)))
op3 = DenseOperator(b3, b3, rand(ComplexF64, length(b3), length(b3)))


# Test Vector{Int}, Vector{AbstractOperator}
x = embed(b, [1,2], [op1, op2])
y = op1 ⊗ op2 ⊗ I3
@test 0 ≈ abs(tracedistance_nh(x, y))

x = embed(b, [1,2], [sparse(op1), sparse(op2)])
y = op1 ⊗ op2 ⊗ I3
@test 0 ≈ abs(tracedistance_nh(dense(x), y))

x = embed(b, 1, op1)
y = op1 ⊗ I2 ⊗ I3
@test 0 ≈ abs(tracedistance_nh(dense(x), y))

x = embed(b, 2, op2)
y = I1 ⊗ op2 ⊗ I3
@test 0 ≈ abs(tracedistance_nh(dense(x), y))

x = embed(b, 3, op3)
y = I1 ⊗ I2 ⊗ op3
@test 0 ≈ abs(tracedistance_nh(dense(x), y))


# Test Dict(Int=>AbstractOperator)
x = embed(b, Dict(1 => sparse(op1), 2 => sparse(op2)))
y = op1 ⊗ op2 ⊗ I3
@test 0 ≈ abs(tracedistance_nh(dense(x), y))

x = embed(b, Dict(1 => op1, 2 => op2))
y = op1 ⊗ op2 ⊗ I3
@test 0 ≈ abs(tracedistance_nh(x, y))

x = embed(b, Dict([1,3] => sparse(op1⊗op3)))
y = op1 ⊗ I2 ⊗ op3
@test 0 ≈ abs(tracedistance_nh(dense(x), y))

x = embed(b, Dict([1,3] => op1⊗op3))
y = op1 ⊗ I2 ⊗ op3
@test 0 ≈ abs(tracedistance_nh(x, y))

x = embed(b, Dict([3,1] => sparse(op3⊗op1)))
y = op1 ⊗ I2 ⊗ op3
@test 0 ≈ abs(tracedistance_nh(dense(x), y))

x = embed(b, Dict([3,1] => op3⊗op1))
y = op1 ⊗ I2 ⊗ op3
@test 0 ≈ abs(tracedistance_nh(x, y))

@testset "inferred multi-index embedding" begin
    b1 = NLevelBasis(2)
    b2 = SpinBasis(1 // 2)
    b3 = FockBasis(2)
    b4 = GenericBasis(2)
    full_basis = b1 ⊗ b2 ⊗ b3 ⊗ b4

    op1_real = DenseOperator(b1, reshape(Float64.(1:4), 2, 2))
    op2_real = DenseOperator(b2, reshape(Float64.(1:4), 2, 2))
    op3_real = DenseOperator(b3, reshape(Float64.(1:9), 3, 3))
    op4_real = DenseOperator(b4, reshape(Float64.(1:4), 2, 2))
    op1_complex = DenseOperator(b1, (1 + 2im) .* op1_real.data)
    op3_complex = DenseOperator(b3, (2 - 1im) .* op3_real.data)

    expected_real = op1_real ⊗ identityoperator(b2) ⊗ op3_real ⊗ identityoperator(b4)
    selected_real = op1_real ⊗ op3_real
    indices = [1, 3]
    selected_data = copy(selected_real.data)
    embedded_real = @inferred embed(full_basis, indices, selected_real)
    @test embedded_real == expected_real
    @test embedded_real.data isa SparseMatrixCSC{Float64,Int}
    @test embedded_real.basis_l === full_basis
    @test embedded_real.basis_r === full_basis
    @test indices == [1, 3]
    @test selected_real.data == selected_data

    selected_complex = op1_complex ⊗ op3_complex
    expected_complex = op1_complex ⊗ identityoperator(b2) ⊗ op3_complex ⊗ identityoperator(b4)
    @test (@inferred embed(full_basis, [1, 3], selected_complex)) == expected_complex
    @test (@inferred embed(full_basis, [1, 3], sparse(selected_real))) == expected_real
    @test (@inferred embed(full_basis, [1, 3], sparse(selected_complex))) == expected_complex

    dense_adjoint = dagger(selected_complex)
    sparse_adjoint = dagger(sparse(selected_complex))
    expected_adjoint =
        dagger(op1_complex) ⊗ identityoperator(b2) ⊗ dagger(op3_complex) ⊗ identityoperator(b4)
    @test (@inferred embed(full_basis, [1, 3], dense_adjoint)) == expected_adjoint
    @test (@inferred embed(full_basis, [1, 3], sparse_adjoint)) == expected_adjoint

    selected_identity = identityoperator(b1 ⊗ b3)
    @test (@inferred embed(full_basis, [1, 3], selected_identity)) == identityoperator(full_basis)

    selected_reordered = op3_complex ⊗ op1_complex
    @test (@inferred embed(full_basis, [3, 1], selected_reordered)) == expected_complex

    expected_contiguous =
        identityoperator(b1) ⊗ op2_real ⊗ op3_real ⊗ identityoperator(b4)
    @test (@inferred embed(full_basis, [2, 3], op2_real ⊗ op3_real)) == expected_contiguous

    selected_permutation = op4_real ⊗ op2_real ⊗ op1_real ⊗ op3_real
    expected_permutation = op1_real ⊗ op2_real ⊗ op3_real ⊗ op4_real
    @test (@inferred embed(full_basis, [4, 2, 1, 3], selected_permutation)) == expected_permutation

    vector_result = @inferred embed(full_basis, [2], op2_real)
    integer_result = @inferred embed(full_basis, 2, op2_real)
    @test vector_result == integer_result

    @test_throws QuantumOpticsBase.IncompatibleBases embed(
        full_basis, [1, 3], op1_real ⊗ op2_real
    )
    @test_throws ArgumentError embed(full_basis, [1, 1], op1_real ⊗ op1_real)
    @test_throws ArgumentError embed(full_basis, [1, 5], op1_real ⊗ op1_real)
    @test_throws AssertionError embed(full_basis, b1 ⊗ b2 ⊗ b3, [1], op1_real)
end

@testset "rectangular multi-index embedding" begin
    dimensions_l = (2, 3, 4, 2)
    dimensions_r = (3, 2, 2, 4)
    bases_l = GenericBasis.(dimensions_l)
    bases_r = GenericBasis.(dimensions_r)
    basis_l = reduce(⊗, bases_l)
    basis_r = reduce(⊗, bases_r)

    op1 = DenseOperator(
        bases_l[1], bases_r[1], reshape(ComplexF64.(1:6), dimensions_l[1], dimensions_r[1])
    )
    op3 = DenseOperator(
        bases_l[3], bases_r[3], reshape(ComplexF64.(1:8), dimensions_l[3], dimensions_r[3])
    )
    selected = op1 ⊗ op3
    expected =
        op1 ⊗ identityoperator(bases_l[2], bases_r[2]) ⊗
        op3 ⊗ identityoperator(bases_l[4], bases_r[4])

    embedded = @inferred embed(basis_l, basis_r, [1, 3], selected)
    @test embedded == expected
    @test embedded.data isa SparseMatrixCSC{ComplexF64,Int}
end

@testset "DataOperator compatibility fallback" begin
    b1 = GenericBasis(2)
    b2 = GenericBasis(3)
    basis = b1 ⊗ b2
    selected_basis = b2 ⊗ b1
    data = reshape(ComplexF64.(1:36), 6, 6)
    custom = EmbedFallbackOperator(selected_basis, selected_basis, data)

    embedded = embed(basis, [2, 1], custom)
    reference = embed(basis, [2, 1], Operator(selected_basis, data))
    @test embedded isa EmbedFallbackOperator
    @test embedded.basis_l === basis
    @test embedded.basis_r === basis
    @test embedded.data == reference.data
    @test custom.data == data

    b3 = GenericBasis(2)
    full_basis = b1 ⊗ b2 ⊗ b3
    selected_basis = b1 ⊗ b3
    diagonal1 = Operator(b1, Diagonal([1.0, 2.0]))
    diagonal3 = Operator(b3, Diagonal([3.0, 4.0]))
    diagonal_operator = diagonal1 ⊗ diagonal3
    diagonal_data = diagonal_operator.data
    @test diagonal_data isa Diagonal
    @test embed(full_basis, [1, 3], diagonal_operator) ==
          diagonal1 ⊗ identityoperator(b2) ⊗ diagonal3
    @test diagonal_operator.data === diagonal_data
end

@testset "cross-type basis compatibility" begin
    basis_a = EmbedEquivalentBasisA([2])
    basis_b = EmbedEquivalentBasisB([2])
    gap_basis = GenericBasis(3)
    full_basis = basis_a ⊗ gap_basis
    data = [1.0 2.0; 3.0 4.0]
    selected = DenseOperator(basis_b, data)

    embedded = @inferred embed(full_basis, [1], selected)
    expected = DenseOperator(basis_a, data) ⊗ identityoperator(gap_basis)
    @test embedded == expected
end

end # testset
end

@testitem "test_spin" begin
using Test
using QuantumOpticsBase
using LinearAlgebra

@testset "spin" begin

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))

# Test creation
@test_throws ArgumentError SpinBasis(1//3)
@test_throws ArgumentError SpinBasis(-1//2)
@test_throws ArgumentError SpinBasis(-1)


for spinnumber=[1//2, 1, 3//2, 4//2]
    spinbasis = SpinBasis(spinnumber)
    I = identityoperator(spinbasis)
    Zero = SparseOperator(spinbasis)
    sx = sigmax(spinbasis)
    sy = sigmay(spinbasis)
    sz = sigmaz(spinbasis)
    sp = sigmap(spinbasis)
    sm = sigmam(spinbasis)


    # Test traces
    @test 0 == tr(sx)
    @test 0 == tr(sy)
    @test 0 == tr(sz)


    # Test kommutation relations
    kommutator(x, y) = x*y - y*x

    @test 1e-12 > D(kommutator(sx, sx), Zero)
    @test 1e-12 > D(kommutator(sx, sy), 2im*sz)
    @test 1e-12 > D(kommutator(sx, sz), -2im*sy)
    @test 1e-12 > D(kommutator(sy, sx), -2im*sz)
    @test 1e-12 > D(kommutator(sy, sy), Zero)
    @test 1e-12 > D(kommutator(sy, sz), 2im*sx)
    @test 1e-12 > D(kommutator(sz, sx), 2im*sy)
    @test 1e-12 > D(kommutator(sz, sy), -2im*sx)
    @test 1e-12 > D(kommutator(sz, sz), Zero)


    # Test creation and anihilation operators
    @test 0 == D(sp, 0.5*(sx + 1im*sy))
    @test 0 == D(sm, 0.5*(sx - 1im*sy))
    @test 0 == D(sx, (sp + sm))
    @test 0 == D(sy, -1im*(sp - sm))


    # Test commutation relations with creation and anihilation operators
    @test 1e-12 > D(kommutator(sp, sm), sz)
    @test 1e-12 > D(kommutator(sz, sp), 2*sp)
    @test 1e-12 > D(kommutator(sz, sm), -2*sm)


    # Test v x (v x u) relation: [sa, [sa, sb]] = 4*(1-delta_{ab})*sb
    @test 1e-12 > D(kommutator(sx, kommutator(sx, sx)), Zero)
    @test 1e-12 > D(kommutator(sx, kommutator(sx, sy)), 4*sy)
    @test 1e-12 > D(kommutator(sx, kommutator(sx, sz)), 4*sz)
    @test 1e-12 > D(kommutator(sy, kommutator(sy, sx)), 4*sx)
    @test 1e-12 > D(kommutator(sy, kommutator(sy, sy)), Zero)
    @test 1e-12 > D(kommutator(sy, kommutator(sy, sz)), 4*sz)
    @test 1e-12 > D(kommutator(sz, kommutator(sz, sx)), 4*sx)
    @test 1e-12 > D(kommutator(sz, kommutator(sz, sy)), 4*sy)
    @test 1e-12 > D(kommutator(sz, kommutator(sz, sz)), Zero)


    # Test spinup and spindown states
    @test 1 ≈ norm(spinup(spinbasis))
    @test 1 ≈ norm(spindown(spinbasis))
    @test 0 ≈ norm(sp*spinup(spinbasis))
    @test 0 ≈ norm(sm*spindown(spinbasis))
end


# Test special relations for spin 1/2

spinbasis = SpinBasis(1//2)
I = identityoperator(spinbasis)
Zero = SparseOperator(spinbasis)
sx = sigmax(spinbasis)
sy = sigmay(spinbasis)
sz = sigmaz(spinbasis)
sp = sigmap(spinbasis)
sm = sigmam(spinbasis)


# Test antikommutator
antikommutator(x, y) = x*y + y*x

@test 0 ≈ D(antikommutator(sx, sx), 2*I)
@test 0 ≈ D(antikommutator(sx, sy), Zero)
@test 0 ≈ D(antikommutator(sx, sz), Zero)
@test 0 ≈ D(antikommutator(sy, sx), Zero)
@test 0 ≈ D(antikommutator(sy, sy), 2*I)
@test 0 ≈ D(antikommutator(sy, sz), Zero)
@test 0 ≈ D(antikommutator(sz, sx), Zero)
@test 0 ≈ D(antikommutator(sz, sy), Zero)
@test 0 ≈ D(antikommutator(sz, sz), 2*I)


# Test if involutory for spin 1/2
@test 0 ≈ D(sx*sx, I)
@test 0 ≈ D(sy*sy, I)
@test 0 ≈ D(sz*sz, I)
@test 0 ≈ D(-1im*sx*sy*sz, I)


# Test consistency of spin up and down with sigmap and sigmam
@test 1e-11 > norm(sm*spinup(spinbasis) - spindown(spinbasis))
@test 1e-11 > norm(sp*spindown(spinbasis) - spinup(spinbasis))

# squeeze operator test SPIN
Nspins = 500
b_spin = SpinBasis(Nspins//2)
s1 = squeeze(b_spin,0.23*sqrt(Nspins)*exp(1im*0.23*pi))
s2 = s1*spindown(b_spin);

# Heisenberg uncertainty test
@test abs(variance(sigmax(b_spin)/2,s2)*variance(sigmay(b_spin)/2,s2)) ≥ abs2(expect(sigmaz(b_spin)/2,s2))/4

# small squeezing test
x1 = 0.023
s1 = squeeze(b_spin,x1*sqrt(Nspins));
s2 = s1*spindown(b_spin);

@test isapprox(2*log(real(variance(sigmax(b_spin)/2,s2))/Nspins*4) , -x1*sqrt(Nspins), atol=1e-2)
@test isapprox(2*log(real(variance(sigmay(b_spin)/2,s2))/Nspins*4) , x1*sqrt(Nspins), atol=1e-2)

end # testset
end

@testitem "JET optimization: TimeDependentSum pairs" tags = [:jet] begin
using JET
using QuantumOpticsBase
using Test

basis = SpinBasis(1 // 2)
sx = sigmax(basis)
sz = sigmaz(basis)

JET.@test_opt target_modules=(QuantumOpticsBase,) TimeDependentSum(cos => sx, sin => sz)

operator = TimeDependentSum(cos => sx, sin => sz)
@test QuantumOpticsBase.coefficients(operator) == (cos, sin)
JET.@test_opt target_modules=(QuantumOpticsBase,) set_time!(operator, 0.25)
end

@testitem "LazyProduct constructor inference" tags = [:jet] begin
using Test
using QuantumOpticsBase
using JET
using LinearAlgebra

basis_1 = SpinBasis(1 // 2)
basis_2 = FockBasis(1)
basis_3 = NLevelBasis(2)
basis_4 = GenericBasis(2)
data = Matrix{ComplexF64}(I, 2, 2)

operator_1 = DenseOperator(basis_1, basis_2, data)
operator_2 = DenseOperator(basis_2, basis_3, data)
operator_3 = DenseOperator(basis_3, basis_4, data)
operator_4 = DenseOperator(basis_4, basis_1, data)

JET.@test_opt target_modules=(QuantumOpticsBase,) LazyProduct(
    operator_1,
    operator_2,
    operator_3,
    operator_4,
)
end

@testitem "JET optimization: partial transpose metrics" tags = [:jet] begin
using Test
using QuantumOpticsBase
using JET

basis = SpinBasis(1 // 2)
up = spinup(basis)
down = spindown(basis)
state = (up ⊗ down - down ⊗ up) / sqrt(2)
rho = dm(state)

JET.@test_opt target_modules=(QuantumOpticsBase,) ptranspose(rho, [1])
JET.@test_opt target_modules=(QuantumOpticsBase,) negativity(rho, 1)
end

@testitem "JET optimization: fundamental quantum operations" tags = [:jet] begin
using Test
using JET
using QuantumOpticsBase
using SparseArrays: sparse
using LinearAlgebra: mul!

spin_basis = SpinBasis(1 // 2)
fock_basis = FockBasis(3)

spin_up = basisstate(spin_basis, 1)
spin_down = basisstate(spin_basis, 2)
fock_one_photon = basisstate(fock_basis, 2)
spin_superposition = spin_up + spin_down
composite_basis = spin_basis ⊗ fock_basis
composite_state = spin_up ⊗ fock_one_photon
spin_density = dm(spin_up)
fock_density = dm(fock_one_photon)
composite_density = dm(composite_state)

sx_sparse = sigmax(spin_basis)
sz_sparse = sigmaz(spin_basis)
sx_dense = dense(sx_sparse)
sz_dense = dense(sz_sparse)
fock_number = number(fock_basis)
spin_identity = identityoperator(spin_basis)
mul_output = copy(spin_up)

jump_operators = [destroy(fock_basis)]
fock_liouvillian = liouvillian(fock_number, jump_operators)

@testset "State algebra" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) basisstate(spin_basis, 1)
    JET.@test_opt target_modules=(QuantumOpticsBase,) dagger(spin_up)
    JET.@test_opt target_modules=(QuantumOpticsBase,) spin_up + spin_down
    JET.@test_opt target_modules=(QuantumOpticsBase,) normalize(spin_superposition)
    JET.@test_opt target_modules=(QuantumOpticsBase,) dagger(spin_up) * spin_up
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(spin_up, fock_one_photon)
    JET.@test_opt target_modules=(QuantumOpticsBase,) dm(spin_up)
    JET.@test_opt target_modules=(QuantumOpticsBase,) tr(spin_density)
end

@testset "Operator kernels" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) dense(sx_sparse)
    JET.@test_opt target_modules=(QuantumOpticsBase,) sparse(sx_dense)
    JET.@test_opt target_modules=(QuantumOpticsBase,) dagger(sx_dense)
    JET.@test_opt target_modules=(QuantumOpticsBase,) sx_sparse + sz_sparse
    JET.@test_opt target_modules=(QuantumOpticsBase,) sx_dense * spin_up
    JET.@test_opt target_modules=(QuantumOpticsBase,) sx_sparse * spin_up
    JET.@test_opt target_modules=(QuantumOpticsBase,) sx_dense * sz_sparse
    JET.@test_opt target_modules=(QuantumOpticsBase,) sx_sparse * sz_dense
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(sx_sparse, fock_number)
    JET.@test_opt target_modules=(QuantumOpticsBase,) mul!(
        mul_output, sx_sparse, spin_down, 1.0 + 0im, 0.0 + 0im
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) spin_identity * spin_up
end

@testset "Observables and composite systems" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) expect(sx_dense, spin_up)
    JET.@test_opt target_modules=(QuantumOpticsBase,) expect(sz_sparse, spin_density)
    JET.@test_opt target_modules=(QuantumOpticsBase,) variance(sz_sparse, spin_up)
    JET.@test_opt target_modules=(QuantumOpticsBase,) embed(composite_basis, 1, sx_sparse)
    JET.@test_opt target_modules=(QuantumOpticsBase,) apply!(
        copy(composite_state), 1, sx_sparse
    )
end

@testset "Open systems" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) liouvillian(
        fock_number, jump_operators
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) fock_liouvillian * fock_density
end

@testset "Inference-sensitive composite operations" begin
    @testset "Composite state construction" begin
        JET.@test_opt target_modules=(QuantumOpticsBase,) basisstate(
            composite_basis, [1, 1]
        )
        JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
            spin_up, fock_one_photon, spin_down
        )
    end

    @testset "Partial trace and indexed expectation" begin
        JET.@test_opt target_modules=(QuantumOpticsBase,) ptrace(
            composite_state, 1
        )
        JET.@test_opt target_modules=(QuantumOpticsBase,) ptrace(
            composite_density, 1
        )
        JET.@test_opt target_modules=(QuantumOpticsBase,) expect(
            1, sx_sparse, composite_state
        )
    end

    @testset "System permutations" begin
        JET.@test_opt target_modules=(QuantumOpticsBase,) permutesystems(
            composite_state, [2, 1]
        )
        JET.@test_opt target_modules=(QuantumOpticsBase,) permutesystems(
            composite_density, [2, 1]
        )
    end
end
end

@testitem "JET optimization: generalized state construction" tags = [:jet] begin
using Test
using JET
using QuantumOpticsBase

basis_1 = SpinBasis(1 // 2)
basis_2 = FockBasis(3)
basis_3 = NLevelBasis(3)
basis_4 = GenericBasis(5)
basis_5 = GenericBasis(2)
basis_123 = tensor(basis_1, basis_2, basis_3)
basis_1234 = tensor(basis_1, basis_2, basis_3, basis_4)
shaped_basis = GenericBasis([2, 3, 4, 5])

@testset "Basis states" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) basisstate(
        basis_1234, length(basis_1234)
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) basisstate(
        basis_123, [1, 2, 3]
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) basisstate(
        ComplexF32, basis_1234, (1, 2, 3, 4)
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) basisstate(
        basis_1234, (Int8(1), UInt8(2), Int32(3), Int64(4))
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) basisstate(
        basis_1234, 1:4
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) basisstate(
        shaped_basis, [1, 2, 3, 4]
    )

    JET.@test_opt target_modules=(QuantumOpticsBase,) sparsebasisstate(
        basis_123, (1, 2, 3)
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) sparsebasisstate(
        Float32, basis_1234, [1, 2, 3, 4]
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) sparsebasisstate(
        shaped_basis, (1, 2, 3, 4)
    )

    # Abstractly typed coordinates still dispatch dynamically in the stride loop.
    abstract_coordinates = Integer[1, 2, 3, 4]
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) basisstate(
        basis_1234, abstract_coordinates
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) sparsebasisstate(
        basis_1234, abstract_coordinates
    )
end

ket_1 = basisstate(Float32, basis_1, 1)
ket_2 = sparsebasisstate(ComplexF64, basis_2, 2)
ket_3 = basisstate(Float64, basis_3, 3)
ket_4 = sparsebasisstate(ComplexF32, basis_4, 4)
ket_5 = basisstate(Int, basis_5, 2)
bra_1, bra_2, bra_3, bra_4, bra_5 = dagger.((ket_1, ket_2, ket_3, ket_4, ket_5))
dense_ket_2 = basisstate(ComplexF64, basis_2, 2)
dense_ket_4 = basisstate(ComplexF32, basis_4, 4)
dense_bra_2 = dagger(dense_ket_2)
dense_bra_4 = dagger(dense_ket_4)
sparse_ket_1 = sparsebasisstate(Float32, basis_1, 1)
sparse_ket_3 = sparsebasisstate(Float64, basis_3, 3)
sparse_ket_5 = sparsebasisstate(Int, basis_5, 2)
sparse_bra_1, sparse_bra_3, sparse_bra_5 =
    dagger.((sparse_ket_1, sparse_ket_3, sparse_ket_5))

@testset "State tensors" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(ket_1)
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(ket_2)
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(bra_1)
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(bra_2)

    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(ket_1, ket_2)
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(ket_2, ket_3)
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(bra_1, bra_2)
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(bra_2, bra_3)

    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        ket_1, ket_2, ket_3, ket_4
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        bra_1, bra_2, bra_3, bra_4
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        ket_1, ket_2, ket_3, ket_4, ket_5
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        bra_1, bra_2, bra_3, bra_4, bra_5
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        ket_1, dense_ket_2, ket_3, dense_ket_4, ket_5
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        bra_1, dense_bra_2, bra_3, dense_bra_4, bra_5
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        sparse_ket_1, ket_2, sparse_ket_3, ket_4, sparse_ket_5
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        sparse_bra_1, bra_2, sparse_bra_3, bra_4, sparse_bra_5
    )

    composite_ket_12 = tensor(ket_1, ket_2)
    composite_ket_23 = tensor(ket_2, ket_3)
    composite_ket_45 = tensor(ket_4, ket_5)
    composite_bra_12 = dagger(composite_ket_12)
    composite_bra_23 = dagger(composite_ket_23)
    composite_bra_45 = dagger(composite_ket_45)

    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        composite_ket_12, ket_3, ket_4
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        ket_1, composite_ket_23, ket_4
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        ket_1, ket_3, composite_ket_45
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        composite_ket_12, composite_ket_45, ket_3
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        composite_bra_12, bra_3, bra_4
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        bra_1, composite_bra_23, bra_4
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        bra_1, bra_3, composite_bra_45
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) tensor(
        composite_bra_12, composite_bra_45, bra_3
    )
end
end

@testitem "JET optimization: generalized traces and observables" tags = [:jet] begin
using Test
using JET
using QuantumOpticsBase
using SparseArrays: sparse

basis_1 = SpinBasis(1 // 2)
basis_2 = FockBasis(1)
basis_3 = NLevelBasis(3)
basis_4 = GenericBasis(2)
ket_1 = basisstate(basis_1, 1)
ket_2 = basisstate(basis_2, 2)
ket_3 = basisstate(basis_3, 3)
ket_4 = basisstate(basis_4, 1)

state_12 = tensor(ket_1, ket_2)
bra_12 = dagger(state_12)
density_12 = dm(state_12)
state_123 = tensor(ket_1, ket_2, ket_3)
bra_123 = dagger(state_123)
density_123 = dm(state_123)
state_1234 = tensor(ket_1, ket_2, ket_3, ket_4)
bra_1234 = dagger(state_1234)
density_1234 = dm(state_1234)

left_12 = basis_1 ⊗ basis_2
right_12 = GenericBasis(2) ⊗ NLevelBasis(3)
dense_rectangular_12 = DenseOperator(
    left_12,
    right_12,
    reshape(ComplexF32.(1:24), 4, 6),
)
sparse_rectangular_12 = sparse(dense_rectangular_12)

left_123 = basis_1 ⊗ basis_2 ⊗ NLevelBasis(4)
right_123 = GenericBasis(2) ⊗ NLevelBasis(3) ⊗ FockBasis(3)
dense_rectangular_123 = DenseOperator(
    left_123,
    right_123,
    reshape(ComplexF32.(1:384), 16, 24),
)
sparse_rectangular_123 = sparse(dense_rectangular_123)

left_1234 = basis_1 ⊗ basis_2 ⊗ basis_3 ⊗ FockBasis(3)
right_1234 = GenericBasis(2) ⊗ NLevelBasis(3) ⊗ FockBasis(2) ⊗ NLevelBasis(5)
dense_rectangular_1234 = DenseOperator(
    left_1234,
    right_1234,
    reshape(ComplexF64.(1:4320), 48, 90),
)
sparse_rectangular_1234 = sparse(dense_rectangular_1234)

operator_1_dense = DenseOperator(basis_1, ComplexF64[0 1; 2im 0])
operator_1_sparse = sparse(operator_1_dense)
operator_2_dense = DenseOperator(basis_2, Float64[0 2; -1 0])
operator_2_sparse = sparse(operator_2_dense)
operator_3_dense = DenseOperator(basis_3, Float32[0 1 0; 0 0 2; 3 0 0])
operator_3_sparse = sparse(operator_3_dense)
operator_12_dense = tensor(operator_1_dense, operator_2_dense)
operator_12_sparse = sparse(operator_12_dense)
state_123_f32 = Ket(state_123.basis, ComplexF32.(state_123.data))
state_123_sparse = Ket(state_123.basis, sparse(state_123.data))
homogeneous_state_1234 = tensor(ket_1, ket_1, ket_1, ket_1)

# A broken marker must emit at least one package-owned report. If the call becomes
# inference-clean, the test fails so that the marker can be removed.
@testset "Partial traces and reductions" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) ptrace(bra_12, 1)
    JET.@test_opt target_modules=(QuantumOpticsBase,) ptrace(
        dense_rectangular_12, 1
    )

    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        state_12, [1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        bra_12, [2]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        density_12, [1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) reduced(
        state_12, 1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) reduced(
        density_12, [2]
    )

    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        state_123, 1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        state_123, [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        bra_123, [2]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        density_123, 3
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        density_123, [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) reduced(
        state_123, 2
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) reduced(
        bra_123, [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) reduced(
        density_123, [2]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        state_123_sparse, 1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        dagger(state_123_sparse), [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) reduced(
        state_123_sparse, [2]
    )

    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        state_1234, 2
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        state_1234, [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        bra_1234, [1, 3, 4]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        density_1234, 4
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        density_1234, [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) reduced(
        density_1234, [1, 3]
    )

    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        sparse_rectangular_12, 1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        dense_rectangular_123, 1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        dense_rectangular_123, [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        sparse_rectangular_123, [1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        sparse_rectangular_123, [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        dense_rectangular_1234, [1, 3]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) ptrace(
        sparse_rectangular_1234, [1, 3]
    )
end

@testset "Indexed expectations and variances" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) expect(
        1, operator_1_sparse, state_123
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) expect(
        2, operator_2_sparse, state_123
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) expect(
        3, operator_3_sparse, state_123
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) expect(
        1, operator_1_sparse, state_123_f32
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) expect(
        1, operator_1_sparse, state_123_sparse
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) expect(
        2, operator_1_sparse, homogeneous_state_1234
    )

    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        1, operator_1_dense, state_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        [1], operator_1_sparse, state_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        1, dagger(operator_1_sparse), state_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        [1, 2], operator_12_dense, state_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        [1, 2], operator_12_sparse, state_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        2, operator_2_sparse, state_1234
    )

    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        1, operator_1_dense, density_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        2, operator_2_sparse, density_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        [1, 2], operator_12_sparse, density_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) expect(
        2, operator_2_sparse, density_1234
    )

    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) variance(
        1, operator_1_dense, state_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) variance(
        2, operator_2_sparse, state_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) variance(
        [1, 2], operator_12_dense, state_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) variance(
        2, operator_2_sparse, state_1234
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) variance(
        1, operator_1_dense, density_123
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) variance(
        2, operator_2_sparse, density_1234
    )
end
end

@testitem "JET optimization: generalized system permutations" tags = [:jet] begin
using Test
using JET
using QuantumOpticsBase
using SparseArrays: sparse

basis_1 = SpinBasis(1 // 2)
basis_2 = FockBasis(2)
basis_3 = NLevelBasis(2)
basis_4 = GenericBasis(2)

basis_12 = basis_1 ⊗ basis_2
basis_123 = basis_12 ⊗ basis_3
basis_1234 = basis_123 ⊗ basis_4
homogeneous_basis_123 = basis_1 ⊗ basis_1 ⊗ basis_1

state_12 = basisstate(basis_12, [1, 2])
state_123 = basisstate(basis_123, [1, 2, 2])
state_1234 = basisstate(basis_1234, [1, 2, 2, 1])
homogeneous_state_123 = basisstate(homogeneous_basis_123, [1, 2, 1])
sparse_state_12 = sparsebasisstate(basis_12, [1, 2])
sparse_state_123 = sparsebasisstate(basis_123, [1, 2, 2])

right_basis_12 = GenericBasis(4) ⊗ NLevelBasis(2)
right_basis_123 = right_basis_12 ⊗ FockBasis(1)
right_basis_1234 = right_basis_123 ⊗ GenericBasis(2)
dense_rectangular_12 = DenseOperator(
    basis_12,
    right_basis_12,
    zeros(ComplexF64, length(basis_12), length(right_basis_12)),
)
dense_rectangular_123 = DenseOperator(
    basis_123,
    right_basis_123,
    zeros(ComplexF64, length(basis_123), length(right_basis_123)),
)
dense_rectangular_1234 = DenseOperator(
    basis_1234,
    right_basis_1234,
    zeros(ComplexF64, length(basis_1234), length(right_basis_1234)),
)
sparse_rectangular_12 = sparse(dense_rectangular_12)
sparse_rectangular_123 = sparse(dense_rectangular_123)
sparse_rectangular_1234 = sparse(dense_rectangular_1234)

dense_identity_12 = dense(identityoperator(basis_12))
dense_identity_123 = dense(identityoperator(basis_123))
lazy_tensor_12 = LazyTensor(basis_12, (1,), (sigmax(basis_1),))
lazy_tensor_123 = LazyTensor(
    basis_123,
    (1, 3),
    (sigmax(basis_1), identityoperator(basis_3)),
)
lazy_tensor_1234 = LazyTensor(
    basis_1234,
    (1, 4),
    (sigmax(basis_1), identityoperator(basis_4)),
)
lazy_sum_12 = LazySum(dense_identity_12, 2 * dense_identity_12)
lazy_sum_123 = LazySum(dense_identity_123, 2 * dense_identity_123)
lazy_product_12 = LazyProduct(dense_identity_12, dense_identity_12)
lazy_product_123 = LazyProduct(dense_identity_123, dense_identity_123)

@testset "Bipartite fast paths" begin
    JET.@test_opt target_modules=(QuantumOpticsBase,) permutesystems(
        dagger(state_12), [2, 1]
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) permutesystems(
        sparse_state_12, Int8[2, 1]
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) permutesystems(
        state_12, 2:-1:1
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) permutesystems(
        dense_rectangular_12, view([2, 1], :)
    )
    JET.@test_opt target_modules=(QuantumOpticsBase,) permutesystems(
        lazy_sum_12, [2, 1]
    )
end

@testset "General-rank state debt" begin
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        state_123, [2, 3, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        dagger(state_123), 3:-1:1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        dm(state_123), view([1, 2, 3], :)
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        homogeneous_state_123, [2, 3, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        sparse_state_123, [2, 3, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        state_1234, Int8[2, 3, 4, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        dagger(state_1234), [4, 3, 2, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        dm(state_1234), 1:4
    )
end

@testset "Operator storage and wrapper debt" begin
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        dense_rectangular_123, [2, 3, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        dense_rectangular_1234, [2, 3, 4, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        sparse_rectangular_12, [2, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        sparse_rectangular_123, 3:-1:1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        sparse_rectangular_1234, 4:-1:1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        identityoperator(basis_123), [2, 3, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        dagger(dense_rectangular_12), [2, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        dagger(dense_rectangular_123), [2, 3, 1]
    )
end

@testset "Lazy operator debt" begin
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        lazy_tensor_12, [2, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        lazy_tensor_123, 3:-1:1
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        lazy_tensor_1234, [2, 3, 4, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        lazy_sum_123, [2, 3, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        lazy_product_12, [2, 1]
    )
    JET.@test_opt broken=true target_modules=(QuantumOpticsBase,) permutesystems(
        lazy_product_123, [2, 3, 1]
    )
end
end

# Optional test flags
JET_flag = get(ENV, "JET_TEST", "") == "true"
CUDA_flag = false
AMDGPU_flag = false
OpenCL_flag = false

JET_flag && @info "Running with JET tests."

if Sys.iswindows()
    @info "Skipping GPU tests -- only executed on *NIX platforms."
else
    CUDA_flag = get(ENV, "CUDA_TEST", "") == "true"
    AMDGPU_flag = get(ENV, "AMDGPU_TEST", "") == "true"
    OpenCL_flag = get(ENV, "OpenCL_TEST", "") == "true"

    CUDA_flag && @info "Running with CUDA tests."
    AMDGPU_flag && @info "Running with AMDGPU tests."
    OpenCL_flag && @info "Running with OpenCL tests."
    if !any((CUDA_flag, AMDGPU_flag, OpenCL_flag))
        @info "Skipping GPU tests -- must be explicitly enabled."
        @info "Environment must set [CUDA, AMDGPU, OpenCL]_TEST=true."
    end
end

using Pkg
JET_flag && Pkg.add("JET")
CUDA_flag && Pkg.add("CUDA")
AMDGPU_flag && Pkg.add("AMDGPU")
OpenCL_flag && Pkg.add(["pocl_jll", "OpenCL"])
if any((CUDA_flag, AMDGPU_flag, OpenCL_flag))
    Pkg.add(["Adapt", "GPUArraysCore", "GPUArrays"])
end

using TestItemRunner
using QuantumOpticsBase

# filter for the test
testfilter = ti -> begin
  exclude = Symbol[]
  
  if JET_flag
    return :jet in ti.tags
  else
    push!(exclude, :jet)
  end
  
  if CUDA_flag
    return :cuda in ti.tags
  else
    push!(exclude, :cuda)
  end

  if AMDGPU_flag
    return :amdgpu in ti.tags
  else
    push!(exclude, :amdgpu)
  end

  if OpenCL_flag
    return :opencl in ti.tags
  else
    push!(exclude, :opencl)
  end
  
  if !(VERSION >= v"1.10") || get(ENV, "QUANTUMSAVORY_DOWNGRADE_TEST", "") == "true"
    push!(exclude, :aqua)
    push!(exclude, :doctests)
  end

  return all(!in(exclude), ti.tags)
end
println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

@run_package_tests filter=testfilter

@testitem "test_printing" begin
using Test
using QuantumOpticsBase

@testset "printing" begin

@test sprint(show, GenericBasis([2, 3])) == "Basis(shape=[2,3])"
@test sprint(show, GenericBasis(2)) == "Basis(dim=2)"
@test sprint(show, SpinBasis(1//1)) == "Spin(1)"
@test sprint(show, SpinBasis(3//2)) == "Spin(3/2)"
@test sprint(show, FockBasis(1)) == "Fock(cutoff=1)"
@test sprint(show, NLevelBasis(2)) == "NLevel(N=2)"

@test sprint(show, PositionBasis(-4, 4, 10)) == "Position(xmin=-4, xmax=4, N=10)"
@test sprint(show, MomentumBasis(-4, 4, 10)) == "Momentum(pmin=-4, pmax=4, N=10)"

b_fock = FockBasis(4)
states = [fockstate(b_fock, 2), coherentstate(b_fock, 0.4)]
@test sprint(show, SubspaceBasis(states)) == "Subspace(superbasis=Fock(cutoff=4), states:2)"

b_mb = ManyBodyBasis(b_fock, fermionstates(b_fock, 2))
@test sprint(show, b_mb) == "ManyBody(onebodybasis=Fock(cutoff=4), states:10)"

state = fockstate(FockBasis(2), 2)
@test sprint(show, state) == "Ket(dim=3)\n  basis: Fock(cutoff=2)\n 0.0 + 0.0im\n 0.0 + 0.0im\n 1.0 + 0.0im"
state = dagger(state)
@test sprint(show, state) == "Bra(dim=3)\n  basis: Fock(cutoff=2)\n 0.0 - 0.0im\n 0.0 - 0.0im\n 1.0 - 0.0im"

op = DenseOperator(FockBasis(1))
@test sprint(show, op) == "Operator(dim=2x2)
  basis: Fock(cutoff=1)
 0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im"

op = DenseOperator(b_fock, b_fock ⊗ SpinBasis(1//2))
@test sprint(show, op) == "Operator(dim=5x10)
  basis left:  Fock(cutoff=4)
  basis right: [Fock(cutoff=4) ⊗ Spin(1/2)]
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im"

op = SparseOperator(b_fock, b_fock ⊗ SpinBasis(1//2))
if VERSION < v"1.6.0-beta1"
@test sprint(show, op) == "Operator(dim=5x10)
  basis left:  Fock(cutoff=4)
  basis right: [Fock(cutoff=4) ⊗ Spin(1/2)]
    []"
else
# @test sprint(show, op) == "Operator(dim=5x10)\n  basis left:  Fock(cutoff=4)\n  basis right: [Fock(cutoff=4) ⊗ Spin(1/2)]\n     ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅    \n     ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅    \n     ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅    \n     ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅    \n     ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅          ⋅    "
end

op = SparseOperator(b_fock)
op.data[2,2] = 1
if VERSION < v"1.6.0-beta1"
@test replace(sprint(show, op), "\t" => "  ") == "Operator(dim=5x5)
  basis: Fock(cutoff=4)\n  [2, 2]  =  1.0+0.0im"
else
# @test replace(sprint(show, op), "\t" => "  ") == "Operator(dim=5x5)\n  basis: Fock(cutoff=4)\n     ⋅          ⋅          ⋅          ⋅          ⋅    \n     ⋅      1.0+0.0im      ⋅          ⋅          ⋅    \n     ⋅          ⋅          ⋅          ⋅          ⋅    \n     ⋅          ⋅          ⋅          ⋅          ⋅    \n     ⋅          ⋅          ⋅          ⋅          ⋅    "
end

op = LazySum(SparseOperator(b_fock), DenseOperator(b_fock))
@test sprint(show, op) == "LazySum(dim=5x5)
  basis: Fock(cutoff=4)
  operators: 2"

op = LazyProduct(SparseOperator(b_fock), DenseOperator(b_fock))
@test sprint(show, op) == "LazyProduct(dim=5x5)
  basis: Fock(cutoff=4)
  operators: 2"

b_fock = FockBasis(2)
b_spin = SpinBasis(1//2)
b_mb = ManyBodyBasis(b_spin, fermionstates(b_spin, 1))
op = LazyTensor(b_fock ⊗ b_mb ⊗ b_spin, [1, 3], (SparseOperator(b_fock), DenseOperator(b_spin)))
@test sprint(show, op) == "LazyTensor(dim=12x12)
  basis: [Fock(cutoff=2) ⊗ ManyBody(onebodybasis=Spin(1/2), states:2) ⊗ Spin(1/2)]
  operators: 2
  indices: [1,3]"

bx = PositionBasis(-2, 2, 4)
bp = MomentumBasis(bx)
Tpx = transform(bp, bx)
@test sprint(show, Tpx) == "FFTOperators(dim=4x4)
  basis left:  Momentum(pmin=-3.141592653589793, pmax=3.141592653589793, N=4)
  basis right: Position(xmin=-2, xmax=2, N=4)"

# Inversed tensor product ordering
QuantumOpticsBase.set_printing(standard_order=true)

n = fockstate(b_fock, 1)
@test sprint(show, n) == "Ket(dim=3)\n  basis: Fock(cutoff=2)\n 0.0 + 0.0im\n 1.0 + 0.0im\n 0.0 + 0.0im"

spin1 = spindown(b_spin)
spin2 = spinup(b_spin)
state = n ⊗ spin1 ⊗ spin2
state_data = kron(n.data, spin1.data, spin2.data)
state_data_str = sprint(Base.print_array, state_data)
@test sprint(show, state) == "Ket(dim=12)
  basis: [Fock(cutoff=2) ⊗ Spin(1/2) ⊗ Spin(1/2)]\n"*state_data_str

state_data_str = sprint(Base.print_array, conj.(state_data))
@test sprint(show, dagger(state)) == "Bra(dim=12)
  basis: [Fock(cutoff=2) ⊗ Spin(1/2) ⊗ Spin(1/2)]\n"*state_data_str

op = dm(state)
op_data = state_data * state_data'
type_len = if VERSION < v"1.6.0-beta1"
    length("Complex{Float64}")
else
    length("ComplexF64")
end
op_data_str1 = split(sprint(show, op_data)[type_len+2:end-1], ";")
for i=1:length(op_data_str1)
    op_data_str1[i] = join(split(op_data_str1[i]), "  ")
    op_data_str1[i] = replace(op_data_str1[i], "  +  "=>"+")
end
op_data_str = join(op_data_str1, "\n ")
@test sprint(show, op) == "Operator(dim=12x12)
  basis: [Fock(cutoff=2) ⊗ Spin(1/2) ⊗ Spin(1/2)]\n "*op_data_str

op = sparse(op)
op_data = sparse(op_data)
op_data_str = sprint(show, op_data)[4:end]
# @test sprint(show, op) == "Operator(dim=12x12)
#   basis: [Fock(cutoff=2) ⊗ Spin(1/2) ⊗ Spin(1/2)]\n  "*op_data_str

paulix, pauliy = sigmax(b_spin), sigmay(b_spin)
pauli = paulix ⊗ pauliy
@test sprint(show, pauli) == "Operator(dim=4x4)\n  basis: [Spin(1/2) ⊗ Spin(1/2)]\n  [4, 1]  =  0.0+1.0im\n  [3, 2]  =  0.0-1.0im\n  [2, 3]  =  0.0+1.0im\n  [1, 4]  =  0.0-1.0im"
@test sprint((io, x) -> show(IOContext(io, :limit=>true, :displaysize=>(20,80)), x), pauli ⊗ pauli) == "Operator(dim=16x16)\n  basis: [Spin(1/2) ⊗ Spin(1/2) ⊗ Spin(1/2) ⊗ Spin(1/2)]\n  [16,  1]  =  -1.0+0.0im\n  [15,  2]  =  1.0+0.0im\n  [14,  3]  =  -1.0+0.0im\n  [13,  4]  =  1.0+0.0im\n  [12,  5]  =  1.0+0.0im\n  ⋮\n  [6 , 11]  =  -1.0+0.0im\n  [5 , 12]  =  1.0+0.0im\n  [4 , 13]  =  1.0+0.0im\n  [3 , 14]  =  -1.0-0.0im\n  [2 , 15]  =  1.0+0.0im\n  [1 , 16]  =  -1.0-0.0im"
@test sprint(show, dense(pauli)) == "Operator(dim=4x4)
  basis: [Spin(1/2) ⊗ Spin(1/2)]
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0-1.0im
 0.0+0.0im  0.0+0.0im  0.0+1.0im  0.0+0.0im
 0.0+0.0im  0.0-1.0im  0.0+0.0im  0.0+0.0im
 0.0+1.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im"

hadamard = DenseOperator(b_spin, 1/sqrt(2) * Complex.([1 1; 1 -1]))
@test sprint(show, sigmax(b_spin) ⊗ hadamard) == "Operator(dim=4x4)\n  basis: [Spin(1/2) ⊗ Spin(1/2)]\n  [3, 1]  =  0.707107+0.0im\n  [4, 1]  =  0.707107+0.0im\n  [3, 2]  =  0.707107+0.0im\n  [4, 2]  =  -0.707107+0.0im\n  [1, 3]  =  0.707107+0.0im\n  [2, 3]  =  0.707107+0.0im\n  [1, 4]  =  0.707107+0.0im\n  [2, 4]  =  -0.707107+0.0im"
@test sprint((io, x) -> show(IOContext(io, :limit=>true, :displaysize=>(20,80)), x), dense(sigmax(b_spin) ⊗ hadamard ⊗ hadamard ⊗ hadamard)) ==
"Operator(dim=16x16)\n  basis: [Spin(1/2) ⊗ Spin(1/2) ⊗ Spin(1/2) ⊗ Spin(1/2)]\n      0.0+0.0im        0.0+0.0im  …   0.353553+0.0im   0.353553+0.0im\n      0.0+0.0im        0.0+0.0im      0.353553+0.0im  -0.353553+0.0im\n      0.0+0.0im        0.0+0.0im     -0.353553+0.0im  -0.353553+0.0im\n      0.0+0.0im        0.0+0.0im     -0.353553+0.0im   0.353553-0.0im\n      0.0+0.0im        0.0+0.0im     -0.353553+0.0im  -0.353553+0.0im\n      0.0+0.0im        0.0+0.0im  …  -0.353553+0.0im   0.353553-0.0im\n      0.0+0.0im        0.0+0.0im      0.353553+0.0im   0.353553+0.0im\n      0.0+0.0im        0.0+0.0im      0.353553+0.0im  -0.353553+0.0im\n 0.353553+0.0im   0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im  -0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im   0.353553+0.0im  …        0.0+0.0im        0.0+0.0im\n 0.353553+0.0im  -0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im   0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im  -0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im   0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im  -0.353553+0.0im  …        0.0+0.0im        0.0+0.0im"

@test sprint((io, x) -> show(IOContext(io, :limit=>true, :displaysize=>(16,80)), x), dense(sigmax(b_spin) ⊗ hadamard ⊗ hadamard ⊗ hadamard)) ==
"Operator(dim=16x16)\n  basis: [Spin(1/2) ⊗ Spin(1/2) ⊗ Spin(1/2) ⊗ Spin(1/2)]\n      0.0+0.0im        0.0+0.0im  …   0.353553+0.0im   0.353553+0.0im\n      0.0+0.0im        0.0+0.0im      0.353553+0.0im  -0.353553+0.0im\n      0.0+0.0im        0.0+0.0im     -0.353553+0.0im  -0.353553+0.0im\n      0.0+0.0im        0.0+0.0im     -0.353553+0.0im   0.353553-0.0im\n      0.0+0.0im        0.0+0.0im     -0.353553+0.0im  -0.353553+0.0im\n      0.0+0.0im        0.0+0.0im  …  -0.353553+0.0im   0.353553-0.0im\n         ⋮                        ⋱                            ⋮     \n 0.353553+0.0im  -0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im   0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im  -0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im   0.353553+0.0im           0.0+0.0im        0.0+0.0im\n 0.353553+0.0im  -0.353553+0.0im  …        0.0+0.0im        0.0+0.0im"

nlevel1 = basisstate(NLevelBasis(4), 1)
nlevel2 = basisstate(NLevelBasis(4), 2)
nlevel3 = basisstate(NLevelBasis(3), 3)
@test sprint((io, x) -> show(IOContext(io, :limit=>true, :displaysize=>(16,80)), x), (nlevel1 ⊗ nlevel2) ⊗ dagger(nlevel3)) ==
"Operator(dim=16x3)\n  basis left:  [NLevel(N=4) ⊗ NLevel(N=4)]\n  basis right: NLevel(N=3)\n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n 0.0+0.0im  0.0+0.0im  1.0+0.0im\n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n    ⋮                           \n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n 0.0+0.0im  0.0+0.0im  0.0+0.0im\n 0.0+0.0im  0.0+0.0im  0.0+0.0im"

# Test switching back
QuantumOpticsBase.set_printing(standard_order=false)
state_data = kron(spin2.data, spin1.data, n.data)
state_data_str = sprint(Base.print_array, state_data)
@test sprint(show, state) == "Ket(dim=12)
  basis: [Fock(cutoff=2) ⊗ Spin(1/2) ⊗ Spin(1/2)]\n"*state_data_str


end # testset
end

# GPU backend imports
import Adapt
using QuantumOpticsBase
using LinearAlgebra, Random, Test
using SparseArrays

# For memory management in GPU tests
using GPUArrays: AllocCache, @cached, unsafe_free!

function test_basic_operations(AT, synchronize)
    """Test basic quantum operations on GPU arrays."""
    cache = AllocCache()
    
    for n in test_sizes
        for r in 1:round_count
            @cached cache begin
                
                @testset "Basic Operations - Size $n" begin
                    # Create test bases
                    b1 = GenericBasis(n)
                    b2 = GenericBasis(n)
                    
                    # Test operator creation and adaptation
                    cpu_op, gpu_op = create_test_operator(b1, b2, AT)
                    
                    @test typeof(gpu_op.data) <: AT
                    @test verify_gpu_result(cpu_op, gpu_op)
                    
                    # Test ket creation and adaptation  
                    cpu_ket, gpu_ket = create_test_ket(b1, AT)
                    
                    @test typeof(gpu_ket.data) <: AT
                    @test verify_gpu_result(cpu_ket, gpu_ket)
                    
                    # Test bra creation and adaptation
                    cpu_bra, gpu_bra = create_test_bra(b1, AT)
                    
                    @test typeof(gpu_bra.data) <: AT
                    @test verify_gpu_result(cpu_bra, gpu_bra)
                    
                    # Test operator multiplication (both on GPU)
                    cpu_op2, gpu_op2 = create_test_operator(b2, b1, AT)
                    
                    cpu_result = cpu_op * cpu_op2
                    gpu_result = gpu_op * gpu_op2
                    synchronize()
                    
                    @test verify_gpu_result(cpu_result, gpu_result)
                    
                    # Test adjoint/dagger operation
                    cpu_dag = dagger(cpu_op)
                    gpu_dag = dagger(gpu_op)
                    synchronize()
                    
                    @test verify_gpu_result(cpu_dag, gpu_dag)
                    
                    # Test trace operation
                    if n == length(b2)  # Square matrices only
                        cpu_trace = tr(cpu_op)
                        gpu_trace = tr(gpu_op)
                        synchronize()
                        
                        @test isapprox(cpu_trace, gpu_trace, atol=GPU_TOL)
                    end
                    
                    # Test norm operations
                    cpu_norm = norm(cpu_ket)
                    gpu_norm = norm(gpu_ket)
                    synchronize()
                    
                    @test isapprox(cpu_norm, gpu_norm, atol=GPU_TOL)
                end
                
            end
        end
    end
end

import Base: ==, *, /, +, -, Broadcast
import SparseArrays: sparse
import FastExpm: fastExpm

const SparseOpPureType{BL,BR} = Operator{BL,BR,<:SparseMatrixCSC}
const SparseOpAdjType{BL,BR} = Operator{BL,BR,<:Adjoint{<:Number,<:SparseMatrixCSC}}
const SparseOpType{BL,BR} = Union{SparseOpPureType{BL,BR},SparseOpAdjType{BL,BR}}

"""
    SparseOperator(b1[, b2, data])

Sparse array implementation of Operator.

The matrix is stored as the julia built-in type `SparseMatrixCSC` in the `data` field.
"""
SparseOperator(b1::Basis, b2::Basis, data) = Operator(b1, b2, SparseMatrixCSC(data))
SparseOperator(b1::Basis, b2::Basis, data::SparseMatrixCSC) = Operator(b1, b2, data)
SparseOperator(b::Basis, data) = SparseOperator(b, b, data)
SparseOperator(op::DataOperator) = SparseOperator(op.basis_l, op.basis_r, op.data)
SparseOperator(::Type{T},b1::Basis,b2::Basis) where T = SparseOperator(b1,b2,spzeros(T,length(b1),length(b2)))
SparseOperator(::Type{T},b::Basis) where T = SparseOperator(b,b,spzeros(T,length(b),length(b)))
SparseOperator(b1::Basis, b2::Basis) = SparseOperator(ComplexF64, b1, b2)
SparseOperator(b::Basis) = SparseOperator(ComplexF64, b, b)

sparse(a::DataOperator) = Operator(a.basis_l, a.basis_r, sparse(a.data))

function ptrace(op::SparseOpPureType, indices)
    check_ptrace_arguments(op, indices)
    shape = [op.basis_l.shape; op.basis_r.shape]
    data = ptrace(op.data, shape, indices)
    b_l = ptrace(op.basis_l, indices)
    b_r = ptrace(op.basis_r, indices)
    Operator(b_l, b_r, data)
end

function expect(op::SparseOpPureType{B1,B2}, state::Operator{B2,B2}) where {B1,B2}
    check_samebases(op, state)
    result = zero(promote_type(eltype(op),eltype(state)))
    @inbounds for colindex = 1:op.data.n
        for i=op.data.colptr[colindex]:op.data.colptr[colindex+1]-1
            result += op.data.nzval[i]*state.data[colindex, op.data.rowval[i]]
        end
    end
    result
end

"""
    exp(op::SparseOpType; opts...)

Operator exponential used, for example, to calculate displacement operators.
Uses [`FastExpm.jl.jl`](https://github.com/fmentink/FastExpm.jl) which will return a sparse
or dense operator depending on which is more efficient.
All optional arguments are passed to `fastExpm` and can be used to specify tolerances.

If you only need the result of the exponential acting on a vector,
consider using much faster implicit methods that do not calculate the entire exponential.
"""
function exp(op::T; opts...) where {B,T<:SparseOpType{B,B}}
    if iszero(op)
        return identityoperator(op)
    else
        return SparseOperator(op.basis_l, op.basis_r, fastExpm(op.data; opts...))
    end
end

identityoperator(::Type{T}, ::Type{S}, b1::Basis, b2::Basis) where {T<:SparseOpType,S<:Number} =
    SparseOperator(b1, b2, sparse(one(S)*I, length(b1), length(b2)))
identityoperator(::Type{T}, ::Type{S}, b::Basis) where {T<:SparseOpType,S<:Number} =
    SparseOperator(b, b, sparse(one(S)*I, length(b), length(b)))

const EyeOpPureType{BL,BR} = Operator{BL,BR,<:Eye}
const EyeOpAdjType{BL,BR} = Operator{BL,BR,<:Adjoint{<:Number,<:Eye}}
const EyeOpType{BL,BR} = Union{EyeOpPureType{BL,BR},EyeOpAdjType{BL,BR}}

identityoperator(::Type{T}, ::Type{S}, b1::Basis, b2::Basis) where {T<:DataOperator,S<:Number} =
    Operator(b1, b2, Eye{S}(length(b1), length(b2)))
identityoperator(::Type{T}, ::Type{S}, b::Basis) where {T<:DataOperator,S<:Number} =
    Operator(b, b, Eye{S}(length(b)))

identityoperator(::Type{T}, b1::Basis, b2::Basis) where T<:Number = identityoperator(DataOperator, T, b1, b2) # XXX This is purposeful type piracy over QuantumInterface, that hardcodes the use of QuantumOpticsBase.DataOperator in identityoperator. Also necessary for backward compatibility.
identityoperator(::Type{T}, b::Basis) where T<:Number = identityoperator(DataOperator, T, b)

"""
    diagonaloperator(b::Basis)

Create a diagonal operator of type [`SparseOperator`](@ref).
"""
function diagonaloperator(b::Basis, diag)
  @assert 1 <= length(diag) <= length(b)
  SparseOperator(b, spdiagm(0=>diag))
end

# Fast in-place multiplication implementations
mul!(result::DenseOpType{B1,B3},M::SparseOpType{B1,B2},b::DenseOpType{B2,B3},alpha,beta) where {B1,B2,B3} = (gemm!(alpha,M.data,b.data,beta,result.data); result)
mul!(result::DenseOpType{B1,B3},a::DenseOpType{B1,B2},M::SparseOpType{B2,B3},alpha,beta) where {B1,B2,B3} = (gemm!(alpha,a.data,M.data,beta,result.data); result)
mul!(result::Ket{B1},M::SparseOpPureType{B1,B2},b::Ket{B2},alpha,beta) where {B1,B2} = (gemv!(alpha,M.data,b.data,beta,result.data); result)
mul!(result::Bra{B2},b::Bra{B1},M::SparseOpPureType{B1,B2},alpha,beta) where {B1,B2} = (gemv!(alpha,b.data,M.data,beta,result.data); result)

# Ensure that Eye is not densified # TODO - some of this can still be special cased on Eye or lazy embed
+(op1::EyeOpType{BL,BR},op2::SparseOpType{BL,BR}) where {BL,BR} = sparse(op1) + op2
-(op1::EyeOpType{BL,BR},op2::SparseOpType{BL,BR}) where {BL,BR} = sparse(op1) - op2
+(op1::SparseOpType{BL,BR},op2::EyeOpType{BL,BR}) where {BL,BR} = sparse(op2) + op1
-(op2::SparseOpType{BL,BR},op1::EyeOpType{BL,BR}) where {BL,BR} = op2 - sparse(op1)
+(op1::EyeOpType{BL,BR},op2::EyeOpType{BL,BR}) where {BL,BR} = sparse(op1) + sparse(op2)
-(op2::EyeOpType{BL,BR},op1::EyeOpType{BL,BR}) where {BL,BR} = sparse(op2) - sparse(op1)
-(op::EyeOpType) = -sparse(op)
*(op::EyeOpType,a::T) where {T<:Number} = a*sparse(op)
*(a::T,op::EyeOpType) where {T<:Number} = a*sparse(op)
/(op::EyeOpType,a::T) where {T<:Number} = sparse(op)/a
tensor(a::EyeOpType, b::SparseOpType) = tensor(sparse(a),b)
tensor(a::SparseOpType, b::EyeOpType) = tensor(a,sparse(b))
tensor(a::EyeOpType, b::EyeOpType) = tensor(sparse(a),sparse(b))
dagger(a::EyeOpType) = dagger(sparse(a))

"""
    blochsphereplot(state::Ket; kwargs...)

Visualize a pure qubit state as an arrow on a Bloch sphere.

Requires a Makie backend be already imported.
"""
function blochsphereplot end

"""
    blochsphereplot!(ax, state::Ket; kwargs...)

In-place version of [`blochsphereplot`](@ref). Plots onto an existing Makie axis.

Requires a Makie backend be already imported.
"""
function blochsphereplot! end

"""
    blochsphereplot_axis([ax,] state::Ket; kwargs...) -> (Figure, Axis3, Plot)

Visualize a pure qubit state on a Bloch sphere, creating a new Figure and Axis3
or plotting onto an existing one.

Requires a Makie backend be already imported.
"""
function blochsphereplot_axis end

import Base: isequal, ==, *, /, +, -
import SparseArrays: sparse, spzeros
import QuantumInterface: BASES_CHECK
import Adapt

function _check_bases(basis_l, basis_r, operators)
    for o in operators
        basis_l == o.basis_l || throw(IncompatibleBases())
        basis_r == o.basis_r || throw(IncompatibleBases())
    end
end

"""
Abstract class for all Lazy type operators ([`LazySum`](@ref), [`LazyProduct`](@ref), and [`LazyTensor`](@ref))
"""
abstract type LazyOperator{BL,BR} <: AbstractOperator{BL,BR} end

"""
    LazySum([Tf,] [factors,] operators)
    LazySum([Tf,] basis_l, basis_r, [factors,] [operators])
    LazySum(::Tuple, x::LazySum)

Lazy evaluation of sums of operators.

All operators have to be given in respect to the same bases. The field
`factors` accounts for an additional multiplicative factor for each operator
stored in the `operators` field.

The factor type `Tf` can be specified to avoid having to infer it from the
factors and operators themselves. All `factors` will be converted to type `Tf`.

The `operators` will be kept as is. It can be, for example, a `Tuple` or a
`Vector` of operators. Using a `Tuple` is recommended for runtime performance
of operator-state operations, such as simulating time evolution. A `Vector` can
reduce compile-time overhead when doing arithmetic on `LazySum`s, such as
summing many `LazySum`s together.

To convert a vector-based `LazySum` `x` to use a tuple for operator
storage, use `LazySum(::Tuple, x)`. 
"""
mutable struct LazySum{BL,BR,F,T} <: LazyOperator{BL,BR}
    basis_l::BL
    basis_r::BR
    factors::F
    operators::T
    function LazySum(basis_l::BL, basis_r::BR, factors::F, operators::T) where {BL,BR,F,T}
        length(operators) == length(factors) || throw(ArgumentError("LazySum `operators` and `factors` have different lengths."))
        BASES_CHECK[] && _check_bases(basis_l, basis_r, operators)
        new{BL,BR,F,T}(basis_l,basis_r,factors,operators)
    end
end

LazySum(::Type{Tf}, basis_l::Basis, basis_r::Basis) where Tf = LazySum(basis_l,basis_r,Tf[],())
LazySum(basis_l::Basis, basis_r::Basis) = LazySum(ComplexF64, basis_l, basis_r)

function LazySum(::Type{Tf}, basis_l::Basis, basis_r::Basis, factors, operators) where Tf
    factors_ = eltype(factors) != Tf ? map(Tf, factors) : factors
    LazySum(basis_l, basis_r, factors_, operators)
end
function LazySum(::Type{Tf}, factors, operators) where Tf
    LazySum(Tf, operators[1].basis_l, operators[1].basis_r, factors, operators)
end
function LazySum(factors, operators)
    Tf = promote_type(eltype(factors), mapreduce(eltype, promote_type, operators))
    LazySum(Tf, factors, operators)
end
LazySum(::Type{Tf}, operators::AbstractOperator...) where Tf = LazySum(ones(Tf, length(operators)), (operators...,))
LazySum(operators::AbstractOperator...) = LazySum(mapreduce(eltype, promote_type, operators), operators...)
LazySum() = throw(ArgumentError("LazySum needs a basis, or at least one operator!"))
LazySum(x::LazySum) = x
LazySum(::Type{Tuple}, x::LazySum) = LazySum(x.basis_l, x.basis_r, x.factors, (x.operators...,))

coefficients(x::LazySum) = x.factors
suboperators(x::LazySum) = x.operators

# FIXME: Should copy really copy each operator?
Base.copy(x::LazySum) = @samebases LazySum(x.basis_l, x.basis_r, copy.(x.factors), copy.(x.operators))
Base.eltype(x::LazySum) = mapreduce(eltype, promote_type, x.operators; init=eltype(x.factors))

dense(op::LazySum) = length(op.operators) > 0 ? sum(op.factors .* dense.(op.operators)) : Operator(op.basis_l, op.basis_r, zeros(eltype(op.factors), length(op.basis_l), length(op.basis_r)))
SparseArrays.sparse(op::LazySum) = length(op.operators) > 0 ? sum(op.factors .* sparse.(op.operators)) : Operator(op.basis_l, op.basis_r, spzeros(eltype(op.factors), length(op.basis_l), length(op.basis_r)))

isequal(x::LazySum, y::LazySum) = samebases(x,y) && isequal(x.operators, y.operators) && isequal(x.factors, y.factors)
==(x::LazySum, y::LazySum) = (samebases(x,y) && x.operators==y.operators && x.factors==y.factors)

# Make vectors contagious in LazySum arithmetic, but preserve "tuple-only" cases
_lazysum_cat(opsA::Tuple, opsB::Tuple) = (opsA..., opsB...)
_lazysum_cat(opsA, opsB) = [opsA..., opsB...]

# Arithmetic operations
function +(a::LazySum{B1,B2}, b::LazySum{B1,B2}) where {B1,B2}
    check_samebases(a,b)
    factors = _lazysum_cat(a.factors, b.factors)
    ops = _lazysum_cat(a.operators, b.operators)
    @samebases LazySum(a.basis_l, a.basis_r, factors, ops)
end
+(a::LazySum{B1,B2}, b::LazySum{B3,B4}) where {B1,B2,B3,B4} = throw(IncompatibleBases())
+(a::LazyOperator, b::AbstractOperator) = LazySum(a) + LazySum(b)
+(a::AbstractOperator, b::LazyOperator) = LazySum(a) + LazySum(b)
+(a::O1, b::O2) where {O1<:LazyOperator,O2<:LazyOperator} = LazySum(a) + LazySum(b)

-(a::LazySum) = @samebases LazySum(a.basis_l, a.basis_r, -a.factors, a.operators)
function -(a::LazySum{B1,B2}, b::LazySum{B1,B2}) where {B1,B2}
    check_samebases(a,b)
    factors = _lazysum_cat(a.factors, -b.factors)
    ops = _lazysum_cat(a.operators, b.operators)
    @samebases LazySum(a.basis_l, a.basis_r, factors, ops)
end
-(a::LazySum{B1,B2}, b::LazySum{B3,B4}) where {B1,B2,B3,B4} = throw(IncompatibleBases())
-(a::LazyOperator, b::AbstractOperator) = LazySum(a) - LazySum(b)
-(a::AbstractOperator, b::LazyOperator) = LazySum(a) - LazySum(b)
-(a::O1, b::O2) where {O1<:LazyOperator,O2<:LazyOperator} = LazySum(a) - LazySum(b)

_lazysum_cartprod(prodop, a::Tuple, b::Tuple) = ((prodop(a_, b_) for (a_,b_) in Iterators.product(a, b))...,)
_lazysum_cartprod(prodop, a, b) = promote_type(eltype(a),eltype(b))[(prodop(a_, b_) for (a_,b_) in Iterators.product(a, b))...]
function *(a::LazySum{B1,B2}, b::LazySum{B2,B3}) where {B1,B2,B3}
    check_samebases(a.basis_r, b.basis_l)
    ops = _lazysum_cartprod(*, a.operators, b.operators)
    factors = _lazysum_cartprod(*, a.factors, b.factors)
    @samebases LazySum(a.basis_l, b.basis_r, factors, ops)
end
*(a::LazySum{B1,B2}, b::LazySum{B3,B4}) where {B1,B2,B3,B4} = throw(IncompatibleBases())

function *(a::LazySum, b::Number)
    factors = b*a.factors
    @samebases LazySum(a.basis_l, a.basis_r, factors, a.operators)
end
*(a::Number, b::LazySum) = b*a

function /(a::LazySum, b::Number)
    factors = a.factors/b
    @samebases LazySum(a.basis_l, a.basis_r, factors, a.operators)
end

function tensor(a::Operator,b::LazySum)
    btotal_l = a.basis_l ⊗ b.basis_l
    btotal_r = a.basis_r ⊗ b.basis_r
    ops = ([a ⊗ op for op in b.operators]...,)
    LazySum(btotal_l,btotal_r,b.factors,ops)
end
function tensor(a::LazySum,b::Operator)
    btotal_l = a.basis_l ⊗ b.basis_l
    btotal_r = a.basis_r ⊗ b.basis_r
    ops = ([op ⊗ b for op in a.operators]...,)
    LazySum(btotal_l,btotal_r,a.factors,ops)
end

function dagger(op::LazySum)
    ops = dagger.(op.operators)
    @samebases LazySum(op.basis_r, op.basis_l, conj.(op.factors), ops)
end

tr(op::LazySum) = sum(op.factors .* tr.(op.operators))

function ptrace(op::LazySum, indices)
    check_ptrace_arguments(op, indices)
    #rank = length(op.basis_l.shape) - length(indices) #????
    LazySum(op.factors, map(o->ptrace(o, indices), op.operators))
end

normalize!(op::LazySum) = (op.factors /= tr(op); op)

function permutesystems(op::LazySum, perm)
    ops = map(o->permutesystems(o, perm), op.operators)
    bl = ops[1].basis_l
    br = ops[1].basis_r
    @samebases LazySum(bl, br, op.factors, ops)
end

identityoperator(::Type{<:LazySum}, ::Type{S}, b1::Basis, b2::Basis) where S<:Number = LazySum(identityoperator(S, b1, b2))

function embed(basis_l::CompositeBasis, basis_r::CompositeBasis, indices, op::LazySum)
    LazySum(basis_l, basis_r, op.factors, map(o->embed(basis_l, basis_r, indices, o), op.operators))
end
function embed(basis_l::CompositeBasis, basis_r::CompositeBasis, index::Integer, op::LazySum) # defined to avoid method ambiguity
    LazySum(basis_l, basis_r, op.factors, map(o->embed(basis_l, basis_r, index, o), op.operators)) # dispatch to fast-path single-index `embed`
end

function _zero_op_mul!(data, beta)
    if iszero(beta)
        fill!(data, zero(eltype(data)))
    elseif !isone(beta)
        data .*= beta
    end
    return data
end

# Fast in-place multiplication
function mul!(result::Ket{B1},a::LazySum{B1,B2},b::Ket{B2},alpha,beta) where {B1,B2}
    if length(a.operators) == 0 || iszero(alpha)
        _check_mul!_dim_compatibility(size(result), size(a), size(b))
        _zero_op_mul!(result.data, beta)
    else
        mul!(result,a.operators[1],b,alpha*a.factors[1],beta)
        for i=2:length(a.operators)
            mul!(result,a.operators[i],b,alpha*a.factors[i],1)
        end
    end
    return result
end

function mul!(result::Bra{B2},a::Bra{B1},b::LazySum{B1,B2},alpha,beta) where {B1,B2}
    if length(b.operators) == 0 || iszero(alpha)
        _check_mul!_dim_compatibility(size(result), reverse(size(b)), size(a))
        _zero_op_mul!(result.data, beta)
    else
        mul!(result,a,b.operators[1],alpha*b.factors[1],beta)
        for i=2:length(b.operators)
            mul!(result,a,b.operators[i],alpha*b.factors[i],1)
        end
    end
    return result
end

function mul!(result::Operator{B1,B3},a::LazySum{B1,B2},b::Operator{B2,B3},alpha,beta) where {B1,B2,B3}
    if length(a.operators) == 0 || iszero(alpha)
        _check_mul!_dim_compatibility(size(result), size(a), size(b))
        _zero_op_mul!(result.data, beta)
    else
        mul!(result,a.operators[1],b,alpha*a.factors[1],beta)
        for i=2:length(a.operators)
            mul!(result,a.operators[i],b,alpha*a.factors[i],1)
        end
    end
    return result
end
function mul!(result::Operator{B1,B3},a::Operator{B1,B2},b::LazySum{B2,B3},alpha,beta) where {B1,B2,B3}
    if length(b.operators) == 0 || iszero(alpha)
        _check_mul!_dim_compatibility(size(result), size(a), size(b))
        _zero_op_mul!(result.data, beta)
    else
        mul!(result,a,b.operators[1],alpha*b.factors[1],beta)
        for i=2:length(b.operators)
            mul!(result,a,b.operators[i],alpha*b.factors[i],1)
        end
    end
    return result
end

# GPU adaptation
Adapt.adapt_structure(to, x::LazySum) = LazySum(x.basis_l, x.basis_r, x.factors, [Adapt.adapt(to, op) for op in x.operators])

import Base: isequal, ==, *, /, +, -
import Adapt

"""
    LazyTensor(b1[, b2], indices, operators[, factor=1])

Lazy implementation of a tensor product of operators.

The suboperators are stored in the `operators` field. The `indices` field
specifies in which subsystem the corresponding operator lives. Note that these
must be sorted.
Additionally, a factor is stored in the `factor` field which allows for fast
multiplication with numbers.
"""
mutable struct LazyTensor{BL,BR,F,I,T} <: LazyOperator{BL,BR}
    basis_l::BL
    basis_r::BR
    factor::F
    indices::I
    operators::T
    function LazyTensor(bl::BL, br::BR, indices::I, ops::T, factor::F=_default_factor(ops)) where {BL<:CompositeBasis,BR<:CompositeBasis,F,I,T<:Tuple}
        N = length(bl.bases)
        @assert N==length(br.bases)
        check_indices(N, indices)
        @assert length(indices) == length(ops)
        @assert issorted(indices)
        for n=1:length(indices)
            @assert isa(ops[n], AbstractOperator)
            @assert ops[n].basis_l == bl.bases[indices[n]]
            @assert ops[n].basis_r == br.bases[indices[n]]
        end
        F_ = promote_type(F, mapreduce(eltype, promote_type, ops; init=F))
        factor_ = convert(F_, factor)
        new{BL,BR,F_,I,T}(bl, br, factor_, indices, ops)
    end
end
function LazyTensor(bl::CompositeBasis, br::CompositeBasis, indices::I, ops::Vector, factor::F=_default_factor(ops)) where {F,I}
    Base.depwarn("LazyTensor(bl, br, indices, ops::Vector, factor) is deprecated, use LazyTensor(bl, br, indices, Tuple(ops), factor) instead.",
                :LazyTensor; force=true)
    return LazyTensor(bl,br,indices,Tuple(ops),factor)
end

function LazyTensor(basis_l::CompositeBasis, basis_r::Basis, indices::I, ops::T, factor::F=_default_factor(ops)) where {F,I,T<:Tuple}
    br = CompositeBasis(basis_r.shape, [basis_r])
    return LazyTensor(basis_l, br, indices, ops, factor)
end
function LazyTensor(basis_l::Basis, basis_r::CompositeBasis, indices::I, ops::T, factor::F=_default_factor(ops)) where {F,I,T<:Tuple}
    bl = CompositeBasis(basis_l.shape, [basis_l])
    return LazyTensor(bl, basis_r, indices, ops, factor)
end
function LazyTensor(basis_l::Basis, basis_r::Basis, indices::I, ops::T, factor::F=_default_factor(ops)) where {F,I,T<:Tuple}
    bl = CompositeBasis(basis_l.shape, [basis_l])
    br = CompositeBasis(basis_r.shape, [basis_r])
    return LazyTensor(bl, br, indices, ops, factor)
end
LazyTensor(op::T, factor) where {T<:LazyTensor} = LazyTensor(op.basis_l, op.basis_r, op.indices, op.operators, factor)
LazyTensor(basis_l::CompositeBasis, basis_r::CompositeBasis, index::Integer, operator::T, factor=one(eltype(operator))) where T<:AbstractOperator = LazyTensor(basis_l, basis_r, [index], (operator,), factor)
LazyTensor(basis::Basis, index, operators, factor=_default_factor(operators)) = LazyTensor(basis, basis, index, operators, factor)

Base.copy(x::LazyTensor) = LazyTensor(x.basis_l, x.basis_r, copy(x.indices), Tuple(copy(op) for op in x.operators), x.factor)
function Base.eltype(x::LazyTensor)
    F = eltype(x.factor)
    promote_type(F, mapreduce(eltype, promote_type, x.operators; init=F))
end

function _default_factor(ops)
    T = mapreduce(eltype, promote_type, ops)
    return one(T)
end
function _default_factor(op::T) where T<:AbstractOperator
    return one(eltype(op))
end

"""
    suboperator(op::LazyTensor, index)

Return the suboperator corresponding to the subsystem specified by `index`. Fails
if there is no corresponding operator (i.e. it would be an identity operater).
"""
suboperator(op::LazyTensor, index::Integer) = op.operators[findfirst(isequal(index), op.indices)]

"""
    suboperators(op::LazyTensor, indices)

Return the suboperators corresponding to the subsystems specified by `indices`. Fails
if there is no corresponding operator (i.e. it would be an identity operater).
"""
suboperators(op::LazyTensor, indices) = [op.operators[[findfirst(isequal(i), op.indices) for i in indices]]...]

DenseOperator(op::LazyTensor) = op.factor*embed(op.basis_l, op.basis_r, op.indices, DenseOpType[DenseOperator(x) for x in op.operators])
SparseArrays.sparse(op::LazyTensor) = op.factor*embed(op.basis_l, op.basis_r, op.indices, SparseOpType[SparseOperator(x) for x in op.operators])

isequal(x::LazyTensor, y::LazyTensor) = samebases(x,y) && isequal(x.indices, y.indices) && isequal(x.operators, y.operators) && isequal(x.factor, y.factor)
==(x::LazyTensor, y::LazyTensor) = samebases(x,y) && x.indices==y.indices && x.operators==y.operators && x.factor==y.factor


# Arithmetic operations
-(a::LazyTensor) = LazyTensor(a, -a.factor)

const single_dataoperator{B1,B2} = LazyTensor{B1,B2,F,I,Tuple{T}} where {B1,B2,F,I,T<:DataOperator}
function +(a::T1,b::T2) where {T1 <: single_dataoperator{B1,B2},T2 <: single_dataoperator{B1,B2}} where {B1,B2}
    if a.indices == b.indices
        op = a.operators[1] * a.factor + b.operators[1] * b.factor
        return LazyTensor(a.basis_l, a.basis_r, a.indices, (op,))
    end
    LazySum(a) + LazySum(b)
end
function -(a::T1,b::T2) where {T1 <: single_dataoperator{B1,B2},T2 <: single_dataoperator{B1,B2}} where {B1,B2}
    if a.indices == b.indices
        op = a.operators[1] * a.factor - b.operators[1] * b.factor
        return LazyTensor(a.basis_l, a.basis_r, a.indices, (op,))
    end
    LazySum(a) - LazySum(b)
end

function tensor(a::LazyTensor{B1,B2},b::AbstractOperator{B3,B4}) where {B1,B2,B3,B4}
    if B3 <: CompositeBasis || B4 <: CompositeBasis
        throw(ArgumentError("tensor(a::LazyTensor{B1,B2},b::AbstractOperator{B3,B4}) is not implemented for B3 or B4 being CompositeBasis unless b is identityoperator "))
    else
        a ⊗ LazyTensor(b.basis_l,b.basis_r,[1],(b,),1)
    end
end
function tensor(a::AbstractOperator{B1,B2},b::LazyTensor{B3,B4})  where {B1,B2,B3,B4}
    if B1 <: CompositeBasis || B2 <: CompositeBasis
        throw(ArgumentError("tensor(a::AbstractOperator{B1,B2},b::LazyTensor{B3,B4}) is not implemented for B1 or B2 being CompositeBasis unless b is identityoperator "))
    else
        LazyTensor(a.basis_l,a.basis_r,[1],(a,),1) ⊗ b
    end
end


function *(a::LazyTensor{B1,B2}, b::LazyTensor{B2,B3}) where {B1,B2,B3}
    indices = sort(union(a.indices, b.indices))
    # ops = Vector{AbstractOperator}(undef, length(indices))
    function _prod(n)
        i = indices[n]
        in_a = i in a.indices
        in_b = i in b.indices
        if in_a && in_b
            return suboperator(a, i)*suboperator(b, i)
        elseif in_a
            a_i = suboperator(a, i)
            return a_i*identityoperator(typeof(a_i), b.basis_l.bases[i], b.basis_r.bases[i])
        elseif in_b
            b_i = suboperator(b, i)
            return identityoperator(typeof(b_i), a.basis_l.bases[i], a.basis_r.bases[i])*b_i
        end
    end
    ops = Tuple(_prod(n) for n ∈ 1:length(indices))
    return LazyTensor(a.basis_l, b.basis_r, indices, ops, a.factor*b.factor)
end
*(a::LazyTensor, b::Number) = LazyTensor(a, a.factor*b)
*(a::Number, b::LazyTensor) = LazyTensor(b, a*b.factor)
function *(a::LazyTensor{B1,B2}, b::DenseOpType{B2,B3}) where {B1,B2,B3}
    result = DenseOperator(a.basis_l, b.basis_r)
    mul!(result,a,b,complex(1.),complex(1.))
    result
end
function *(a::DenseOpType{B1,B2}, b::LazyTensor{B2,B3}) where {B1,B2,B3}
    result = DenseOperator(a.basis_l, b.basis_r)
    mul!(result,a,b,complex(1.),complex(1.))
    result
end

/(a::LazyTensor, b::Number) = LazyTensor(a, a.factor/b)


dagger(op::LazyTensor) = LazyTensor(op.basis_r, op.basis_l, op.indices, Tuple(dagger(x) for x in op.operators), conj(op.factor))

tensor(a::LazyTensor, b::LazyTensor) = LazyTensor(a.basis_l ⊗ b.basis_l, a.basis_r ⊗ b.basis_r, [a.indices; b.indices .+ length(a.basis_l.bases)], (a.operators..., b.operators...), a.factor*b.factor)

function tr(op::LazyTensor)
    b = basis(op)
    result = op.factor
    for i in 1:length(b.bases)
        if i in op.indices
            result *= tr(suboperator(op, i))
        else
            result *= length(b.bases[i])
        end
    end
    result
end

function ptrace(op::LazyTensor, indices)
    check_ptrace_arguments(op, indices)
    N = length(op.basis_l.shape)
    rank = N - length(indices)
    factor = op.factor
    for i in indices
        if i in op.indices
            factor *= tr(suboperator(op, i))
        else
            factor *= length(op.basis_l.bases[i])
        end
    end
    remaining_indices = remove(op.indices, indices)
    if rank==1 && length(remaining_indices)==1
        return factor * suboperator(op, remaining_indices[1])
    end
    b_l = ptrace(op.basis_l, indices)
    b_r = ptrace(op.basis_r, indices)
    if rank==1
        return factor * identityoperator(b_l, b_r)
    end
    ops = Tuple(suboperator(op, idx) for idx ∈ remaining_indices)
    LazyTensor(b_l, b_r, shiftremove(op.indices, indices), ops, factor)
end

normalize!(op::LazyTensor) = (op.factor /= tr(op); op)

function permutesystems(op::LazyTensor, perm)
    b_l = permutesystems(op.basis_l, perm)
    b_r = permutesystems(op.basis_r, perm)
    indices = [findfirst(isequal(i), perm) for i in op.indices]
    perm_ = sortperm(indices)
    LazyTensor(b_l, b_r, indices[perm_], op.operators[perm_], op.factor)
end

identityoperator(::Type{<:LazyTensor}, ::Type{T}, b1::Basis, b2::Basis) where {T<:Number} = LazyTensor(b1, b2, Int[], Tuple{}(), one(T))

## LazyTensor global cache

function lazytensor_default_cache_size()
    return Int(min(Int64(1)<<32, Sys.total_memory()>>2, typemax(Int)))
end

# NOTE: By specifying a union type here, the compiler should find it easy to
#       automatically specialize on the vector types and avoid runtime dispatch.
const LazyTensorCacheable = Union{Vector{ComplexF64}, Vector{ComplexF32}, Vector{Float64}, Vector{Float32}}
const lazytensor_cache = LRU{Tuple{Symbol, UInt, UInt, DataType}, LazyTensorCacheable}(; maxsize=lazytensor_default_cache_size(), by=sizeof)

taskid() = convert(UInt, pointer_from_objref(current_task()))
const _lazytensor_use_cache = Ref(true)
lazytensor_use_cache() = _lazytensor_use_cache[]

"""
    lazytensor_clear_cache()
Clear the current contents of the cache.
"""
function lazytensor_clear_cache()
    empty!(lazytensor_cache)
    return
end

"""
    lazytensor_cachesize()
Return the current memory size (in bytes) of all the objects in the cache.
"""
lazytensor_cachesize() = lazytensor_cache.currentsize

"""
    lazytensor_disable_cache()
Disable the cache for further use but does not clear its current contents.
Also see [`lazytensor_clear_cache()`](@ref)
"""
function lazytensor_disable_cache()
    _lazytensor_use_cache[] = false
    return
end

"""
    lazytensor_enable_cache(; maxsize::Int = ..., maxrelsize::Real = ...)
(Re)-enable the cache for further use; set the maximal size `maxsize` (as number of bytes)
or relative size `maxrelsize`, as a fraction between 0 and 1, resulting in
`maxsize = floor(Int, maxrelsize * Sys.total_memory())`. Default value is `maxsize = 2^32` bytes, which amounts to 4 gigabytes of memory.
"""
function lazytensor_enable_cache(; maxsize::Int = -1, maxrelsize::Real = 0.0)
    if maxsize == -1 && maxrelsize == 0.0
        maxsize = lazytensor_default_cache_size()
    elseif maxrelsize > 0
        maxsize = max(maxsize, floor(Int, maxrelsize*Sys.total_memory()))
    else
        @assert maxsize >= 0
    end
    _lazytensor_use_cache[] = true
    resize!(lazytensor_cache; maxsize = maxsize)
    return
end

function _tp_matmul_first!(result, a::AbstractMatrix, b, α::Number, β::Number)
    d_first = size(a, 2)
    d_rest = length(b)÷d_first
    bp = parent(b)
    rp = parent(result)
    @views br = reshape(bp, (d_first, d_rest))
    @views result_r = reshape(rp, (size(a, 1), d_rest))
    mul!(result_r, a, br, α, β)
    result
end

function _tp_matmul_last!(result, a::AbstractMatrix, b, α::Number, β::Number)
    d_last = size(a, 2)
    d_rest = length(b)÷d_last
    bp = parent(b)
    rp = parent(result)
    @views br = reshape(bp, (d_rest, d_last))
    @views result_r = reshape(rp, (d_rest, size(a, 1)))
    mul!(result_r, br, transpose(a), α, β)
    result
end

function _tp_matmul_get_tmp(::Type{T}, shp::NTuple{N,Int}, sym, ::Array) where {T,N}
    len = prod(shp)
    use_cache = lazytensor_use_cache()
    key = (sym, taskid(), UInt(len), T)
    if use_cache && Vector{T} <: LazyTensorCacheable
        tmp::Vector{T} = get!(lazytensor_cache, key) do
            Vector{T}(undef, len)
        end
    else
        tmp = Vector{T}(undef, len)
    end
    Base.ReshapedArray(tmp, shp, ())
end

function _tp_matmul_get_tmp(::Type{T}, shp::NTuple{N,Int}, sym, arr::AbstractArray) where {T,N}
    if parent(arr) === arr
        # This is a fallback that does not use the cache. Does not get triggered for arr <: Array.
        return similar(arr, T, shp)
    end
    # Unpack wrapped arrays. If we hit an Array, we will use the cache.
    # If we hit a different non-wrapped array-like, we will call `similar()`.
    _tp_matmul_get_tmp(T, shp, sym, parent(arr))
end

# reshapes of plain arrays are fine for strided, but wrappers like `Adjoint`
# can break things
_probably_strided(x::Base.ReshapedArray) = _probably_strided(parent(x))
_probably_strided(x::Array) = true
_probably_strided(x) = false

function _tp_matmul_mid!(result, a::AbstractMatrix, loc::Integer, b, α::Number, β::Number)
    sz_b_1 = 1
    for i in 1:loc-1
        sz_b_1 *= size(b,i)
    end
    sz_b_3 = 1
    for i in loc+1:ndims(b)
        sz_b_3 *= size(b,i)
    end

    # TODO: Perhaps we should avoid reshaping here... should be possible to infer
    # contraction index tuple sizes
    br = Base.ReshapedArray(b, (sz_b_1, size(b, loc), sz_b_3), ())
    result_r = Base.ReshapedArray(result, (sz_b_1, size(a, 1), sz_b_3), ())

    if a isa FillArrays.Eye
        # Square Eyes are skipped higher up. This handles the non-square case.
        size(b, loc) == size(a, 2) && size(result, loc) == size(a, 1) || throw(DimensionMismatch("Dimensions of Eye matrix do not match subspace dimensions."))
        d = min(size(a)...)

        if iszero(β)
            # Need to handle this separately, as the values in `result` may not be valid numbers
            fill!(result, zero(eltype(result)))
            if _probably_strided(result) && _probably_strided(b)
                @strided result_r[:, 1:d, :] .= α .* br[:, 1:d, :]
            else
                result_r[:, 1:d, :] .= α .* br[:, 1:d, :]
            end
        else
            rmul!(result, β)
            if _probably_strided(result) && _probably_strided(b)
                @strided result_r[:, 1:d, :] .+= α .* br[:, 1:d, :]
            else
                result_r[:, 1:d, :] .+= α .* br[:, 1:d, :]
            end
        end

        return result
    end

    # Try to "minimize" the transpose for efficiency.
    move_left = sz_b_1 < sz_b_3
    perm = move_left ? (2,1,3) : (1,3,2)

    br_p = _tp_matmul_get_tmp(eltype(br), ((size(br, i) for i in perm)...,), :_tp_matmul_mid_in_2, result)
    if _probably_strided(b)
        @strided permutedims!(br_p, br, perm)
    else
        permutedims!(br_p, br, perm)
    end

    result_r_p = _tp_matmul_get_tmp(eltype(result_r), ((size(result_r, i) for i in perm)...,), :_tp_matmul_mid_out, result)
    if _probably_strided(result)
        iszero(β) || @strided permutedims!(result_r_p, result_r, perm)
    else
        iszero(β) || permutedims!(result_r_p, result_r, perm)
    end

    if move_left
        _tp_matmul_first!(result_r_p, a, br_p, α, β)
    else
        _tp_matmul_last!(result_r_p, a, br_p, α, β)
    end

    if _probably_strided(result)
        @strided permutedims!(result_r, result_r_p, perm)
    else
        permutedims!(result_r, result_r_p, perm)
    end

    result
end

function _tp_matmul!(result, a::AbstractMatrix, loc::Integer, b, α::Number, β::Number)
    # Apply a matrix `α * a` to one tensor factor of a tensor `b`.
    # If β is nonzero, add to β times `result`. In other words, we do:
    # result = α * a * b + β * result
    #
    # Parameters:
    #     result: Array to hold the output tensor.
    #     a: Matrix to apply.
    #     loc: Index of the dimension of `b` to which `a` should be applied.
    #     b: Array containing the tensor to which `a` should be applied.
    #     α: Factor multiplying `a`.
    #     β: Factor multiplying `result`.
    # Returns:
    #     The modified `result`.
    #
    # Use GEMM directly where possible, otherwise we have to permute
    if loc == 1
        return _tp_matmul_first!(result, a, b, α, β)
    elseif loc == ndims(b)
        return _tp_matmul_last!(result, a, b, α, β)
    end
    _tp_matmul_mid!(result, a, loc, b, α, β)
end

function _tp_sum_get_tmp(op::AbstractMatrix{T}, loc::Integer, arr::AbstractArray{S,N}, arr_typeref::AbstractArray, sym) where {T,S,N}
    shp = ntuple(i -> i == loc ? size(op,1) : size(arr,i), N)
    _tp_matmul_get_tmp(promote_type(T,S), shp, sym, arr_typeref)
end

# Eyes need not be identities, but square Eyes are.
_is_square_eye(::AbstractArray) = false
_is_square_eye(::FillArrays.SquareEye) = true
_is_square_eye(x::FillArrays.Eye) = size(x, 1) == size(x, 2)
_is_square_eye(x::LinearAlgebra.Adjoint) = _is_square_eye(parent(x))
_is_square_eye(x::LinearAlgebra.Transpose) = _is_square_eye(parent(x))

#Apply a tensor product of operators to a vector.
function _tp_sum_matmul!(result_data, tp_ops, iso_ops, b_data, alpha, beta)
    if iso_ops === nothing
        ops = tp_ops
    else
        ops = (tp_ops..., iso_ops...)
    end

    n_ops = length(ops)

    # TODO: Perhaps replace with a single for loop and branch inside?
    if n_ops == 0
        if iszero(beta)
            @. result_data = alpha * b_data
        else
            @. result_data = alpha * b_data + beta * result_data
        end
    elseif n_ops == 1
        # Can add directly to the output array.
        _tp_matmul!(result_data, ops[1][1], ops[1][2], b_data, alpha, beta)
    elseif n_ops == 2
        # One temporary vector needed.
        tmp = _tp_sum_get_tmp(ops[1][1], ops[1][2], b_data, result_data, :_tp_sum_matmul_tmp1)
        _tp_matmul!(tmp, ops[1][1], ops[1][2], b_data, alpha, zero(beta))

        _tp_matmul!(result_data, ops[2][1], ops[2][2], tmp, one(alpha), beta)
    else
        # At least two temporary vectors needed.
        # Symbols identify computation stages in the cache.
        sym1 = :_tp_sum_matmul_tmp1
        sym2 = :_tp_sum_matmul_tmp2

        tmp1 = _tp_sum_get_tmp(ops[1][1], ops[1][2], b_data, result_data, sym1)
        _tp_matmul!(tmp1, ops[1][1], ops[1][2], b_data, alpha, zero(beta))

        for i in 2:n_ops-1
            tmp2 = _tp_sum_get_tmp(ops[i][1], ops[i][2], tmp1, result_data, sym2)
            _tp_matmul!(tmp2, ops[i][1], ops[i][2], tmp1, one(alpha), zero(beta))
            tmp1, tmp2 = tmp2, tmp1
            sym1, sym2 = sym2, sym1
        end

        _tp_matmul!(result_data, ops[n_ops][1], ops[n_ops][2], tmp1, one(alpha), beta)
    end

    result_data
end

# Insert explicit Eye operators where left and right bases have different sizes.
function _explicit_isometries(::Type{T}, used_indices, bl::Basis, br::Basis, shift=0) where T
    shp_l = _comp_size(bl)
    shp_r = _comp_size(br)
    shp_l != shp_r || return nothing

    isos = nothing
    iso_inds = nothing
    for (i, (sl, sr)) in enumerate(zip(shp_l, shp_r))
        if (sl != sr) && !(i + shift in used_indices)
            if isos === nothing
                isos = [Eye{T}(sl, sr)]
                iso_inds = [i + shift]
            else
                push!(isos, Eye{T}(sl, sr))
                push!(iso_inds::Vector{Int}, i + shift) # Help with inference (detected by JET)
            end
        end
    end
    if isos === nothing
        return nothing
    end
    res = tuple(zip(isos, iso_inds)...)
    return res
end

# To get the shape of a CompositeBasis with number of dims inferrable at compile-time
_comp_size(b::CompositeBasis) = tuple((length(b_) for b_ in b.bases)...)
_comp_size(b::Basis) = (length(b),)

_is_pure_sparse(operators) = all(o isa Union{SparseOpPureType,EyeOpType} for o in operators)

# Prepare the tensor-product operator and indices tuple
function _tpops_tuple(operators, indices; shift=0, op_transform=identity)
    length(operators) == 0 == length(indices) && return ()

    op_pairs = tuple(((op_transform(op.data), i + shift) for (op, i) in zip(operators, indices))...)

    # Filter out identities:
    # This induces a non-trivial cost only if _is_square_eye is not inferrable.
    # This happens if we have Eyes that are not SquareEyes.
    # This can happen if the user constructs LazyTensor operators including
    # explicit identityoperator(b,b).
    filtered = filter(p->!_is_square_eye(p[1]), op_pairs)
    return filtered
end

_tpops_tuple(a::LazyTensor; shift=0, op_transform=identity) = _tpops_tuple((a.operators...,), (a.indices...,); shift, op_transform)

function mul!(result::Ket{B1}, a::LazyTensor{B1,B2,F,I,T}, b::Ket{B2}, alpha, beta) where {B1<:Basis,B2<:Basis, F,I,T<:Tuple{Vararg{DataOperator}}}
    iszero(alpha) && (_zero_op_mul!(result.data, beta); return result)

    if length(a.operators) > 0 && _is_pure_sparse(a.operators)
        return _mul_puresparse!(result, a, b, alpha, beta)
    end

    # We reshape here so that we have the proper shape information for the
    # tensor contraction later on. Using ReshapedArray vs. reshape() avoids
    # an allocation.
    b_data = Base.ReshapedArray(b.data, _comp_size(basis(b)), ())
    result_data = Base.ReshapedArray(result.data, _comp_size(basis(result)), ())

    tp_ops = _tpops_tuple(a)
    iso_ops = _explicit_isometries(eltype(a), a.indices, a.basis_l, a.basis_r)
    _tp_sum_matmul!(result_data, tp_ops, iso_ops, b_data, alpha * a.factor, beta)

    result
end

function mul!(result::Bra{B2}, a::Bra{B1}, b::LazyTensor{B1,B2,F,I,T}, alpha, beta) where {B1<:Basis,B2<:Basis, F,I,T<:Tuple{Vararg{DataOperator}}}
    iszero(alpha) && (_zero_op_mul!(result.data, beta); return result)

    if length(b.operators) > 0 && _is_pure_sparse(b.operators)
        return _mul_puresparse!(result, a, b, alpha, beta)
    end

    a_data = Base.ReshapedArray(a.data, _comp_size(basis(a)), ())
    result_data = Base.ReshapedArray(result.data, _comp_size(basis(result)), ())

    tp_ops = _tpops_tuple(b; op_transform=transpose)
    iso_ops = _explicit_isometries(eltype(b), b.indices, b.basis_r, b.basis_l)
    _tp_sum_matmul!(result_data, tp_ops, iso_ops, a_data, alpha * b.factor, beta)

    result
end

function mul!(result::DenseOpType{B1,B3}, a::LazyTensor{B1,B2,F,I,T}, b::DenseOpType{B2,B3}, alpha, beta) where {B1<:Basis,B2<:Basis,B3<:Basis, F,I,T<:Tuple{Vararg{DataOperator}}}
    iszero(alpha) && (_zero_op_mul!(result.data, beta); return result)

    if length(a.operators) > 0 && _is_pure_sparse(a.operators) && (b isa DenseOpPureType)
        return _mul_puresparse!(result, a, b, alpha, beta)
    end

    b_data = Base.ReshapedArray(b.data, (_comp_size(b.basis_l)..., _comp_size(b.basis_r)...), ())
    result_data = Base.ReshapedArray(result.data, (_comp_size(result.basis_l)..., _comp_size(result.basis_r)...), ())

    tp_ops = _tpops_tuple(a)
    iso_ops = _explicit_isometries(eltype(a), a.indices, a.basis_l, a.basis_r)
    _tp_sum_matmul!(result_data, tp_ops, iso_ops, b_data, alpha * a.factor, beta)

    result
end

function mul!(result::DenseOpType{B1,B3}, a::DenseOpType{B1,B2}, b::LazyTensor{B2,B3,F,I,T}, alpha, beta) where {B1<:Basis,B2<:Basis,B3<:Basis, F,I,T<:Tuple{Vararg{DataOperator}}}
    iszero(alpha) && (_zero_op_mul!(result.data, beta); return result)

    if length(b.operators) > 0 && _is_pure_sparse(b.operators) && (a isa DenseOpPureType)
        return _mul_puresparse!(result, a, b, alpha, beta)
    end

    a_data = Base.ReshapedArray(a.data, (_comp_size(a.basis_l)..., _comp_size(a.basis_r)...), ())
    result_data = Base.ReshapedArray(result.data, (_comp_size(result.basis_l)..., _comp_size(result.basis_r)...), ())

    shft = length(a.basis_l.shape)  # b must be applied to the "B2" side of a
    tp_ops = _tpops_tuple(b; shift=shft, op_transform=transpose)
    iso_ops = _explicit_isometries(eltype(b), ((i + shft for i in b.indices)...,), b.basis_r, b.basis_l, shft)
    _tp_sum_matmul!(result_data, tp_ops, iso_ops, a_data, alpha * b.factor, beta)

    result
end


# Recursively calculate result_{IK} = \\sum_J op_{IJ} h_{JK}
function _gemm_recursive_dense_lazy(i_k, N_k, K, J, val,
                        shape, strides_k, strides_j,
                        indices, h::LazyTensor,
                        op::AbstractArray, result::AbstractArray)
    if i_k > N_k
        if isa(op, AbstractVector)
            result[K] += val*op[J]
        else I=1:size(op, 1)
            result[I, K] += val*op[I, J]
        end
        return nothing
    end
    if i_k in indices
        h_i = suboperator(h, i_k)
        if isa(h_i, SparseOpPureType)
            h_i_data = h_i.data
            @inbounds for k=1:h_i_data.n
                K_ = K + strides_k[i_k]*(k-1)
                @inbounds for jptr=h_i_data.colptr[k]:h_i_data.colptr[k+1]-1
                    j = h_i_data.rowval[jptr]
                    J_ = J + strides_j[i_k]*(j-1)
                    val_ = val*h_i_data.nzval[jptr]
                    _gemm_recursive_dense_lazy(i_k+1, N_k, K_, J_, val_, shape, strides_k, strides_j, indices, h, op, result)
                end
            end
            return nothing
        elseif !isa(h_i, EyeOpType)
            throw(ArgumentError("gemm! of LazyTensor is not implemented for $(typeof(h_i))"))
        end
    end
    @inbounds for k=1:shape[i_k]
        K_ = K + strides_k[i_k]*(k-1)
        J_ = J + strides_j[i_k]*(k-1)
        _gemm_recursive_dense_lazy(i_k + 1, N_k, K_, J_, val, shape, strides_k, strides_j, indices, h, op, result)
    end
end


# Recursively calculate result_{JI} = \\sum_K h_{JK} op_{KI}
function _gemm_recursive_lazy_dense(i_k, N_k, K, J, val,
                        shape, strides_k, strides_j,
                        indices, h::LazyTensor,
                        op::AbstractArray, result::AbstractArray)
    if i_k > N_k
        for I=1:size(op, 2)
            result[J, I] += val*op[K, I]
        end
        return nothing
    end
    if i_k in indices
        h_i = suboperator(h, i_k)
        if isa(h_i, SparseOpPureType) # TODO: adjoint sparse matrices
            h_i_data = h_i.data
            @inbounds for k=1:h_i_data.n
                K_ = K + strides_k[i_k]*(k-1)
                @inbounds for jptr=h_i_data.colptr[k]:h_i_data.colptr[k+1]-1
                    j = h_i_data.rowval[jptr]
                    J_ = J + strides_j[i_k]*(j-1)
                    val_ = val*h_i_data.nzval[jptr]
                    _gemm_recursive_lazy_dense(i_k+1, N_k, K_, J_, val_, shape, strides_k, strides_j, indices, h, op, result)
                end
            end
            return nothing
        elseif !isa(h_i, EyeOpType)  # identity operator get handled below
            throw(ArgumentError("gemm! of LazyTensor is not implemented for $(typeof(h_i))"))
        end
    end
    @inbounds for k=1:shape[i_k]
        K_ = K + strides_k[i_k]*(k-1)
        J_ = J + strides_j[i_k]*(k-1)
        _gemm_recursive_lazy_dense(i_k + 1, N_k, K_, J_, val, shape, strides_k, strides_j, indices, h, op, result)
    end
end

"""
    check_mul!_compatibility(R, A, B)
Check that `R,A,B` are dimentially compatible for `R.=A*B`. And that `R` is not aliased with either `A` nor `B`.
"""
function check_mul!_compatibility(R::AbstractVecOrMat, A, B)
    _check_mul!_aliasing_compatibility(R, A, B)
    _check_mul!_dim_compatibility(size(R), size(A), size(B))
end
function _check_mul!_dim_compatibility(sizeR::Tuple, sizeA::Tuple, sizeB::Tuple)
    # R .= A*B
    if sizeA[2] != sizeB[1]
        throw(DimensionMismatch("A and B dimensions do not match. Can't do `A*B`"))
    end
    if sizeR != (sizeA[1], Base.tail(sizeB)...) # using tail to account for vectors
        throw(DimensionMismatch("Output dimensions do not match A*B. Can't do `R.=A*B`"))
    end
end
function _check_mul!_aliasing_compatibility(R, A, B)
    if R===A || R===B
        throw(ArgumentError("output matrix must not be aliased with input matrix"))
    end
end


function _gemm_puresparse(alpha, op::AbstractArray, h::LazyTensor{B1,B2,F,I,T}, beta, result::AbstractArray) where {B1,B2,F,I,T}
    if op isa AbstractVector
        # _gemm_recursive_dense_lazy will treat `op` as a `Bra`
        _check_mul!_aliasing_compatibility(result, op, h)
        _check_mul!_dim_compatibility(size(result), reverse(size(h)), size(op))
    else
        check_mul!_compatibility(result, op, h)
    end
    if iszero(beta)
        fill!(result, beta)
    elseif !isone(beta)
        rmul!(result, beta)
    end
    N_k = length(h.basis_r.bases)
    shape, strides_j, strides_k = _get_shape_and_strides(h)
    _gemm_recursive_dense_lazy(1, N_k, 1, 1, alpha*h.factor, shape, strides_k, strides_j, h.indices, h, op, result)
end

function _gemm_puresparse(alpha, h::LazyTensor{B1,B2,F,I,T}, op::AbstractArray, beta, result::AbstractArray) where {B1,B2,F,I,T}
    check_mul!_compatibility(result, h, op)
    if iszero(beta)
        fill!(result, beta)
    elseif !isone(beta)
        rmul!(result, beta)
    end
    N_k = length(h.basis_l.bases)
    shape, strides_j, strides_k = _get_shape_and_strides(h)
    _gemm_recursive_lazy_dense(1, N_k, 1, 1, alpha*h.factor, shape, strides_k, strides_j, h.indices, h, op, result)
end

function _get_shape_and_strides(h)
    shape_l, shape_r = _comp_size(h.basis_l), _comp_size(h.basis_r)
    shape = min.(shape_l, shape_r)
    strides_j, strides_k = _strides(shape_l), _strides(shape_r)
    return shape, strides_j, strides_k
end

_mul_puresparse!(result::DenseOpType{B1,B3},h::LazyTensor{B1,B2,F,I,T},op::DenseOpType{B2,B3},alpha,beta) where {B1,B2,B3,F,I,T} = (_gemm_puresparse(alpha, h, op.data, beta, result.data); result)
_mul_puresparse!(result::DenseOpType{B1,B3},op::DenseOpType{B1,B2},h::LazyTensor{B2,B3,F,I,T},alpha,beta) where {B1,B2,B3,F,I,T} = (_gemm_puresparse(alpha, op.data, h, beta, result.data); result)
_mul_puresparse!(result::Ket{B1},a::LazyTensor{B1,B2,F,I,T},b::Ket{B2},alpha,beta) where {B1,B2,F,I,T} = (_gemm_puresparse(alpha, a, b.data, beta, result.data); result)
_mul_puresparse!(result::Bra{B2},a::Bra{B1},b::LazyTensor{B1,B2,F,I,T},alpha,beta) where {B1,B2,F,I,T} = (_gemm_puresparse(alpha, a.data, b, beta, result.data); result)

# GPU adaptation
Adapt.adapt_structure(to, x::LazyTensor) = LazyTensor(x.basis_l, x.basis_r, x.indices, Tuple(Adapt.adapt(to, op) for op in x.operators), x.factor)

function fock()
    basis = FockBasis(20)
    alpha = 1.2
    annihilation = destroy(basis)
    state = coherentstate(basis, alpha)
    density = dm(state)
    derivative = -1im * (annihilation + create(basis)) * state

    check(isapprox(expect(annihilation, state), alpha; atol=1e-10), "coherent-state amplitude is incorrect")
    check(isapprox(expect(number(basis), density), abs2(alpha); atol=1e-9), "photon number is incorrect")
    check(isapprox(tr(density), 1; atol=1e-12), "density operator is not normalized")
    check(isfinite(norm(derivative)), "Fock-space operator application returned a non-finite result")
    return real(expect(number(basis), state))
end

function composite()
    spin_basis = SpinBasis(1 // 2)
    raising = sigmap(spin_basis)
    lowering = sigmam(spin_basis)
    atom_hamiltonian = 2 * raising * lowering

    fock_basis = FockBasis(20)
    annihilation = destroy(fock_basis)
    field_hamiltonian = number(fock_basis)
    interaction = annihilation ⊗ raising + create(fock_basis) ⊗ lowering

    basis = fock_basis ⊗ spin_basis
    hamiltonian =
        embed(basis, 1, field_hamiltonian) +
        embed(basis, 2, atom_hamiltonian) +
        interaction
    initial_state = fockstate(fock_basis, 1) ⊗ spindown(spin_basis)
    derivative = hamiltonian * initial_state
    reduced_field = ptrace(dm(initial_state), 2)

    check(QuantumOpticsBase.basis(derivative) == basis, "composite operator changed the state basis")
    check(isapprox(tr(reduced_field), 1; atol=1e-12), "partial trace is not normalized")
    check(isfinite(norm(derivative)), "composite operator application returned a non-finite result")
    return norm(derivative)
end

function embed_noncontiguous()
    nlevel_basis = NLevelBasis(3)
    spin_basis = SpinBasis(1 // 2)
    fock_basis = FockBasis(4)
    auxiliary_basis = GenericBasis(2)
    basis = nlevel_basis ⊗ spin_basis ⊗ fock_basis ⊗ auxiliary_basis

    nlevel_operator = dense(paulix(nlevel_basis))
    fock_operator = dense(number(fock_basis))
    selected_operator = nlevel_operator ⊗ fock_operator
    embedded = embed(basis, [1, 3], selected_operator)
    expected =
        nlevel_operator ⊗ identityoperator(spin_basis) ⊗
        fock_operator ⊗ identityoperator(auxiliary_basis)

    check(embedded == expected, "noncontiguous embedding returned the wrong operator")
    return length(embedded.data.nzval)
end

function particle()
    position_basis = PositionBasis(-10, 10, 200)
    momentum_basis = MomentumBasis(position_basis)
    position_state = gaussianstate(position_basis, 0.1, 0.3, 1.0)
    to_momentum = transform(momentum_basis, position_basis)
    momentum_state = to_momentum * position_state

    position_operator = position(position_basis)
    momentum_operator = momentum(momentum_basis)
    hamiltonian = LazySum(
        LazyProduct(dagger(to_momentum), momentum_operator^2 / 2, to_momentum),
        position_operator^2,
    )
    derivative = hamiltonian * position_state

    check(isapprox(norm(momentum_state), 1; atol=1e-12), "particle transform changed the state norm")
    check(isapprox(real(expect(momentum_operator, momentum_state)), 0.3; atol=1e-12), "particle momentum is incorrect")
    check(isfinite(norm(derivative)), "lazy particle Hamiltonian returned a non-finite result")
    return norm(derivative)
end

function manybody()
    one_body_basis = NLevelBasis(2)
    many_body_basis = ManyBodyBasis(
        one_body_basis,
        bosonstates(one_body_basis, [0, 1, 2, 3]),
    )
    one_body_hamiltonian = diagonaloperator(one_body_basis, [0.0, 1.0])
    many_body_hamiltonian = manybodyoperator(many_body_basis, one_body_hamiltonian)
    state = basisstate(many_body_basis, [1, 2])
    transferred = transition(many_body_basis, 1, 2) * state
    expected = 2 * basisstate(many_body_basis, [2, 1])

    check(isapprox(expect(many_body_hamiltonian, state), 2; atol=1e-12), "many-body energy is incorrect")
    check(norm(transferred - expected) < 1e-12, "many-body transition returned the wrong state")
    return real(expect(many_body_hamiltonian, state))
end

function superoperator()
    basis = FockBasis(10)
    hamiltonian = number(basis)
    jump = destroy(basis)
    generator = liouvillian(hamiltonian, [jump])
    density = dm(coherentstate(basis, 0.5))
    derivative = generator * density

    check(isapprox(tr(derivative), 0; atol=1e-11), "Lindblad generator is not trace preserving")
    check(isfinite(norm(derivative)), "Lindblad generator returned a non-finite result")
    return norm(derivative)
end

function metrics()
    basis = SpinBasis(1 // 2)
    up = spinup(basis)
    down = spindown(basis)
    state = (up ⊗ down - down ⊗ up) / sqrt(2)
    density = dm(state)
    reduced_spin = ptrace(density, 2)

    check(isapprox(tr(reduced_spin), 1; atol=1e-12), "reduced spin state is not normalized")
    check(isapprox(entropy_vn(reduced_spin), log(2); atol=1e-12), "spin entropy is incorrect")
    check(isapprox(negativity(density, 1), 0.5; atol=1e-12), "spin negativity is incorrect")
    check(isapprox(real(fidelity(reduced_spin, reduced_spin)), 1; atol=1e-12), "self-fidelity is incorrect")
    return real(entropy_vn(reduced_spin))
end

function nlevel()
    basis = NLevelBasis(4)
    state = nlevelstate(basis, 2)
    shift = paulix(basis)
    clock = pauliz(basis)
    transitioned = transition(basis, 3, 2) * state

    check(isapprox(norm(transitioned), 1; atol=1e-12), "N-level transition returned the wrong norm")
    check(isapprox(norm(shift^4 - identityoperator(basis)), 0; atol=1e-12), "N-level shift is not cyclic")
    check(isapprox(norm(clock^4 - identityoperator(basis)), 0; atol=1e-12), "N-level clock is not cyclic")
    return norm(transitioned)
end

function charge()
    basis = ChargeBasis(5)
    state = chargestate(basis, -3)
    shift = expiφ(basis)
    charge_operator = chargeop(basis)
    shifted = shift * state

    check(shifted == chargestate(basis, -2), "charge shift returned the wrong state")
    check(charge_operator * state == -3 * state, "charge operator returned the wrong eigenvalue")
    check(charge_operator * shift - shift * charge_operator == shift, "charge commutator is incorrect")
    return norm(shifted)
end

function time_dependent()
    basis = SpinBasis(1 // 2)
    sx = sigmax(basis)
    sz = sigmaz(basis)
    operator = TimeDependentSum((cos, sin), (sx, sz))
    set_time!(operator, 0.25)
    state = spinup(basis)
    result = operator * state
    expected = (cos(0.25) * sx + sin(0.25) * sz) * state

    check(current_time(operator) == 0.25, "time-dependent operator has the wrong time")
    check(norm(result - expected) < 1e-12, "time-dependent operator returned the wrong state")
    return norm(result)
end

function pauli()
    basis = SpinBasis(1 // 2)
    up = spinup(basis)
    down = spindown(basis)
    gate = dm(up) ⊗ identityoperator(basis) + dm(down) ⊗ sigmax(basis)
    superoperator_gate = SuperOperator(gate)
    chi_gate = ChiMatrix(gate)
    transfer_gate = PauliTransferMatrix(gate)

    check(isapprox(avg_gate_fidelity(superoperator_gate, superoperator_gate), 1; atol=1e-12), "superoperator fidelity is incorrect")
    check(isapprox(avg_gate_fidelity(chi_gate, chi_gate), 1; atol=1e-12), "Chi-matrix fidelity is incorrect")
    check(isapprox(avg_gate_fidelity(transfer_gate, transfer_gate), 1; atol=1e-12), "Pauli-transfer fidelity is incorrect")
    return real(avg_gate_fidelity(transfer_gate, transfer_gate))
end

function chi_multiply()
    spin_basis = SpinBasis(1 // 2)
    basis = spin_basis^2
    chi_basis = (basis, basis)
    left_data = zeros(ComplexF64, 16, 16)
    right_data = zeros(ComplexF64, 16, 16)
    left_data[2, 1] = 2
    right_data[3, 1] = 2
    left = DenseChiMatrix(chi_basis, chi_basis, left_data)
    right = DenseChiMatrix(chi_basis, chi_basis, right_data)

    result = left * right
    expected = zeros(ComplexF64, 16, 16)
    expected[4, 1] = 1im
    check(
        result.basis_l == chi_basis && result.basis_r == chi_basis,
        "Chi multiplication changed the bases",
    )
    check(result.data == expected, "Chi multiplication returned the wrong matrix")
    return abs2(result.data[4, 1])
end

const PRECOMPILE_BENCHMARKS = (
    fock=fock,
    composite=composite,
    embed_noncontiguous=embed_noncontiguous,
    particle=particle,
    manybody=manybody,
    superoperator=superoperator,
    metrics=metrics,
    nlevel=nlevel,
    charge=charge,
    time_dependent=time_dependent,
    pauli=pauli,
    chi_multiply=chi_multiply,
)

import Base: isapprox
import QuantumInterface: PauliBasis

"""
    Base class for Pauli transfer matrix classes.
"""
abstract type PauliTransferMatrix{B1, B2} end


"""
    DensePauliTransferMatrix(B1, B2, data)

DensePauliTransferMatrix stored as a dense matrix.
"""
mutable struct DensePauliTransferMatrix{B1,B2,T<:Matrix} <: PauliTransferMatrix{B1, B2}
    basis_l::B1
    basis_r::B2
    data::T
    function DensePauliTransferMatrix(basis_l::BL, basis_r::BR, data::T) where {BL,
                                                                                BR,
                                                                                T<:Matrix}
        if length(basis_l[1])*length(basis_l[2]) != size(data, 1) ||
           length(basis_r[1])*length(basis_r[2]) != size(data, 2)
            throw(DimensionMismatch())
        end
        new{BL, BR, T}(basis_l, basis_r, data)
    end
end

PauliTransferMatrix(ptm::DensePauliTransferMatrix) = ptm

function *(ptm0::DensePauliTransferMatrix{B, B},ptm1::DensePauliTransferMatrix{B, B}) where B
    return DensePauliTransferMatrix(ptm0.basis_l, ptm1.basis_r, ptm0.data*ptm1.data)
end

"""
    Base class for χ (process) matrix classes.
"""
abstract type ChiMatrix{B1, B2} end

"""
    DenseChiMatrix(b, b, data)

DenseChiMatrix stored as a dense matrix.
"""
mutable struct DenseChiMatrix{B1,B2,T<:Matrix} <: PauliTransferMatrix{B1, B2}
    basis_l::B1
    basis_r::B2
    data::T
    function DenseChiMatrix(basis_l::BL, basis_r::BR, data::T) where {BL,BR,T<:Matrix}
        if length(basis_l[1])*length(basis_l[2]) != size(data, 1) ||
           length(basis_r[1])*length(basis_r[2]) != size(data, 2)
            throw(DimensionMismatch())
        end
        new{BL, BR, T}(basis_l, basis_r, data)
    end
end

ChiMatrix(chi_matrix::DenseChiMatrix) = chi_matrix

"""
The phase of a one-qubit Pauli product, indexed by
`4left_digit + right_digit + 1`.
"""
const pauli_multiplication_phases = (
    1.0 + 0.0im, 1.0 + 0.0im, 1.0 + 0.0im, 1.0 + 0.0im,
    1.0 + 0.0im, 1.0 + 0.0im, 0.0 + 1.0im, 0.0 - 1.0im,
    1.0 + 0.0im, 0.0 - 1.0im, 1.0 + 0.0im, 0.0 + 1.0im,
    1.0 + 0.0im, 0.0 + 1.0im, 0.0 - 1.0im, 1.0 + 0.0im,
)

const ASCII_ZERO = UInt8('0')
const ASCII_THREE = UInt8('3')

@inline function base4_digit(digit::UInt8)
    ASCII_ZERO <= digit <= ASCII_THREE ||
        throw(ArgumentError("Pauli strings must contain only base-4 digits from 0 to 3."))
    return Int(digit - ASCII_ZERO)
end

@inline function pauli_multiplication_phase(left::Int, right::Int, num_qubits::Int)::ComplexF64
    phase = one(ComplexF64)
    for _ in 1:num_qubits
        left, left_digit = divrem(left, 4)
        right, right_digit = divrem(right, 4)
        phase *= pauli_multiplication_phases[4left_digit + right_digit + 1]
    end
    return phase
end

"""
    multiply_pauli_matrices(i4::String, j4::String)

A function to algebraically determine result of multiplying two
(N-qubit) Pauli matrices. Each Pauli matrix is represented by a string
in base 4. For example, σ₃⊗σ₀⊗σ₂ would be "302". The product of any pair of
Pauli matrices will itself be a Pauli matrix multiplied by any of the 1/4 roots
of 1.
"""
function multiply_pauli_matrices(i4::String, j4::String)
    i4_digits = codeunits(i4)
    j4_digits = codeunits(j4)
    isempty(i4_digits) && throw(ArgumentError("Pauli strings must be nonempty."))
    length(i4_digits) == length(j4_digits) ||
        throw(ArgumentError("Pauli strings must have equal lengths."))

    product = Vector{UInt8}(undef, length(i4_digits))
    phase = one(ComplexF64)
    for index in eachindex(i4_digits, j4_digits)
        left_digit = base4_digit(i4_digits[index])
        right_digit = base4_digit(j4_digits[index])
        product[index] = ASCII_ZERO + xor(left_digit, right_digit)
        phase *= pauli_multiplication_phases[4left_digit + right_digit + 1]
    end
    return String(product), phase
end

const multiply_pauli_matirices = multiply_pauli_matrices

function *(chi_matrix0::DenseChiMatrix{B, B},chi_matrix1::DenseChiMatrix{B, B}) where B

    num_qubits = length(chi_matrix0.basis_l[1].shape)
    sop_dim = 4 ^ num_qubits
    ret = zeros(ComplexF64, (sop_dim, sop_dim))

    phase_lookup = Matrix{ComplexF64}(undef, sop_dim, sop_dim)
    for right in 0:(sop_dim-1), left in 0:(sop_dim-1)
        phase_lookup[left+1, right+1] = pauli_multiplication_phase(left, right, num_qubits)
    end

    for ijkl in Iterators.product(0:(sop_dim-1),
                                  0:(sop_dim-1),
                                  0:(sop_dim-1),
                                  0:(sop_dim-1))
        i, j, k, l = ijkl
        if (chi_matrix0.data[i+1, j+1] != 0.0) & (chi_matrix1.data[k+1, l+1] != 0.0)
            ret[xor(i, k)+1, xor(l, j)+1] += (phase_lookup[i+1, k+1] * phase_lookup[l+1, j+1] * chi_matrix0.data[i+1, j+1] * chi_matrix1.data[k+1, l+1])
        end
    end
    return DenseChiMatrix(chi_matrix0.basis_l, chi_matrix0.basis_r, ret / 2^num_qubits)
end


# TODO MAKE A GENERATOR FUNCTION
"""
    pauli_operators(num_qubits::Integer)

Generate a list of N-qubit Pauli operators.
"""
function pauli_operators(num_qubits::Integer)
    pauli_funcs = (identityoperator, sigmax, sigmay, sigmaz)
    po = []
    for paulis in Iterators.product((pauli_funcs for _ in 1:num_qubits)...)
        basis_vector = reduce(⊗, f(SpinBasis(1//2)) for f in paulis)
        push!(po, basis_vector)
    end
    return po
end

"""
    pauli_basis_vectors(num_qubits::Integer)

Generate a matrix of basis vectors in the Pauli representation given a number
of qubits.
"""
function pauli_basis_vectors(num_qubits::Integer)
    num_qubits > 0 || throw(ArgumentError("Number of qubits must be positive."))

    basis = SpinBasis(1//2)
    paulis = (
        identityoperator(SparseOpType, ComplexF64, basis).data,
        sigmax(basis).data,
        sigmay(basis).data,
        sigmaz(basis).data,
    )
    sop_dim = 4 ^ num_qubits
    columns = Vector{SparseVector{ComplexF64,Int}}(undef, sop_dim)
    for column in eachindex(columns)
        code = column - 1
        data = paulis[mod(code, 4) + 1]
        code = div(code, 4)
        for _ in 2:num_qubits
            data = kron(paulis[mod(code, 4) + 1], data)
            code = div(code, 4)
        end
        columns[column] = sparse(reshape(data, sop_dim))
    end
    return reduce(hcat, columns)
end

"""
    PauliTransferMatrix(sop::DenseSuperOpType)

Convert a superoperator to its representation as a Pauli transfer matrix.
"""
function PauliTransferMatrix(sop::DenseSuperOpType)
    num_qubits = length(sop.basis_l[1].bases)
    pbv = pauli_basis_vectors(num_qubits)
    sop_dim = 4 ^ num_qubits
    data = real.(pbv' * sop.data * pbv / √sop_dim)
    return DensePauliTransferMatrix(sop.basis_l, sop.basis_r, data)
end

SuperOperator(unitary::DenseOpType) = spre(unitary) * spost(unitary')
SuperOperator(sop::DenseSuperOpType) = sop

"""
    SuperOperator(ptm::DensePauliTransferMatrix)

Convert a Pauli transfer matrix to its representation as a superoperator.
"""
function SuperOperator(ptm::DensePauliTransferMatrix)
    num_qubits = length(ptm.basis_l[1].bases)
    pbv = pauli_basis_vectors(num_qubits)
    sop_dim = 4 ^ num_qubits
    data = pbv * ptm.data * pbv' / √sop_dim
    return DenseSuperOperator(ptm.basis_l, ptm.basis_r, data)
end

"""
    PauliTransferMatrix(unitary::DenseOpType)

Convert an operator, presumably a unitary operator, to its representation as a
Pauli transfer matrix.
"""
PauliTransferMatrix(unitary::DenseOpType) = PauliTransferMatrix(SuperOperator(unitary))

"""
    ChiMatrix(unitary::DenseOpType)

Convert an operator, presumably a unitary operator, to its representation as a χ matrix.
"""
function ChiMatrix(unitary::DenseOpType)
    num_qubits = length(unitary.basis_l.bases)
    pbv = pauli_basis_vectors(num_qubits)
    aj = pbv' * reshape(unitary.data, 4 ^ num_qubits)
    return DenseChiMatrix((unitary.basis_l, unitary.basis_l), (unitary.basis_r, unitary.basis_r), aj * aj' / (2 ^ num_qubits))
end

"""
    ChiMatrix(sop::DenseSuperOpType)

Convert a superoperator to its representation as a Chi matrix.
"""
function ChiMatrix(sop::DenseSuperOpType{B, B, T}) where {B, T}
    num_qubits = length(sop.basis_l)
    sop_dim = 4 ^ num_qubits
    po = pauli_operators(num_qubits)
    data = Matrix{eltype(T)}(undef, (sop_dim, sop_dim))
    for (idx, jdx) in Iterators.product(1:sop_dim, 1:sop_dim)
        data[idx, jdx] = tr((spre(po[idx]) * spost(po[jdx])).data' * sop.data) / √sop_dim
    end
    return DenseChiMatrix(sop.basis_l, sop.basis_r, data)
end

"""
    PauliTransferMatrix(chi_matrix::DenseChiMatrix)

Convert a χ matrix to its representation as a Pauli transfer matrix.
"""
function PauliTransferMatrix(chi_matrix::DenseChiMatrix{B, B, T}) where {B, T}
    num_qubits = length(chi_matrix.basis_l)
    sop_dim = 4 ^ num_qubits
    po = pauli_operators(num_qubits)
    data = Matrix{real(eltype(T))}(undef, (sop_dim, sop_dim))
    for (idx, jdx) in Iterators.product(1:sop_dim, 1:sop_dim)
        data[idx, jdx] = tr(mapreduce(x -> po[idx] * po[x[1]] * po[jdx] * po[x[2]] * chi_matrix.data[x[1], x[2]],
                                      +,
                                      Iterators.product(1:16, 1:16)).data) / sop_dim |> real
    end
    return DensePauliTransferMatrix(chi_matrix.basis_l, chi_matrix.basis_r, data)
end

"""
    SuperOperator(chi_matrix::DenseChiMatrix)

Convert a χ matrix to its representation as a superoperator.
"""
SuperOperator(chi_matrix::DenseChiMatrix) = SuperOperator(PauliTransferMatrix(chi_matrix))

"""
    ChiMatrix(ptm::DensePauliTransferMatrix)

Convert a Pauli transfer matrix to its representation as a χ matrix.
"""
ChiMatrix(ptm::DensePauliTransferMatrix) = ChiMatrix(SuperOperator(ptm))

"""Equality for all varieties of superoperators."""
==(sop1::T, sop2::T) where T<:Union{DensePauliTransferMatrix, DenseSuperOpType, DenseChiMatrix} = sop1.data == sop2.data
==(sop1::Union{DensePauliTransferMatrix, DenseSuperOpType, DenseChiMatrix}, sop2::Union{DensePauliTransferMatrix, DenseSuperOpType, DenseChiMatrix}) = false

"""Approximate equality for all varieties of superoperators."""
function isapprox(sop1::T, sop2::T; kwargs...) where T<:Union{DensePauliTransferMatrix, DenseSuperOpType, DenseChiMatrix}
    return isapprox(sop1.data, sop2.data; kwargs...)
end

@testitem "test_operators_sparse" begin
using Test
using QuantumOpticsBase
using Random, SparseArrays, LinearAlgebra


# Custom operator type for testing error msg
mutable struct TestOperator{BL<:Basis,BR<:Basis} <: AbstractOperator{BL,BR}; end

@testset "operators-sparse" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x1::StateVector, x2::StateVector) = norm(x2-x1)
sprandop(b1, b2) = sparse(randoperator(b1, b2))
sprandop(b) = sprandop(b, b)

b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(1)
b3b = GenericBasis(5)

b_l = b1a⊗b2a⊗b3a
b_r = b1b⊗b2b⊗b3b

# Test creation
@test_throws DimensionMismatch DenseOperator(b1a, spzeros(ComplexF64, 3, 2))
@test_throws DimensionMismatch DenseOperator(b1a, b1b, spzeros(ComplexF64, 3, 2))
op1 = SparseOperator(b1a, b1b, sparse([1 1 1; 1 1 1]))
op2 = sparse(DenseOperator(b1b, b1a, [1 1; 1 1; 1 1]))
@test op1 == dagger(op2)

# Test transpose
@test transpose(op2) == conj(op2')

# Test copy
op1 = sparse(randoperator(b1a))
op2 = copy(op1)
@test isequal(op1, op2)
@test op1 == op2
@test !(op1.data === op2.data)
op2.data[1,1] = complex(10.)
@test op1.data[1,1] != op2.data[1,1]

@test QuantumOpticsBase.is_const(op1)

# Arithmetic operations
# =====================
op_zero = SparseOperator(b_l, b_r)
op1 = sprandop(b_l, b_r)
op2 = sprandop(b_l, b_r)
op3 = sprandop(b_l, b_r)
op1_ = dense(op1)
op2_ = dense(op2)
op3_ = dense(op3)

x1 = randstate(b_r)
x2 = randstate(b_r)

xbra1 = dagger(randstate(b_l))
xbra2 = dagger(randstate(b_l))

# Addition
@test_throws DimensionMismatch op1 + dagger(op2)
@test 1e-14 > D(op1+op2, op1_+op2_)
@test 1e-14 > D(op1+op2, op1+op2_)
@test 1e-14 > D(op1+op2, op1_+op2)

# Subtraction
@test_throws DimensionMismatch op1 - dagger(op2)
@test 1e-14 > D(op1-op2, op1_-op2_)
@test 1e-14 > D(op1-op2, op1-op2_)
@test 1e-14 > D(op1-op2, op1_-op2)
@test 1e-14 > D(op1+(-op2), op1_ - op2_)
@test 1e-14 > D(op1+(-1*op2), op1_ - op2_)

# Test multiplication
@test_throws DimensionMismatch op1*op2
@test 1e-11 > D(op1*(x1 + 0.3*x2), op1_*(x1 + 0.3*x2))
@test 1e-11 > D(op1*x1 + 0.3*op1*x2, op1_*x1 + 0.3*op1_*x2)
@test 1e-11 > D((op1+op2)*(x1+0.3*x2), (op1_+op2_)*(x1+0.3*x2))

@test 1e-11 > D((xbra1 + 0.3*xbra2)*op1, (xbra1 + 0.3*xbra2)*op1_)
@test 1e-11 > D(xbra1*op1 + 0.3*xbra2*op1, xbra1*op1_ + 0.3*xbra2*op1_)
@test 1e-11 > D((xbra1+0.3*xbra2)*(op1+op2), (xbra1+0.3*xbra2)*(op1_+op2_))

@test 1e-12 > D(op1*dagger(0.3*op2), op1_*dagger(0.3*op2_))
@test 1e-12 > D(0.3*dagger(op2*dagger(op1)), 0.3*dagger(op2_*dagger(op1_)))
@test 1e-12 > D((op1 + op2)*dagger(0.3*op3), (op1_ + op2_)*dagger(0.3*op3_))
@test 1e-12 > D(0.3*op1*dagger(op3) + 0.3*op2*dagger(op3), 0.3*op1_*dagger(op3_) + 0.3*op2_*dagger(op3_))

# Test division
@test 1e-14 > D(op1/7, op1_/7)

# Conjugation
tmp = copy(op1)
conj!(tmp)
@test tmp == conj(op1) && conj(tmp.data) == op1.data

# Test identityoperator
Idense = identityoperator(DenseOpType, b_r)
I = identityoperator(SparseOpType, b_r)
@test isa(I, SparseOpType)
@test dense(I) == Idense
@test 1e-11 > D(I*x1, x1)
@test I == identityoperator(SparseOpType, b1b) ⊗ identityoperator(SparseOpType, b2b) ⊗ identityoperator(SparseOpType, b3b)

Idense = identityoperator(DenseOpType, b_l)
I = identityoperator(SparseOpType, b_l)
@test isa(I, SparseOpType)
@test dense(I) == Idense
@test 1e-11 > D(xbra1*I, xbra1)
@test I == identityoperator(SparseOpType, b1a) ⊗ identityoperator(SparseOpType, b2a) ⊗ identityoperator(SparseOpType, b3a)

IEye = identityoperator(b_l)
@test isa(IEye, EyeOpType)
@test sparse(IEye) == I
Icomp = identityoperator(b1a) ⊗ identityoperator(b2a) ⊗ identityoperator(b3a)
@test IEye == Icomp

for _IEye in (identityoperator(b_l), identityoperator(b1a, b1b))
    for IEye in (_IEye, -_IEye, _IEye', dagger(_IEye))
        @test isa(2*IEye, SparseOpType)
        @test isa(IEye*2, SparseOpType)
        @test isa(IEye/2, SparseOpType)
        @test isa(IEye+sparse(IEye), SparseOpType)
        @test isa(sparse(IEye)+IEye, SparseOpType)
        @test isa(sparse(IEye)-IEye, SparseOpType)
        @test isa(IEye-sparse(IEye), SparseOpType)
        @test isa(IEye+IEye, SparseOpType)
        @test isa(IEye-IEye, SparseOpType)
        @test isa(-IEye, SparseOpType)
        if VERSION.major == 1 && VERSION.minor == 6
            # julia 1.6 LTS, something's broken here
            @test_skip isa(tensor(IEye, sparse(IEye)), SparseOpType)
            @test_skip isa(tensor(sparse(IEye), IEye), SparseOpType)
            @test_skip isa(tensor(IEye, IEye), SparseOpType)
        else
            @test isa(tensor(IEye, sparse(IEye)), SparseOpType)
            @test isa(tensor(sparse(IEye), IEye), SparseOpType)
            @test isa(tensor(IEye, IEye), SparseOpType)
        end
    end
end

# Test tr and normalize
op = sparse(DenseOperator(GenericBasis(3), [1 3 2;5 2 2;-1 2 5]))
@test 8 == tr(op)
op_normalized = normalize(op)
@test 8 == tr(op)
@test 1 == tr(op_normalized)
# op_ = normalize!(op)
# @test op_ === op
# @test 1 == tr(op)

# Test partial tr
b1 = GenericBasis(3)
b2 = GenericBasis(5)
b3 = GenericBasis(7)
b_l = b1 ⊗ b2 ⊗ b3
op1 = sprandop(b1)
op2 = sprandop(b2)
op3 = sprandop(b3)
op123 = op1 ⊗ op2 ⊗ op3
op123_ = dense(op123)

@test 1e-14 > D(ptrace(op123_, 3), ptrace(op123, 3))
@test 1e-14 > D(ptrace(op123_, 2), ptrace(op123, 2))
@test 1e-14 > D(ptrace(op123_, 1), ptrace(op123, 1))

@test 1e-14 > D(ptrace(op123_, [2,3]), ptrace(op123, [2,3]))
@test 1e-14 > D(ptrace(op123_, [1,3]), ptrace(op123, [1,3]))
@test 1e-14 > D(ptrace(op123_, [1,2]), ptrace(op123, [1,2]))

@test_throws ArgumentError ptrace(op123, [1,2,3])

# Test expect
state = randstate(b_l)
@test expect(op123, state) ≈ expect(op123_, state)

state = randoperator(b_l)
@test expect(op123, state) ≈ expect(op123_, state)

@test_throws QuantumOpticsBase.IncompatibleBases expect(op1, op2)

# Tensor product
# ==============
b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(1)
b3b = GenericBasis(5)
b_l = b1a ⊗ b2a ⊗ b3a
b_r = b1b ⊗ b2b ⊗ b3b
op1a = sprandop(b1a, b1b)
op1b = sprandop(b1a, b1b)
op2a = sprandop(b2a, b2b)
op2b = sprandop(b2a, b2b)
op3a = sprandop(b3a, b3b)
op1a_ = dense(op1a)
op1b_ = dense(op1b)
op2a_ = dense(op2a)
op2b_ = dense(op2b)
op3a_ = dense(op3a)
op123 = op1a ⊗ op2a ⊗ op3a
op123_ = op1a_ ⊗ op2a_ ⊗ op3a_
@test op123.basis_l == b_l
@test op123.basis_r == b_r

# Associativity
@test 1e-13 > D((op1a ⊗ op2a) ⊗ op3a, (op1a_ ⊗ op2a_) ⊗ op3a_)
@test 1e-13 > D(op1a ⊗ (op2a ⊗ op3a), op1a_ ⊗ (op2a_ ⊗ op3a_))
@test 1e-13 > D(op1a ⊗ (op2a ⊗ op3a), op1a_ ⊗ (op2a_ ⊗ op3a))

# Linearity
@test 1e-13 > D(op1a ⊗ (0.3*op2a), op1a_ ⊗ (0.3*op2a_))
@test 1e-13 > D(0.3*(op1a ⊗ op2a), 0.3*(op1a_ ⊗ op2a_))
@test 1e-13 > D((0.3*op1a) ⊗ op2a, (0.3*op1a_) ⊗ op2a_)
@test 1e-13 > D(0.3*(op1a ⊗ op2a), 0.3*(op1a_ ⊗ op2a_))
@test 1e-13 > D(0.3*(op1a ⊗ op2a), 0.3*(op1a ⊗ op2a_))

# Distributivity
@test 1e-13 > D(op1a ⊗ (op2a + op2b), op1a_ ⊗ (op2a_ + op2b_))
@test 1e-13 > D(op1a ⊗ op2a + op1a ⊗ op2b, op1a_ ⊗ op2a_ + op1a_ ⊗ op2b_)
@test 1e-13 > D((op2a + op2b) ⊗ op3a, (op2a_ + op2b_) ⊗ op3a_)
@test 1e-13 > D(op2a ⊗ op3a + op2b ⊗ op3a, op2a_ ⊗ op3a_ + op2b_ ⊗ op3a_)
@test 1e-13 > D(op2a ⊗ op3a + op2b ⊗ op3a, op2a ⊗ op3a_ + op2b_ ⊗ op3a_)

# Mixed-product property
@test 1e-13 > D((op1a ⊗ op2a) * dagger(op1b ⊗ op2b), (op1a_ ⊗ op2a_) * dagger(op1b_ ⊗ op2b_))
@test 1e-13 > D((op1a*dagger(op1b)) ⊗ (op2a*dagger(op2b)), (op1a_*dagger(op1b_)) ⊗ (op2a_*dagger(op2b_)))
@test 1e-13 > D((op1a*dagger(op1b)) ⊗ (op2a*dagger(op2b)), (op1a_*dagger(op1b)) ⊗ (op2a_*dagger(op2b_)))

# Transpose
@test 1e-13 > D(dagger(op1a ⊗ op2a), dagger(op1a_ ⊗ op2a_))
@test 1e-13 > D(dagger(op1a ⊗ op2a), dagger(op1a ⊗ op2a_))
@test 1e-13 > D(dagger(op1a) ⊗ dagger(op2a), dagger(op1a_) ⊗ dagger(op2a_))


# Permute systems
op1 = sprandop(b1a, b1b)
op2 = sprandop(b2a, b2b)
op3 = sprandop(b3a, b3b)
op123 = op1⊗op2⊗op3

op132 = op1⊗op3⊗op2
@test 1e-14 > D(permutesystems(op123, [1, 3, 2]), op132)

op213 = op2⊗op1⊗op3
@test 1e-14 > D(permutesystems(op123, [2, 1, 3]), op213)

op231 = op2⊗op3⊗op1
@test 1e-14 > D(permutesystems(op123, [2, 3, 1]), op231)

op312 = op3⊗op1⊗op2
@test 1e-14 > D(permutesystems(op123, [3, 1, 2]), op312)

op321 = op3⊗op2⊗op1
@test 1e-14 > D(permutesystems(op123, [3, 2, 1]), op321)

# Test diagonaloperator
b = GenericBasis(4)
I = identityoperator(b)

@test diagonaloperator(b, [1, 1, 1, 1]) == I
@test diagonaloperator(b, [1., 1., 1., 1.]) == I
@test diagonaloperator(b, [1im, 1im, 1im, 1im]) == 1im*I
@test diagonaloperator(b, [0:3;]) == sparse(DenseOperator(b, Diagonal([0:3;])))

# Test gemv
op = sprandop(b_l, b_r)
op_ = dense(op)
xket = randstate(b_l)
xbra = dagger(xket)

state = randstate(b_r)
result_ = randstate(b_l)
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,op,state,complex(1.0),complex(0.))
@test 1e-13 > D(result, op_*state)

result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,op,state,alpha,beta)
@test 1e-13 > D(result, alpha*op_*state + beta*result_)

state = dagger(randstate(b_l))
result_ = dagger(randstate(b_r))
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,state,op,complex(1.0),complex(0.))
@test 1e-13 > D(result, state*op_)

result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,state,op,alpha,beta)
@test 1e-13 > D(result, alpha*state*op_ + beta*result_)

# Test gemm small version
b1 = GenericBasis(3)
b2 = GenericBasis(5)
b3 = GenericBasis(7)

op = sprandop(b1, b2)
op_ = dense(op)

state = randoperator(b2, b3)
result_ = randoperator(b1, b3)
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
@test 1e-12 > D(result, op_*state)

result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,op,state,alpha,beta)
@test 1e-12 > D(result, alpha*op_*state + beta*result_)

state = randoperator(b3, b1)
result_ = randoperator(b3, b2)
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
@test 1e-12 > D(result, state*op_)

result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,state,op,alpha,beta)
@test 1e-12 > D(result, alpha*state*op_ + beta*result_)

state = randoperator(b1, b3)
result_ = randoperator(b2, b3)
result = deepcopy(result_)
result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,op',state,alpha,beta) # gemm! with lazy adjoint sparse
@test 1e-12 > D(result, alpha*op_'*state + beta*result_)

state = randoperator(b1, b2)
result_ = randoperator(b1, b1)
result = deepcopy(result_)
result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,state,op',alpha,beta) # gemm! with lazy adjoint sparse
@test 1e-12 > D(result, alpha*state*op_' + beta*result_)

# Test gemm big version
b1 = GenericBasis(50)
b2 = GenericBasis(60)
b3 = GenericBasis(55)

op = sprandop(b1, b2)
op_ = dense(op)

state = randoperator(b2, b3)
result_ = randoperator(b1, b3)
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
@test 1e-11 > D(result, op_*state)

result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,op,state,alpha,beta)
@test 1e-11 > D(result, alpha*op_*state + beta*result_)

state = randoperator(b3, b1)
result_ = randoperator(b3, b2)
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
@test 1e-11 > D(result, state*op_)

result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,state,op,alpha,beta)
@test 1e-11 > D(result, alpha*state*op_ + beta*result_)

state = randoperator(b1, b2)
result_ = randoperator(b1, b1)
result = deepcopy(result_)
result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,state,op',alpha,beta) # gemm! with lazy adjoint sparse
@test 1e-11 > D(result, alpha*state*op_' + beta*result_)

# Test remaining uncovered code
@test_throws DimensionMismatch SparseOperator(b1, b2, zeros(10, 10))
dat = sprandop(b1, b1).data
@test SparseOperator(b1, dat) == SparseOperator(b1, Matrix{ComplexF64}(dat))

@test_throws ArgumentError sparse(TestOperator{Basis,Basis}())

@test 2*SparseOperator(b1, dat) == SparseOperator(b1, dat)*2
@test copy(op1) == deepcopy(op1)

# Test Hermitian
bspin = SpinBasis(1//2)
bnlevel = NLevelBasis(2)
@test ishermitian(SparseOperator(bspin, bspin, sparse([1.0 im; -im 2.0])))
@test !ishermitian(SparseOperator(bspin, bnlevel, sparse([1.0 im; -im 2.0])))

# Test broadcasting
@test_throws DimensionMismatch op1 .+ op2
@test op1 .+ op1 == op1 + op1
op1 .= DenseOperator(op1)
@test isa(op1, SparseOpType)
# @test isa(op1 .+ DenseOperator(op1), DenseOpType) # Broadcasting of sparse .+ dense matrix results in sparse
op3 = sprandop(FockBasis(1),FockBasis(2))
@test_throws QuantumOpticsBase.IncompatibleBases op1 .+ op3
@test_throws QuantumOpticsBase.IncompatibleBases op1 .= op3
op_ = copy(op1)
op_ .+= op1
@test op_ == 2*op1

# Dimension mismatches
b1, b2, b3 = NLevelBasis.((2,3,4))  # N is not a type parameter
@test_throws DimensionMismatch mul!(randstate(b1), sparse(randoperator(b2)), randstate(b3))
@test_throws DimensionMismatch mul!(randstate(b1)', randstate(b3)', sparse(randoperator(b2)))
@test_throws DimensionMismatch mul!(randoperator(b1), sparse(randoperator(b2)), randoperator(b3))
@test_throws DimensionMismatch mul!(randoperator(b1), randoperator(b3)', sparse(randoperator(b2)))

end # testset

@testset "State-operator tensor products, sparse" begin
    b = FockBasis(2) ⊗ SpinBasis(1//2) ⊗ GenericBasis(2)
    b1, b2, b3 = b.bases

    o1 = sparse(randoperator(b1))
    v1 = sparse(randstate(b1))
    p1 = sparse(projector(v1))
    o2 = sparse(randoperator(b2))
    v2 = sparse(randstate(b2))
    p2 = sparse(projector(v2))
    o3 = sparse(randoperator(b3))
    v3 = sparse(randstate(b3))
    p3 = sparse(projector(v3))

    res = ((o1 ⊗ v2) * (o1 ⊗ v2'))
    @test res isa SparseOpType
    @test res.data ≈ (o1^2 ⊗ p2).data

    res = ((o1 ⊗ v2') * (o1 ⊗ v2))
    @test res isa SparseOpType
    @test res.data ≈ (o1^2).data

    res = ((o1 ⊗ v2 ⊗ o3) * (o1 ⊗ v2' ⊗ o3))
    @test res isa SparseOpType
    @test res.data ≈ (o1^2 ⊗ p2 ⊗ o3^2).data

    res = ((v1 ⊗ o2 ⊗ o3) * (v1' ⊗ o2 ⊗ o3))
    @test res isa SparseOpType
    @test res.data ≈ (p1 ⊗ o2^2 ⊗ o3^2).data

    res = ((v1 ⊗ o2 ⊗ v3) * (v1' ⊗ o2 ⊗ v3'))
    @test res isa SparseOpType
    @test res.data ≈ (p1 ⊗ o2^2 ⊗ p3).data
end
end

import FastGaussQuadrature: hermpoly_rec

"""
    transform([S=ComplexF64, ]b1::PositionBasis, b2::FockBasis; x0=1)
    transform([S=ComplexF64, ]b1::FockBasis, b2::PositionBasis; x0=1)

Transformation operator between position basis and fock basis.

The coefficients are connected via the relation
```math
ψ(x_i) = \\sum_{n=0}^N ⟨x_i|n⟩ ψ_n
```
where ``⟨x_i|n⟩`` is the value of the n-th eigenstate of a particle in
a harmonic trap potential at position ``x``, i.e.:
```math
⟨x_i|n⟩ = π^{-\\frac{1}{4}} \\frac{e^{-\\frac{1}{2}\\left(\\frac{x}{x_0}\\right)^2}}{\\sqrt{x_0}}
            \\frac{1}{\\sqrt{2^n n!}} H_n\\left(\\frac{x}{x_0}\\right)
```
"""
function transform(::Type{S}, bp::PositionBasis, bf::FockBasis; x0=1) where S
    T = Matrix{S}(undef, length(bp), length(bf))
    xvec = samplepoints(bp)
    C = pi^(-1/4)*sqrt(spacing(bp)/x0)
    for i in 1:length(bp)
        T[i,:] = C*hermpoly_rec(bf.offset:bf.N, sqrt(2)*xvec[i]/x0)
    end
    DenseOperator(bp, bf, T)
end

transform(::Type{S}, bf::FockBasis, bp::PositionBasis; x0=1) where S =
    dagger(transform(S, bp, bf; x0=x0))

transform(b1::Basis,b2::Basis;kwargs...) = transform(ComplexF64,b1,b2;kwargs...)

import Base: ==, +, -, *, /, length, copy, eltype
import LinearAlgebra: norm, normalize, normalize!
import QuantumInterface: StateVector, AbstractKet, AbstractBra
import Adapt

"""
    Bra(b::Basis[, data])

Bra state defined by coefficients in respect to the basis.
"""
mutable struct Bra{B,T} <: AbstractBra{B,T}
    basis::B
    data::T
    function Bra{B,T}(b::B, data::T) where {B,T}
        (length(b)==length(data)) || throw(DimensionMismatch("Tried to assign data of length $(length(data)) to Hilbert space of size $(length(b))"))
        new(b, data)
    end
end

"""
    Ket(b::Basis[, data])

Ket state defined by coefficients in respect to the given basis.
"""
mutable struct Ket{B,T} <: AbstractKet{B,T}
    basis::B
    data::T
    function Ket{B,T}(b::B, data::T) where {B,T}
        (length(b)==length(data)) || throw(DimensionMismatch("Tried to assign data of length $(length(data)) to Hilbert space of size $(length(b))"))
        new(b, data)
    end
end

Base.zero(x::T) where {T<:Union{Bra,Ket}} = T(x.basis, zero(x.data))
Base.eltype(::Type{K}) where {K <: Ket{B,V}} where {B,V} = eltype(V)
Base.eltype(::Type{K}) where {K <: Bra{B,V}} where {B,V} = eltype(V)
Base.size(x::Union{Bra,Ket}) = size(x.data)
@inline Base.axes(x::Union{Bra,Ket}) = axes(x.data)
Base.isempty(x::Union{Bra,Ket}) = isempty(x.data)

Bra{B}(b::B, data::T) where {B,T} = Bra{B,T}(b, data)
Ket{B}(b::B, data::T) where {B,T} = Ket{B,T}(b, data)

Bra(b::B, data::T) where {B,T} = Bra{B,T}(b, data)
Ket(b::B, data::T) where {B,T} = Ket{B,T}(b, data)

Bra{B}(::Type{T}, b::B) where {T,B} = Bra{B}(b, zeros(T, length(b)))
Ket{B}(::Type{T}, b::B) where {T,B} = Ket{B}(b, zeros(T, length(b)))
Bra(::Type{T}, b::Basis) where T = Bra(b, zeros(T, length(b)))
Ket(::Type{T}, b::Basis) where T = Ket(b, zeros(T, length(b)))

Bra{B}(b::B) where B = Bra{B}(ComplexF64, b)
Ket{B}(b::B) where B = Ket{B}(ComplexF64, b)
Bra(b::Basis) = Bra(ComplexF64, b)
Ket(b::Basis) = Ket(ComplexF64, b)

Base.copy(a::T) where {T<:Union{Bra,Ket}} = T(a.basis, copy(a.data))

==(x::Ket{B}, y::Ket{B}) where {B} = (samebases(x, y) && x.data==y.data)
==(x::Bra{B}, y::Bra{B}) where {B} = (samebases(x, y) && x.data==y.data)
==(x::Ket, y::Ket) = false
==(x::Bra, y::Bra) = false

Base.isapprox(x::Ket{B}, y::Ket{B}; kwargs...) where {B} = (samebases(x, y) && isapprox(x.data,y.data;kwargs...))
Base.isapprox(x::Bra{B}, y::Bra{B}; kwargs...) where {B} = (samebases(x, y) && isapprox(x.data,y.data;kwargs...))
Base.isapprox(x::Ket, y::Ket; kwargs...) = false
Base.isapprox(x::Bra, y::Bra; kwargs...) = false

# Arithmetic operations
+(a::Ket{B}, b::Ket{B}) where {B} = Ket(a.basis, a.data+b.data)
+(a::Bra{B}, b::Bra{B}) where {B} = Bra(a.basis, a.data+b.data)
+(a::Ket, b::Ket) = throw(IncompatibleBases())
+(a::Bra, b::Bra) = throw(IncompatibleBases())

-(a::Ket{B}, b::Ket{B}) where {B} = Ket(a.basis, a.data-b.data)
-(a::Bra{B}, b::Bra{B}) where {B} = Bra(a.basis, a.data-b.data)
-(a::Ket, b::Ket) = throw(IncompatibleBases())
-(a::Bra, b::Bra) = throw(IncompatibleBases())

*(a::Bra{B}, b::Ket{B}) where {B} = transpose(a.data)*b.data
*(a::Bra, b::Ket) = throw(IncompatibleBases())
*(a::Number, b::Ket) = Ket(b.basis, a*b.data)
*(a::Number, b::Bra) = Bra(b.basis, a*b.data)

/(a::Ket, b::Number) = Ket(a.basis, a.data ./ b)
/(a::Bra, b::Number) = Bra(a.basis, a.data ./ b)

-(a::T) where {T<:Union{Ket,Bra}} = T(a.basis, -a.data)
norm(x::Union{Ket,Bra}) = norm(x.data)
normalize!(x::Union{Ket,Bra}) = (normalize!(x.data); x)

"""
    dagger(x)

Hermitian conjugate.
"""
dagger(x::Bra) = Ket(x.basis, conj(x.data))
dagger(x::Ket) = Bra(x.basis, conj(x.data))

"""
    tensor(x::Ket, y::Ket, z::Ket...)

Tensor product ``|x⟩⊗|y⟩⊗|z⟩⊗…`` of the given states.
"""
tensor(a::Ket, b::Ket) = Ket(tensor(a.basis, b.basis), kron(b.data, a.data))
tensor(a::Bra, b::Bra) = Bra(tensor(a.basis, b.basis), kron(b.data, a.data))
tensor(states::Ket...) = reduce(tensor, states)
tensor(states::Bra...) = reduce(tensor, states)

function permutesystems(state::T, perm) where T<:Ket
    @assert length(state.basis.bases) == length(perm)
    @assert isperm(perm)
    data = reshape(state.data, state.basis.shape...)
    data = permutedims(data, perm)
    data = reshape(data, length(data))
    Ket(permutesystems(state.basis, perm), data)
end
function permutesystems(state::T, perm) where T<:Bra
    @assert length(state.basis.bases) == length(perm)
    @assert isperm(perm)
    data = reshape(state.data, state.basis.shape...)
    data = permutedims(data, perm)
    data = reshape(data, length(data))
    Bra(permutesystems(state.basis, perm), data)
end

# Creation of basis states.
"""
    basisstate([T=ComplexF64, ]b, index)

Basis vector specified by `index` as ket state.

For a composite system `index` can be a vector which then creates a tensor
product state ``|i_1⟩⊗|i_2⟩⊗…⊗|i_n⟩`` of the corresponding basis states.
"""
function basisstate(::Type{T}, b::Basis, indices) where T
    @assert length(b.shape) == length(indices)
    x = zeros(T, length(b))
    x[LinearIndices(tuple(b.shape...))[indices...]] = one(T)
    Ket(b, x)
end
function basisstate(::Type{T}, b::Basis, index::Integer) where T
    data = zeros(T, length(b))
    data[index] = one(T)
    Ket(b, data)
end
basisstate(b::Basis, indices) = basisstate(ComplexF64, b, indices)

"""
    sparsebasisstate([T=ComplexF64, ]b, index)

Sparse version of [`basisstate`](@ref).
"""
function sparsebasisstate(::Type{T}, b::Basis, indices) where T
    @assert length(b.shape) == length(indices)
    x = spzeros(T, length(b))
    x[LinearIndices(tuple(b.shape...))[indices...]] = one(T)
    Ket(b, x)
end
function sparsebasisstate(::Type{T}, b::Basis, index::Integer) where T
    data = spzeros(T, length(b))
    data[index] = one(T)
    Ket(b, data)
end
sparsebasisstate(b::Basis, indices) = sparsebasisstate(ComplexF64, b, indices)

SparseArrays.sparse(x::Ket) = Ket(x.basis,sparse(x.data))
SparseArrays.sparse(x::Bra) = Bra(x.basis,sparse(x.data))

# Helper functions to check validity of arguments
function check_multiplicable(a::Bra, b::Ket)
    if a.basis != b.basis
        throw(IncompatibleBases())
    end
end

samebases(a::Ket{B}, b::Ket{B}) where {B} = samebases(a.basis, b.basis)::Bool
samebases(a::Bra{B}, b::Bra{B}) where {B} = samebases(a.basis, b.basis)::Bool

# Custom broadcasting style
abstract type StateVectorStyle{B} <: Broadcast.BroadcastStyle end
struct KetStyle{B} <: StateVectorStyle{B} end
struct BraStyle{B} <: StateVectorStyle{B} end

# Style precedence rules
Broadcast.BroadcastStyle(::Type{<:Ket{B}}) where {B} = KetStyle{B}()
Broadcast.BroadcastStyle(::Type{<:Bra{B}}) where {B} = BraStyle{B}()
Broadcast.BroadcastStyle(::KetStyle{B1}, ::KetStyle{B2}) where {B1,B2} = throw(IncompatibleBases())
Broadcast.BroadcastStyle(::BraStyle{B1}, ::BraStyle{B2}) where {B1,B2} = throw(IncompatibleBases())

# Broadcast with scalars (of use in ODE solvers checking for tolerances, e.g. `.* reltol .+ abstol`)
Broadcast.BroadcastStyle(::T, ::Broadcast.DefaultArrayStyle{0}) where {B<:Basis, T<:KetStyle{B}} = T()
Broadcast.BroadcastStyle(::T, ::Broadcast.DefaultArrayStyle{0}) where {B<:Basis, T<:BraStyle{B}} = T()

# Out-of-place broadcasting
@inline function Base.copy(bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {B,Style<:KetStyle{B},Axes,F,Args<:Tuple}
    bcf = Broadcast.flatten(bc)
    b = find_basis(bcf)
    T = find_dType(bcf)
    data = zeros(T, length(b))
    @inbounds @simd for I in eachindex(bcf)
        data[I] = bcf[I]
    end
    return Ket{B}(b, data)
end
@inline function Base.copy(bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {B,Style<:BraStyle{B},Axes,F,Args<:Tuple}
    bcf = Broadcast.flatten(bc)
    b = find_basis(bcf)
    T = find_dType(bcf)
    data = zeros(T, length(b))
    @inbounds @simd for I in eachindex(bcf)
        data[I] = bcf[I]
    end
    return Bra{B}(b, data)
end
for f ∈ [:find_basis,:find_dType]
    @eval ($f)(bc::Broadcast.Broadcasted) = ($f)(bc.args)
    @eval ($f)(args::Tuple) = ($f)(($f)(args[1]), Base.tail(args))
    @eval ($f)(x) = x
    @eval ($f)(::Any, rest) = ($f)(rest)
end

find_basis(x::T, rest) where {T<:Union{Ket, Bra}} = x.basis
find_dType(x::T, rest) where {T<:Union{Ket, Bra}} = eltype(x)
@inline Base.getindex(x::T, idx) where {T<:Union{Ket, Bra}} = getindex(x.data, idx)
Base.@propagate_inbounds Base.Broadcast._broadcast_getindex(x::T, i) where {T<:Union{Ket, Bra}} = x.data[i]

# In-place broadcasting for Kets
@inline function Base.copyto!(dest::Ket{B}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {B,Style<:KetStyle{B},Axes,F,Args}
    axes(dest) == axes(bc) || Base.Broadcast.throwdm(axes(dest), axes(bc))
    bc′ = Base.Broadcast.preprocess(dest, bc)
    dest′ = dest.data
    @inbounds @simd for I in eachindex(bc′)
        dest′[I] = bc′[I]
    end
    return dest
end
# same implementation as Base.copyto!(dest::AbstractArray, bc::Broadcasted{<:AbstractArrayStyle{0}}) in https://github.com/JuliaLang/julia/blob/master/base/broadcast.jl
@inline function Base.copyto!(dest::Ket{B}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {B,Style<:Broadcast.DefaultArrayStyle{0},Axes,F,Args}
    # Typically, we must independently execute bc for every storage location in `dest`, but:
    # IF we're in the common no-op identity case with no nested args (like `dest .= val`),
    if bc.f === identity && bc.args isa Tuple{Any} && Broadcast.isflat(bc)
        # THEN we can just extract the argument and `fill!` the destination with it
        return fill!(dest, bc.args[1][])
    else
        throw(ArgumentError("no fallback implementation has been defined outside of dest .= val."))
    end
end
@inline Base.copyto!(dest::Ket{B1}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {B1,B2,Style<:KetStyle{B2},Axes,F,Args} =
    throw(IncompatibleBases())

# In-place broadcasting for Bras
@inline function Base.copyto!(dest::Bra{B}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {B,Style<:BraStyle{B},Axes,F,Args}
    axes(dest) == axes(bc) || Base.Broadcast.throwdm(axes(dest), axes(bc))
    bc′ = Base.Broadcast.preprocess(dest, bc)
    dest′ = dest.data
    @inbounds @simd for I in eachindex(bc′)
        dest′[I] = bc′[I]
    end
    return dest
end
# same implementation as Base.copyto!(dest::AbstractArray, bc::Broadcasted{<:AbstractArrayStyle{0}}) in https://github.com/JuliaLang/julia/blob/master/base/broadcast.jl
@inline function Base.copyto!(dest::Bra{B}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {B,Style<:Broadcast.DefaultArrayStyle{0},Axes,F,Args}
    # Typically, we must independently execute bc for every storage location in `dest`, but:
    # IF we're in the common no-op identity case with no nested args (like `dest .= val`),
    if bc.f === identity && bc.args isa Tuple{Any} && Broadcast.isflat(bc)
        # THEN we can just extract the argument and `fill!` the destination with it
        return fill!(dest, bc.args[1][])
    else
        throw(ArgumentError("no fallback implementation has been defined outside of dest .= val."))
    end
end
@inline Base.copyto!(dest::Bra{B1}, bc::Broadcast.Broadcasted{Style,Axes,F,Args}) where {B1,B2,Style<:BraStyle{B2},Axes,F,Args} =
    throw(IncompatibleBases())

@inline Base.copyto!(dest::T,src::T) where {T<:Union{Ket, Bra}} = (copyto!(dest.data,src.data); dest) # Can not use T<:QuantumInterface.StateVector, because StateVector does not imply the existence of a data property

# A few more standard interfaces: These do not necessarily make sense for a StateVector, but enable transparent use of DifferentialEquations.jl
Base.eltype(::Type{Ket{B,A}}) where {B,N,A<:AbstractVector{N}} = N # ODE init
Base.eltype(::Type{Bra{B,A}}) where {B,N,A<:AbstractVector{N}} = N
Base.any(f::Function, x::T; kwargs...) where {T<:Union{Ket, Bra}} = any(f, x.data; kwargs...) # ODE nan checks
Base.all(f::Function, x::T; kwargs...) where {T<:Union{Ket, Bra}} = all(f, x.data; kwargs...)
Base.fill!(x::T, a) where {T<:Union{Ket, Bra}} = typeof(x)(x.basis, fill!(x.data, a))
Base.similar(x::T, t) where {T<:Union{Ket, Bra}} = typeof(x)(x.basis, similar(x.data))
RecursiveArrayTools.recursivecopy!(dest::Ket{B,A},src::Ket{B,A}) where {B,A} = copyto!(dest, src) # ODE in-place equations
RecursiveArrayTools.recursivecopy!(dest::Bra{B,A},src::Bra{B,A}) where {B,A} = copyto!(dest, src)
RecursiveArrayTools.recursivecopy(x::T) where {T<:Union{Ket, Bra}} = copy(x)
RecursiveArrayTools.recursivecopy(x::AbstractArray{T}) where {T<:Union{Ket, Bra}} = copy(x)
RecursiveArrayTools.recursivefill!(x::T, a) where {T<:Union{Ket, Bra}} = fill!(x, a)

# GPU adaptation
Adapt.adapt_structure(to, x::Ket) = Ket(x.basis, Adapt.adapt(to, x.data))
Adapt.adapt_structure(to, x::Bra) = Bra(x.basis, Adapt.adapt(to, x.data))

@testitem "test_operators_lazyproduct" begin
using Test
using QuantumOpticsBase
using LinearAlgebra, Random


@testset "operators-lazyproduct" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x1::StateVector, x2::StateVector) = norm(x2-x1)

b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(1)
b3b = GenericBasis(5)

b_l = b1a⊗b2a⊗b3a
b_r = b1b⊗b2b⊗b3b

# Test creation
@test_throws ArgumentError LazyProduct()
@test_throws QuantumOpticsBase.IncompatibleBases LazyProduct(randoperator(b_l, b_r), randoperator(b_l, b_r))
@test_throws QuantumOpticsBase.IncompatibleBases LazyProduct(randoperator(b_l, b_r), sparse(randoperator(b_l, b_r)))

# Test copy
op1 = 2*LazyProduct(randoperator(b_l, b_r), sparse(randoperator(b_r, b_l)))
op2 = copy(op1)
@test op1 == op2
@test isequal(op1, op2)
@test !(op1 === op2)
op2.operators[1].data[1,1] = complex(10.)
@test op1.operators[1].data[1,1] != op2.operators[1].data[1,1]
op2.factor = 3.
@test op2.factor != op1.factor

@test QuantumOpticsBase.is_const(op1)

# Test dense & sparse
op1 = randoperator(b_l, b_r)
op2 = randoperator(b_r, b_l)
@test 0.1*(op1*op2) == dense(LazyProduct([sparse(op1), sparse(op2)], 0.1))
@test 0.1*(sparse(op1)*sparse(op2)) == sparse(LazyProduct([op1, op2], 0.1))

# Arithmetic operations
# =====================
op1a = randoperator(b_l, b_r)
op1b = randoperator(b_r, b_l)
op2a = randoperator(b_l, b_r)
op2b = randoperator(b_r, b_l)
op3a = randoperator(b_l, b_l)
op3b = randoperator(b_r, b_r)

op1 = LazyProduct([op1a, sparse(op1b)])*0.1
op1_ = 0.1*(op1a*op1b)
op2 = LazyProduct([sparse(op2a), op2b], 0.3)
op2_ = 0.3*(op2a*op2b)
op3 = LazyProduct(op3a)
op3_ = op3a
op4 = LazyProduct(op3b)
op4_ = op3b

x1 = Ket(b_l, rand(ComplexF64, length(b_l)))
x2 = Ket(b_l, rand(ComplexF64, length(b_l)))
xbra1 = Bra(b_l, rand(ComplexF64, length(b_l)))
xbra2 = Bra(b_l, rand(ComplexF64, length(b_l)))

# Test Addition
@test_throws QuantumOpticsBase.IncompatibleBases op1 + dagger(op4)
@test 1e-14 > D(-op1_, -op1)
@test 1e-14 > D(op1+op2, op1_+op2_)
@test 1e-14 > D(op1+op2_, op1_+op2_)
@test 1e-14 > D(op1_+op2, op1_+op2_)
#Check for unallowed addition:
@test_throws QuantumOpticsBase.IncompatibleBases LazyProduct([op1a, sparse(op1a)])+LazyProduct([sparse(op2b), op2b], 0.3)

# Test Subtraction
@test_throws QuantumOpticsBase.IncompatibleBases op1 - dagger(op4)
@test 1e-14 > D(op1 - op2, op1_ - op2_)
@test 1e-14 > D(op1 - op2_, op1_ - op2_)
@test 1e-14 > D(op1_ - op2, op1_ - op2_)
@test 1e-14 > D(op1 + (-op2), op1_ - op2_)
@test 1e-14 > D(op1 + (-1*op2), op1_ - op2_)
#Check for unallowed subtraction:
@test_throws QuantumOpticsBase.IncompatibleBases LazyProduct([op1a, sparse(op1a)])-LazyProduct([sparse(op2b), op2b], 0.3)


# Test multiplication
@test_throws DimensionMismatch op1a*op1a
@test 1e-11 > D(op1*(x1 + 0.3*x2), op1_*(x1 + 0.3*x2))
@test 1e-11 > D((xbra1 + 0.3*xbra2)*op1, (xbra1 + 0.3*xbra2)*op1_)
@test 1e-11 > D(op1*x1 + 0.3*op1*x2, op1_*x1 + 0.3*op1_*x2)
@test 1e-12 > D(dagger(x1)*dagger(0.3*op2), dagger(x1)*dagger(0.3*op2_))
@test 0.3*LazyProduct(op1, sparse(op2)) == LazyProduct([op1, sparse(op2)], 0.3)
@test 0.3*LazyProduct(op1)*LazyProduct(sparse(op2)) == LazyProduct([op1, sparse(op2)], 0.3)

# Test division
@test 1e-14 > D(op1/7, op1_/7)

#Test Tensor product
op = op1a ⊗ op1
op_ = op1a ⊗ op1_
@test 1e-11 > D(op,op_)
op = op1 ⊗ op2a
op_ = op1_ ⊗ op2a 
@test 1e-11 > D(op,op_)

# Test identityoperator
Idense = identityoperator(DenseOpType, b_l)
id = identityoperator(LazyProduct, b_l)
@test isa(id, LazyProduct)
@test dense(id) == Idense
@test 1e-11 > D(id*x1, x1)
@test 1e-11 > D(xbra1*id, xbra1)

# Test tr and normalize
op1 = randoperator(b_l)
op2 = randoperator(b_l)
op = LazyProduct(op1, op2)
@test_throws ArgumentError tr(op)
@test_throws ArgumentError ptrace(op, [1, 2])
@test_throws ArgumentError normalize(op)
@test_throws ArgumentError normalize!(op)

# Test expect
op1 = randoperator(b_l)
op2 = randoperator(b_l)
op = 0.3*LazyProduct(op1, sparse(op2))
op_ = 0.3*op1*op2

state = Ket(b_l, rand(ComplexF64, length(b_l)))
@test expect(op, state) ≈ expect(op_, state)

state = DenseOperator(b_l, b_l, rand(ComplexF64, length(b_l), length(b_l)))
@test expect(op, state) ≈ expect(op_, state)

# Permute systems
op1 = randoperator(b_l)
op2 = randoperator(b_l)
op3 = randoperator(b_l)
op = 0.3*LazyProduct(op1, op2, sparse(op3))
op_ = 0.3*op1*op2*op3

@test 1e-14 > D(permutesystems(op, [1, 3, 2]), permutesystems(op_, [1, 3, 2]))
@test 1e-14 > D(permutesystems(op, [2, 1, 3]), permutesystems(op_, [2, 1, 3]))
@test 1e-14 > D(permutesystems(op, [2, 3, 1]), permutesystems(op_, [2, 3, 1]))
@test 1e-14 > D(permutesystems(op, [3, 1, 2]), permutesystems(op_, [3, 1, 2]))
@test 1e-14 > D(permutesystems(op, [3, 2, 1]), permutesystems(op_, [3, 2, 1]))


# Test gemv
op1 = randoperator(b_l, b_r)
op2 = randoperator(b_r, b_l)
op3 = randoperator(b_l, b_r)
op4 = randoperator(b_r, b_l)
for N=1:3
    op = LazyProduct([op1, sparse(op2), op3, op4][1:N], 0.2)
    op_ = 0.2*prod([op1,op2,op3,op4][1:N])

    state = randstate(iseven(N) ? b_l : b_r)
    result_ = randstate(b_l)
    result = copy(result_)
    QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
    @test 1e-11 > D(result, op_*state)

    result = copy(result_)
    alpha = complex(1.5)
    beta = complex(2.1)
    QuantumOpticsBase.mul!(result,op,state,alpha,beta)
    @test 1e-11 > D(result, alpha*op_*state + beta*result_)

    result = copy(result_)
    QuantumOpticsBase.mul!(result,op,state,0,beta)
    @test 1e-11 > D(result, beta*result_)

    state = Bra(b_l, rand(ComplexF64, length(b_l)))
    result_ = randstate(iseven(N) ? b_l : b_r)'
    result = copy(result_)
    QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
    @test 1e-11 > D(result, state*op_)

    result = copy(result_)
    alpha = complex(1.5)
    beta = complex(2.1)
    QuantumOpticsBase.mul!(result,state,op,alpha,beta)
    @test 1e-11 > D(result, alpha*state*op_ + beta*result_)

    result = copy(result_)
    QuantumOpticsBase.mul!(result,state,op,0,beta)
    @test 1e-11 > D(result, beta*result_)

    # Test gemm
    state = randoperator(iseven(N) ? b_l : b_r, b_r)
    result_ = randoperator(b_l, b_r)
    result = copy(result_)
    QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
    @test 1e-11 > D(result, op_*state)

    result = copy(result_)
    alpha = complex(1.5)
    beta = complex(2.1)
    QuantumOpticsBase.mul!(result,op,state,alpha,beta)
    @test 1e-11 > D(result, alpha*op_*state + beta*result_)

    result = copy(result_)
    QuantumOpticsBase.mul!(result,op,state,0,beta)
    @test 1e-11 > D(result, beta*result_)

    state = randoperator(b_l, b_l)
    result_ = randoperator(b_l, iseven(N) ? b_l : b_r)
    result = copy(result_)
    QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
    @test 1e-11 > D(result, state*op_)

    result = copy(result_)
    alpha = complex(1.5)
    beta = complex(2.1)
    QuantumOpticsBase.mul!(result,state,op,alpha,beta)
    @test 1e-11 > D(result, alpha*state*op_ + beta*result_)

    result = copy(result_)
    QuantumOpticsBase.mul!(result,state,op,0,beta)
    @test 1e-11 > D(result, beta*result_)
end

end # testset
end

@testitem "test_fock" begin
using Test
using QuantumOpticsBase
using Random, SparseArrays, LinearAlgebra

@testset "fock" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
randstate(b) = normalize(Ket(b, rand(ComplexF64, length(b))))
randop(bl, br) = DenseOperator(bl, br, rand(ComplexF64, length(bl), length(br)))
randop(b) = randop(b, b)

basis = FockBasis(2)

# Test creation
@test basis.N == 2
@test basis.shape[1] == 3
@test_throws ArgumentError FockBasis(-1)

# Test equality
@test FockBasis(2) == FockBasis(2)
@test FockBasis(2) != FockBasis(3)

# Test operators
@test number(basis) == SparseOperator(basis, sparse(Diagonal(ComplexF64[0, 1, 2])))
@test destroy(basis) == SparseOperator(basis, sparse(ComplexF64[0 1 0; 0 0 sqrt(2); 0 0 0]))
@test create(basis) == SparseOperator(basis, sparse(ComplexF64[0 0 0; 1 0 0; 0 sqrt(2) 0]))
@test number(basis) == dagger(number(basis))
@test create(basis) == dagger(destroy(basis))
@test destroy(basis) == dagger(create(basis))
@test 1e-15 > D(create(basis)*destroy(basis), number(basis))

# Test application onto statevectors
@test create(basis)*fockstate(basis, 0) == fockstate(basis, 1)
@test create(basis)*fockstate(basis, 1) == sqrt(2)*fockstate(basis, 2)
@test dagger(fockstate(basis, 0))*destroy(basis) == dagger(fockstate(basis, 1))
@test dagger(fockstate(basis, 1))*destroy(basis) == sqrt(2)*dagger(fockstate(basis, 2))

@test destroy(basis)*fockstate(basis, 1) == fockstate(basis, 0)
@test destroy(basis)*fockstate(basis, 2) == sqrt(2)*fockstate(basis, 1)
@test dagger(fockstate(basis, 1))*create(basis) == dagger(fockstate(basis, 0))
@test dagger(fockstate(basis, 2))*create(basis) == sqrt(2)*dagger(fockstate(basis, 1))

# Test displacement operator
b = FockBasis(30)
alpha = complex(0.5, 0.3)
d = displace(b, alpha)
@test 1e-12 > D(d*dagger(d), identityoperator(b))
@test 1e-12 > D(dagger(d)*d, identityoperator(b))
@test 1e-12 > D(dagger(d), displace(b, -alpha))
@test 1e-15 > norm(coherentstate(b, alpha) - displace(b, alpha)*fockstate(b, 0))
alpha = 5
@test coherentstate(b, alpha) ≈ displace_analytical(b, alpha)*fockstate(b, 0)

# Test squeezing operator
b = FockBasis(30)
z = complex(0.5, 0.3)
s = squeeze(b, z)
@test 1e-12 > D(s*dagger(s), identityoperator(b))
@test 1e-12 > D(dagger(s)*s, identityoperator(b))
@test 1e-12 > D(dagger(s), squeeze(b, -z))

α = complex(rand(0.0:0.1:2.0), rand(0.0:0.1:2.0))
for ofs in 0:3
    b = FockBasis(100, ofs)
    D = displace_analytical(b, α).data
    D̂ = displace(b, α).data
    
    chunk = 20
    imin = ofs > 0 ? chunk : 1
    imax = imin + 10
    @test D[imin:imax,imin:imax] ≈ D̂[imin:imax,imin:imax]

    m = rand(ofs:100)
    n = rand(ofs:100)
    @test D[m-ofs + 1, n-ofs + 1] == displace_analytical(α, m, n)
end

# Test Fock states
b = FockBasis(5)
@test expect(number(b), fockstate(b, 3)) == complex(3.)

# Test coherent states
b = FockBasis(100)
alpha = complex(3.)
a = destroy(b)
n = number(b)
psi = coherentstate(b, alpha)
rho = dm(psi)

@test 1e-14 > norm(expect(a, psi) - alpha)
@test 1e-14 > norm(expect(a, rho) - alpha)
@test 1e-13 > abs(variance(n, psi) - abs(alpha)^2)
@test 1e-13 > abs(variance(n, rho) - abs(alpha)^2)

# Test FockBasis with offset
b_off = FockBasis(100,4)
@test_throws AssertionError fockstate(b_off, 0)
n = 55
psi = fockstate(b_off, n)
@test expect(number(b_off), psi)==n==expect(create(b_off)*destroy(b_off), psi)

alpha = 5
psi = coherentstate(b, alpha)
psi_off = coherentstate(b_off, alpha)
@test psi.data[b_off.offset+1:end] == psi_off.data
@test isapprox(norm(psi_off), 1, atol=1e-7)

end # testset
end

@testitem "test_spinors" begin
using QuantumOpticsBase
using Test
using Random

@testset "spinors" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))

b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(1)
b3b = GenericBasis(5)

b_l = b1a⊕b2a⊕b3a
b_r = b1b⊕b2b⊕b3b

op1a = randoperator(b1a, b1b)
op1b = randoperator(b1a, b1b)
op2a = randoperator(b2a, b2b)
op2b = randoperator(b2a, b2b)
op3a = randoperator(b3a, b3b)
op123 = op1a ⊕ op2a ⊕ op3a
@test op123.basis_l == b_l
@test op123.basis_r == b_r

# Associativity
@test 1e-13 > D((op1a ⊕ op2a) ⊕ op3a, op1a ⊕ (op2a ⊕ op3a))
@test 1e-13 > D(op1a ⊕ op2a ⊕ op3a, op1a ⊕ (op2a ⊕ op3a))

# Mixed-product property
@test 1e-13 > D((op1a ⊕ op2a) * dagger(op1b ⊕ op2b), (op1a*dagger(op1b)) ⊕ (op2a*dagger(op2b)))

# Transpose
@test 1e-13 > D(dagger(op1a ⊕ op2a), dagger(op1a) ⊕ dagger(op2a))
@test 1e-13 > D(dagger(op1a ⊕ op2a), dagger(op1a) ⊕ dagger(op2a))

# Sparse version
@test isa(sparse(op1a)⊕sparse(op2a)⊕sparse(op3a), SparseOpType)

# Test lazy implementation
L = LazyDirectSum(op1a,op2a)
@test 1e-13 > D(op1a⊕op2a, L)
@test 1e-13 > D(2*(op1a⊕op2a), L+L)
@test isa(L ⊕ op3a, LazyDirectSum)
@test 1e-13 > D(op1a ⊕ op2a ⊕ op3a, L ⊕ op3a)
@test 1e-13 > D((op1a⊕op2a)*dagger(op1a⊕op2a), L*L')

# Test embedding
@test embed(b_l,b_r,1,op1a) == op1a ⊕ SparseOperator(b2a,b2b) ⊕ SparseOperator(b3a,b3b)
@test embed(b_l,b_r,[1,3],op1a ⊕ op3a) == embed(b_l,b_r,[1,3],(op1a,op3a)) == op1a ⊕ SparseOperator(b2a,b2b) ⊕ op3a

# Test with off-diagonal blocks
op = op1a ⊕ op3a
op_upper = randoperator(b1a,b3b)
setblock!(op, op_upper, 1, 2)
op_lower = randoperator(b1b,b3a)
setblock!(op, op_lower', 2, 1)

op_tot = op1a ⊕ SparseOperator(b2a,b2b) ⊕ op3a
setblock!(op_tot, op_upper, 1, 3)
setblock!(op_tot, op_lower', 3, 1)
@test op_tot == embed(b_l,b_r,[1,3],op)

# Lazy embed
@test embed(b_l,b_r,[1,2],L) == L ⊕ SparseOperator(b3a,b3b)

### Test example

# Define x-space
Nunitcells=2
Lx=Nunitcells/2
x_min=0
x_max = Lx
x_steps = 4

# Define y-space
Ly=Nunitcells/2
y_min = 0
y_max = Ly
y_steps = 8

# Define Bases
b_x = PositionBasis(x_min, x_max, x_steps)
b_y = PositionBasis(y_min, y_max, y_steps)
bcomp_x = b_x ⊗ b_y
b_sum = bcomp_x ⊕ bcomp_x

b_mom = MomentumBasis(b_x)
b_mom_y = MomentumBasis(b_y)
bcomp_p = MomentumBasis(b_x) ⊗ MomentumBasis(b_y)
b_sum_p = bcomp_p ⊕ bcomp_p

# Define Operators
H_up = randoperator(bcomp_x)
H_down = randoperator(b_x⊗b_y)
Hkin_x = randoperator(bcomp_x)
H = (H_up ⊕ H_down)

# Off-diagonal blocks - assign by hand
Ω_R = randoperator(bcomp_x)
nn = length(H_up.basis_l)
H.data[1:nn,nn+1:end] = Ω_R.data
H.data[nn+1:end,1:nn] = Ω_R.data'

H_h_upperline = hcat(Matrix(H_up.data),Matrix(Ω_R.data))
H_h_lowerline = hcat(Matrix(Ω_R.data'),Matrix(H_down.data))
H_matr=vcat(H_h_upperline,H_h_lowerline)
@test H.data ≈ H_matr
@test getblock(H, 1,2) == Ω_R

# States
ψ0_x=randstate(b_x)
ψ0_y=randstate(b_y)
ψ0_up=ψ0_x⊗ψ0_y
# Build with directsum (\oplus)
ψ0=(ψ0_x⊗ψ0_y)⊕(ψ0_x⊗ψ0_y)

# Test initial state
@test ψ0.data ≈ [ψ0_up.data;ψ0_up.data]
@test getblock(ψ0, 1) == ψ0_up == getblock(ψ0, 2)

# Test FFTs
Txp = transform(bcomp_x, bcomp_p; ket_only=true) # "normal" FFT operators as implemented
Tpx = transform(bcomp_p, bcomp_x; ket_only=true)
ψ0_p1 = (Tpx*ψ0_up)⊕(Tpx*ψ0_up) # Build with usual FFTs
ψ0_p2 = (Tpx⊕Tpx)*ψ0
@test ψ0_p1.data ≈ ψ0_p2.data

# Test off-diagonal blocks
H_test = copy(H)
setblock!(H_test, Ω_R, 1, 2)
setblock!(H_test, Ω_R', 2, 1)
@test H == H_test

# Lazy formulation
Txp_tot = Txp ⊕ Txp
Tpx_tot = Tpx ⊕ Tpx
Hkin_p = Tpx*Hkin_x*Txp
Hkin_tot = Hkin_p ⊕ Hkin_p
H_lazy = LazySum(H, LazyProduct(Txp_tot, Hkin_tot, Tpx_tot))

Hkin_x_tot = Txp_tot*Hkin_tot*Tpx_tot
@test dense(H_lazy).data ≈ dense(H + Hkin_x_tot).data
@test (H_lazy*ψ0).data ≈ (H*ψ0 + Hkin_x_tot*ψ0).data

# # Test time evolution
# tout, ψt = timeevolution.schroedinger([0.0:0.1:1.0;], ψ0, H)
# tout, ψt_lazy = timeevolution.schroedinger([0.0:0.1:1.0;], ψ0, H_lazy)
#
# for i=1:length(tout)
#     @test ψt[i].data ≈ ψt_lazy[i].data
# end

end # testset
end

# Utility functions for GPU testing

function create_test_operator(basis_l, basis_r, AT)
    """Create a test operator and adapt it to the specified array type."""
    data = rand(ComplexF64, length(basis_l), length(basis_r))
    cpu_op = DenseOperator(basis_l, basis_r, data)
    gpu_op = Adapt.adapt(AT, cpu_op)
    return cpu_op, gpu_op
end

function create_test_ket(basis, AT)
    """Create a test ket and adapt it to the specified array type."""
    data = rand(ComplexF64, length(basis))
    normalize!(data)
    cpu_ket = Ket(basis, data)
    gpu_ket = Adapt.adapt(AT, cpu_ket)
    return cpu_ket, gpu_ket
end

function create_test_bra(basis, AT)
    """Create a test bra and adapt it to the specified array type."""
    data = rand(ComplexF64, length(basis))
    normalize!(data)
    cpu_bra = Bra(basis, data)
    gpu_bra = Adapt.adapt(AT, cpu_bra)
    return cpu_bra, gpu_bra
end

function verify_gpu_result(cpu_result, gpu_result, tolerance=GPU_TOL)
    """Verify that GPU computation matches CPU result within tolerance."""
    cpu_data = cpu_result isa AbstractOperator ? cpu_result.data : cpu_result.data
    gpu_data_cpu = Array(gpu_result isa AbstractOperator ? gpu_result.data : gpu_result.data)
    return isapprox(cpu_data, gpu_data_cpu, atol=tolerance)
end

@testitem "test_superoperators" begin
using Test
using QuantumOpticsBase
using SparseArrays, LinearAlgebra
import QuantumOpticsBase: ChoiState # Remove when ChoiState is publicly exported

@testset "superoperators" begin

# Test creation
b = GenericBasis(3)
@test_throws DimensionMismatch DenseSuperOperator((b, b), (b, b), zeros(ComplexF64, 3, 3))
@test_throws DimensionMismatch SparseSuperOperator((b, b), (b, b), spzeros(ComplexF64, 3, 3))
@test_throws DimensionMismatch ChoiState((b, b), (b, b), zeros(ComplexF64, 3, 3))

# Test copy, sparse and dense
b1 = GenericBasis(2)
b2 = GenericBasis(7)
b3 = GenericBasis(5)
b4 = GenericBasis(3)

s = DenseSuperOperator((b1, b2), (b3, b4))
s_ = dense(s)
s_.data[1,1] = 1
@test s.data[1,1] == 0
s_sparse = sparse(s_)
@test isa(s_sparse, SparseSuperOpType)
@test s_sparse.data[1,1] == 1

s = SparseSuperOperator((b1, b2), (b3, b4))
s_ = sparse(s)
s_.data[1,1] = 1
@test s.data[1,1] == 0
s_dense = dense(s_)
@test isa(s_dense, DenseSuperOpType)
@test s_dense.data[1,1] == 1

# Test length
b1 = GenericBasis(3)
op = DenseOperator(b1, b1)
S = spre(op)
@test length(S) == length(S.data) == (3*3)^2
S = spost(op)
@test length(S) == length(S.data) == (3*3)^2
b2 = GenericBasis(5)
op = DenseOperator(b1, b2)
S = sprepost(dagger(op), op)
@test length(S) == length(S.data) == (3*5)^2

# Test arithmetic
b1 = GenericBasis(3)
b2 = GenericBasis(5)
b3 = GenericBasis(5)
b4 = GenericBasis(3)

d1 = DenseSuperOperator((b1, b2), (b3, b4))
d2 = DenseSuperOperator((b3, b4), (b1, b2))
s1 = SparseSuperOperator((b1, b2), (b3, b4))
s2 = SparseSuperOperator((b3, b4), (b1, b2))

x = d1*d2
@test isa(x, DenseSuperOpType)
@test x.basis_l == x.basis_r == (b1, b2)

x = s1*s2
@test isa(x, SparseSuperOpType)
@test x.basis_l == x.basis_r == (b1, b2)

x = d1*s2
@test isa(x, DenseSuperOpType)
@test x.basis_l == x.basis_r == (b1, b2)

x = s1*d2
@test isa(x, DenseSuperOpType)
@test x.basis_l == x.basis_r == (b1, b2)

x = d1*3
@test isa(x, DenseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = 2.5*s1
@test isa(x, SparseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = d1 + d1
@test isa(x, DenseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = s1 + s1
@test isa(x, SparseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = d1 + s1
@test isa(x, DenseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = d1 - d1
@test isa(x, DenseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = s1 - s1
@test isa(x, SparseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = d1 - s1
@test isa(x, DenseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = -d1
@test isa(x, DenseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

x = -s1
@test isa(x, SparseSuperOpType)
@test x.basis_l == (b1, b2)
@test x.basis_r == (b3, b4)

# TODO: Clean-up this part
ωc = 1.2
ωa = 0.9
g = 1.0
γ = 0.5
κ = 1.1

T = Float64[0.,1.]


fockbasis = FockBasis(7)
spinbasis = SpinBasis(1//2)
basis = tensor(spinbasis, fockbasis)

sx = sigmax(spinbasis)
sy = sigmay(spinbasis)
sz = sigmaz(spinbasis)
sp = sigmap(spinbasis)
sm = sigmam(spinbasis)

Ha = embed(basis, 1, 0.5*ωa*sz)
Hc = embed(basis, 2, ωc*number(fockbasis))
Hint = sm ⊗ create(fockbasis) + sp ⊗ destroy(fockbasis)
H = Ha + Hc + Hint

Ja = embed(basis, 1, sqrt(γ)*sm)
Jc = embed(basis, 2, sqrt(κ)*destroy(fockbasis))
J = [Ja, Jc]

Ψ₀ = spinup(spinbasis) ⊗ fockstate(fockbasis, 5)
ρ₀ = dm(Ψ₀)

@test identitysuperoperator(spinbasis)*sx == sx
@test ChoiState(identitysuperoperator(spinbasis))*sx == sx
@test identitysuperoperator(sparse(spre(sx)))*sx == sparse(sx)
@test ChoiState(identitysuperoperator(sparse(spre(sx))))*sx == sparse(sx)
@test sparse(ChoiState(identitysuperoperator(spre(sx))))*sx == sparse(sx)
@test identitysuperoperator(dense(spre(sx)))*sx == dense(sx)
@test ChoiState(identitysuperoperator(dense(spre(sx))))*sx == dense(sx)
@test dense(ChoiState(identitysuperoperator(spre(sx))))*sx == dense(sx)

op1 = DenseOperator(spinbasis, [1.2+0.3im 0.7+1.2im;0.3+0.1im 0.8+3.2im])
op2 = DenseOperator(spinbasis, [0.2+0.1im 0.1+2.3im; 0.8+4.0im 0.3+1.4im])
@test tracedistance(spre(op1)*op2, op1*op2) < 1e-12
@test tracedistance(ChoiState(spre(op1))*op2, op1*op2) < 1e-12
@test tracedistance(spost(op1)*op2, op2*op1) < 1e-12
@test tracedistance(ChoiState(spost(op1))*op2, op2*op1) < 1e-12

@test spre(sparse(op1))*op2 == op1*op2
@test ChoiState(spre(sparse(op1)))*op2 == op1*op2
@test spost(sparse(op1))*op2 == op2*op1
@test ChoiState(spost(sparse(op1)))*op2 == op2*op1
@test spre(sparse(dagger(op1)))*op2 == dagger(op1)*op2
@test ChoiState(spre(sparse(dagger(op1))))*op2 == dagger(op1)*op2
@test spre(dense(dagger(op1)))*op2 ≈ dagger(op1)*op2
@test ChoiState(spre(dense(dagger(op1))))*op2 ≈ dagger(op1)*op2
@test sprepost(sparse(op1), op1)*op2 ≈ op1*op2*op1
@test ChoiState(sprepost(sparse(op1), op1))*op2 ≈ op1*op2*op1

@test spre(sparse(op1))*sparse(op2) == sparse(op1*op2)
@test ChoiState(spre(sparse(op1)))*sparse(op2) == sparse(op1*op2)
@test spost(sparse(op1))*sparse(op2) == sparse(op2*op1)
@test ChoiState(spost(sparse(op1)))*sparse(op2) == sparse(op2*op1)
@test sprepost(sparse(op1), sparse(op1))*sparse(op2) ≈ sparse(op1*op2*op1)
@test ChoiState(sprepost(sparse(op1), sparse(op1)))*sparse(op2) ≈ sparse(op1*op2*op1)

@test sprepost(op1, op2) ≈ spre(op1)*spost(op2)
b1 = FockBasis(1)
b2 = FockBasis(5)
op = fockstate(b1, 0) ⊗ dagger(fockstate(b2, 0))
@test sprepost(dagger(op), op)*dm(fockstate(b1, 0)) == dm(fockstate(b2, 0))
@test ChoiState(sprepost(dagger(op), op))*dm(fockstate(b1, 0)) == dm(fockstate(b2, 0))
@test_throws ArgumentError spre(op)
@test_throws ArgumentError spost(op)

L = liouvillian(H, J)
ρ = -1im*(H*ρ₀ - ρ₀*H)
for j=J
    ρ .+= j*ρ₀*dagger(j) - 0.5*dagger(j)*j*ρ₀ - 0.5*ρ₀*dagger(j)*j
end
@test tracedistance(L*ρ₀, ρ) < 1e-10
@test tracedistance(ChoiState(L)*ρ₀, ρ) < 1e-10

# tout, ρt = timeevolution.master([0.,1.], ρ₀, H, J; reltol=1e-7)
# @test tracedistance(exp(dense(L))*ρ₀, ρt[end]) < 1e-6
# @test tracedistance(exp(sparse(L))*ρ₀, ρt[end]) < 1e-6

@test dense(spre(op1)) == spre(op1)
@test dense(ChoiState(spre(op1))) == ChoiState(spre(op1))

@test L/2.0 == 0.5*L == L*0.5
@test -L == SparseSuperOperator(L.basis_l, L.basis_r, -L.data)

@test_throws AssertionError liouvillian(H, J; rates=zeros(4, 4))

rates = diagm(0 => [1.0, 1.0])
@test liouvillian(H, J; rates=rates) == L

# Test broadcasting
@test L .+ L == L + L
Ldense = dense(L)
# @test isa(L .+ Ldense, DenseSuperOpType) # Broadcasting of sparse .+ dense returns sparse
L_ = copy(L)
L .+= L
@test L == 2*L_
L .+= Ldense
@test L == 3*L_
Ldense_ = dense(L_)
Ldense .+= Ldense
@test Ldense == 2*Ldense_
Ldense .+= L
@test isa(Ldense, DenseSuperOpType)
@test isapprox(Ldense.data, 5*Ldense_.data)

b = FockBasis(20)
L = liouvillian(identityoperator(b), [destroy(b)])
@test exp(sparse(L)).data ≈ exp(dense(L)).data
@test exp(sparse(zero(identitysuperoperator(b)))).data ≈ identitysuperoperator(b).data
N = exp(log(2) * sparse(L)) # 50% loss channel
ρ = N * dm(coherentstate(b, 1))
@test (1 - real(tr(ρ^2))) < 1e-10 # coherent state remains pure under loss
@test tracedistance(ρ, dm(coherentstate(b, 1/sqrt(2)))) < 1e-10
ρ = N * dm(fockstate(b, 1))
@test (0.5 - real(tr(ρ^2))) < 1e-10 # one photon state becomes maximally mixed
@test tracedistance(ρ, normalize(dm(fockstate(b, 0)) + dm(fockstate(b, 1)))) < 1e-10

# Testing 0-2-4 binomial code encoder
b_logical = SpinBasis(1//2)
b_fock = FockBasis(5)
z_l = normalize(fockstate(b_fock, 0) + fockstate(b_fock, 4))
o_l = fockstate(b_fock, 2)
encoder_kraus = z_l ⊗ dagger(spinup(b_logical)) + o_l ⊗ dagger(spindown(b_logical))
    encoder_sup = sprepost(encoder_kraus, dagger(encoder_kraus))
decoder_sup = sprepost(dagger(encoder_kraus), encoder_kraus)
@test SuperOperator(ChoiState(encoder_sup)).data == encoder_sup.data
@test decoder_sup == dagger(encoder_sup)
@test ChoiState(decoder_sup) == dagger(ChoiState(encoder_sup))
@test decoder_sup*encoder_sup ≈ dense(identitysuperoperator(b_logical))
@test decoder_sup*ChoiState(encoder_sup) ≈ dense(identitysuperoperator(b_logical))
@test ChoiState(decoder_sup)*encoder_sup ≈ dense(identitysuperoperator(b_logical))
@test SuperOperator(ChoiState(decoder_sup)*ChoiState(encoder_sup)) ≈ dense(identitysuperoperator(b_logical))

end # testset
end

@testitem "test_transformations" begin
using Test
using QuantumOpticsBase
using Random, LinearAlgebra

@testset "transformation" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x::Ket, y::Ket) = norm(x-y)

# Test transformations
b_fock = FockBasis(20)
b_position = PositionBasis(-10, 10, 200)
Txn = transform(b_position, b_fock)
Tnx = transform(b_fock, b_position)
@test 1e-10 > D(dagger(Txn), Tnx)
@test 1e-10 > D(one(b_fock), Tnx*Txn)

x0 = 0.1
p0 = 0.3
α0 = (x0 + 1im*p0)/sqrt(2)
psi_n = coherentstate(b_fock, α0)
psi_x = gaussianstate(b_position, x0, p0, 1)
@test 1e-10 > D(psi_x, Txn*psi_n)

# Test different characteristic length
x0 = 0.0
p0 = 0.2
α0 = (x0 + 1im*p0)/sqrt(2)
σ0 = 0.7
Txn = transform(b_position, b_fock; x0=σ0)
Tnx = transform(b_fock, b_position; x0=σ0)
@test 1e-10 > D(dagger(Txn), Tnx)
@test 1e-10 > D(one(b_fock), Tnx*Txn)

psi_n = coherentstate(b_fock, α0)
psi_x = gaussianstate(b_position, x0/σ0, p0/σ0, σ0)
@test 1e-10 > D(psi_x, Txn*psi_n)

# Test with offset in FockBasis
b_fock = FockBasis(50,1)
b_position = PositionBasis(-10, 10, 300)

x0 = 6.1
p0 = 0.3
α0 = (x0 + 1im*p0)/sqrt(2)

psi_n = coherentstate(b_fock, α0)
psi_x = gaussianstate(b_position, x0, p0, 1)
@test isapprox(norm(psi_n), 1, atol=1e-8)

Txn = transform(b_position, b_fock)
Tnx = transform(b_fock, b_position)
@test 1e-10 > D(dagger(Txn), Tnx)
@test 1e-4 > D(psi_x, Txn*psi_n)
@test 1e-4 > D(psi_n, Tnx*psi_x)

end # testset
end

"""
    tracenorm(rho)

Trace norm of `rho`.

It is defined as

```math
T(ρ) = Tr\\{\\sqrt{ρ^† ρ}\\}.
```

Depending if `rho` is hermitian either [`tracenorm_h`](@ref) or
[`tracenorm_nh`](@ref) is called.
"""
function tracenorm(rho::DenseOpType)
    ishermitian(rho) ? tracenorm_h(rho) : tracenorm_nh(rho)
end
function tracenorm(rho::T) where T<:AbstractOperator
    throw(ArgumentError("tracenorm not implemented for $(typeof(rho)). Use dense operators instead."))
end

"""
    tracenorm_h(rho)

Trace norm of `rho`.

It uses the identity

```math
T(ρ) = Tr\\{\\sqrt{ρ^† ρ}\\} = \\sum_i |λ_i|
```

where ``λ_i`` are the eigenvalues of `rho`.
"""
function tracenorm_h(rho::DenseOpType{B,B}) where B
    s = eigvals(Hermitian(rho.data))
    sum(abs.(s))
end
function tracenorm_h(rho::T) where T<:AbstractOperator
    throw(ArgumentError("tracenorm_h not implemented for $(typeof(rho)). Use dense operators instead."))
end


"""
    tracenorm_nh(rho)

Trace norm of `rho`.

Note that in this case `rho` doesn't have to be represented by a square
matrix (i.e. it can have different left-hand and right-hand bases).

It uses the identity

```math
    T(ρ) = Tr\\{\\sqrt{ρ^† ρ}\\} = \\sum_i σ_i
```

where ``σ_i`` are the singular values of `rho`.
"""
tracenorm_nh(rho::DenseOpType) = sum(svdvals(rho.data))
function tracenorm_nh(rho::AbstractOperator)
    throw(ArgumentError("tracenorm_nh not implemented for $(typeof(rho)). Use dense operators instead."))
end


"""
    tracedistance(rho, sigma)

Trace distance between `rho` and `sigma`.

It is defined as

```math
T(ρ,σ) = \\frac{1}{2} Tr\\{\\sqrt{(ρ - σ)^† (ρ - σ)}\\}.
```

It calls [`tracenorm`](@ref) which in turn either uses [`tracenorm_h`](@ref)
or [`tracenorm_nh`](@ref) depending if ``ρ-σ`` is hermitian or not.
"""
tracedistance(rho::DenseOpType{B,B}, sigma::DenseOpType{B,B}) where {B} = 0.5*tracenorm(rho - sigma)
function tracedistance(rho::AbstractOperator, sigma::AbstractOperator)
    throw(ArgumentError("tracedistance not implemented for $(typeof(rho)) and $(typeof(sigma)). Use dense operators instead."))
end

"""
    tracedistance_h(rho, sigma)

Trace distance between `rho` and `sigma`.

It uses the identity

```math
T(ρ,σ) = \\frac{1}{2} Tr\\{\\sqrt{(ρ - σ)^† (ρ - σ)}\\} = \\frac{1}{2} \\sum_i |λ_i|
```

where ``λ_i`` are the eigenvalues of `rho` - `sigma`.
"""
tracedistance_h(rho::DenseOpType{B,B}, sigma::DenseOpType{B,B}) where {B}= 0.5*tracenorm_h(rho - sigma)
function tracedistance_h(rho::AbstractOperator, sigma::AbstractOperator)
    throw(ArgumentError("tracedistance_h not implemented for $(typeof(rho)) and $(typeof(sigma)). Use dense operators instead."))
end

"""
    tracedistance_nh(rho, sigma)

Trace distance between `rho` and `sigma`.

Note that in this case `rho` and `sigma` don't have to be represented by square
matrices (i.e. they can have different left-hand and right-hand bases).

It uses the identity

```math
    T(ρ,σ) = \\frac{1}{2} Tr\\{\\sqrt{(ρ - σ)^† (ρ - σ)}\\}
         = \\frac{1}{2} \\sum_i σ_i
```

where ``σ_i`` are the singular values of `rho` - `sigma`.
"""
tracedistance_nh(rho::DenseOpType{B1,B2}, sigma::DenseOpType{B1,B2}) where {B1,B2} = 0.5*tracenorm_nh(rho - sigma)
function tracedistance_nh(rho::AbstractOperator, sigma::AbstractOperator)
    throw(ArgumentError("tracedistance_nh not implemented for $(typeof(rho)) and $(typeof(sigma)). Use dense operators instead."))
end


"""
    entropy_vn(rho)

Von Neumann entropy of a density matrix.

The Von Neumann entropy of a density operator is defined as

```math
S(ρ) = -Tr(ρ \\log(ρ)) = -\\sum_n λ_n\\log(λ_n)
```

where ``λ_n`` are the eigenvalues of the density matrix ``ρ``, ``\\log`` is the
natural logarithm and ``0\\log(0) ≡ 0``.

# Arguments
* `rho`: Density operator of which to calculate Von Neumann entropy.
* `tol=1e-15`: Tolerance for rounding errors in the computed eigenvalues.
"""
function entropy_vn(rho::DenseOpType{B,B}; tol=1e-15) where B
    evals::Vector{ComplexF64} = eigvals(rho.data)
    entr = zero(eltype(rho))
    for d ∈ evals
        if !(abs(d) < tol)
            entr -= d*log(d)
        end
    end
    return entr
end

"""
    entropy_renyi(rho, α::Integer=2)

Renyi α-entropy of a density matrix, where r α≥0, α≂̸1.

The Renyi α-entropy of a density operator is defined as

```math
S_α(ρ) = 1/(1-α) \\log(Tr(ρ^α))
```
"""
function entropy_renyi(rho::DenseOpType{B,B}, α::Integer=2) where B
    α <  0 && throw(ArgumentError("α-Renyi entropy is defined for α≥0, α≂̸1"))
    α == 1 && throw(ArgumentError("α-Renyi entropy is defined for α≥0, α≂̸1"))

    return 1/(1-α) * log(tr(rho^α))
end

entropy_renyi(psi::StateVector, args...) = entropy_renyi(dm(psi), args...)

"""
    fidelity(rho, sigma)

Fidelity of two density operators.

The fidelity of two density operators ``ρ`` and ``σ`` is defined by

```math
F(ρ, σ) = Tr\\left(\\sqrt{\\sqrt{ρ}σ\\sqrt{ρ}}\\right),
```

where ``\\sqrt{ρ}=\\sum_n\\sqrt{λ_n}|ψ⟩⟨ψ|``.
"""
fidelity(rho::DenseOpType{B,B}, sigma::DenseOpType{B,B}) where {B} = tr(sqrt(sqrt(rho.data)*sigma.data*sqrt(rho.data)))


"""
    ptranspose(rho, indices)

Partial transpose of rho with respect to subsystem specified by indices. 
                        
The `indices` argument can be a single integer or a collection of integers.
"""
function ptranspose(rho::DenseOpType{B,B}, indices=1) where B<:CompositeBasis
    # adapted from qutip.partial_transpose (https://qutip.org/docs/4.0.2/modules/qutip/partial_transpose.html)
    # works as long as QuantumOptics.jl doesn't change the implementation of `tensor`, i.e. tensor(a,b).data = kron(b.data,a.data)
    nsys = length(rho.basis_l.shape)
    mask = ones(Int, nsys)
    mask[collect(indices)] .+= 1
    pt_dims = reshape(1:2*nsys, (nsys,2)) # indices of the operator viewed as a tensor with 2nsys legs
    pt_idx = [[pt_dims[i,mask[i]] for i = 1 : nsys]; [pt_dims[i,3-mask[i]] for i = 1 : nsys] ] # permute the legs on the subsystem of `indices`
    # reshape the operator data into a 2nsys-legged tensor and shape it back with the legs permuted
    data = reshape(permutedims(reshape(rho.data, Tuple([rho.basis_l.shape; rho.basis_r.shape])), pt_idx), size(rho.data))

    return DenseOperator(rho.basis_l,data)
    
end
                        


"""
    PPT(rho, index)

Peres-Horodecki criterion of partial transpose.
"""
PPT(rho::DenseOpType{B,B}, index) where B<:CompositeBasis = all(real.(eigvals(ptranspose(rho, index).data)) .>= 0.0)


"""
    negativity(rho, index)

Negativity of rho with respect to subsystem index.

The negativity of a density matrix ρ is defined as

```math
N(ρ) = \\frac{\\|ρᵀ\\|-1}{2},
```
where `ρᵀ` is the partial transpose.
"""
negativity(rho::DenseOpType{B,B}, index) where B<:CompositeBasis = 0.5*(tracenorm(ptranspose(rho, index)) - 1.0)


"""
    logarithmic_negativity(rho, index)

The logarithmic negativity of a density matrix ρ is defined as

```math
N(ρ) = \\log₂\\|ρᵀ\\|,
```
where `ρᵀ` is the partial transpose.
"""
logarithmic_negativity(rho::DenseOpType{B,B}, index) where B<:CompositeBasis = log(2, tracenorm(ptranspose(rho, index)))


"""
    avg_gate_fidelity(x, y)

The average gate fidelity between two superoperators x and y.
"""
function avg_gate_fidelity(x::T, y::T) where T <: Union{PauliTransferMatrix{B, B} where B, SuperOperator{B, B} where B, ChiMatrix{B, B} where B}
    dim = 2 ^ length(x.basis_l)
    return (tr(transpose(x.data) * y.data) + dim) / (dim^2 + dim)
end

"""
    entanglement_entropy(state, partition, [entropy_fun=entropy_vn])

Computes the entanglement entropy of `state` between the list of sites `partition`
and the rest of the system. The state must be defined in a composite basis.

If `state isa AbstractOperator` the operator-space entanglement entropy is
computed, which has the property
```julia
entanglement_entropy(dm(ket)) = 2 * entanglement_entropy(ket)
```

By default the computed entropy is the Von-Neumann entropy, but a different
function can be provided (for example to compute the entanglement-renyi entropy).
"""
function entanglement_entropy(psi::Ket{B}, partition, entropy_fun=entropy_vn) where B<:CompositeBasis
    # check that sites are within the range
    @assert all(partition .<= length(psi.basis.bases))

    rho = ptrace(psi, partition)
    return entropy_fun(rho)
end

function entanglement_entropy(rho::DenseOpType{B,B}, partition, args...) where {B<:CompositeBasis}
    # check that sites is within the range
    hilb = rho.basis_l
    all(partition .<= length(hilb.bases)) || throw(ArgumentError("Indices in partition must be within the bounds of the composite basis."))
    length(partition) <= length(hilb.bases) || throw(ArgumentError("Partition cannot include the whole system."))

    # build the doubled hilbert space for the vectorised dm, normalized like a Ket.
    b_doubled = hilb^2
    rho_vec = normalize!(Ket(b_doubled, vec(rho.data)))

    if partition isa Tuple
        partition_ = tuple(partition..., (partition.+length(hilb.bases))...)
    else
        partition_ = vcat(partition, partition.+length(hilb.bases))
    end

    return entanglement_entropy(rho_vec,partition_,args...)
end

entanglement_entropy(state::Ket{B}, partition::Number, args...) where B<:CompositeBasis =
    entanglement_entropy(state, [partition], args...)
entanglement_entropy(state::DenseOpType{B,B}, partition::Number, args...) where B<:CompositeBasis =
    entanglement_entropy(state, [partition], args...)

include("imports.jl")
include("definitions.jl")
include("utilities.jl")
include("test_basic_operations.jl")
include("test_adapt_methods.jl")

@inline function test_platform(AT, synchronize)
    @testset "Basic Operations" begin
        test_basic_operations(AT, synchronize)
    end
    
    @testset "Adapt Methods" begin
        test_adapt_methods(AT, synchronize)
    end
end

@testitem "test_charge" begin
using Test
using QuantumOpticsBase

@testset "charge" begin

    @test_throws DimensionMismatch ChargeBasis(-1)

    @test_throws DimensionMismatch ShiftedChargeBasis(2, 1)

    ncut = rand(1:10)
    cb1 = ChargeBasis(ncut)
    cb2 = ChargeBasis(ncut)
    @test cb1 == cb2

    n1 = rand(-10:-1)
    n2 = rand(1:10)
    cb1 = ShiftedChargeBasis(n1, n2)
    cb2 = ShiftedChargeBasis(n1, n2)
    @test cb1 == cb2

    for cb in [ChargeBasis(5), ShiftedChargeBasis(-4, 5)]
        ψ = chargestate(cb, -3)
        eiφ = expiφ(cb)
        @test eiφ * ψ == chargestate(cb, -2)
        @test eiφ' * ψ == chargestate(cb, -4)
        @test expiφ(cb, k=3) * ψ == chargestate(cb, 0)
        @test expiφ(cb, k=9) * ψ == 0 * ψ
        @test expiφ(cb, k=-3) * ψ == 0 * ψ
        @test expiφ(cb, k=3) == eiφ^3
        @test expiφ(cb, k=11) == 0 * eiφ

        @test eltype(chargeop(Float64, cb).data) == Float64
        @test eltype(chargeop(ComplexF64, cb).data) == ComplexF64
        @test eltype(expiφ(Float64, cb).data) == Float64
        @test eltype(expiφ(ComplexF64, cb).data) == ComplexF64

        n = chargeop(cb)
        @test n * ψ == -3 * ψ
        @test n * eiφ - eiφ * n == eiφ

        ei3φ = expiφ(cb, k=3)
        @test cosφ(cb, k=3) == (ei3φ + ei3φ') / 2
        @test sinφ(cb, k=3) == (ei3φ - ei3φ') / 2im
    end

end  # testset
end

@testitem "test_manybody" begin
using Test
using QuantumOpticsBase
using Random, SparseArrays, LinearAlgebra

@testset "manybody" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x1::StateVector, x2::StateVector) = norm(x2-x1)

# Test `SortedVector`
ve = [3, 2, 1, 4, 5]
sv1 = QuantumOpticsBase.SortedVector(ve)
sv2 = QuantumOpticsBase.SortedVector(ve, Base.Reverse)
@test length(sv1) == 5
@test length(sv2) == 5
@test collect(sv1) == [1, 2, 3, 4, 5]
@test collect(sv2) == [5, 4, 3, 2, 1]
@test map(x -> x^2, sv1) == [1, 4, 9, 16, 25]
@test map(x -> x^2, sv2) == [25, 16, 9, 4, 1]
@test findfirst(iseven, sv1) == 2
@test findfirst(iseven, sv2) == 2

# Test state creation
Nmodes = 5
b = GenericBasis(Nmodes)
@test bosonstates(b, 1) == fermionstates(b, 1)
@test bosonstates(b, 2) != fermionstates(b, 2)
@test length(bosonstates(b, 1)) == Nmodes
@test bosonstates(b, 1) ∪ bosonstates(b, 2) == bosonstates(b, [1, 2])
@test fermionstates(b, 1) ∪ fermionstates(b, 2) == fermionstates(b, [1, 2])

@test ManyBodyBasis(b, bosonstates(b, 1)) == ManyBodyBasis(b, fermionstates(b, 1))
@test ManyBodyBasis(b, bosonstates(b, 2)) != ManyBodyBasis(b, fermionstates(b, 2))

@test collect(fermionstates(FermionBitstring, b, 3)) ==
    convert.(FermionBitstring, fermionstates(b, 3))
@test collect(bosonstates(Vector{Int}, b, 3)) ==
    convert.(Vector{Int}, bosonstates(b, 3))
b2 = GenericBasis(130)
@test collect(fermionstates(FermionBitstring{BigInt}, b2, 2)) ==
    convert.(FermionBitstring{BigInt}, fermionstates(b2, 2))

# Test basisstate
b_mb = ManyBodyBasis(b, bosonstates(b, 2))
psi_mb = basisstate(b_mb, [2, 0, 0, 0, 0])
op = dm(basisstate(b, 1))
@test onebodyexpect(op, psi_mb) ≈ 2
psi_mb = basisstate(b_mb, [1, 0, 1, 0, 0])
@test onebodyexpect(op, psi_mb) ≈ 1
@test_throws ArgumentError basisstate(b_mb, [1, 0, 0, 0, 0])

# Test creation operator
b_mb = ManyBodyBasis(b, bosonstates(b, [0, 1, 2]))
vac = basisstate(b_mb, [0, 0, 0, 0, 0])
at1 = create(b_mb, 1)
at2 = create(b_mb, 2)
at3 = create(b_mb, 3)
at4 = create(b_mb, 4)
at5 = create(b_mb, 5)
@test 1e-12 > D(at1*vac, basisstate(b_mb, [1, 0, 0, 0, 0]))
@test 1e-12 > D(at2*vac, basisstate(b_mb, [0, 1, 0, 0, 0]))
@test 1e-12 > D(at3*vac, basisstate(b_mb, [0, 0, 1, 0, 0]))
@test 1e-12 > D(at4*vac, basisstate(b_mb, [0, 0, 0, 1, 0]))
@test 1e-12 > D(at5*vac, basisstate(b_mb, [0, 0, 0, 0, 1]))

@test 1e-12 > D(at1*at1*vac, sqrt(2)*basisstate(b_mb, [2, 0, 0, 0, 0]))
@test 1e-12 > D(at1*at2*vac, basisstate(b_mb, [1, 1, 0, 0, 0]))
@test 1e-12 > norm(at1*basisstate(b_mb, [2, 0, 0, 0, 0]))

# Test annihilation operator
b_mb = ManyBodyBasis(b, bosonstates(b, [0, 1, 2]))
vac = basisstate(b_mb, [0, 0, 0, 0, 0])
a1 = destroy(b_mb, 1)
a2 = destroy(b_mb, 2)
a3 = destroy(b_mb, 3)
a4 = destroy(b_mb, 4)
a5 = destroy(b_mb, 5)
@test 1e-12 > D(a1*basisstate(b_mb, [1, 0, 0, 0, 0]), vac)
@test 1e-12 > D(a2*basisstate(b_mb, [0, 1, 0, 0, 0]), vac)
@test 1e-12 > D(a3*basisstate(b_mb, [0, 0, 1, 0, 0]), vac)
@test 1e-12 > D(a4*basisstate(b_mb, [0, 0, 0, 1, 0]), vac)
@test 1e-12 > D(a5*basisstate(b_mb, [0, 0, 0, 0, 1]), vac)

@test 1e-12 > D(a1*a1*basisstate(b_mb, [2, 0, 0, 0, 0]), sqrt(2)*vac)
@test 1e-12 > D(a1*a2*basisstate(b_mb, [1, 1, 0, 0, 0]), vac)
@test 1e-12 > norm(a1*vac)

# Test number operator
b = GenericBasis(3)
b_mb = ManyBodyBasis(b, bosonstates(b, [0, 1, 2, 3, 4]))
vac = basisstate(b_mb, [0, 0, 0])
n = number(b_mb)
n1 = number(b_mb, 1)
n2 = number(b_mb, 2)
n3 = number(b_mb, 3)

@test 1 ≈ expect(n2, basisstate(b_mb, [0, 1, 0]))
@test 2 ≈ expect(n3, basisstate(b_mb, [0, 0, 2]))
@test 0 ≈ expect(n1+n2+n3, vac)
@test 4 ≈ expect(n, basisstate(b_mb, [1, 3, 0]))

psi = randstate(b_mb)
rho = randoperator(b_mb)

n1_ = dm(basisstate(b, 1))
n2_ = dm(basisstate(b, 2))
n3_ = dm(basisstate(b, 3))

@test expect(n1, psi) ≈ onebodyexpect(n1_, psi)
@test expect(n2, psi) ≈ onebodyexpect(n2_, psi)
@test expect(n3, psi) ≈ onebodyexpect(n3_, psi)
@test expect(n1, rho) ≈ onebodyexpect(n1_, rho)
@test expect(n2, rho) ≈ onebodyexpect(n2_, rho)
@test expect(n3, rho) ≈ onebodyexpect(n3_, rho)

# Test transition operator
b = NLevelBasis(4)
b_mb = ManyBodyBasis(b, bosonstates(b, [0, 1, 2, 3]))
t23 = transition(b_mb, 2, 3)
t32 = transition(b_mb, 3, 2)

@test t23 == dagger(t32)
@test t32*basisstate(b_mb, [0, 1, 0, 0]) == basisstate(b_mb, [0, 0, 1, 0])
@test 1e-12 > D(t32*basisstate(b_mb, [0, 2, 1, 0]), 2*basisstate(b_mb, [0, 1, 2, 0]))
@test 1e-12 > D(number(b_mb, 2), transition(b_mb, 2, 2))

t22_33 = transition(b_mb, (2, 2), (3, 3))
d3 = destroy(b_mb, 3)
c2 = create(b_mb, 2)
@test t22_33 ≈ c2 * c2 * d3 * d3

# Test commutator and anticommutator
state = basisstate(b_mb, [1, 0, 0, 0])
a1 = destroy(b_mb, 1)
at2 = create(b_mb, 2)
at3 = create(b_mb, 3)
@test 1e-12 > D(a1 * at2 * state, at2 * a1 * state)
@test 1e-12 > D(at2 * at3 * state, at3 * at2 * state)

f_mb = ManyBodyBasis(b, fermionstates(b, [0, 1, 2]))
state = basisstate(f_mb, [1, 0, 0, 0])
a1 = destroy(f_mb, 1)
at2 = create(f_mb, 2)
at3 = create(f_mb, 3)
@test 1e-12 > D(a1 * at2 * state, -at2 * a1 * state)
@test 1e-12 > D(at2 * at3 * state, -at3 * at2 * state)

f_mb2 = ManyBodyBasis(b, fermionstates(FermionBitstring, b, [0, 1, 2]))
state = basisstate(f_mb2, [1, 0, 0, 0])
a1 = destroy(f_mb2, 1)
at2 = create(f_mb2, 2)
at3 = create(f_mb2, 3)
@test 1e-12 > D(a1 * at2 * state, -at2 * a1 * state)
@test 1e-12 > D(at2 * at3 * state, -at3 * at2 * state)

# Single particle operator in second quantization
b_single = GenericBasis(Nmodes)
b = ManyBodyBasis(b_single, bosonstates(b_single, [1, 2]))
x = randoperator(b_single)
y = randoperator(b_single)

X = manybodyoperator(b, x)
Y = manybodyoperator(b, y)

@test 1e-12 > D(X + Y, manybodyoperator(b, x + y))

x_ = sparse(x)
y_ = sparse(y)
@test 1e-12 > D(X, manybodyoperator(b, x_))
@test 1e-12 > D(Y, manybodyoperator(b, y_))
@test 1e-12 > D(X + Y, manybodyoperator(b, x_ + y_))

# Same for fermions
bf1 = ManyBodyBasis(b_single, fermionstates(b_single, [1, 2]))
bf2 = ManyBodyBasis(b_single, fermionstates(FermionBitstring, b_single, [1, 2]))

X1 = manybodyoperator(bf1, x)
X2 = manybodyoperator(bf2, x)
@test X1.data == X2.data
@test 1e-12 > D(X2, manybodyoperator(bf2, x_))

# Particle-particle interaction operator in second quantization
x = randoperator(b_single ⊗ b_single)
y = randoperator(b_single ⊗ b_single)

X = manybodyoperator(b, x)
Y = manybodyoperator(b, y)

@test 1e-12 > D(X + Y, manybodyoperator(b, x + y))

x_ = sparse(x)
y_ = sparse(y)
@test 1e-12 > D(X, manybodyoperator(b, x_))
@test 1e-12 > D(Y, manybodyoperator(b, y_))
@test 1e-12 > D(X + Y, manybodyoperator(b, x_ + y_))

# Same for fermions
X1 = manybodyoperator(bf1, x)
X2 = manybodyoperator(bf2, x)
Y2 = manybodyoperator(bf2, y)
@test X1.data == X2.data
@test 1e-12 > D(X2, manybodyoperator(bf2, x_))
@test 1e-12 > D(X2 + Y2, manybodyoperator(bf2, x + y))

# Test one-body expect
x = randoperator(b_single)
y = randoperator(b_single)
X = manybodyoperator(b, x)
Y = manybodyoperator(b, y)

psi = randstate(b)

@test onebodyexpect(x, psi) ≈ expect(X, dm(psi))
@test onebodyexpect(x, Y) ≈ expect(X, Y)
@test onebodyexpect(sparse(x), psi) ≈ expect(X, dm(psi))
@test onebodyexpect(sparse(x), Y) ≈ expect(X, Y)
@test onebodyexpect(x, [psi, Y]) == [onebodyexpect(x, psi), onebodyexpect(x, Y)]

@test_throws ArgumentError manybodyoperator(b_mb, x)
@test_throws ArgumentError onebodyexpect(X, psi)
@test_throws ArgumentError onebodyexpect(X, dm(psi))

end # testset
end

import QuantumInterface: SpinBasis

"""
    sigmax([T=ComplexF64,] b::SpinBasis)

Angular momentum ``σ_x`` operator for the given `SpinBasis`. For
`SpinBasis(1//2)` this is the Pauli ``X`` operator while for higher spins this
is the Hermitian operator that gives the quantized angular momentum observable
along the ``x`` direction.

See [`paulix`](@ref) for the generalization of the qubit pauli operators to
qudits while preserving them being unitary instead of Hermitian.
"""
function sigmax(::Type{T}, b::SpinBasis) where T
    N = length(b)
    diag = T[complex(sqrt(real((b.spinnumber + 1)*2*a - a*(a+1)))) for a=1:N-1]
    data = spdiagm(1 => diag, -1 => diag)
    SparseOperator(b, data)
end
sigmax(b::SpinBasis) = sigmax(ComplexF64,b)

"""
    sigmay([T=ComplexF64,] b::SpinBasis)

Angular momentum ``σ_y`` operator for the given `SpinBasis`. For
`SpinBasis(1//2)` this is the Pauli ``Y`` operator while for higher spins this
is the Hermitian operator that gives the quantized angular momentum observable
along the ``y`` direction.

See [`pauliy`](@ref) for the generalization of the qubit pauli operators to
qudits while preserving them being unitary instead of Hermitian.
"""
function sigmay(::Type{T}, b::SpinBasis) where T
    N = length(b)
    diag = T[1im*complex(sqrt(real((b.spinnumber + 1)*2*a - a*(a+1)))) for a=1:N-1]
    data = spdiagm(-1 => diag, 1 => -diag)
    SparseOperator(b, data)
end
sigmay(b::SpinBasis) = sigmay(ComplexF64,b)

"""
    sigmaz([T=ComplexF64,] b::SpinBasis)

Angular momentum ``σ_z`` operator for the given `SpinBasis`. For
`SpinBasis(1//2)` this is the Pauli ``Z`` operator while for higher spins this
is the Hermitian operator that gives the quantized angular momentum observable
along the ``z`` direction.

See [`pauliz`](@ref) for the generalization of the qubit pauli operators to
qudits while preserving them being unitary instead of Hermitian.
"""
function sigmaz(::Type{T}, b::SpinBasis) where T
    N = length(b)
    diag = T[complex(2*m) for m=b.spinnumber:-1:-b.spinnumber]
    data = spdiagm(0 => diag)
    SparseOperator(b, data)
end
sigmaz(b::SpinBasis) = sigmaz(ComplexF64,b)

"""
    sigmap([T=ComplexF64,] b::SpinBasis)

Raising operator ``σ_+`` for the given Spin basis.
"""
function sigmap(::Type{T}, b::SpinBasis) where T
    N = length(b)
    S = (b.spinnumber + 1)*b.spinnumber
    diag = T[complex(sqrt(float(S - m*(m+1)))) for m=b.spinnumber-1:-1:-b.spinnumber]
    data = spdiagm(1 => diag)
    SparseOperator(b, data)
end
sigmap(b::SpinBasis) = sigmap(ComplexF64,b)

"""
    sigmam([T=ComplexF64,] b::SpinBasis)

Lowering operator ``σ_-`` for the given Spin basis.
"""
function sigmam(::Type{T}, b::SpinBasis) where T
    N = length(b)
    S = (b.spinnumber + 1)*b.spinnumber
    diag = T[complex(sqrt(float(S - m*(m-1)))) for m=b.spinnumber:-1:-b.spinnumber+1]
    data = spdiagm(-1 => diag)
    SparseOperator(b, data)
end
sigmam(b::SpinBasis) = sigmam(ComplexF64,b)


"""
    spinup([T=ComplexF64,] b::SpinBasis)

Spin up state for the given Spin basis.
"""
spinup(::Type{T}, b::SpinBasis) where T = basisstate(T, b, 1)
spinup(b::SpinBasis) = spinup(ComplexF64, b)

"""
    spindown([T=ComplexF64], b::SpinBasis)

Spin down state for the given Spin basis.
"""
spindown(::Type{T}, b::SpinBasis) where T = basisstate(T, b, b.shape[1])
spindown(b::SpinBasis) = spindown(ComplexF64, b)


"""
    squeeze([T=ComplexF64,] b::SpinBasis, z)

Squeezing operator ``S(z)=\\exp{\\left(\\frac{z^*\\hat{J_-}^2 - z\\hat{J}_+}{2 N}\\right)}`` for the 
specified Spin-``N/2`` basis with optional data type `T`, computed as the matrix exponential. Too
large squeezing (``|z| > \\sqrt{N}``) will create an oversqueezed state.
"""
function squeeze(::Type{T}, b::SpinBasis, z::Number) where T
    N = Int(length(b)-1)
    z = T(z)/2N
    Jm = sigmam(b)/2
    Jp = sigmap(b)/2
    exp(conj(z)*dense(Jm)^2 - z*dense(Jp)^2)
end
squeeze(b::SpinBasis, z::T) where {T <: Number} = squeeze(ComplexF64, b, z)

@testitem "test_operators_lazysum" begin
using Test
using QuantumOpticsBase
using LinearAlgebra, Random


@testset "operators-lazysum" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x1::StateVector, x2::StateVector) = norm(x2-x1)

b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(1)
b3b = GenericBasis(5)

b_l = b1a⊗b2a⊗b3a
b_r = b1b⊗b2b⊗b3b

# Test creation
@test_throws ArgumentError LazySum()
@test_throws ArgumentError LazySum([1., 2.], [randoperator(b_l)])
@test_throws QuantumOpticsBase.IncompatibleBases LazySum(randoperator(b_l, b_r), sparse(randoperator(b_l, b_l)))
@test_throws QuantumOpticsBase.IncompatibleBases LazySum(randoperator(b_l, b_r), sparse(randoperator(b_r, b_r)))

# Test copy
op1 = 2*LazySum(randoperator(b_l, b_r), sparse(randoperator(b_l, b_r)))
op2 = copy(op1)
@test op1 == op2
@test isequal(op1, op2)
@test !(op1 === op2)
op2.operators[1].data[1,1] = complex(10.)
@test op1.operators[1].data[1,1] != op2.operators[1].data[1,1]
op2.factors[1] = 3.
@test op2.factors[1] != op1.factors[1]

@test QuantumOpticsBase.coefficients(op2) == op2.factors
@test QuantumOpticsBase.suboperators(op2) == op2.operators

@test QuantumOpticsBase.is_const(op1)

# Test dense & sparse
op1 = randoperator(b_l, b_r)
op2 = sparse(randoperator(b_l, b_r))
@test 0.1*op1 == dense(LazySum([0.1], (op1,)))
@test 0.3*op2 == sparse(LazySum([0.3], (op2,)))
@test 0.1*sparse(op1) + 0.3*op2 == sparse(LazySum([0.1, 0.3], (op1, op2)))
@test 0.1*op1 + 0.3*dense(op2) == dense(LazySum([0.1, 0.3], (op1, op2)))
@test 0.1*sparse(op1) + 0.3*op2 == sparse(LazySum([0.1, 0.3], (op1, op2)))

# Test embed
for T in (Float32, Float64, ComplexF32, ComplexF64)
    x1 = randoperator(T, b1a,b1b)
    y1 = randoperator(T, b1a,b1b)
    xy1 = LazySum(T[1., 2.], (x1, y1))
    x = LazySum(T[1.], (embed(b_l, b_r, 1, x1),))
    y = LazySum(T[2.], (embed(b_l, b_r, 1, y1),))
    @test eltype(x) == T
    @test eltype(y) == T
    xy = x + y
    @test embed(b_l, b_r, [1], xy1) == xy
    @test eltype(xy) == T
end


# Arithmetic operations
# =====================
op1a = randoperator(b_l, b_r)
op1b = randoperator(b_l, b_r)
op2a = randoperator(b_l, b_r)
op2b = randoperator(b_l, b_r)
op3a = randoperator(b_l, b_r)
op1 = LazySum([0.1, 0.3], (op1a, sparse(op1b)))
op1_ = 0.1*op1a + 0.3*op1b
op2 = LazySum([0.7, 0.9], [sparse(op2a), op2b])
op2_ = 0.7*op2a + 0.9*op2b
op3 = LazySum(op3a)
op3_ = op3a

x1 = Ket(b_r, rand(ComplexF64, length(b_r)))
x2 = Ket(b_r, rand(ComplexF64, length(b_r)))
xbra1 = Bra(b_l, rand(ComplexF64, length(b_l)))

# Addition
@test_throws QuantumOpticsBase.IncompatibleBases op1 + dagger(op2)
@test 1e-14 > D(op1+op2, op1_+op2_)
@test 1e-14 > D(op1+op2_, op1_+op2_)
@test 1e-14 > D(op1_+op2, op1_+op2_)

# Subtraction
@test_throws QuantumOpticsBase.IncompatibleBases op1 - dagger(op2)
@test 1e-14 > D(op1 - op2, op1_ - op2_)
@test 1e-14 > D(op1 - op2_, op1_ - op2_)
@test 1e-14 > D(op1_ - op2, op1_ - op2_)
@test 1e-14 > D(op1 + (-op2), op1_ - op2_)
@test 1e-14 > D(op1 + (-1*op2), op1_ - op2_)

# Test multiplication
@test_throws QuantumOpticsBase.IncompatibleBases op1*op2
@test 1e-11 > D(dense(op1*op2'), op1_ * op2_')
@test LazySum([0.1, 0.1], (op1a, op2a)) == LazySum(op1a, op2a)*0.1
@test LazySum([0.1, 0.1], (op1a, op2a)) == 0.1*LazySum(op1a, op2a)
@test 1e-11 > D(op1*(x1 + 0.3*x2), op1_*(x1 + 0.3*x2))
@test 1e-11 > D(op1*x1 + 0.3*op1*x2, op1_*x1 + 0.3*op1_*x2)
@test 1e-11 > D((op1+op2)*(x1+0.3*x2), (op1_+op2_)*(x1+0.3*x2))
@test 1e-12 > D(dagger(x1)*dagger(0.3*op2), dagger(x1)*dagger(0.3*op2_))

## Test multiplication with LazySum that has no elements
@test LazySum(b_r, b_r) == LazySum(b_r, b_l) * LazySum(b_l, b_r)
@test iszero( LazySum(b_r, b_l) * op1a )
@test iszero( op1a * LazySum(b_r, b_l) )
@test iszero( LazySum(b_l, b_r) * x1 )
@test iszero( xbra1 * LazySum(b_l, b_r) )
@test_throws DimensionMismatch LazySum(FockBasis(2), NLevelBasis(2)) * randoperator(NLevelBasis(4), GenericBasis(2)) # save Basis with different size
@test_throws DimensionMismatch randoperator(GenericBasis(1), FockBasis(3)) * LazySum(FockBasis(1), NLevelBasis(2))
@test_throws DimensionMismatch LazySum(FockBasis(2), NLevelBasis(2)) * randstate(NLevelBasis(7))
@test_throws DimensionMismatch randstate(FockBasis(3))' * LazySum(FockBasis(1), NLevelBasis(2))

## multiplication with Operator of AbstractMatrix
LSop = LazySum(randoperator(b1a^2)) # AbstractOperator
LSop_s = LazySum(sparse(randoperator(b1a^2)))
hermitian_op = Operator(basis(LSop), Hermitian(randn(ComplexF64,length(basis(LSop)),length(basis(LSop))))) # Hermitian
symmetric_op = Operator(basis(LSop), Symmetric(randn(ComplexF64,length(basis(LSop)),length(basis(LSop))))) # Symmetric
adjoint_op = randoperator(basis(LSop))' # Adjoint
real_op = Operator(basis(LSop), real(adjoint_op.data)) # real
ops_tuple = (symmetric_op,hermitian_op,adjoint_op)
### Test
@test all(isapprox.(ops_tuple.*(LSop,) , dense.(ops_tuple).*(LSop,), atol=1e-13))
@test all(isapprox.((LSop,).*ops_tuple , (LSop,).*dense.(ops_tuple), atol=1e-13))
### test with sparse
@test all(isapprox.(sparse.(ops_tuple).*(LSop,) , dense.(ops_tuple).*(LSop,), atol=1e-13))
@test all(isapprox.((LSop,).*sparse.(ops_tuple) , (LSop,).*dense.(ops_tuple), atol=1e-13))
@test all(isapprox.(dense.(sparse.(ops_tuple).*(LSop_s,)) , dense.(ops_tuple).*(LSop_s,), atol=1e-13))
@test all(isapprox.(dense.((LSop_s,).*sparse.(ops_tuple)) , (LSop_s,).*dense.(ops_tuple), atol=1e-13))
### test real valued op with AbstractOperator
@test isapprox(LSop*real_op*LSop , LSop*Operator(basis(real_op), complex.(real_op.data))*LSop, atol=1e-13)

# Test division
@test 1e-14 > D(op1/7, op1_/7)

#Test Tensor
op1_tensor = op1a ⊗ op1
op2_tensor = op1 ⊗ op1a
op1_tensor_ = op1a ⊗ op1_
op2_tensor_ = op1_ ⊗ op1a
@test 1e-14 > D(op1_tensor,op1_tensor_)
@test 1e-14 > D(op1_tensor_,op1_tensor)

#Test addition of with and of LazyTensor and LazyProduct
subop1 = randoperator(b1a, b1b)
subop2 = randoperator(b2a, b2b)
subop3 = randoperator(b3a, b3b)
I1 = dense(identityoperator(b1a, b1b))
I2 = dense(identityoperator(b2a, b2b))
I3 = dense(identityoperator(b3a, b3b))
op1_LT = LazyTensor(b_l, b_r, [1, 3], (subop1, sparse(subop3)), 0.1)
op1_LT_ = 0.1*subop1 ⊗ I2 ⊗ subop3
op1_LP  = LazyProduct([op1a])*0.1
op1_LP_ = op1a*0.1
@test 1e-14 > D(op1_LT+op1_LP,op1_LT_+op1_LP_)
@test 1e-14 > D(op1_LT+op1,op1_LT_+op1_)
@test 1e-14 > D(op1_LP+op1,op1_LP_+op1_)

# Test tuples vs. vectors
@test (op1+op1).operators isa Tuple
@test (op1+op2).operators isa Vector
@test (op2+op1).operators isa Vector
@test (op2+op2).operators isa Vector

# Test identityoperator
Idense = identityoperator(DenseOpType, b_r)
id = identityoperator(LazySum, b_r)
@test isa(id, LazySum)
@test dense(id) == Idense
@test 1e-11 > D(id*x1, x1)

Idense = identityoperator(DenseOpType, b_l)
id = identityoperator(LazySum, b_l)
@test isa(id, LazySum)
@test dense(id) == Idense
@test 1e-11 > D(xbra1*id, xbra1)

# Test tr and normalize
op1 = randoperator(b_l)
op2 = randoperator(b_l)
op3 = randoperator(b_l)
op = LazySum([0.1, 0.3, 1.2], (op1, op2, op3))
op_ = 0.1*op1 + 0.3*op2 + 1.2*op3

@test tr(op_) ≈ tr(op)
op_normalized = normalize(op)
@test tr(op_) ≈ tr(op)
@test 1 ≈ tr(op_normalized)
op_copy = deepcopy(op)
normalize!(op_copy)
@test tr(op) != tr(op_copy)
@test 1 ≈ tr(op_copy)
@test op_copy === normalize!(op_copy)


# Test partial tr
op1 = randoperator(b_l)
op2 = randoperator(b_l)
op3 = randoperator(b_l)
op123 = LazySum([0.1, 0.3, 1.2], (op1, op2, op3))
op123_v = LazySum([0.1, 0.3, 1.2], [op1, op2, op3])
op123_ = 0.1*op1 + 0.3*op2 + 1.2*op3

@test 1e-14 > D(ptrace(op123_, 3), ptrace(op123, 3))
@test 1e-14 > D(ptrace(op123_, 2), ptrace(op123, 2))
@test 1e-14 > D(ptrace(op123_, 1), ptrace(op123, 1))

@test 1e-14 > D(ptrace(op123_, [2,3]), ptrace(op123, [2,3]))
@test 1e-14 > D(ptrace(op123_, [1,3]), ptrace(op123, [1,3]))
@test 1e-14 > D(ptrace(op123_, [1,2]), ptrace(op123, [1,2]))

@test 1e-14 > D(ptrace(op123_v, [1,2]), ptrace(op123, [1,2]))

@test_throws ArgumentError ptrace(op123, [1,2,3])

# Test expect
state = Ket(b_l, rand(ComplexF64, length(b_l)))
@test expect(op123, state) ≈ expect(op123_, state)

state = DenseOperator(b_l, b_l, rand(ComplexF64, length(b_l), length(b_l)))
@test expect(op123, state) ≈ expect(op123_, state)

# Permute systems
op1a = randoperator(b1a)
op2a = randoperator(b2a)
op3a = randoperator(b3a)
op1b = randoperator(b1a)
op2b = randoperator(b2a)
op3b = randoperator(b3a)
op1c = randoperator(b1a)
op2c = randoperator(b2a)
op3c = randoperator(b3a)
op123a = op1a⊗op2a⊗op3a
op123b = op1b⊗op2b⊗op3b
op123c = op1c⊗op2c⊗op3c
op = LazySum([0.3, 0.7, 1.2], [op123a, sparse(op123b), op123c])
op_ = 0.3*op123a + 0.7*op123b + 1.2*op123c

@test 1e-14 > D(permutesystems(op, [1, 3, 2]), permutesystems(op_, [1, 3, 2]))
@test 1e-14 > D(permutesystems(op, [2, 1, 3]), permutesystems(op_, [2, 1, 3]))
@test 1e-14 > D(permutesystems(op, [2, 3, 1]), permutesystems(op_, [2, 3, 1]))
@test 1e-14 > D(permutesystems(op, [3, 1, 2]), permutesystems(op_, [3, 1, 2]))
@test 1e-14 > D(permutesystems(op, [3, 2, 1]), permutesystems(op_, [3, 2, 1]))


# Test gemv
op1 = randoperator(b_l, b_r)
op2 = randoperator(b_l, b_r)
op3 = randoperator(b_l, b_r)
op = LazySum([0.1, 0.3, 1.2], (op1, op2, op3))
op_ = 0.1*op1 + 0.3*op2 + 1.2*op3

zero_op = LazySum(b_l, b_r)
zero_op_ = sparse(zero_op)
@test dense(zero_op) == zero_op_

state = Ket(b_r, rand(ComplexF64, length(b_r)))
result_ = Ket(b_l, rand(ComplexF64, length(b_l)))
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
@test 1e-13 > D(result, op_*state)

result = deepcopy(result_)
QuantumOpticsBase.mul!(result,zero_op,state,complex(1.),complex(0.))
@test 1e-13 > D(result, zero_op_*state)

result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,op,state,alpha,beta)
@test 1e-13 > D(result, alpha*op_*state + beta*result_)

result = deepcopy(result_)
QuantumOpticsBase.mul!(result,zero_op,state,alpha,beta)
@test 1e-13 > D(result, beta*result_)

state = Bra(b_l, rand(ComplexF64, length(b_l)))
result_ = Bra(b_r, rand(ComplexF64, length(b_r)))
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
@test 1e-13 > D(result, state*op_)

result = deepcopy(result_)
QuantumOpticsBase.mul!(result,state,zero_op,complex(1.),complex(0.))
@test 1e-13 > D(result, state*zero_op_)

result = deepcopy(result_)
alpha = complex(1.5)
beta = complex(2.1)
QuantumOpticsBase.mul!(result,state,op,alpha,beta)
@test 1e-13 > D(result, alpha*state*op_ + beta*result_)

# Test gemm
op1 = randoperator(b_l, b_r)
op2 = randoperator(b_l, b_r)
op3 = randoperator(b_l, b_r)
op = LazySum([0.1, 0.3, 1.2], (op1, op2, op3))
op_ = 0.1*op1 + 0.3*op2 + 1.2*op3

state = randoperator(b_r, b_r)
result_ = randoperator(b_l, b_r)
result = NaN * deepcopy(result_)  # with beta=0, NaNs should be killed
QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
@test 1e-12 > D(result, op_*state)

result = deepcopy(result_)
QuantumOpticsBase.mul!(result,zero_op,state,complex(1.),complex(0.))
@test 1e-12 > D(result, zero_op_*state)

alpha = complex(1.5)
beta = complex(2.1)
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,op,state,alpha,beta)
@test 1e-12 > D(result, alpha*op_*state + beta*result_)

result = deepcopy(result_)
QuantumOpticsBase.mul!(result,zero_op,state,alpha,beta)
@test 1e-12 > D(result, beta*result_)

state = randoperator(b_l, b_l)
result_ = randoperator(b_l, b_r)
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
@test 1e-12 > D(result, state*op_)

result = NaN * deepcopy(result_)  # with beta=0, NaNs should be killed
QuantumOpticsBase.mul!(result,state,zero_op,complex(1.),complex(0.))
@test 1e-12 > D(result, state*zero_op_)

alpha = complex(1.5)
beta = complex(2.1)
result = deepcopy(result_)
QuantumOpticsBase.mul!(result,state,op,alpha,beta)
@test 1e-12 > D(result, alpha*state*op_ + beta*result_)

result = deepcopy(result_)
QuantumOpticsBase.mul!(result,state,zero_op,alpha,beta)
@test 1e-12 > D(result, beta*result_)

end # testset
end

@testitem "test_subspace" begin
using Test
using QuantumOpticsBase

@testset "subspace" begin

b = FockBasis(3)

u = Ket[fockstate(b, 1), fockstate(b, 2)]
v = Ket[fockstate(b, 2), fockstate(b, 1)]
w = Ket[Ket(b, [1 + 1im, 1 - 0.5im, 0, 0] / norm([1 + 1im, 1 - 0.5im, 0, 0]))]

bu = SubspaceBasis(u)
bv = SubspaceBasis(v)
bw = SubspaceBasis(w)

T1 = projector(bu, b)
T2 = projector(bv, b)
T12 = projector(bu, bv)
Tw = projector(bw, b)

state = fockstate(b, 2)
state_1 = Ket(b, [1 + 1im, 1 - 0.5im, 0, 0] / norm([1 + 1im, 1 - 0.5im, 0, 0]))
state_u = Ket(bu, [0, 1])
state_v = Ket(bv, [1., 0])
state_w = Ket(bw, [1.0])
@test Tw * state_1 ≈ state_w

@test T1*state == state_u
@test T2*state == state_v


state_v = Ket(bv, [1, -1])
state_u = Ket(bu, [-1, 1])

@test T12*state_v == state_u

u2 = Ket[1.5*fockstate(b, 1), fockstate(b, 1) + fockstate(b, 2)]
bu2_orth = QuantumOpticsBase.orthonormalize(SubspaceBasis(u))
@test bu2_orth.basisstates == bu.basisstates

# Test sparse version
T1 = sparseprojector(bu, b)
T2 = sparseprojector(bv, b)
T12 = sparseprojector(bu, bv)

@test isa(T1, SparseOpType)

state_u = Ket(bu, [0, 1])
state_v = Ket(bv, [1., 0])

@test T1*state == state_u
@test T2*state == state_v

state_v = Ket(bv, [1, -1])
state_u = Ket(bu, [-1, 1])

@test T12*state_v == state_u

# Test errors
b2 = FockBasis(4)
@test_throws ArgumentError SubspaceBasis(b2, u)
@test_throws ArgumentError projector(bu, b2)
@test_throws ArgumentError projector(b2, bu)
b2_sub = SubspaceBasis(b2, [fockstate(b2, 1)])
@test_throws ArgumentError projector(bu, b2_sub)

end # testset
end

function test_adapt_methods(AT, synchronize)
    """Test new Adapt methods for all quantum optics types."""
    cache = AllocCache()
    
    for n in test_sizes
        for r in 1:round_count
            @cached cache begin
                
                @testset "Adapt Methods - Size $n" begin
                    # Create test bases
                    b1 = GenericBasis(n)
                    b2 = GenericBasis(n)
                    cb = b1 ⊗ b2
                    
                    # Test Ket adaptation 
                    ket_data = rand(ComplexF64, n)
                    normalize!(ket_data)
                    cpu_ket = Ket(b1, ket_data)
                    gpu_ket = Adapt.adapt(AT, cpu_ket)
                    
                    @test typeof(gpu_ket.data) <: AT
                    @test gpu_ket.basis == cpu_ket.basis
                    @test verify_gpu_result(cpu_ket, gpu_ket)
                    
                    # Test Bra adaptation
                    bra_data = rand(ComplexF64, n)  
                    normalize!(bra_data)
                    cpu_bra = Bra(b1, bra_data)
                    gpu_bra = Adapt.adapt(AT, cpu_bra)
                    
                    @test typeof(gpu_bra.data) <: AT
                    @test gpu_bra.basis == cpu_bra.basis
                    @test verify_gpu_result(cpu_bra, gpu_bra)
                    
                    # Test SuperOperator adaptation
                    super_data = rand(ComplexF64, n*n, n*n)
                    cpu_super = SuperOperator([b1,b1], [b1,b1], super_data)
                    gpu_super = Adapt.adapt(AT, cpu_super)
                    
                    @test typeof(gpu_super.data) <: AT
                    @test gpu_super.basis_l == cpu_super.basis_l
                    @test gpu_super.basis_r == cpu_super.basis_r
                    @test verify_gpu_result(cpu_super, gpu_super)
                    
                    # Test LazyKet adaptation 
                    ket1 = Ket(b1, rand(ComplexF64, n))
                    ket2 = Ket(b2, rand(ComplexF64, n))
                    cpu_lazy_ket = LazyKet(cb, (ket1, ket2))
                    gpu_lazy_ket = Adapt.adapt(AT, cpu_lazy_ket)
                    
                    @test typeof(gpu_lazy_ket.kets[1].data) <: AT
                    @test typeof(gpu_lazy_ket.kets[2].data) <: AT
                    @test gpu_lazy_ket.basis == cpu_lazy_ket.basis
                    
                    # Test LazySum adaptation
                    op1 = Operator(b1, b1, rand(ComplexF64, n, n))
                    op2 = Operator(b1, b1, rand(ComplexF64, n, n))
                    cpu_lazy_sum = LazySum([1.0, 2.0], [op1, op2])
                    gpu_lazy_sum = Adapt.adapt(AT, cpu_lazy_sum)
                    
                    @test typeof(gpu_lazy_sum.operators[1].data) <: AT
                    @test typeof(gpu_lazy_sum.operators[2].data) <: AT
                    @test gpu_lazy_sum.basis_l == cpu_lazy_sum.basis_l
                    @test gpu_lazy_sum.basis_r == cpu_lazy_sum.basis_r
                    @test gpu_lazy_sum.factors == cpu_lazy_sum.factors
                    
                    # Test LazyProduct adaptation
                    cpu_lazy_prod = LazyProduct([op1, op2])
                    gpu_lazy_prod = Adapt.adapt(AT, cpu_lazy_prod)
                    
                    @test typeof(gpu_lazy_prod.operators[1].data) <: AT
                    @test typeof(gpu_lazy_prod.operators[2].data) <: AT
                    @test gpu_lazy_prod.basis_l == cpu_lazy_prod.basis_l
                    @test gpu_lazy_prod.basis_r == cpu_lazy_prod.basis_r
                    
                    # Test LazyTensor adaptation (for composite systems)
                    if n >= 2
                        indices = [1]
                        sub_op = Operator(b1, b1, rand(ComplexF64, n, n))
                        cpu_lazy_tensor = LazyTensor(cb, cb, indices, (sub_op,))
                        gpu_lazy_tensor = Adapt.adapt(AT, cpu_lazy_tensor)
                        
                        @test typeof(gpu_lazy_tensor.operators[1].data) <: AT
                        @test gpu_lazy_tensor.basis_l == cpu_lazy_tensor.basis_l
                        @test gpu_lazy_tensor.basis_r == cpu_lazy_tensor.basis_r
                        @test gpu_lazy_tensor.indices == cpu_lazy_tensor.indices
                    end
                    
                    # Test LazyDirectSum adaptation 
                    op_ds1 = Operator(b1, b1, rand(ComplexF64, n, n))
                    op_ds2 = Operator(b2, b2, rand(ComplexF64, n, n)) 
                    cpu_lazy_ds = LazyDirectSum(op_ds1, op_ds2)
                    gpu_lazy_ds = Adapt.adapt(AT, cpu_lazy_ds)
                    
                    @test typeof(gpu_lazy_ds.operators[1].data) <: AT
                    @test typeof(gpu_lazy_ds.operators[2].data) <: AT
                    @test gpu_lazy_ds.basis_l == cpu_lazy_ds.basis_l
                    @test gpu_lazy_ds.basis_r == cpu_lazy_ds.basis_r
                    
                    synchronize()
                end
                
            end
        end
    end
end

import Base: size, *, +, -, /, ==, isequal, adjoint, convert

"""
    AbstractTimeDependentOperator{BL,BR} <: AbstractOperator{BL,BR}

Abstract type providing a time-dependent operator interface. Time-dependent
operators have internal "clocks" that can be addressed with [`set_time!`](@ref)
and [`current_time`](@ref). A shorthand `op(t)`, equivalent to
`set_time!(copy(op), t)`, is available for brevity.

A time-dependent operator is always concrete-valued according to the current
time of its internal clock.
"""
abstract type AbstractTimeDependentOperator{BL,BR} <: AbstractOperator{BL,BR} end

"""
    current_time(op::AbstractOperator)

Returns the current time of the operator `op`. If `op` is not time-dependent,
this throws an `ArgumentError`.
"""
current_time(::T) where {T<:AbstractOperator} = 
  throw(ArgumentError("Time not defined for operators of type $T. Consider using a TimeDependentSum or another time-dependence wrapper."))

"""
    static_operator(op::AbstractOperator)

Returns a static (not time dependent) representation of `op` the current time.
This strips the time-dependence and can be used to obtain a non-lazy matrix
representation of the operator.

For example: `sparse(static_operator(op(t))` return a sparse-matrix representation
of `op` at time `t`.
"""
static_operator(o::AbstractOperator) = o

"""
    set_time!(o::AbstractOperator, t::Number)

Sets the clock of an operator (see [`AbstractTimeDependentOperator`](@ref)).
If `o` contains other operators (e.g. in case `o` is a `LazyOperator`),
recursively calls `set_time!` on those.

This does nothing in case `o` is not time-dependent.
"""
set_time!(o::AbstractOperator, ::Number) = o
set_time!(o::LazyOperator, t::Number) = (set_time!.(o.operators, t); return o)

(o::AbstractTimeDependentOperator)(t::Number) = set_time!(copy(o), t)

function _check_same_time(A::AbstractTimeDependentOperator, B::AbstractTimeDependentOperator)
    tA = current_time(A)
    tB = current_time(B)
    tA == tB || throw(ArgumentError(
        "Time-dependent operators with different times ($tA and $tB) cannot be combined. Consider setting their clocks to a common time with `set_time!`."))
end

is_const(op::AbstractTimeDependentOperator) = false
is_const(op::AbstractOperator) = true
is_const(op::LazySum) = all(is_const(o) for o in op.operators)
is_const(op::LazyTensor) = all(is_const(o) for o in op.operators)
is_const(op::LazyProduct) = all(is_const(o) for o in op.operators)
is_const(c::Number) = true
is_const(c::Function) = false

for func in (:basis, :length, :size, :tr, :normalize, :normalize!,
    :identityoperator, :one, :eltype)
    @eval $func(op::AbstractTimeDependentOperator) = $func(static_operator(op))
end

for func in (:ptrace,)
    @eval $func(op::AbstractTimeDependentOperator, arg) = $func(static_operator(op), arg)
end

for func in (:expect, :variance)
    @eval $func(op::AbstractTimeDependentOperator{B,B}, x::Ket{B}) where B = $func(static_operator(op), x)
    @eval $func(op::AbstractTimeDependentOperator{B,B}, x::AbstractOperator{B,B}) where B = $func(static_operator(op), x)
    @eval $func(index::Integer, op::AbstractTimeDependentOperator{B1,B2}, x::AbstractOperator{B3,B3}) where {B1,B2,B3<:CompositeBasis} = $func(index, static_operator(op), x)
    @eval $func(indices, op::AbstractTimeDependentOperator{B1,B2}, x::AbstractOperator{B3,B3}) where {B1,B2,B3<:CompositeBasis} = $func(indices, static_operator(op), x)
end

# TODO: Consider using promotion to define arithmetic between operator types
#promote_rule(::Type{T}, ::Type{S}) where {T<:AbstractTimeDependentOperator,S<:AbstractOperator} = T
#convert(::Type{T}, O::AbstractOperator) where {T<:AbstractTimeDependentOperator} = T(O)

const VecOrTuple = Union{Tuple,AbstractVector}

"""
    TimeDependentSum(lazysum, coeffs, init_time)
    TimeDependentSum(::Type{Tf}, basis_l, basis_r; init_time=0.0)
    TimeDependentSum([::Type{Tf},] [basis_l,] [basis_r,] coeffs, operators; init_time=0.0)
    TimeDependentSum([::Type{Tf},] coeff1=>op1, coeff2=>op2, ...; init_time=0.0)
    TimeDependentSum(::Tuple, op::TimeDependentSum)

Lazy sum of operators with time-dependent coefficients. Wraps a
[`LazySum`](@ref) `lazysum`, adding a `current_time` (or operator "clock") and a
means of specifying time coefficients as functions of time (or numbers).

The coefficient type `Tf` may be specified explicitly.
Time-dependent coefficients will be converted to this type on evaluation.
"""
mutable struct TimeDependentSum{BL<:Basis,BR<:Basis,C<:VecOrTuple,O<:LazySum,T<:Number} <: AbstractTimeDependentOperator{BL,BR}
    basis_l::BL
    basis_r::BR
    coefficients::C
    static_op::O
    current_time::T
    function TimeDependentSum(coeffs::C, lazysum::O, init_time::T) where {C<:VecOrTuple,O<:LazySum,T<:Number}
        length(coeffs) == length(lazysum.operators) || throw(ArgumentError("Number of coefficients does not match number of operators."))
        bl = lazysum.basis_l
        br = lazysum.basis_r
        update_static_coefficients!(lazysum, coeffs, init_time)
        set_time!(lazysum, init_time)
        new{typeof(bl), typeof(br), C, O, T}(bl, br, coeffs, lazysum, init_time)
    end
end
TimeDependentSum(coeffs::C, lazysum::O; init_time::T=0.0) where {C<:VecOrTuple,O<:LazySum,T<:Number} = TimeDependentSum(coeffs, lazysum, init_time)

function TimeDependentSum(::Type{Tf}, basis_l::Basis, basis_r::Basis; init_time::T=0.0) where {Tf<:Number,T<:Number}
    TimeDependentSum(Tf[], LazySum(Tf, basis_l, basis_r), init_time)
end

function TimeDependentSum(::Type{Tf}, basis_l::Basis, basis_r::Basis, coeffs::C, operators::O; init_time::T=0.0) where {Tf<:Number,C<:VecOrTuple,O<:VecOrTuple,T<:Number}
    coeff_vec = ones(Tf, length(coeffs))
    ls = LazySum(basis_l, basis_r, coeff_vec, operators)
    TimeDependentSum(coeffs, ls, init_time)
end

function TimeDependentSum(::Type{Tf}, coeffs::C, operators::O; init_time::T=0.0) where {Tf<:Number,C<:VecOrTuple,O<:VecOrTuple,T<:Number}
    TimeDependentSum(Tf, operators[1].basis_l, operators[1].basis_r, coeffs, operators; init_time)
end

function TimeDependentSum(coeffs::C, operators::O; init_time::T=0.0)  where {C<:VecOrTuple,O<:VecOrTuple,T<:Number}
    Tf = mapreduce(typeof, promote_type, eval_coefficients(coeffs, init_time))
    TimeDependentSum(Tf, coeffs, operators; init_time)
end

function TimeDependentSum(::Type{Tf}, args::Vararg{Pair}; init_time::T=0.0) where {Tf<:Number,T<:Number}
    cs, ops = zip(args...)
    TimeDependentSum(Tf, [cs...], [ops...]; init_time)
end

function TimeDependentSum(args::Vararg{Pair}; init_time::T=0.0) where {T<:Number}
    cs, _ = zip(args...)
    Tf = mapreduce(typeof, promote_type, eval_coefficients(cs, init_time))
    TimeDependentSum(Tf, args...; init_time)
end

TimeDependentSum(op::LazySum; init_time::Number=0.0) = TimeDependentSum(op.factors, op, init_time)
TimeDependentSum(op::AbstractOperator; init_time::Number=0.0) = TimeDependentSum(LazySum(op); init_time)
TimeDependentSum(coefficient, op::AbstractOperator; init_time::Number=0.0) = TimeDependentSum([coefficient], [op]; init_time)
TimeDependentSum(op::TimeDependentSum) = op
TimeDependentSum(::Type{Tuple}, op::TimeDependentSum) = TimeDependentSum((coefficients(op)...,), LazySum(Tuple, static_operator(op)), current_time(op))

static_operator(o::TimeDependentSum) = o.static_op
coefficients(o::TimeDependentSum) = o.coefficients
current_time(o::TimeDependentSum) = o.current_time
suboperators(o::TimeDependentSum) = static_operator(o).operators
eval_coefficients(o::TimeDependentSum, t::Number) = eval_coefficients(coefficient_type(o), coefficients(o), t)

function set_time!(o::TimeDependentSum, t::Number)
    if o.current_time != t
        o.current_time = t
        update_static_coefficients!(static_operator(o), coefficients(o), t)
    end
    # foreach is type-stable for tuples and concrete-typed vectors
    foreach(o -> set_time!(o, t), suboperators(o))
    o
end

is_const(op::TimeDependentSum) = all(is_const(c) for c in op.coefficients) && all(is_const(o) for o in suboperators(op))

coefficient_type(o::TimeDependentSum) = coefficient_type(static_operator(o))
coefficient_type(o::LazySum) = eltype(o.factors)

_coeff_copy(c) = copy(c)
_coeff_copy(c::Function) = c
_coeff_copy(t::Tuple) = _coeff_copy.(t)
Base.copy(op::TimeDependentSum) = TimeDependentSum(_coeff_copy(op.coefficients), copy(op.static_op); init_time=current_time(op))

function ==(A::TimeDependentSum, B::TimeDependentSum)
    A.current_time == B.current_time && A.coefficients == B.coefficients && A.static_op == B.static_op
end

function isequal(A::TimeDependentSum, B::TimeDependentSum)
    isequal(A.current_time, B.current_time) && isequal(A.coefficients, B.coefficients) && isequal(A.static_op, B.static_op)
end

_lazysum_op_map(f, op::LazySum) = LazySum(eltype(op.factors), op.basis_l, op.basis_r, copy.(op.factors), map(f, op.operators))

dense(op::TimeDependentSum) = TimeDependentSum(coefficients(op), _lazysum_op_map(dense, static_operator(op)), current_time(op))
sparse(op::TimeDependentSum) = TimeDependentSum(coefficients(op), _lazysum_op_map(sparse, static_operator(op)), current_time(op))

_conj_coeff(c) = conj(c)
_conj_coeff(c::Function) = conj ∘ c
function dagger(op::TimeDependentSum)
    TimeDependentSum(
        _conj_coeff.(coefficients(op)),
        dagger(static_operator(op)),
        current_time(op))
end
adjoint(op::TimeDependentSum) = dagger(op)

function embed(basis_l::CompositeBasis, basis_r::CompositeBasis, i::Integer, o::TimeDependentSum)
    TimeDependentSum(coefficients(o), embed(basis_l, basis_r, i, static_operator(o)), o.current_time)
end

function embed(basis_l::CompositeBasis, basis_r::CompositeBasis, indices, o::TimeDependentSum)
    TimeDependentSum(coefficients(o), embed(basis_l, basis_r, indices, static_operator(o)), o.current_time)
end

function +(A::TimeDependentSum, B::TimeDependentSum)
    _check_same_time(A, B)
    TimeDependentSum(
        _lazysum_cat(coefficients(A), coefficients(B)),
        static_operator(A) + static_operator(B),
        current_time(A))
end
+(A::AbstractOperator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) + B
+(A::TimeDependentSum, B::AbstractOperator) = A + TimeDependentSum(B; init_time=current_time(A))
+(A::LazyOperator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) + B
+(A::TimeDependentSum, B::LazyOperator) = A + TimeDependentSum(B; init_time=current_time(A))
+(A::Operator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) + B
+(A::TimeDependentSum, B::Operator) = A + TimeDependentSum(B; init_time=current_time(A))

_unary_minus(c::Function) = Base.:- ∘ c
_unary_minus(c) = -c
function -(o::TimeDependentSum)
    TimeDependentSum(_unary_minus.(coefficients(o)), -static_operator(o), current_time(o))
end

function -(A::TimeDependentSum, B::TimeDependentSum)
    _check_same_time(A, B)
    TimeDependentSum(
        _lazysum_cat(coefficients(A), _unary_minus.(coefficients(B))),
        static_operator(A) - static_operator(B),
        current_time(A))
end
-(A::AbstractOperator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) - B
-(A::TimeDependentSum, B::AbstractOperator) = A - TimeDependentSum(B; init_time=current_time(A))
-(A::LazyOperator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) - B
-(A::TimeDependentSum, B::LazyOperator) = A - TimeDependentSum(B; init_time=current_time(A))
-(A::Operator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) - B
-(A::TimeDependentSum, B::Operator) = A - TimeDependentSum(B; init_time=current_time(A))

_mul_coeffs(a, b) = a*b
_mul_coeffs(a, b::Function) = (@inline multiplied_coeffs_fn(t)=a*b(t))
_mul_coeffs(a::Function, b) = _mul_coeffs(b, a)
_mul_coeffs(a::Function, b::Function) = (@inline multiplied_coeffs_ff(t)=a(t)*b(t))
function *(A::TimeDependentSum, B::TimeDependentSum)
    _check_same_time(A, B)
    coeffs = _lazysum_cartprod(_mul_coeffs, coefficients(A), coefficients(B))
    TimeDependentSum(coeffs, static_operator(A) * static_operator(B), current_time(A))
end
*(A::AbstractOperator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) * B
*(A::TimeDependentSum, B::AbstractOperator) = A * TimeDependentSum(B; init_time=current_time(A))
*(A::LazyOperator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) * B
*(A::TimeDependentSum, B::LazyOperator) = A * TimeDependentSum(B; init_time=current_time(A))
*(A::Operator, B::TimeDependentSum) = TimeDependentSum(A; init_time=current_time(B)) * B
*(A::TimeDependentSum, B::Operator) = A * TimeDependentSum(B; init_time=current_time(A))

function *(A::TimeDependentSum, B::Number)
    TimeDependentSum(_mul_coeffs.(coefficients(A), B), static_operator(A) * B, current_time(A))
end
*(A::Number, B::TimeDependentSum) = B*A

_div_coeffs(a, b) = a/b
_div_coeffs(a::Function, b) = _mul_coeffs(a, 1/b)
function /(A::TimeDependentSum, B::Number)
    TimeDependentSum(_div_coeffs.(coefficients(A), B), static_operator(A) / B, current_time(A))
end

mul!(out::Operator{B1,B3}, a::TimeDependentSum{B1,B2}, b::Operator{B2,B3}, alpha, beta) where {B1,B2,B3} = mul!(out, static_operator(a), b, alpha, beta)
mul!(out::Ket{B1}, a::TimeDependentSum{B1,B2}, b::Ket{B2}, alpha, beta) where {B1,B2} = mul!(out, static_operator(a), b, alpha, beta)
mul!(out::Operator{B1,B3}, a::Operator{B1,B2}, b::TimeDependentSum{B2,B3}, alpha, beta) where {B1,B2,B3} = mul!(out, a, static_operator(b), alpha, beta)
mul!(out::Bra{B2}, a::Bra{B1}, b::TimeDependentSum{B1,B2}, alpha, beta) where {B1,B2} = mul!(out, a, static_operator(b), alpha, beta)

function update_static_coefficients!(o::LazySum, coeffs, t)
    o.factors .= eval_coefficients(eltype(o.factors), coeffs, t)
    return
end

function update_static_coefficients!(o::LazySum, coeffs::Vector, t)
    T = eltype(o.factors)
    for (k, coeff) in enumerate(coeffs)
        o.factors[k] = T(eval_coefficient(coeff, t))
    end
    return
end

@inline eval_coefficient(c, t::Number) = c(t)
@inline eval_coefficient(c::Number, ::Number) = c
@inline eval_coefficients(coeffs::AbstractVector, t::Number) = [eval_coefficient(c, t) for c in coeffs]
@inline eval_coefficients(::Type{T}, coeffs::AbstractVector, t::Number) where T = T[T(eval_coefficient(c, t)) for c in coeffs]

@inline eval_coefficients(coeffs::Tuple, t::Number) = map(c->eval_coefficient(c, t), coeffs)

# This is the performance-critical implementation. map(f, ::Tuple) avoids allocs in most cases
@inline eval_coefficients(::Type{T}, coeffs::Tuple, t::Number) where T = map(c->T(eval_coefficient(c, t)), coeffs)

# Now just using map here instead. Maybe restore this in case of regressions.
## To avoid allocations in most cases, we model this on map(f, t::Tuple).
#@inline eval_coefficients(::Type{T}, coeffs::Tuple{Any,}, t::Number) where T          = (T(eval_coefficient(coeffs[1], t)),)
#@inline eval_coefficients(::Type{T}, coeffs::Tuple{Any, Any}, t::Number) where T      = (T(eval_coefficient(coeffs[1], t)), T(eval_coefficient(coeffs[2], t)))
#@inline eval_coefficients(::Type{T}, coeffs::Tuple{Any, Any, Any}, t::Number) where T = (T(eval_coefficient(coeffs[1], t)), T(eval_coefficient(coeffs[2], t)), T(eval_coefficient(coeffs[3], t)))
#@inline eval_coefficients(::Type{T}, coeffs::Tuple, t::Number) where T                = (T(eval_coefficient(coeffs[1], t)), eval_coefficients(T, Base.tail(coeffs), t)...)

_timeshift_coeff(coeff, t0) = (@inline shifted_coeff(t) = coeff(t-t0))
_timeshift_coeff(coeff::Number, _) = coeff

"""
    time_shift(op::TimeDependentSum, t0)

Shift (translate) a [`TimeDependentSum`](@ref) `op` forward in time (delaying its
action) by `t0` units, so that the coefficient functions of time `f(t)` become
`f(t-t0)`. Return a new [`TimeDependentSum`](@ref).
"""
function time_shift(op::TimeDependentSum, t0)
    iszero(t0) && return op
    TimeDependentSum(_timeshift_coeff.(coefficients(op), t0), copy(static_operator(op)), current_time(op))
end

_timestretch_coeff(coeff, Sfactor) = (@inline stretched_coeff(t) = coeff(t/Sfactor)) 
_timestretch_coeff(coeff::Number, _) = coeff

"""
    time_stretch(op::TimeDependentSum, Sfactor)
Stretch (in time) a [`TimeDependentSum`](@ref) `op` by a factor of `Sfactor` (making it 'longer'),
so that the coefficient functions of time `f(t)` become `f(t/Sfactor)`. Return a new [`TimeDependentSum`](@ref).
"""
function time_stretch(op::TimeDependentSum, Sfactor)
    isone(Sfactor) && return op
    TimeDependentSum(_timestretch_coeff.(coefficients(op), Sfactor), copy(static_operator(op)), current_time(op))
end

_restrict_coeff(c::Number, t_from, t_to) = (@inline restricted_coeff_n(t) = ifelse(t_from <= t < t_to, c, zero(c)))
_restrict_coeff(c, t_from, t_to) = (@inline restricted_coeff_f(t) = ifelse(t_from <= t < t_to, c(t), zero(c(t_from))))

"""
    time_restrict(op::TimeDependentSum, t_from, t_to)
    time_restrict(op::TimeDependentSum, t_to)

Restrict a [`TimeDependentSum`](@ref) `op` to the time window `t_from <= t < t_to`,
forcing it to be exactly zero outside that range of times. If `t_from` is not
provided, it is assumed to be zero.
Return a new [`TimeDependentSum`](@ref).
"""
function time_restrict(op::TimeDependentSum, t_from, t_to)
    TimeDependentSum(_restrict_coeff.(coefficients(op), t_from, t_to), copy(static_operator(op)), current_time(op))
end
time_restrict(op::TimeDependentSum, t_duration) = time_restrict(op, zero(t_duration), t_duration)

@testitem "test_nlevel" begin
using Test
using QuantumOpticsBase
using LinearAlgebra

@testset "nlevel" begin

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))

N = 3
b = NLevelBasis(N)

# Test basis equality
@test b == NLevelBasis(N)
@test b != NLevelBasis(N+1)
@test_throws ArgumentError NLevelBasis(0)

# Test transition operator
@test_throws BoundsError transition(b, 0, 1)
@test_throws BoundsError transition(b, N+1, 1)
@test_throws BoundsError transition(b, 1, 0)
@test_throws BoundsError transition(b, 1, N+1)
@test dense(transition(b, 2, 1)) == basisstate(b, 2) ⊗ dagger(basisstate(b, 1))

# Test nlevel states
@test_throws BoundsError nlevelstate(b, 0)
@test_throws BoundsError nlevelstate(b, N+1)
@test norm(nlevelstate(b, 1)) == 1.
@test norm(dagger(nlevelstate(b, 1))*nlevelstate(b, 2)) == 0.
@test norm(dagger(nlevelstate(b, 1))*transition(b, 1, 2)*nlevelstate(b, 2)) == 1.

for N=[2, 3, 4, 5]
    b = NLevelBasis(N)
    I = identityoperator(b)
    Zero = SparseOperator(b)
    px = paulix(b)
    pz = pauliz(b)

    @test 1e-14 > abs(tr(px))
    @test 1e-14 > abs(tr(pz))
    @test 1e-14 > D(px^N, I)
    @test 1e-14 > D(pz^N, I)
    for m=2:N
        @test 1e-14 > D(px^m, paulix(b,m))
        @test 1e-14 > D(pz^m, pauliz(b,m))
    end

    for m=1:N,n=1:N
        @test 1e-14 > D(px^m * pz^n, exp(2π*1im*m*n/N) * pz^n * px^m)
    end
end


# Test special relations for qubit pauli
b = NLevelBasis(2)
I = identityoperator(b)
Zero = SparseOperator(b)
px = paulix(b)
py = pauliy(b)
pz = pauliz(b)

antikommutator(x, y) = x*y + y*x

@test 1e-14 > D(antikommutator(px, px), 2*I)
@test 1e-14 > D(antikommutator(px, py), Zero)
@test 1e-14 > D(antikommutator(px, pz), Zero)
@test 1e-14 > D(antikommutator(py, px), Zero)
@test 1e-14 > D(antikommutator(py, py), 2*I)
@test 1e-14 > D(antikommutator(py, pz), Zero)
@test 1e-14 > D(antikommutator(pz, px), Zero)
@test 1e-14 > D(antikommutator(pz, py), Zero)
@test 1e-14 > D(antikommutator(pz, pz), 2*I)

# Test if involutory for spin 1/2
@test 1e-14 > D(px*px, I)
@test 1e-14 > D(py*py, I)
@test 1e-14 > D(pz*pz, I)
@test 1e-14 > D(-1im*px*py*pz, I)

end # testset
end

@testitem "Bloch Sphere Plotting" tags=[:plotting] begin
    using QuantumOpticsBase
    using CairoMakie   

    b = SpinBasis(1//2)

    # ── Return types ──────────────────────────────────────────────────────────
    @testset "blochsphereplot_axis returns Figure, Axis3, and plot object" begin
        fig, ax, plt = blochsphereplot_axis(spinup(b))
        @test fig isa Figure
        @test ax  isa Axis3
        @test plt isa AbstractPlot
    end

    # ── Render test ───────────────────────────────────────────────────────────
    @testset "arbitrary state renders without error" begin
        ψ = cos(π/6)*spinup(b) + exp(im*π/4)*sin(π/6)*spindown(b)
        fig, _, _ = blochsphereplot_axis(ψ)
        save("test_bloch.png", fig)
        @test isfile("test_bloch.png")
        rm("test_bloch.png")
    end

    # ── Render tests: custom attributes ──────────────────────────────────────
    @testset "Custom arrowcolor and spherealpha" begin
        fig, _, _ = blochsphereplot_axis(spinup(b); arrowcolor=:blue, spherealpha=0.3)
        save("test_bloch_custom_color.png", fig)
        @test isfile("test_bloch_custom_color.png")
        rm("test_bloch_custom_color.png")
    end

    @testset "Custom spherecolor" begin
        fig, _, _ = blochsphereplot_axis(spindown(b); spherecolor=:pink, spherealpha=0.2)
        save("test_bloch_custom_sphere.png", fig)
        @test isfile("test_bloch_custom_sphere.png")
        rm("test_bloch_custom_sphere.png")
    end

    @testset "Wireframe, labels and axes toggled off" begin
        fig, _, _ = blochsphereplot_axis(spinup(b); showwireframe=false, showlabels=false, showaxes=false)
        save("test_bloch_minimal.png", fig)
        @test isfile("test_bloch_minimal.png")
        rm("test_bloch_minimal.png")
    end

    # ── Error handling ────────────────────────────────────────────────────────
    @testset "Wrong dimension state throws error" begin
        b3  = SpinBasis(1)
        ψ_3 = basisstate(b3, 1)
        @test_throws ErrorException blochsphereplot_axis(ψ_3)
    end

    # ── Observable reactivity ─────────────────────────────────────────────────
    @testset "Observable state updates reactively" begin
        using Makie: Observable
        state_obs = Observable(spinup(b))
        fig, ax, _ = blochsphereplot_axis(state_obs)
        state_obs[] = spindown(b)
        save("test_bloch_observable.png", fig)
        @test isfile("test_bloch_observable.png")
        rm("test_bloch_observable.png")
    end
end

import Base: show, summary

"""
    QuantumOptics.set_printing(; standard_order, rounding_tol)

Set options for REPL output.

# Arguments
* `standard_order=false`: For performance reasons, the order of the tensor
    product is inverted, i.e. `tensor(a, b)=kron(b, a)`. When changing this
    to `true`, the output shown in the REPL will exhibit the correct order.
* `rounding_tol=1e-17`: Tolerance for floating point errors shown in the output.
"""
function set_printing(; standard_order::Bool=_std_order, rounding_tol::Real=_round_tol)
    global _std_order = standard_order
    global _round_tol = rounding_tol
    global machineprecorder = Int32(round(-log10(_round_tol), digits=0))
    nothing
end
set_printing(standard_order=false, rounding_tol=1e-17)


function show(stream::IO, x::SubspaceBasis)
    write(stream, "Subspace(superbasis=$(x.superbasis), states:$(length(x.basisstates)))")
end

function show(stream::IO, x::ManyBodyBasis)
    write(stream, "ManyBody(onebodybasis=$(x.onebodybasis), states:$(length(x.occupations)))")
end

summary(io::IO, x::Ket) = print(io, "Ket(dim=$(length(x.basis)))\n  basis: $(x.basis)\n")
function show(stream::IO, x::Ket)
    summary(stream, x)
    if !_std_order
        Base.print_array(stream, round.(x.data; digits=machineprecorder))
    else
        showarray_stdord(stream, round.(x.data; digits=machineprecorder), x.basis.shape, false, header=false)
    end
end

summary(io::IO, x::Bra) = print(io, "Bra(dim=$(length(x.basis)))\n  basis: $(x.basis)\n")
function show(stream::IO, x::Bra)
    summary(stream, x)
    if !_std_order
        Base.print_array(stream, round.(x.data; digits=machineprecorder))
    else
        showarray_stdord(stream, round.(x.data; digits=machineprecorder), x.basis.shape, false, header=false)
    end
end

function show(stream::IO, x::DataOperator)
    summary(stream, x)
    print(stream, "\n")
    if !_std_order
        if !haskey(stream, :compact)
            stream = IOContext(stream, :compact => true)
        end
        show(stream, x.data)
    else
        error("Standard-Order printing not implemented for data of type $(typeof(x.data))!")
    end
end

function show(stream::IO, x::DenseOpType)
    summary(stream, x)
    print(stream, "\n")
    if !_std_order
        if !haskey(stream, :compact)
            stream = IOContext(stream, :compact => true)
        end
        Base.print_array(stream, round.(x.data; digits=machineprecorder))
    else
        showarray_stdord(stream, round.(x.data; digits=machineprecorder), x.basis_l.shape, x.basis_r.shape, false, header=false)
    end
end

function show(stream::IO, x::SparseOpPureType)
    summary(stream, x)
    if nnz(x.data) == 0 && (VERSION < v"1.6.0-beta1")
        print(stream, "\n    []")
    else
        if !_std_order
            if !haskey(stream, :compact) && (VERSION < v"1.6.0-beta1")
                stream = IOContext(stream, :compact => true)
            end
            print(stream, "\n")
            Base.print_array(stream, round.(x.data; digits=machineprecorder))
        else
            showsparsearray_stdord(stream, round.(x.data; digits=machineprecorder), x.basis_l.shape, x.basis_r.shape)
        end
    end
end

function show(stream::IO, x::LazyTensor)
    summary(stream, x)
    print(stream, "\n  operators: $(length(x.operators))")
    s = replace(string(x.indices), " " => "")
    print(stream, "\n  indices: $s")
end

function show(stream::IO, x::Union{LazySum, LazyProduct, LazyDirectSum})
    summary(stream, x)
    print(stream, "\n  operators: $(length(x.operators))")
end

"""
    ind2Nary(m::Int, dims::Vector{Int})

The inverse of `Nary2ind`.

# Example
```
julia> dims = [2,2,3];

julia> for i in 1:prod(dims)
           println(i,": ", ind2Nary(i,dims))
       end
1: [0, 0, 0]
2: [0, 0, 1]
3: [0, 0, 2]
4: [0, 1, 0]
5: [0, 1, 1]
6: [0, 1, 2]
7: [1, 0, 0]
8: [1, 0, 1]
9: [1, 0, 2]
10: [1, 1, 0]
11: [1, 1, 1]
12: [1, 1, 2]
```
"""
function ind2Nary(m::Int, dims::Vector{Int})
    m = m - 1
    nq = length(dims)
    ar = zeros(Int, nq)
    product = prod(dims[2:end])
    for ith in 1:nq-1
        d = div(m, product)
        m = m - d * product
        product = div(product, dims[ith+1])
        ar[ith] = d
    end
    ar[end] = m
    return ar
end

"""
    Nary2ind(x, dims) -> index

Convert composite N-arys to index.

# Example
```
julia> dims = [2,2,3];

julia> Nary2ind([1,1,0], dims)
10

julia> for i in 1:prod(dims)
           println(i,": ", Nary2ind(ind2Nary(i,dims),dims), ": ", ind2Nary(i,dims))
       end
1: 1: [0, 0, 0]
2: 2: [0, 0, 1]
3: 3: [0, 0, 2]
4: 4: [0, 1, 0]
5: 5: [0, 1, 1]
6: 6: [0, 1, 2]
7: 7: [1, 0, 0]
8: 8: [1, 0, 1]
9: 9: [1, 0, 2]
10: 10: [1, 1, 0]
11: 11: [1, 1, 1]
12: 12: [1, 1, 2]
```
"""
function Nary2ind(x::Vector{Int}, dims::Vector{Int})
    tmp = 0
    @assert length(x) == length(dims)
    nterms = length(x)
    tp = prod(dims[2:end])
    for i in 1:nterms-1
        tmp += x[i] * tp
        tp = div(tp, dims[i+1])
    end
    tmp += x[end] + 1
end

"""
    mirror_world_index(idx, dims)

Convert index of standard order to that of inversed order.
This function is named after the book, '鏡の中の物理学' (Physics in the mirror),
written by Tomonaga Shin'ichirō (Japanese physicist).
"""
function mirror_world_index(idx::Int, dims::Vector{Int})
    return Nary2ind( reverse(ind2Nary(idx, dims)), reverse(dims)  )
end

# Following program is modified:
# julia/base/show.jl
# https://github.com/JuliaLang/julia/blob/5cd144ffa328fdd4cd9e983b616c7205f9bb4f51/base/show.jl
# and
# julia/base/sparse/sparsematrix.jl
# https://github.com/JuliaLang/julia/blob/78831902cc412e298c5fcc94dae1e4382c8e7cd0/base/sparse/sparsematrix.jl

# Copyright (c) 2009-2018: Jeff Bezanson, Stefan Karpinski, Viral B. Shah,
# and other contributors:
#
# https://github.com/JuliaLang/julia/contributors
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

"""
`alignment_std(X, ldims, rdims, rows, cols, cols_if_complete, cols_otherwise, sep)` returns the
alignment for specified parts of array `X`, returning the (left,right) info.
It will look in X's `rows`, `cols` (both lists of indices)
and figure out what's needed to be fully aligned, for example looking all
the way down a column and finding out the maximum size of each element.
Parameter `sep::Integer` is number of spaces to put between elements.
`cols_if_complete` and `cols_otherwise` indicate screen width to use.
Alignment is reported as a vector of (left,right) tuples, one for each
column going across the screen.
"""
function alignment_std(io::IO, X::AbstractVecOrMat, ldims::Vector, rdims::Vector,
        rows::AbstractVector, cols::AbstractVector,
        cols_if_complete::Integer, cols_otherwise::Integer, sep::Integer)
    a = Tuple{Int, Int}[]
    for j in cols # need to go down each column one at a time
        l = r = 0
        for i in rows # plumb down and see what largest element sizes are
            aij = Base.alignment(io, X[mirror_world_index(i, ldims), mirror_world_index(j, rdims)])
            l = max(l, aij[1]) # left characters
            r = max(r, aij[2]) # right characters
        end
        push!(a, (l, r)) # one tuple per column of X, pruned to screen width
        if length(a) > 1 && sum(map(sum,a)) + sep*length(a) >= cols_if_complete
            pop!(a) # remove this latest tuple if we're already beyond screen width
            break
        end
    end
    if 1 < length(a) < length(axes(X,2))
        while sum(map(sum,a)) + sep*length(a) >= cols_otherwise
            pop!(a)
        end
    end
    return a
end

"""
`print_matrix_row_std(io, X, A, ldims, rdims, i, cols, sep)` produces the aligned output for
a single matrix row X[i, cols] where the desired list of columns is given.
The corresponding alignment A is used, and the separation between elements
is specified as string sep.
`print_matrix_row_std` will also respect compact output for elements.
"""
function print_matrix_row_std(io::IO,
        X::AbstractVecOrMat, A::Vector, ldims::Vector, rdims::Vector,
        i::Integer, cols::AbstractVector, sep::AbstractString)
    isempty(A) || first(axes(cols,1)) == 1 || throw(DimensionMismatch("indices of cols ($(axes(cols,1))) must start at 1"))
    for k = 1:length(A)
        j = cols[k]
        x = X[mirror_world_index(i, ldims), mirror_world_index(j, rdims)]
        a = Base.alignment(io, x)
        sx = sprint(show, x, context=io)
        l = repeat(" ", A[k][1]-a[1]) # pad on left and right as needed
        r = repeat(" ", A[k][2]-a[2])
        prettysx = Base.replace_in_print_matrix(X,mirror_world_index(i, ldims),mirror_world_index(j, rdims),sx)
        print(io, l, prettysx, r)
        if k < length(A); print(io, sep); end
    end
end


function print_matrix_std(io::IO, X::AbstractVecOrMat, ldims::Vector, rdims::Vector,
                      pre::AbstractString = " ",  # pre-matrix string
                      sep::AbstractString = "  ", # separator between elements
                      post::AbstractString = "",  # post-matrix string
                      hdots::AbstractString = "  \u2026  ",
                      vdots::AbstractString = "\u22ee",
                      ddots::AbstractString = "  \u22f1  ",
                      hmod::Integer = 5, vmod::Integer = 5)
    if !get(io, :limit, false)
        screenheight = screenwidth = typemax(Int)
    else
        sz = displaysize(io)
        screenheight, screenwidth = sz[1] - 4, sz[2]
    end
    screenwidth -= length(pre) + length(post)
    presp = repeat(" ", length(pre))  # indent each row to match pre string
    postsp = ""
    @assert textwidth(hdots) == textwidth(ddots)
    sepsize = length(sep)
    rowsA, colsA = axes(X,1), axes(X,2)
    m, n = length(rowsA), length(colsA)
    # To figure out alignments, only need to look at as many rows as could
    # fit down screen. If screen has at least as many rows as A, look at A.
    # If not, then we only need to look at the first and last chunks of A,
    # each half a screen height in size.
    halfheight = div(screenheight,2)
    if m > screenheight
        rowsA = [rowsA[1:halfheight]; rowsA[m-div(screenheight-1,2)+1:m]]
    end
    # Similarly for columns, only necessary to get alignments for as many
    # columns as could conceivably fit across the screen
    maxpossiblecols = div(screenwidth, 1+sepsize)
    if n > maxpossiblecols
        colsA = [colsA[1:maxpossiblecols]; colsA[(n-maxpossiblecols+1):n]]
    end
    A = alignment_std(io, X, ldims, rdims, rowsA, colsA, screenwidth, screenwidth, sepsize)
    # Nine-slicing is accomplished using print_matrix_row_std repeatedly
    if m <= screenheight # rows fit vertically on screen
        if n <= length(A) # rows and cols fit so just print whole matrix in one piece
            for i in rowsA
                print(io, i == first(rowsA) ? pre : presp)
                print_matrix_row_std(io, X,A,ldims,rdims,i,colsA,sep)
                print(io, i == last(rowsA) ? post : postsp)
                if i != last(rowsA); println(io); end
            end
        else # rows fit down screen but cols don't, so need horizontal ellipsis
            c = div(screenwidth-length(hdots)+1,2)+1  # what goes to right of ellipsis
            Ralign = reverse(alignment_std(io, X, ldims, rdims, rowsA, reverse(colsA), c, c, sepsize)) # alignments for right
            c = screenwidth - sum(map(sum,Ralign)) - (length(Ralign)-1)*sepsize - length(hdots)
            Lalign = alignment_std(io, X, ldims, rdims, rowsA, colsA, c, c, sepsize) # alignments for left of ellipsis
            for i in rowsA
                print(io, i == first(rowsA) ? pre : presp)
                print_matrix_row_std(io, X,Lalign,ldims,rdims,i,colsA[1:length(Lalign)],sep)
                print(io, (i - first(rowsA)) % hmod == 0 ? hdots : repeat(" ", length(hdots)))
                print_matrix_row_std(io, X,Ralign,ldims,rdims,i,n-length(Ralign).+colsA,sep)
                print(io, i == last(rowsA) ? post : postsp)
                if i != last(rowsA); println(io); end
            end
        end
    else # rows don't fit so will need vertical ellipsis
        if n <= length(A) # rows don't fit, cols do, so only vertical ellipsis
            for i in rowsA
                print(io, i == first(rowsA) ? pre : presp)
                print_matrix_row_std(io, X,A,ldims, rdims,i,colsA,sep)
                print(io, i == last(rowsA) ? post : postsp)
                if i != rowsA[end]; println(io); end
                if i == rowsA[halfheight]
                    print(io, i == first(rowsA) ? pre : presp)
                    Base.print_matrix_vdots(io, vdots,A,sep,vmod,1)
                    println(io, i == last(rowsA) ? post : postsp)
                end
            end
        else # neither rows nor cols fit, so use all 3 kinds of dots
            c = div(screenwidth-length(hdots)+1,2)+1
            Ralign = reverse(alignment_std(io, X, ldims, rdims, rowsA, reverse(colsA), c, c, sepsize))
            c = screenwidth - sum(map(sum,Ralign)) - (length(Ralign)-1)*sepsize - length(hdots)
            Lalign = alignment_std(io, X, ldims, rdims, rowsA, colsA, c, c, sepsize)
            r = mod((length(Ralign)-n+1),vmod) # where to put dots on right half
            for i in rowsA
                print(io, i == first(rowsA) ? pre : presp)
                print_matrix_row_std(io, X,Lalign,ldims, rdims,i,colsA[1:length(Lalign)],sep)
                print(io, (i - first(rowsA)) % hmod == 0 ? hdots : repeat(" ", length(hdots)))
                print_matrix_row_std(io, X,Ralign,ldims, rdims,i,n-length(Ralign).+colsA,sep)
                print(io, i == last(rowsA) ? post : postsp)
                if i != rowsA[end]; println(io); end
                if i == rowsA[halfheight]
                    print(io, i == first(rowsA) ? pre : presp)
                    Base.print_matrix_vdots(io, vdots,Lalign,sep,vmod,1)
                    print(io, ddots)
                    Base.print_matrix_vdots(io, vdots,Ralign,sep,vmod,r)
                    println(io, i == last(rowsA) ? post : postsp)
                end
            end
        end
    end
end

function showarray_stdord(io::IO, X::AbstractVecOrMat, ldims::Vector, rdims::Vector, repr::Bool = true; header = true)
    if !haskey(io, :compact) && length(axes(X, 2)) > 1
        io = IOContext(io, :compact => true)
    end
    if !isempty(X)
        punct = (" ", "  ", "")
        print_matrix_std(io, X, ldims, rdims, punct...)
    end
end
showarray_stdord(io::IO, X::Vector, dims::Vector, repr::Bool = true; header = true) = showarray_stdord(io, X, dims, [1], repr; header = header)


function showsparsearray_stdord(io::IO, S::SparseMatrixCSC, ldims::Vector, rdims::Vector)
    if get(io, :limit, false)
        rows = displaysize(io)[1]
        half_screen_rows = div(rows - 8, 2)
    else
        half_screen_rows = typemax(Int)
    end
    # pad = ndigits(max(S.m,S.n))
    pad = ndigits(maximum(S.rowval))
    sep = "\n  "
    if !haskey(io, :compact) && length(axes(S, 2)) > 1
        io = IOContext(io, :compact => true)
    end

    colval = zeros(Int, nnz(S))
    for col in 1:S.n, k in S.colptr[col] : (S.colptr[col+1]-1)
        colval[k] = col
    end
    rowval = S.rowval
    rowval_std = map(x -> mirror_world_index(x, reverse(ldims)), rowval)
    colval_std = map(x -> mirror_world_index(x, reverse(rdims)), colval)
    idx_nzval = map((x,y,z) -> (x,y,z), rowval_std, colval_std, S.nzval)
    sort!(idx_nzval, by = x -> (x[2], x[1]) )
    rowval_std = map(x -> x[1], idx_nzval)
    colval_std = map(x -> x[2], idx_nzval)
    nzval_std = map(x -> x[3], idx_nzval)

    for (k, val) in enumerate(nzval_std)
        if k < half_screen_rows || k > nnz(S)-half_screen_rows
            print(io, sep, '[', rpad(rowval_std[k], pad), ", ", lpad(colval_std[k], pad), "]  =  ")
            show(io, nzval_std[k])
        elseif k == half_screen_rows
            print(io, sep, '\u22ee')
        end
    end
end

@testitem "test_operators" begin
using Test
using QuantumOpticsBase
using LinearAlgebra, SparseArrays, Random

mutable struct test_operators{BL<:Basis,BR<:Basis} <: AbstractOperator{BL,BR}
  basis_l::BL
  basis_r::BR
  data::Matrix{ComplexF64}
  test_operators(b1::Basis, b2::Basis, data) = length(b1) == size(data, 1) && length(b2) == size(data, 2) ? new{typeof(b1),typeof(b2)}(b1, b2, data) : throw(DimensionMismatch())
end

@testset "operators" begin

Random.seed!(0)

b1 = GenericBasis(3)
b2 = GenericBasis(2)
b = b1 ⊗ b2
op1 = randoperator(b1)
op2 = randoperator(b2)
op = randoperator(b, b)
op_test = test_operators(b, b, op.data)
op_test2 = test_operators(b1, b, randoperator(b1, b).data)
op_test3 = test_operators(b1 ⊗ b2, b2 ⊗ b1, randoperator(b, b).data)
ψ = randstate(b)
ρ = randoperator(b)

@test basis(op1) == b1
@test length(op1) == length(op1.data) == length(b1)^2

@test isequal(+op_test, op_test)

@test_throws ArgumentError op_test*op_test
@test_throws ArgumentError -op_test

@test_throws ArgumentError 1 + op_test
@test_throws ArgumentError op_test + 1
@test_throws ArgumentError 1 - op_test
@test_throws ArgumentError op_test - 1

@test_throws ArgumentError dagger(op_test)
@test_throws ArgumentError op_test'
@test_throws ArgumentError identityoperator(test_operators, b, b)
@test_throws ArgumentError tr(op_test)
@test_throws ArgumentError ptrace(op_test, [1])
@test_throws ArgumentError ishermitian(op_test)
@test_throws MethodError dense(op_test)
@test_throws ArgumentError sparse(op_test)
@test_throws ArgumentError transpose(op_test)

@test expect(1, op1, ρ) ≈ expect(embed(b, 1, op1), ρ)
@test expect(1, op1, ψ) ≈ expect(embed(b, 1, op1), ψ)
@test expect(op, [ρ, ρ]) == [expect(op, ρ) for i=1:2]
@test expect(1, op1, [ρ, ψ]) == [expect(1, op1, ρ), expect(1, op1, ψ)]

@test variance(1, op1, ρ) ≈ variance(embed(b, 1, op1), ρ)
@test variance(1, op1, ψ) ≈ variance(embed(b, 1, op1), ψ)
@test variance(op, [ρ, ρ]) == [variance(op, ρ) for i=1:2]
@test variance(1, op1, [ρ, ψ]) == [variance(1, op1, ρ), variance(1, op1, ψ)]

@test tensor(op_test) === op_test
@test_throws ArgumentError tensor(op_test, op_test)
@test_throws ArgumentError permutesystems(op_test, [1, 2])

@test embed(b, b, [1,2], op) == embed(b, [1,2], op)
@test embed(b, Dict{Vector{Int}, SparseOpType}()) == identityoperator(b)
@test_throws QuantumOpticsBase.IncompatibleBases embed(b1⊗b2, [2], [op1])

b_comp = b⊗b
@test isapprox(embed(b_comp, [1,[3,4]], [op1,op]), dense(op1 ⊗ one(b2) ⊗ op))
@test isapprox(embed(b_comp, [[1,2],4], [op,op2]), dense(op ⊗ one(b1) ⊗ op2))
@test_throws QuantumOpticsBase.IncompatibleBases embed(b_comp, [[1,2],3], [op,op2])
@test_throws QuantumOpticsBase.IncompatibleBases embed(b_comp, [[1,3],4], [op,op2])

function basis_vec(n, N)
    x = zeros(Complex{Float64}, N)
    x[n+1] = 1
    return x
end
function basis_maker(dims...)
    function bm(ns...)
        bases = [basis_vec(n, dim) for (n, dim) in zip(ns, dims)][end:-1:1]
        return reduce(kron, bases)
    end
end

embed_op = embed(b_comp, [1,4], op)
bv = basis_maker(3,2,3,2)
all_idxs = [(idx, jdx) for (idx, jdx) in [Iterators.product(0:1, 0:2)...]]

m11 = reshape([Bra(b_comp, bv(0,idx,jdx,0)) * embed_op * Ket(b_comp, bv(0,kdx,ldx,0))
              for ((idx, jdx), (kdx, ldx)) in Iterators.product(all_idxs, all_idxs)], (6,6))
@test isapprox(m11 / op.data[1, 1], diagm(0=>ones(Complex{Float64}, 6)))

m21 = reshape([Bra(b_comp, bv(1,idx,jdx,0)) * embed_op * Ket(b_comp, bv(0,kdx,ldx,0))
              for ((idx, jdx), (kdx, ldx)) in Iterators.product(all_idxs, all_idxs)], (6,6))
@test isapprox(m21 / op.data[2,1], diagm(0=>ones(Complex{Float64}, 6)))

m12 = reshape([Bra(b_comp, bv(0,idx,jdx,0)) * embed_op * Ket(b_comp, bv(1,kdx,ldx,0))
              for ((idx, jdx), (kdx, ldx)) in Iterators.product(all_idxs, all_idxs)], (6,6))
@test isapprox(m12 / op.data[1,2], diagm(0=>ones(Complex{Float64}, 6)))


b_comp = b_comp⊗b_comp
OP_test1 = dense(tensor([op1,one(b2),op,one(b1),one(b2),op1,one(b2)]...))
OP_test2 = embed(b_comp, [1,[3,4],7], [op1,op,op1])
@test isapprox(OP_test1, OP_test2)

b8 = b2⊗b2⊗b2
cnot = [1 0 0 0; 0 1 0 0; 0 0 0 1; 0 0 1 0]
op_cnot = DenseOperator(b2⊗b2, cnot)
OP_cnot = embed(b8, [1,3], op_cnot)
@test ptrace(OP_cnot, [2])/2. == op_cnot
@test reduced(OP_cnot, [1,3])/2. == op_cnot
@test_throws ArgumentError embed(b2⊗b2, [1,1], op_cnot)

b = FockBasis(40)
alpha = 1+5im
H = alpha * create(b) - conj(alpha) * destroy(b)
@test exp(sparse(H); threshold=1e-10) ≈ displace(b, alpha)
@test exp(sparse(zero(identityoperator(b)))) ≈ identityoperator(b)

@test one(b1).data == Diagonal(ones(b1.shape[1]))
@test one(op1).data == Diagonal(ones(b1.shape[1]))

@test_throws ArgumentError conj!(op_test)

bfock = FockBasis(2)
bspin = SpinBasis(1//2)
b = bfock⊗bspin⊗bspin

op12 = destroy(bfock)⊗sigmap(bspin)

@test embed(b, [1,2], op12) == destroy(bfock)⊗sigmap(bspin)⊗one(bspin)
@test embed(b, [1,3], op12) == destroy(bfock)⊗one(bspin)⊗sigmap(bspin)

# size of AbstractOperator
b1, b2 = NLevelBasis.((2, 3))
Lop1 = LazyTensor(b1^2, b2^2, 2, sparse(randoperator(b1, b2)))
@test size(Lop1) == size(dense(Lop1)) == size(dense(Lop1).data)
@test all(size(Lop1, k) == size(dense(Lop1), k) for k=1:4)
@test_throws ErrorException size(Lop1,  0)
@test_throws ErrorException size(Lop1, -1)
@test_throws ErrorException size(dense(Lop1),  0) # check for consistency
@test_throws ErrorException size(dense(Lop1), -1)

# issue 106 | https://github.com/qojulia/QuantumOpticsBase.jl/issues/106
a = destroy(FockBasis(5))
@test dagger(a^2) == dagger(a)^2
@test convert(Base._return_type(*, Tuple{typeof(a'), typeof(a')}), a') == a'

end # testset
end

@testitem "test_operators_lazytensor" begin
using Test
using QuantumOpticsBase
using LinearAlgebra, SparseArrays, Random

mutable struct test_lazytensor{BL<:Basis,BR<:Basis} <: AbstractOperator{BL,BR}
    basis_l::BL
    basis_r::BR
    data::Matrix{ComplexF64}
    test_lazytensor(b1::Basis, b2::Basis, data) = length(b1) == size(data, 1) && length(b2) == size(data, 2) ? new{typeof(b1),typeof(b2)}(b1, b2, data) : throw(DimensionMismatch())
end
Base.eltype(::test_lazytensor) = ComplexF64

@testset "operators-lazytensor" begin

Random.seed!(0)

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x1::StateVector, x2::StateVector) = norm(x2-x1)

b1a = GenericBasis(2)
b1b = GenericBasis(3)
b2a = GenericBasis(1)
b2b = GenericBasis(4)
b3a = GenericBasis(6)
b3b = GenericBasis(5)

b_l = b1a⊗b2a⊗b3a
b_r = b1b⊗b2b⊗b3b

op1 = randoperator(b1a, b1b)
op2 = randoperator(b2a, b2b)
op3 = randoperator(b3a, b3b)

# Test creation
@test_throws AssertionError LazyTensor(b_l, b_r, [1], (randoperator(b1a),))
@test_throws AssertionError LazyTensor(b_l, b_r, [1, 2], (op1,))
@test_throws AssertionError LazyTensor(b_l, b_r, [1, 2], (op1, sparse(randoperator(b_l, b_l))))
@test_throws AssertionError LazyTensor(b_l, b_r, [1, 2], (randoperator(b_r, b_r), sparse(op2)))

# @test LazyTensor(b_l, b_r, [2, 1], [op2, op1]) == LazyTensor(b_l, b_r, [1, 2], [op1, op2])
x = randoperator(b2a)
@test LazyTensor(b_l, 2, x) == LazyTensor(b_l, b_l, [2], (x,))

# Test copy
x = 2*LazyTensor(b_l, b_r, [1,2], (randoperator(b1a, b1b), sparse(randoperator(b2a, b2b))))
x_ = copy(x)
@test x == x_
@test isequal(x, x_)
@test !(x === x_)
x_.operators[1].data[1,1] = complex(10.)
@test x.operators[1].data[1,1] != x_.operators[1].data[1,1]
x_.factor = 3.
@test x_.factor != x.factor
x_.indices[2] = 100
@test x_.indices != x.indices

@test QuantumOpticsBase.is_const(x)

# Test dense & sparse
I2 = identityoperator(b2a, b2b)
x = LazyTensor(b_l, b_r, [1, 3], (op1, sparse(op3)), 0.3)
@test 1e-12 > D(0.3*op1⊗dense(I2)⊗op3, dense(x))
@test 1e-12 > D(0.3*sparse(op1)⊗I2⊗sparse(op3), sparse(x))

# Test eltype
for T in (Float32, Float64, ComplexF32, ComplexF64)
    I2_T = identityoperator(T, b2a, b2b)
    op1_T = randoperator(T, b1a, b1b)
    op3_T = randoperator(T, b3a, b3b)
    x_T =  LazyTensor(b_l, b_r, [1, 3], (op1_T, sparse(op3_T)), T(0.3))
    @test eltype(x_T) == T
    @test eltype(dense(x_T)) == T
    @test eltype(sparse(x_T)) == T
end

# Test suboperators
@test QuantumOpticsBase.suboperator(x, 1) == op1
@test QuantumOpticsBase.suboperator(x, 3) == sparse(op3)
@test QuantumOpticsBase.suboperators(x, [1, 3]) == [op1, sparse(op3)]

# Test embed
x_1 = LazyTensor(b_l, b_r, [1], (op1,), 0.3)
x_1_sub = LazyTensor(b1a⊗b2a, b1b⊗b2b, [1], (op1,), 0.3)
@test embed(b_l, b_r, Dict([1,2]=>x_1_sub)) == x_1
@test embed(b_l, b_r, [1,2], x_1_sub) == x_1

x_12 = LazyTensor(b1a⊗b3a, b1b⊗b3b, [1,2], (op1, sparse(op3)), 0.3)
@test embed(b_l, b_r, Dict([1,3]=>x_12)) == x
@test embed(b_l, b_r, [1,3], x_12) == x


# Arithmetic operations
# =====================
subop1 = randoperator(b1a, b1b)
subop2 = randoperator(b2a, b2b)
subop3 = randoperator(b3a, b3b)
I1 = dense(identityoperator(b1a, b1b))
I2 = dense(identityoperator(b2a, b2b))
I3 = dense(identityoperator(b3a, b3b))
op1 = LazyTensor(b_l, b_r, [1, 3], (subop1, sparse(subop3)), 0.1)
op1_ = 0.1*subop1 ⊗ I2 ⊗ subop3
op2 = LazyTensor(b_l, b_r, [2, 3], (sparse(subop2), subop3), 0.7)
op2_ = 0.7*I1 ⊗ subop2 ⊗ subop3
op3 = 0.3*LazyTensor(b_l, b_r, 3, subop3)
op3_ = 0.3*I1 ⊗ I2 ⊗ subop3
op4 = 0.4*LazyTensor(b_l, b_r, 2, subop2)
op4_ = 0.4*I1 ⊗ subop2 ⊗ I3

x1 = Ket(b_r, rand(ComplexF64, length(b_r)))
x2 = Ket(b_r, rand(ComplexF64, length(b_r)))
xbra1 = Bra(b_l, rand(ComplexF64, length(b_l)))
xbra2 = Bra(b_l, rand(ComplexF64, length(b_l)))

# Addition one operator at same index
fac = randn()
@test dense(op3 + fac * op3) ≈ dense(op3) * (1 + fac)
@test dense(op3 - fac * op3) ≈ dense(op3) * (1 - fac)
# Addition one operator at different index
@test dense(op3 + fac * op4) ≈ dense(op3_ + fac*op4_)
@test dense(op3 - fac * op4) ≈ dense(op3_ - fac*op4_)

#Test addition
@test_throws QuantumOpticsBase.IncompatibleBases op1 + dagger(op2)
@test 1e-14 > D(-op1_, -op1)
@test 1e-14 > D(op1+op2, op1_+op2_)
@test 1e-14 > D(op1+op2_, op1_+op2_)
@test 1e-14 > D(op1_+op2, op1_+op2_)

#Test substraction
@test_throws QuantumOpticsBase.IncompatibleBases op1 - dagger(op2)
@test 1e-14 > D(op1 - op2, op1_ - op2_)
@test 1e-14 > D(op1 - op2_, op1_ - op2_)
@test 1e-14 > D(op1_ - op2, op1_ - op2_)
@test 1e-14 > D(op1 + (-op2), op1_ - op2_)
@test 1e-14 > D(op1 + (-1*op2), op1_ - op2_)


#Test tensor
op1_tensor =  subop1 ⊗ op1
op1_tensor_ =  subop1 ⊗ op1_
op2_tensor =   op1 ⊗ subop1
op2_tensor_ =   op1_ ⊗ subop1
@test 1e-14 > D(op1_tensor,op1_tensor_)
@test 1e-14 > D(op1_tensor_,op1_tensor)

#Cannot tensor CompositeBasis with LazyTensor:
@test_throws ArgumentError op1 ⊗ op1_
@test_throws ArgumentError op2_ ⊗ op2



# Test multiplication
@test_throws DimensionMismatch op1*op2
@test 1e-11 > D(op1*(x1 + 0.3*x2), op1_*(x1 + 0.3*x2))
@test 1e-11 > D((xbra1 + 0.3*xbra2)*op1, (xbra1 + 0.3*xbra2)*op1_)
@test 1e-11 > D(op1*x1 + 0.3*op1*x2, op1_*x1 + 0.3*op1_*x2)
@test 1e-12 > D(dagger(x1)*dagger(0.3*op2), dagger(x1)*dagger(0.3*op2_))
@test 1e-12 > D(op1_*dagger(0.3*op2), op1_*dagger(0.3*op2_))
@test 1e-12 > D(dagger(0.3*op2)*op1_, dagger(0.3*op2_)*op1_)
@test 1e-12 > D(dagger(0.3*op2)*op1, dagger(0.3*op2_)*op1_)


# Test division
@test 1e-14 > D(op1/7, op1_/7)

# Test identityoperator
Idense = identityoperator(DenseOpType, b_r)
id = identityoperator(LazyTensor, b_r)
@test isa(id, LazyTensor)
@test dense(id) == Idense
@test 1e-11 > D(id*x1, x1)
@test id == identityoperator(LazyTensor, b1b) ⊗ identityoperator(LazyTensor, b2b) ⊗ identityoperator(LazyTensor, b3b)

Idense = identityoperator(DenseOpType, b_l)
id = identityoperator(LazyTensor, b_l)
@test isa(id, LazyTensor)
@test dense(id) == Idense
@test 1e-11 > D(xbra1*id, xbra1)
@test id == identityoperator(LazyTensor, b1a) ⊗ identityoperator(LazyTensor, b2a) ⊗ identityoperator(LazyTensor, b3a)


# Test tr and normalize
subop1 = randoperator(b1a)
I2 = dense(identityoperator(b2a))
subop3 = randoperator(b3a)
op = LazyTensor(b_l, b_l, [1, 3], (subop1, sparse(subop3)), 0.1)
op_ = 0.1*subop1 ⊗ I2 ⊗ subop3

@test tr(op) ≈ tr(op_)
op_normalized = normalize(op)
@test tr(op_) ≈ tr(op)
@test 1 ≈ tr(op_normalized)
op_copy = deepcopy(op)
normalize!(op_copy)
@test tr(op) != tr(op_copy)
@test 1 ≈ tr(op_copy)

# Test partial tr
subop1 = randoperator(b1a)
I2 = dense(identityoperator(b2a))
subop3 = randoperator(b3a)
op = LazyTensor(b_l, b_l, [1, 3], (subop1, sparse(subop3)), 0.1)
op_ = 0.1*subop1 ⊗ I2 ⊗ subop3

@test 1e-14 > D(ptrace(op_, 3), ptrace(op, 3))
@test 1e-14 > D(ptrace(op_, 2), ptrace(op, 2))
@test 1e-14 > D(ptrace(op_, 1), ptrace(op, 1))

@test 1e-14 > D(ptrace(op_, [2,3]), ptrace(op, [2,3]))
@test 1e-14 > D(ptrace(op_, [1,3]), ptrace(op, [1,3]))
@test 1e-14 > D(ptrace(op_, [1,2]), ptrace(op, [1,2]))

@test_throws ArgumentError ptrace(op, [1,2,3])

# Test expect
state = Ket(b_l, rand(ComplexF64, length(b_l)))
@test expect(op, state) ≈ expect(op_, state)

state = DenseOperator(b_l, b_l, rand(ComplexF64, length(b_l), length(b_l)))
@test expect(op, state) ≈ expect(op_, state)

# Permute systems
subop1 = randoperator(b1a, b1b)
subop2 = randoperator(b2a, b2b)
subop3 = randoperator(b3a, b3b)
I2 = dense(identityoperator(b2a, b2b))
op = LazyTensor(b_l, b_r, [1, 3], (subop1, sparse(subop3)))*0.1
op_ = 0.1*subop1 ⊗ I2 ⊗ subop3

@test 1e-14 > D(permutesystems(op, [1, 3, 2]), permutesystems(op_, [1, 3, 2]))
@test 1e-14 > D(permutesystems(op, [2, 1, 3]), permutesystems(op_, [2, 1, 3]))
@test 1e-14 > D(permutesystems(op, [2, 3, 1]), permutesystems(op_, [2, 3, 1]))
@test 1e-14 > D(permutesystems(op, [3, 1, 2]), permutesystems(op_, [3, 1, 2]))
@test 1e-14 > D(permutesystems(op, [3, 2, 1]), permutesystems(op_, [3, 2, 1]))

for _mod_state in (identity, sparse)  # sparse state for testing no-cache, no-strided path
    # Test gemv, mixing precisions
    subop1 = randoperator(ComplexF32, b1a, b1b)
    subop2 = randoperator(b2b, b2a)'  # test adjoint explicitly
    subop3 = randoperator(b3b, b3a)'  # test adjoint explicitly
    op = LazyTensor(b_l, b_r, [1, 2, 3], (subop1, subop2, subop3))*0.1
    op_sp = LazyTensor(b_l, b_r, [1, 2, 3], sparse.((subop1, subop2, subop3)))*0.1
    op_ = 0.1*subop1 ⊗ subop2 ⊗ subop3

    state = _mod_state(Ket(b_r, rand(ComplexF32, length(b_r))))
    result_ = _mod_state(Ket(b_l, rand(ComplexF64, length(b_l))))
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
    @test 1e-6 > D(result, op_*state)

    QuantumOpticsBase.mul!(result,op_sp,state,complex(1.),complex(0.))
    @test 1e-6 > D(result, op_*state)

    _mod_state == identity && @test lazytensor_cachesize() > 0  # the cache should have some entries by now

    lazytensor_disable_cache()
    @test !QuantumOpticsBase.lazytensor_use_cache()

    QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
    @test 1e-6 > D(result, op_*state)

    lazytensor_enable_cache(; maxsize=8)  # tiny cache that won't hold anything
    @test QuantumOpticsBase.lazytensor_use_cache()

    @test lazytensor_cachesize() <= 8

    alpha = complex(1.5)
    beta = complex(2.1)
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op,state,alpha,beta)
    @test 1e-6 > D(result, alpha*op_*state + beta*result_)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op_sp,state,alpha,beta)
    @test 1e-6 > D(result, alpha*op_*state + beta*result_)

    lazytensor_clear_cache()
    lazytensor_enable_cache(; maxsize=2^30, maxrelsize=2^30 / Sys.total_memory())
    lazytensor_enable_cache()

    state = _mod_state(Bra(b_l, rand(ComplexF64, length(b_l))))
    result_ = _mod_state(Bra(b_r, rand(ComplexF64, length(b_r))))
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
    @test 1e-13 > D(result, state*op_)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,state,op_sp,complex(1.),complex(0.))
    @test 1e-13 > D(result, state*op_)

    result = deepcopy(result_)
    alpha = complex(1.5)
    beta = complex(2.1)
    QuantumOpticsBase.mul!(result,state,op,alpha,beta)
    @test 1e-13 > D(result, alpha*state*op_ + beta*result_)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,state,op_sp,alpha,beta)
    @test 1e-13 > D(result, alpha*state*op_ + beta*result_)

    # Test gemm
    b_l2 = GenericBasis(17)
    b_r2 = GenericBasis(13)
    subop1 = randoperator(b1a, b1b)
    subop2 = randoperator(b2a, b2b)
    subop3 = randoperator(b3a, b3b)
    op = LazyTensor(b_l, b_r, [1, 2, 3], (subop1, subop2, sparse(subop3)))*0.1
    op_sp = LazyTensor(b_l, b_r, [1, 2, 3], sparse.((subop1, subop2, subop3)))*0.1
    op_ = 0.1*subop1 ⊗ subop2 ⊗ subop3

    state = _mod_state(randoperator(b_r, b_r2))
    result_ = _mod_state(randoperator(b_l, b_r2))
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op,state,complex(1.),complex(0.))
    @test 1e-12 > D(result, op_*state)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op_sp,state,complex(1.),complex(0.))
    @test 1e-12 > D(result, op_*state)

    result = deepcopy(result_)
    alpha = complex(1.5)
    beta = complex(2.1)
    QuantumOpticsBase.mul!(result,op,state,alpha,beta)
    @test 1e-12 > D(result, alpha*op_*state + beta*result_)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op_sp,state,alpha,beta)
    @test 1e-12 > D(result, alpha*op_*state + beta*result_)

    state = _mod_state(randoperator(b_l2, b_l))
    result_ = _mod_state(randoperator(b_l2, b_r))
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,state,op,complex(1.),complex(0.))
    @test 1e-12 > D(result, state*op_)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,state,op_sp,complex(1.),complex(0.))
    @test 1e-12 > D(result, state*op_)

    result = deepcopy(result_)
    alpha = complex(1.5)
    beta = complex(2.1)
    QuantumOpticsBase.mul!(result,state,op,alpha,beta)
    @test 1e-12 > D(result, alpha*state*op_ + beta*result_)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,state,op_sp,alpha,beta)
    @test 1e-12 > D(result, alpha*state*op_ + beta*result_)

    # Test calling gemv with non-complex factors
    state = _mod_state(Ket(b_r, rand(ComplexF64, length(b_r))))
    result_ = _mod_state(Ket(b_l, rand(ComplexF64, length(b_l))))
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op,state)
    @test 1e-13 > D(result, op_*state)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op_sp,state)
    @test 1e-13 > D(result, op_*state)

    state = _mod_state(Bra(b_l, rand(ComplexF64, length(b_l))))
    result_ = _mod_state(Bra(b_r, rand(ComplexF64, length(b_r))))
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,state,op)
    @test 1e-13 > D(result, state*op_)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,state,op_sp)
    @test 1e-13 > D(result, state*op_)

    # Test scaled isometry action
    op = LazyTensor(b_l, b_r, (), (), 0.5)
    op_ = sparse(op)
    state = _mod_state(randoperator(b_r, b_r2))
    result_ = _mod_state(randoperator(b_l, b_r2))
    alpha = complex(1.5)
    beta = complex(2.1)
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op,state,alpha,beta)
    @test 1e-12 > D(result, alpha*op_*state + beta*result_)

    # Test single operator, no isometries
    subop1 = randoperator(b1a, b1a)
    op = LazyTensor(b_l, b_l, [1], (subop1,), 0.5)
    op_sp = LazyTensor(b_l, b_l, [1], (sparse(subop1),), 0.5)
    op_ = sparse(op)
    state = _mod_state(randoperator(b_l, b_r2))
    result_ = _mod_state(randoperator(b_l, b_r2))
    alpha = complex(1.5)
    beta = complex(2.1)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op,state,alpha,beta)
    @test 1e-12 > D(result, alpha*op_*state + beta*result_)

    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op_sp,state,alpha,beta)
    @test 1e-12 > D(result, alpha*op_*state + beta*result_)

    # Test scaled identity
    op = LazyTensor(b_l, b_l, (), (), 0.5)
    op_ = sparse(op)
    result = deepcopy(result_)
    QuantumOpticsBase.mul!(result,op,state,alpha,beta)
    @test 1e-12 > D(result, alpha*op_*state + beta*result_)

    # Test gemm errors
    test_op = test_lazytensor(b1a, b1a, rand(2, 2))
    test_lazy = LazyTensor(tensor(b1a, b1a), [1, 2], (test_op, test_op))
    test_ket = Ket(tensor(b1a, b1a), rand(4))

    @test_throws MethodError QuantumOpticsBase.mul!(copy(test_ket),test_lazy,test_ket,alpha,beta)
    @test_throws MethodError QuantumOpticsBase.mul!(copy(dagger(test_ket)),dagger(test_ket),test_lazy,alpha,beta)
end

# Test type stability of constructor
callT = typeof((FockBasis(2) ⊗ FockBasis(2), 1, destroy(FockBasis(2))))
T = Core.Compiler.return_type(LazyTensor, callT)
@test all(map(isconcretetype, T.parameters))

# Test mul! of adjoint dense operator with sparse lazy tensor
## adjoint from the left
lop = LazyTensor(b1a⊗b1b, b2a⊗b2b, 1, SparseOperator(randoperator(b1a,b2a)))
dop = randoperator(b1a⊗b1b, b3a⊗b3b)
@test dop'*lop ≈ dop'*lop ≈ Operator(dop.basis_r, lop.basis_r, dop.data'*dense(lop).data)
@test lop'*dop ≈ Operator(lop.basis_r, dop.basis_r, dense(lop).data'*dop.data)
## adjoint from the right
lop = LazyTensor(b1a⊗b1b, b2a⊗b2b, 1, SparseOperator(randoperator(b1a,b2a)))
dop = randoperator(b3a⊗b3b, b2a⊗b2b)
@test dop*lop' ≈ Operator(dop.basis_l, lop.basis_l, dop.data*dense(lop).data')
@test lop*dop' ≈ Operator(lop.basis_l, dop.basis_l, dense(lop).data*dop.data')

# Dimension mismatches for LazyTensor with sparse
b1, b2 = NLevelBasis.((2, 3))
Lop1 = LazyTensor(b1^2, b2^2, 2, sparse(randoperator(b1, b2)))
@test_throws DimensionMismatch Lop1*Lop1
@test_throws DimensionMismatch dense(Lop1)*Lop1
@test_throws DimensionMismatch sparse(Lop1)*Lop1
@test_throws DimensionMismatch Lop1*dense(Lop1)
@test_throws DimensionMismatch Lop1*sparse(Lop1)

end # testset

@testset "LazyTensor: explicit isometries" begin

D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x1::StateVector, x2::StateVector) = norm(x2-x1)

# Test explicit identities and isometries
bl = FockBasis(2) ⊗ GenericBasis(2) ⊗ SpinBasis(1//2) ⊗ GenericBasis(1) ⊗ GenericBasis(2)
br = FockBasis(2) ⊗ GenericBasis(2) ⊗ SpinBasis(1//2) ⊗ GenericBasis(2) ⊗ GenericBasis(1)

iso = identityoperator(bl.bases[5], br.bases[5])

n1 = LazyTensor(bl, br, (1,3), (number(bl.bases[1]), sigmax(bl.bases[3])))
n1_sp = LazyTensor(bl, br, (1,2,3,5), (number(bl.bases[1]), identityoperator(bl.bases[2]), sigmax(bl.bases[3]), iso))
n1_de = LazyTensor(bl, br, (1,2,3,5), (dense(number(bl.bases[1])), identityoperator(bl.bases[2]), sigmax(bl.bases[3]), iso))

@test dense(n1) == dense(n1_sp)
@test dense(n1) == dense(n1_de)

for _mod_state in (identity, sparse)
    state = _mod_state(randoperator(br,br))
    @test 1e-12 > D(n1 * state, n1_sp * state)
    @test 1e-12 > D(n1 * state, n1_de * state)

    out = _mod_state(randoperator(bl,br))
    alpha = randn()
    beta = randn()
    out_ref = mul!(copy(out), n1, state, alpha, beta)
    @test 1e-12 > D(out_ref, mul!(copy(out), n1_sp, state, alpha, beta))
    @test 1e-12 > D(out_ref, mul!(copy(out), n1_de, state, alpha, beta))

    out_NaN = NaN * out 
    out_ref = mul!(copy(out_NaN), n1, state, alpha, 0)
    @test 1e-12 > D(out_ref, mul!(copy(out_NaN), n1_sp, state, alpha, 0))
    @test 1e-12 > D(out_ref, mul!(copy(out_NaN), n1_de, state, alpha, 0))

    out_ref = mul!(copy(out), n1, state, 0, beta)
    @test 1e-12 > D(out_ref, mul!(copy(out), n1_sp, state, 0, beta))
    @test 1e-12 > D(out_ref, mul!(copy(out), n1_de, state, 0, beta))

    out_NaN = NaN * out 
    out_ref = mul!(copy(out_NaN), n1, state, 0, 0)
    @test 1e-12 > D(out_ref, mul!(copy(out_NaN), n1_sp, state, 0, 0))
    @test 1e-12 > D(out_ref, mul!(copy(out_NaN), n1_de, state, 0, 0))

    state = _mod_state(randoperator(bl,bl))
    out_ref = mul!(copy(out), state, n1, alpha, beta)
    @test 1e-12 > D(out_ref, mul!(copy(out), state, n1_sp, alpha, beta))
    @test 1e-12 > D(out_ref, mul!(copy(out), state, n1_de, alpha, beta))
end

end

@testset "LazyTensor: ops with adjoints" begin

bM = reduce(tensor, (GenericBasis(i) for i in 2:4))

bL = GenericBasis(2)
bR = GenericBasis(3)

ltM = LazyTensor(bM, 2, randoperator(bM.bases[2]))

V_ML = dense(identityoperator(bM, bL))
V_LM = copy(V_ML')
V_RM = dense(identityoperator(bR, bM))
V_MR = copy(V_RM')

out1 = V_LM * ltM
out2 = V_ML' * ltM
@test out1 == out2

out1 = ltM * V_MR
out2 = ltM * V_RM'
@test out1 == out2

out_adj = adjoint(copy(adjoint(out1)))
mul!(out_adj, ltM, V_MR)
@test out_adj == out1

end
end

import Base: isequal, ==, *, /, +, -
import Adapt

"""
    LazyProduct(operators[, factor=1])
    LazyProduct(op1, op2...)

Lazy evaluation of products of operators.

The factors of the product are stored in the `operators` field. Additionally a
complex factor is stored in the `factor` field which allows for fast
multiplication with numbers.
"""
mutable struct LazyProduct{BL,BR,F,T,KTL,BTR} <: LazyOperator{BL,BR}
    basis_l::BL
    basis_r::BR
    factor::F
    operators::T
    ket_l::KTL
    bra_r::BTR
    function LazyProduct{BL,BR,F,T,KTL,BTR}(operators::T, ket_l::KTL, bra_r::BTR, factor::F=1) where {BL,BR,F,T,KTL,BTR}
        for i = 2:length(operators)
            check_multiplicable(operators[i-1], operators[i])
        end
        new(operators[1].basis_l, operators[end].basis_r, factor, operators,ket_l,bra_r)
    end
end
function LazyProduct(operators::T, factor::F=1) where {T,F}
    BL = typeof(operators[1].basis_l)
    BR = typeof(operators[end].basis_r)
    ket_l=Tuple(Ket(operators[i].basis_l) for i in 2:length(operators))
    bra_r=Tuple(Bra(operators[i].basis_r) for i in 1:length(operators)-1)
    KTL = typeof(ket_l)
    BTR = typeof(bra_r)
    LazyProduct{BL,BR,F,T,KTL,BTR}(operators, ket_l, bra_r, factor)
end




LazyProduct(operators::Vector{T}, factor=1) where T<:AbstractOperator = LazyProduct((operators...,), factor)
LazyProduct(operators::AbstractOperator...) = LazyProduct((operators...,))
LazyProduct() = throw(ArgumentError("LazyProduct needs at least one operator!"))

Base.copy(x::T) where T<:LazyProduct = T(([copy(op) for op in x.operators]...,),x.ket_l,x.bra_r, x.factor)
Base.eltype(x::LazyProduct) = promote_type(eltype(x.factor), eltype.(x.operators)...)

dense(op::LazyProduct) = op.factor*prod(dense.(op.operators))
dense(op::LazyProduct{B1,B2,F,T}) where {B1,B2,F,T<:Tuple{AbstractOperator}} = op.factor*dense(op.operators[1])
SparseArrays.sparse(op::LazyProduct) = op.factor*prod(sparse.(op.operators))
SparseArrays.sparse(op::LazyProduct{B1,B2,F,T}) where {B1,B2,F,T<:Tuple{AbstractOperator}} = op.factor*sparse(op.operators[1])

isequal(x::LazyProduct{B1,B2}, y::LazyProduct{B1,B2}) where {B1,B2} = (samebases(x,y) && isequal(x.operators, y.operators) && isequal(x.factor, y.factor))
==(x::LazyProduct{B1,B2}, y::LazyProduct{B1,B2}) where {B1,B2} = (samebases(x,y) && x.operators==y.operators && x.factor == y.factor)

# Arithmetic operations
-(a::T) where T<:LazyProduct = T(a.operators,a.ket_l,a.bra_r, -a.factor)

*(a::LazyProduct{B1,B2}, b::LazyProduct{B2,B3}) where {B1,B2,B3} = LazyProduct((a.operators..., b.operators...), a.factor*b.factor)
*(a::LazyProduct, b::Number) = LazyProduct(a.operators, a.factor*b)
*(a::Number, b::LazyProduct) = LazyProduct(b.operators, a*b.factor)

/(a::LazyProduct, b::Number) = LazyProduct(a.operators, a.factor/b)


dagger(op::LazyProduct) = LazyProduct(dagger.(reverse(op.operators)), conj(op.factor))

tr(op::LazyProduct) = throw(ArgumentError("Trace of LazyProduct is not defined. Try to convert to another operator type first with e.g. dense() or sparse()."))

ptrace(op::LazyProduct, indices) = throw(ArgumentError("Partial trace of LazyProduct is not defined. Try to convert to another operator type first with e.g. dense() or sparse()."))

permutesystems(op::LazyProduct, perm::Vector{Int}) = LazyProduct(([permutesystems(op_i, perm) for op_i in op.operators]...,), op.factor)

identityoperator(::Type{LazyProduct}, ::Type{S}, b1::Basis, b2::Basis) where S<:Number = LazyProduct(identityoperator(S, b1, b2))



function tensor(a::Operator{B1,B2},b::LazyProduct{B3, B4, F, T, KTL, BTR}) where {B1,B2,B3,B4, F, T, KTL, BTR}
    ops = ([(i == 1 ? a : identityoperator(a.basis_r) ) ⊗ op for (i,op) in enumerate(b.operators)]...,)
    LazyProduct(ops,b.factor)
end
function tensor(a::LazyProduct{B1, B2, F, T, KTL, BTR},b::Operator{B3,B4}) where {B1,B2,B3,B4, F, T, KTL, BTR}
    ops = ([op ⊗ (i == length(a.operators) ? b : identityoperator(a.basis_l) ) for (i,op) in enumerate(a.operators)]...,)
    LazyProduct(ops,a.factor)
end

function mul!(result::Ket{B1},a::LazyProduct{B1,B2},b::Ket{B2},alpha,beta) where {B1,B2}
    iszero(alpha) && (_zero_op_mul!(result.data, beta); return result)
    if length(a.operators)==1
        mul!(result,a.operators[1],b,a.factor*alpha,beta)
    else
        mul!(a.ket_l[end],a.operators[end],b,a.factor,0)
        for i=length(a.operators)-2:-1:1
            mul!(a.ket_l[i],a.operators[i+1],a.ket_l[i+1])
        end
        mul!(result,a.operators[1],a.ket_l[1],alpha,beta)
    end
    return result
end

function mul!(result::Bra{B2},a::Bra{B1},b::LazyProduct{B1,B2},alpha,beta) where {B1,B2}
    iszero(alpha) && (_zero_op_mul!(result.data, beta); return result)
    if length(b.operators)==1
        mul!(result, a, b.operators[1],b.factor*alpha,beta)
    else
        mul!(b.bra_r[1], a, b.operators[1], b.factor,0)
        for i=2:length(b.operators)-1
            mul!(b.bra_r[i],b.bra_r[i-1],b.operators[i])
        end
        mul!(result,b.bra_r[end],b.operators[end],alpha,beta)
    end
    return result
end

function mul!(result::Operator{B1,B3,T},a::LazyProduct{B1,B2},b::Operator{B2,B3},alpha,beta) where {B1,B2,B3,T}
    iszero(alpha) && (_zero_op_mul!(result.data, beta); return result)
    if length(a.operators) == 1
        mul!(result,a.operators[1],b,a.factor*alpha,beta)
    else
        tmp1 = Operator(a.operators[end].basis_l,b.basis_r,similar(result.data,length(a.operators[end].basis_l),length(b.basis_r)))
        mul!(tmp1,a.operators[end],b,a.factor,0)
        for i=length(a.operators)-1:-1:2
            tmp2 = Operator(a.operators[i].basis_l, b.basis_r, similar(result.data,length(a.operators[i].basis_l),length(b.basis_r)))
            mul!(tmp2,a.operators[i],tmp1)
            tmp1 = tmp2
        end
        mul!(result,a.operators[1],tmp1,alpha,beta)
    end
    return result
end

function mul!(result::Operator{B1,B3,T},a::Operator{B1,B2},b::LazyProduct{B2,B3},alpha,beta) where {B1,B2,B3,T}
    iszero(alpha) && (_zero_op_mul!(result.data, beta); return result)
    if length(b.operators) == 1
        mul!(result, a, b.operators[1],b.factor*alpha,beta)
    else
        tmp1 = Operator(a.basis_l,b.operators[1].basis_r,similar(result.data,length(a.basis_l),length(b.operators[1].basis_r)))
        mul!(tmp1,a,b.operators[1],b.factor,0)
        for i=2:length(b.operators)-1
            tmp2 = Operator(a.basis_l,b.operators[i].basis_r,similar(result.data,length(a.basis_l),length(b.operators[i].basis_r)))
            mul!(tmp2,tmp1,b.operators[i])
            tmp1 = tmp2
        end
        mul!(result,tmp1,b.operators[end],alpha,beta)
    end
    return result
end

# GPU adaptation  
Adapt.adapt_structure(to, x::LazyProduct) = LazyProduct([Adapt.adapt(to, op) for op in x.operators], x.factor)

struct SortedVector{T, OT} <: AbstractVector{T}
    sortedvector::Vector{T}
    order::OT
    function SortedVector(occ::AbstractVector{T}, order::OT=Base.Order.Forward) where {T, OT}
        if issorted(occ, order=order)
            new{T, OT}(occ, order)
        else
            new{T, OT}(sort(occ, order=order), order)
        end
    end
end
Base.:(==)(sv1::SortedVector, sv2::SortedVector) = sv1.sortedvector == sv2.sortedvector
Base.size(sv::SortedVector) = (length(sv.sortedvector),)
Base.@propagate_inbounds function Base.getindex(sv::SortedVector, i::Int)
    @boundscheck !checkbounds(Bool, sv.sortedvector, i) && throw(BoundsError(sv, i))
    return sv.sortedvector[i]
end
Base.union(sv1::SortedVector{T}, svs::SortedVector{T}...) where {T} =
    SortedVector(union(sv1.sortedvector, (occ.sortedvector for occ in svs)...), sv1.order)

# Special methods for fast operator construction
function state_index(sv::SortedVector{T}, occ::T) where {T}
    ret = searchsortedfirst(sv.sortedvector, occ, order = sv.order)
    ret == length(sv) + 1 && return nothing
    return sv.sortedvector[ret] == occ ? ret : nothing
end
state_index(occupations::AbstractVector{T}, occ::T) where {T} = findfirst(==(occ), occupations)
state_index(occupations::AbstractVector{T}, occ::Base.RefValue{T}) where {T} = state_index(occupations, occ[])
state_index(occupations::AbstractVector{T}, occ::Any) where {T} = state_index(occupations, convert(T, occ))

"""
    ManyBodyBasis(b, occupations)

Basis for a many body system.

The basis has to know the associated one-body basis `b` and which occupation states
should be included. The occupations_hash is used to speed up checking if two
many-body bases are equal.
"""
struct ManyBodyBasis{B,O,UT} <: Basis
    shape::Int
    onebodybasis::B
    occupations::O
    occupations_hash::UT
    function ManyBodyBasis{B,O}(onebodybasis::B, occupations::O) where {B,O<:AbstractVector}
        h = hash(hash.(occupations))
        new{B,O,typeof(h)}(length(occupations), onebodybasis, occupations, h)
    end
end
ManyBodyBasis(onebodybasis::B, occupations::O) where {B,O} = ManyBodyBasis{B,O}(onebodybasis, occupations)
ManyBodyBasis(onebodybasis::B, occupations::Vector{T}) where {B,T} = ManyBodyBasis(onebodybasis, SortedVector(occupations))

allocate_buffer(occ) = similar(occ)
allocate_buffer(mb::ManyBodyBasis) = allocate_buffer(first(mb.occupations))

"""
    fermionstates([T, ]Nmodes, Nparticles)
    fermionstates([T, ]b, Nparticles)

Generate all fermionic occupation states for N-particles in M-modes.
`Nparticles` can be a vector to define a Hilbert space with variable
particle number. `T` is the type of the occupation states - default is
`OccupationNumbers{FermionStatistics,Int}`, but can be any occupations type.
"""
function fermionstates(T::Type, Nmodes::Int, Nparticles::Int)
    occ_buffer = zero(similar(T, Nmodes))
    OT = typeof(occ_buffer)
    SortedVector(_distribute_fermions(Nparticles, Nmodes, 1, occ_buffer, OT[]), Base.Reverse)
end
fermionstates(T::Type, Nmodes::Int, Nparticles::Vector{Int}) = union((fermionstates(T, Nmodes, N) for N in Nparticles)...)
fermionstates(T::Type, onebodybasis::Basis, Nparticles) = fermionstates(T, length(onebodybasis), Nparticles)
fermionstates(arg1, arg2) = fermionstates(OccupationNumbers{FermionStatistics,Int}, arg1, arg2)

"""
    bosonstates([T, ]Nmodes, Nparticles)
    bosonstates([T, ]b, Nparticles)

Generate all bosonic occupation states for N-particles in M-modes.
`Nparticles` can be a vector to define a Hilbert space with variable
particle number. `T` is the type of the occupation states - default is
`OccupationNumbers{BosonStatistics,Int}`, but can be any occupations type.
"""
function bosonstates(T::Type, Nmodes::Int, Nparticles::Int)
    occ_buffer = zero(similar(T, Nmodes))
    OT = typeof(occ_buffer)
    SortedVector(_distribute_bosons(Nparticles, Nmodes, 1, occ_buffer, OT[]), Base.Reverse)
end
bosonstates(T::Type, Nmodes::Int, Nparticles::Vector{Int}) = union((bosonstates(T, Nmodes, N) for N in Nparticles)...)
bosonstates(T::Type, onebodybasis::Basis, Nparticles) = bosonstates(T, length(onebodybasis), Nparticles)
bosonstates(arg1, arg2) = bosonstates(OccupationNumbers{BosonStatistics,Int}, arg1, arg2)

==(b1::ManyBodyBasis, b2::ManyBodyBasis) = b1.occupations_hash == b2.occupations_hash && b1.onebodybasis == b2.onebodybasis

"""
    basisstate([T=ComplexF64,] mb::ManyBodyBasis, occupation::Vector)

Return a ket state where the system is in the state specified by the given
occupation numbers.
"""
function basisstate(::Type{T}, mb::ManyBodyBasis, occupation::Vector) where {T}
    index = state_index(mb.occupations, occupation)
    if isa(index, Nothing)
        throw(ArgumentError("Occupation not included in many-body basis."))
    end
    basisstate(T, mb, index)
end

"""
    create([T=ComplexF64,] mb::ManyBodyBasis, index)

Creation operator for the i-th mode of the many-body basis `b`.
"""
create(::Type{T}, mb::ManyBodyBasis, index) where {T} = transition(T, mb, index, ())
create(mb::ManyBodyBasis, index) = create(ComplexF64, mb, index)

"""
    destroy([T=ComplexF64,] mb::ManyBodyBasis, index)

Annihilation operator for the i-th mode of the many-body basis `b`.
"""
destroy(::Type{T}, mb::ManyBodyBasis, index) where {T} = transition(T, mb, (), index)
destroy(mb::ManyBodyBasis, index) = destroy(ComplexF64, mb, index)

"""
    number([T=ComplexF64,] mb::ManyBodyBasis, index)

Particle number operator for the i-th mode of the many-body basis `b`.
"""
function number(::Type{T}, mb::ManyBodyBasis, index) where {T}
    diagonaloperator(mb, T[occ[index] for occ in mb.occupations])
end
number(mb::ManyBodyBasis, index) = number(ComplexF64, mb, index)

"""
    number([T=ComplexF64,] mb::ManyBodyBasis)

Total particle number operator.
"""
function number(::Type{T}, mb::ManyBodyBasis) where {T}
    diagonaloperator(mb, T[sum(occ) for occ in mb.occupations])
end
number(mb::ManyBodyBasis) = number(ComplexF64, mb)

"""
    transition([T=ComplexF64,] mb::ManyBodyBasis, to, from)

Operator ``|\\mathrm{to}⟩⟨\\mathrm{from}|`` transferring particles between modes.

Note that `to` and `from` can be collections of indices. The resulting operator in this case
will be equal to ``\\ldots a^\\dagger_{to_2} a^\\dagger_{to_1} \\ldots a_{from_2} a_{from_1}``.
"""
function transition(::Type{T}, mb::ManyBodyBasis, to, from) where {T}
    Is = Int[]
    Js = Int[]
    Vs = T[]
    buffer = allocate_buffer(mb)
    # <{m}_j| at_to a_from |{m}_i>
    for (i, occ) in enumerate(mb.occupations)
        C = state_transition!(buffer, occ, to, from)
        C === nothing && continue
        j = state_index(mb.occupations, buffer)
        j === nothing && continue
        push!(Is, j)
        push!(Js, i)
        push!(Vs, C)
    end
    return SparseOperator(mb, sparse(Is, Js, Vs, length(mb), length(mb)))
end
transition(mb::ManyBodyBasis, to, from) = transition(ComplexF64, mb, to, from)

# Calculate many-Body operator from one-body operator
"""
    manybodyoperator(mb::ManyBodyBasis, op)

Create the many-body operator from the given one-body operator `op`.

The given operator can either be a one-body operator or a
two-body interaction. Higher order interactions are at the
moment not implemented.

The mathematical formalism for the one-body case is described by

```math
X = \\sum_{ij} a_i^† a_j ⟨u_i| x | u_j⟩
```

and for the interaction case by

```math
X = \\sum_{ijkl} a_i^† a_j^† a_k a_l ⟨u_i|⟨u_j| x |u_k⟩|u_l⟩
```

where ``X`` is the N-particle operator, ``x`` is the one-body operator and
``|u⟩`` are the one-body states associated to the
different modes of the N-particle basis.
"""
function manybodyoperator(mb::ManyBodyBasis, op)
    @assert op.basis_l == op.basis_r
    if op.basis_l == mb.onebodybasis
        result = manybodyoperator_1(mb, op)
    elseif op.basis_l == mb.onebodybasis ⊗ mb.onebodybasis
        result = manybodyoperator_2(mb, op)
    else
        throw(ArgumentError("The basis of the given operator has to either be equal to b or b ⊗ b where b is the 1st quantization basis associated to the nparticle basis."))
    end
    result
end

function manybodyoperator_1(mb::ManyBodyBasis, op::Operator)
    S = length(mb.onebodybasis)
    result = DenseOperator(mb)
    buffer = allocate_buffer(mb)
    @inbounds for j = 1:S, i = 1:S
        value = op.data[i, j]
        iszero(value) && continue
        for (m, occ) in enumerate(mb.occupations)
            C = state_transition!(buffer, occ, j, i)
            C === nothing && continue
            n = state_index(mb.occupations, buffer)
            n === nothing && continue
            result.data[m, n] += C * value
        end
    end
    return result
end
manybodyoperator_1(mb::ManyBodyBasis, op::AdjointOperator) = dagger(manybodyoperator_1(mb, dagger(op)))

function manybodyoperator_1(mb::ManyBodyBasis, op::SparseOpPureType)
    N = length(mb)
    Is = Int[]
    Js = Int[]
    Vs = ComplexF64[]
    buffer = allocate_buffer(mb)
    @inbounds for (row, column, value) in zip(findnz(op.data)...)
        for (m, occ) in enumerate(mb.occupations)
            C = state_transition!(buffer, occ, column, row)
            C === nothing && continue
            n = state_index(mb.occupations, buffer)
            n === nothing && continue
            push!(Is, m)
            push!(Js, n)
            push!(Vs, C * value)
        end
    end
    return SparseOperator(mb, sparse(Is, Js, Vs, N, N))
end

function manybodyoperator_2(mb::ManyBodyBasis, op::Operator)
    S = length(mb.onebodybasis)
    result = DenseOperator(mb)
    op_data = reshape(op.data, S, S, S, S)
    buffer = allocate_buffer(mb)
    @inbounds for l = 1:S, k = 1:S, j = 1:S, i = 1:S
        value = op_data[i, j, k, l]
        iszero(value) && continue
        for (m, occ) in enumerate(mb.occupations)
            C = state_transition!(buffer, occ, (k, l), (i, j))
            C === nothing && continue
            n = state_index(mb.occupations, buffer)
            n === nothing && continue
            result.data[m, n] += C * value
        end
    end
    return result
end

function manybodyoperator_2(mb::ManyBodyBasis, op::SparseOpAdjType)
    throw(ArgumentError("`manybodyoperator_2` is not implemented for adjoint operators yet, convert your operator to not contain adjoints of matrices by collecting."))
end

function manybodyoperator_2(mb::ManyBodyBasis, op::SparseOpPureType)
    N = length(mb)
    S = length(mb.onebodybasis)
    Is = Int[]
    Js = Int[]
    Vs = ComplexF64[]
    buffer = allocate_buffer(mb)
    @inbounds for (row, column, value) in zip(findnz(op.data)...)
        for (m, occ) in enumerate(mb.occupations)
            index = Tuple(CartesianIndices((S, S, S, S))[(column-1)*S^2+row])
            C = state_transition!(buffer, occ, index[3:4], index[1:2])
            C === nothing && continue
            n = state_index(mb.occupations, buffer)
            n === nothing && continue
            push!(Is, m)
            push!(Js, n)
            push!(Vs, C * value)
        end
    end
    return SparseOperator(mb, sparse(Is, Js, Vs, N, N))
end


# Calculate expectation value of one-body operator
"""
    onebodyexpect(op, state)

Expectation value of the one-body operator `op` in respect to the many-body `state`.
"""
function onebodyexpect(op::AbstractOperator, state::Union{Ket,AbstractOperator})
    bas = basis(state)
    @assert bas isa ManyBodyBasis
    @assert op.basis_l == op.basis_r
    if bas.onebodybasis == op.basis_l
        return onebodyexpect_1(op, state)
    elseif bas.onebodybasis ⊗ bas.onebodybasis == op.basis_l
        # Not yet implemented
        throw(ArgumentError("`onebodyexpect` is not implemented for two-body states yet"))
    else
        throw(ArgumentError("The basis of the given operator has to either be equal to b or b ⊗ b where b is the 1st quantization basis associated to the nparticle basis of the state."))
    end
end

onebodyexpect(op::AbstractOperator, states::Vector) = [onebodyexpect(op, state) for state = states]

matrix_element(state::Ket, m, n) = conj(state.data[m]) * state.data[n]
matrix_element(state::Operator, m, n) = state.data[n, m]
function onebodyexpect_1(op::Operator, state)
    mb = basis(state)
    occupations = mb.occupations
    S = length(mb.onebodybasis)
    buffer = allocate_buffer(mb)
    result = complex(0.0)
    for i = 1:S, j = 1:S
        value = op.data[i, j]
        iszero(value) && continue
        for (m, occ) in enumerate(occupations)
            C = state_transition!(buffer, occ, j, i)
            C === nothing && continue
            n = state_index(occupations, buffer)
            n === nothing && continue
            result += C * value * matrix_element(state, m, n)
        end
    end
    result
end

function onebodyexpect_1(op::SparseOpPureType, state)
    mb = basis(state)
    occupations = mb.occupations
    buffer = allocate_buffer(mb)
    result = complex(0.0)
    @inbounds for (row, column, value) in zip(findnz(op.data)...)
        for (m, occ) in enumerate(occupations)
            C = state_transition!(buffer, occ, column, row)
            C === nothing && continue
            n = state_index(occupations, buffer)
            n === nothing && continue
            result += C * value * matrix_element(state, m, n)
        end
    end
    result
end

# Occupations as Vector{Int}
struct OccupationNumbers{StatisticsT,T} <: AbstractVector{T}
    statistics::StatisticsT
    occupations::Vector{T}
end
Base.size(on::OccupationNumbers) = size(on.occupations)
Base.@propagate_inbounds Base.getindex(on::OccupationNumbers, v...) = getindex(on.occupations, v...)
Base.@propagate_inbounds Base.setindex!(on::OccupationNumbers, value, v...) =
    setindex!(on.occupations, value, v...)
Base.IndexStyle(::Type{<:OccupationNumbers}) = Base.IndexLinear()
Base.similar(occ::OccupationNumbers, ::Type{T}, dims::Dims) where {T} =
    OccupationNumbers(occ.statistics, similar(occ.occupations, T, dims))
Base.similar(::Type{OccupationNumbers{StatisticsT,T}}, dims::Dims) where {StatisticsT,T} =
    OccupationNumbers(StatisticsT(), similar(Vector{T}, dims))
Base.isless(occ1::OccupationNumbers, occ2::OccupationNumbers) = occ1.occupations < occ2.occupations
Base.copyto!(dest::OccupationNumbers, src::OccupationNumbers) = copyto!(dest.occupations, src.occupations)
Base.convert(::Type{OccupationNumbers{StatisticsT,T}}, occ::AbstractVector) where {StatisticsT,T} =
    OccupationNumbers(StatisticsT(), convert(Vector{T}, occ))

struct FermionStatistics end
struct BosonStatistics end

Base.@propagate_inbounds function state_transition!(buffer, occ::OccupationNumbers{BosonStatistics},
        at_indices, a_indices)
    any(==(0), (occ[m] for m in a_indices)) && return nothing
    factor_sq = 1
    copyto!(buffer, occ)
    for i in a_indices
        factor_sq *= buffer[i]
        factor_sq == 0 && return nothing
        buffer[i] -= 1
    end
    for i in at_indices
        buffer[i] += 1
        factor_sq *= buffer[i]
    end
    return √factor_sq
end

Base.@propagate_inbounds function state_transition!(buffer, occ::OccupationNumbers{FermionStatistics},
        at_indices, a_indices)
    any(==(0), (occ[m] for m in a_indices)) && return nothing
    factor = 1
    copyto!(buffer, occ)
    for i in a_indices
        buffer[i] == 0 && return nothing
        buffer[i] = 0
        ncomm = count(==(1), @view buffer[1:i-1])
        isodd(ncomm) && (factor *= -1)
    end
    for i in at_indices
        buffer[i] == 1 && return nothing
        buffer[i] = 1
        ncomm = count(==(1), @view buffer[1:i-1])
        isodd(ncomm) && (factor *= -1)
    end
    return factor
end

"""
    FermionBitstring{T}

Bitstring representation of a fermionic occupation state.

---

    FermionBitstring(bits, n)
"""
struct FermionBitstring{T}
    bits::T
    n::Int
    function FermionBitstring{T}(bits, n::Integer) where {T}
        T<:Unsigned && n > sizeof(T) * 8 &&
            throw(ArgumentError("n must be less than $(sizeof(T) * 8)"))
        mask = T(1) << n - 1
        new{T}(bits & mask, Int(n))
    end
end
function FermionBitstring(bits::T, n::Integer) where T
    FermionBitstring{T}(bits, n)
end

Base.zero(fb::FermionBitstring) = FermionBitstring(zero(fb.bits), fb.n)
Base.length(fb::FermionBitstring) = fb.n
Base.similar(::Type{FermionBitstring{T}}, n::Int) where {T} = FermionBitstring(zero(T), n)
function Base.similar(::Type{FermionBitstring}, n::Int)
    for type in (UInt8, UInt16, UInt32, UInt64, UInt128)
        n ≤ sizeof(type) * 8 && return FermionBitstring(zero(type), n)
    end
    throw(ArgumentError("n must be less than 128; got $n"))
end
function Base.convert(::Type{T}, v::AbstractVector) where {T<:FermionBitstring}
    new_v = similar(T, length(v))
    for i in 1:length(new_v)
        new_v = Base.setindex(new_v, Bool(v[i]), i)
    end
    return new_v
end
Base.copy(fb::FermionBitstring) = fb
allocate_buffer(fb::FermionBitstring) = Ref(fb)
@inline Base.:(==)(fb1::FermionBitstring, fb2::FermionBitstring) =
    fb1.bits == fb2.bits && fb1.n == fb2.n
@inline Base.isless(fb1::FermionBitstring, fb2::FermionBitstring) =
    fb1.bits < fb2.bits || fb1.bits == fb2.bits && fb1.n < fb2.n
Base.show(io::IO, fb::FermionBitstring{T}) where {T} =
    print(io, "FermionBitstring{$T}(0b", bitstring(fb.bits)[end-fb.n+1:end], ", ", fb.n, ")")

Base.@propagate_inbounds function Base.getindex(fb::FermionBitstring, i::Int)
    @boundscheck i in 1:fb.n || throw(BoundsError(fb, i))
    Bool((fb.bits >>> (fb.n - i)) & 1)
end
Base.@propagate_inbounds function Base.setindex(fb::FermionBitstring, value::Bool, i::Int)
    @boundscheck i in 1:fb.n || throw(BoundsError(fb, i))
    offset = fb.n - i
    value ? FermionBitstring(fb.bits | (one(fb.bits) << offset), fb.n) :
            FermionBitstring(fb.bits & ~(one(fb.bits) << offset), fb.n)
end
Base.@propagate_inbounds function state_transition!(buffer, occ::FermionBitstring, at_indices, a_indices)
    factor = 1
    for i in a_indices
        occ[i] || return nothing
        occ = setocc(occ, i, false)
        ncomm = count_ones(occ.bits >>> (occ.n - i + 1))
        isodd(ncomm) && (factor *= -1)
    end
    for i in at_indices
        occ[i] && return nothing
        occ = setocc(occ, i, true)
        ncomm = count_ones(occ.bits >>> (occ.n - i + 1))
        isodd(ncomm) && (factor *= -1)
    end
    buffer[] = occ
    return factor
end

Base.@propagate_inbounds setocc(fb::FermionBitstring, i::Int, value) = Base.setindex(fb, value, i)
Base.@propagate_inbounds function setocc(v::AbstractVector, i::Int, value)
    setindex!(v, value, i)
    return v
end
function _distribute_bosons(Nparticles, Nmodes, index, occupations, results)
    if index == Nmodes
        occupations = setocc(occupations, index, Nparticles)
        push!(results, copy(occupations))
    else
        for n = Nparticles:-1:0
            occupations = setocc(occupations, index, n)
            _distribute_bosons(Nparticles - n, Nmodes, index + 1, occupations, results)
        end
    end
    return results
end
function _distribute_fermions(Nparticles, Nmodes, index, occupations, results)
    if (Nmodes - index) + 1 < Nparticles
        return results
    end
    if Nparticles == 0
        push!(results, copy(occupations))
        return results
    end
    for new_index in index:Nmodes - Nparticles + 1
        occupations = setocc(occupations, new_index, true)
        _distribute_fermions(Nparticles - 1, Nmodes, new_index + 1, occupations, results)
        occupations = setocc(occupations, new_index, false)
    end
    return results
end

import QuantumInterface: NLevelBasis

"""
    transition([T=ComplexF64,] b::NLevelBasis, to::Integer, from::Integer)

Transition operator ``|\\mathrm{to}⟩⟨\\mathrm{from}|``.
"""
function transition(::Type{T}, b::NLevelBasis, to::Integer, from::Integer) where T
    if to < 1 || b.N < to
        throw(BoundsError("'to' index has to be between 1 and b.N"))
    end
    if from < 1 || b.N < from
        throw(BoundsError("'from' index has to be between 1 and b.N"))
    end
    op = SparseOperator(T, b)
    op.data[to, from] = 1.
    op
end
transition(b::NLevelBasis,to::Integer,from::Integer) = transition(ComplexF64,b,to,from)


"""
    nlevelstate([T=ComplexF64,] b::NLevelBasis, n::Integer)

State where the system is completely in the n-th level.
"""
function nlevelstate(::Type{T}, b::NLevelBasis, n::Integer) where T
    if n < 1 || b.N < n
        throw(BoundsError("n has to be between 1 and b.N"))
    end
    basisstate(T, b, n)
end
nlevelstate(b::NLevelBasis, n::Integer) = nlevelstate(ComplexF64, b, n)

"""
    paulix([T=ComplexF64,] b::NLevelBasis, pow=1)

Generalized Pauli ``X`` operator for the given `N` level system. This is also
called the shift matrix, and generalizes the qubit pauli matrices to qudits,
while preserving the operators being unitary. A different generalization is
given by the angular momentum operators which preserves the operators being
Hermitian and is implemented for the `SpinBasis` (see [`sigmax`](@ref)).

Powers of `paulix` together with [`pauliz`](@ref) form a complete, orthornormal
(under Hilbert–Schmidt norm) operator basis.

Returns `X^pow`.
"""
function paulix(::Type{T}, b::NLevelBasis, pow=1) where T
    N = length(b)
    SparseOperator(b, spdiagm(pow => fill(one(T), N-pow),
                              pow-N => fill(one(T), pow)))
end
paulix(b::NLevelBasis, pow=1) = paulix(ComplexF64, b, pow)

"""
    pauliz([T=ComplexF64,] b::NLevelBasis, pow=1)

Generalized Pauli ``Z`` operator for the given `N` level system. This is also
called the clock matrix, and generalizes the qubit pauli matrices to qudits,
while preserving the operators being unitary. A different generalization is
given by the angular momentum operators which preserves the operators being
Hermitian and is implemented for the `SpinBasis` (see [`sigmaz`](@ref)).

Powers of `pauliz` together with [`paulix`](@ref) form a complete, orthornormal
(under Hilbert–Schmidt norm) operator basis.

Returns `Z^pow`.
"""
function pauliz(::Type{T}, b::NLevelBasis, pow=1) where T
    N = length(b)
    ω = exp(2π*1im*pow/N)
    SparseOperator(b, spdiagm(0 => T[ω^n for n=1:N]))
end
pauliz(b::NLevelBasis, pow=1) = pauliz(ComplexF64, b, pow)

"""
    pauliy([T=ComplexF64,] b::NLevelBasis)

Generalized Pauli ``Y`` operator for the given `N` level system.

Returns `Y^pow = ω^pow X^pow Z^pow` where `ω = ω = exp(2π*1im*pow/N)` and
`N = length(b)` when odd or `N = 2*length(b)` when even. This is due to the
 order of the generalized Pauli group in even versus odd dimensions.

See [`paulix`](@ref) and [`pauliz`](@ref) for more details.
"""
function pauliy(::Type{T}, b::NLevelBasis, pow=1) where T
    N = length(b)
    N = N%2 == 0 ? 2N : N
    ω = exp(2π*1im*pow/N)
    exp(2π*1im*pow/N)*paulix(T,b,pow)*pauliz(T,b,pow)
end

pauliy(b::NLevelBasis, pow=1) = pauliy(ComplexF64,b)

@testitem "test_aqua" tags = [:aqua] begin
using Test
using QuantumOpticsBase
using Aqua
using FillArrays
using StatsBase

@testset "aqua" begin
    Aqua.test_all(QuantumOpticsBase;
                  ambiguities=(exclude=[FillArrays.reshape, # Due to https://github.com/JuliaArrays/FillArrays.jl/issues/105#issuecomment-1518406018
                                        StatsBase.TestStat, StatsBase.:(==) , StatsBase.sort!],),  # Due to https://github.com/JuliaStats/StatsBase.jl/issues/861
                  piracies=(broken=true,)
                  )
    # manual piracy check to exclude QuantumInterface functions that construct QuantumOpticsBase operators (as QOB.jl takes priority over other users of QuantumInterface)
    pirates = [pirate for pirate in Aqua.Piracy.hunt(QuantumOpticsBase) if pirate.name ∉ [:identityoperator,:identitysuperoperator, :position]]
    @test isempty(pirates)
end # testset
end

using PrecompileTools

@setup_workload let
    # Fock-space states and operators
    fock_basis = FockBasis(20)
    alpha = 1.2

    @compile_workload begin
        annihilation = destroy(fock_basis)
        state = coherentstate(fock_basis, alpha)
        density = dm(state)
        derivative = -1im * (annihilation + create(fock_basis)) * state

        amplitude = expect(annihilation, state)
        photon_number = expect(number(fock_basis), density)
        @assert isapprox(amplitude, alpha; atol=1e-10)
        @assert isapprox(photon_number, abs2(alpha); atol=1e-9)
        @assert isapprox(tr(density), 1; atol=1e-12)
        @assert isfinite(norm(derivative))
    end
end

@setup_workload let
    # Composite systems, embedding, and partial traces
    fock_basis = FockBasis(20)
    spin_basis = SpinBasis(1 // 2)

    @compile_workload begin
        raising = sigmap(spin_basis)
        lowering = sigmam(spin_basis)
        atom_hamiltonian = 2 * raising * lowering

        annihilation = destroy(fock_basis)
        field_hamiltonian = number(fock_basis)
        interaction = annihilation ⊗ raising + create(fock_basis) ⊗ lowering

        composite_basis = fock_basis ⊗ spin_basis
        hamiltonian =
            embed(composite_basis, 1, field_hamiltonian) +
            embed(composite_basis, 2, atom_hamiltonian) +
            interaction
        initial_state = fockstate(fock_basis, 1) ⊗ spindown(spin_basis)
        derivative = hamiltonian * initial_state
        reduced_field = ptrace(dm(initial_state), 2)

        @assert basis(derivative) == composite_basis
        @assert isapprox(tr(reduced_field), 1; atol=1e-12)
        @assert isfinite(norm(derivative))
    end
end

@setup_workload let
    # Entanglement metrics
    spin_basis = SpinBasis(1 // 2)

    @compile_workload begin
        up = spinup(spin_basis)
        down = spindown(spin_basis)
        state = (up ⊗ down - down ⊗ up) / sqrt(2)
        density = dm(state)
        reduced_spin = ptrace(density, 2)

        entropy = real(entropy_vn(reduced_spin))
        state_negativity = negativity(density, 1)
        self_fidelity = real(fidelity(reduced_spin, reduced_spin))
        @assert isapprox(tr(reduced_spin), 1; atol=1e-12)
        @assert isapprox(entropy, log(2); atol=1e-12)
        @assert isapprox(state_negativity, 0.5; atol=1e-12)
        @assert isapprox(self_fidelity, 1; atol=1e-12)
    end
end

@setup_workload let
    # Lindblad superoperators
    fock_basis = FockBasis(10)

    @compile_workload begin
        hamiltonian = number(fock_basis)
        jump = destroy(fock_basis)
        generator = liouvillian(hamiltonian, [jump])
        density = dm(coherentstate(fock_basis, 0.5))
        derivative = generator * density

        @assert isapprox(tr(derivative), 0; atol=1e-11)
        @assert isfinite(norm(derivative))
    end
end

@setup_workload let
    # Time-dependent operators
    spin_basis = SpinBasis(1 // 2)
    sample_time = 0.25

    @compile_workload begin
        sx = sigmax(spin_basis)
        sz = sigmaz(spin_basis)
        operator = TimeDependentSum((cos, sin), (sx, sz))
        set_time!(operator, sample_time)

        state = spinup(spin_basis)
        result = operator * state
        expected = (cos(sample_time) * sx + sin(sample_time) * sz) * state
        @assert current_time(operator) == sample_time
        @assert norm(result - expected) < 1e-12
    end
end

@setup_workload let
    # Bosonic many-body operators
    one_body_basis = NLevelBasis(2)

    @compile_workload begin
        many_body_basis = ManyBodyBasis(
            one_body_basis,
            bosonstates(one_body_basis, [0, 1, 2, 3]),
        )
        one_body_hamiltonian = diagonaloperator(one_body_basis, [0.0, 1.0])
        many_body_hamiltonian = manybodyoperator(
            many_body_basis,
            one_body_hamiltonian,
        )

        state = basisstate(many_body_basis, [1, 2])
        transferred = transition(many_body_basis, 1, 2) * state
        expected = 2 * basisstate(many_body_basis, [2, 1])
        energy = real(expect(many_body_hamiltonian, state))
        @assert isapprox(energy, 2; atol=1e-12)
        @assert norm(transferred - expected) < 1e-12
    end
end

# Generated from the cold-start scenarios on Julia 1.12.6 (x86_64-linux-gnu).
# Each raw trace was filtered with sortprecompile.py revision
# 4ea3c813d9a5adc494d84368e08825f5d765a0a6 using `-m 50.000001`.
# Timing comments preserve the largest observation for each exact statement.
# Recompilations and signatures tied to scenarios, value-specific FFT plans,
# generated names, compiler internals, or modules not bound in QuantumOpticsBase
# are excluded. These observations select statements; they are not benchmarks.

using PrecompileTools: @setup_workload

@setup_workload begin
    #=  106.9 ms =# precompile(Tuple{typeof(Base.:(*)), Array{Base.Complex{Float64}, 1}, LinearAlgebra.Adjoint{Base.Complex{Float64}, Array{Base.Complex{Float64}, 1}}})
    #=  105.5 ms =# precompile(Tuple{typeof(Base.:(*)), LinearAlgebra.Adjoint{Base.Complex{Float64}, SparseArrays.SparseMatrixCSC{Base.Complex{Float64}, Int64}}, Array{Base.Complex{Float64}, 2}, SparseArrays.SparseMatrixCSC{Base.Complex{Float64}, Int64}})
    #=   73.7 ms =# precompile(Tuple{typeof(Base.Broadcast.materialize), Base.Broadcast.Broadcasted{Base.Broadcast.DefaultArrayStyle{2}, Nothing, typeof(Base.real), Tuple{Array{Base.Complex{Float64}, 2}}}})
    #=   67.3 ms =# precompile(Tuple{typeof(Base.:(/)), Array{Base.Complex{Float64}, 2}, Float64})
    #=   58.6 ms =# precompile(Tuple{typeof(Base.:(/)), Array{Base.Complex{Float64}, 2}, Int64})
end

@testitem "Doctests" tags=[:doctests] begin
    using Documenter
    using QuantumOpticsBase
    using QuantumInterface

    DocMeta.setdocmeta!(QuantumOpticsBase, :DocTestSetup, :(using QuantumOpticsBase); recursive=true)
    modules = [QuantumOpticsBase, QuantumInterface]
    doctestfilters = [r"(QuantumOpticsBase\.|)"]
    doctest(nothing, modules;
            doctestfilters
            #fix=true
           )
    # TODO failures in VSCode related to https://github.com/julia-vscode/TestItemRunner.jl/issues/49
end

@testitem "test_metrics" begin
using Test
using QuantumOpticsBase
using SparseArrays, LinearAlgebra

@testset "metrics" begin

b1 = SpinBasis(1//2)
b2 = FockBasis(6)

psi1 = spinup(b1) ⊗ coherentstate(b2, 0.1)
psi2 = spindown(b1) ⊗ fockstate(b2, 2)

rho = tensor(psi1, dagger(psi1))
sigma = tensor(psi2, dagger(psi2))

# tracenorm
@test tracenorm(0*rho) ≈ 0.
@test tracenorm_h(0*rho) ≈ 0.
@test tracenorm_nh(0*rho) ≈ 0.

@test tracenorm(rho) ≈ 1.
@test tracenorm_h(rho) ≈ 1.
@test tracenorm_nh(rho) ≈ 1.

@test_throws ArgumentError tracenorm(sparse(rho))
@test_throws ArgumentError tracenorm_h(sparse(rho))
@test_throws ArgumentError tracenorm_nh(sparse(rho))

# tracedistance
@test tracedistance(rho, sigma) ≈ 1.
@test tracedistance_h(rho, sigma) ≈ 1.
@test tracedistance_nh(rho, sigma) ≈ 1.

@test tracedistance(rho, rho) ≈ 0.
@test tracedistance_h(rho, rho) ≈ 0.
@test tracedistance_nh(rho, rho) ≈ 0.

@test tracedistance(sigma, sigma) ≈ 0.
@test tracedistance_h(sigma, sigma) ≈ 0.
@test tracedistance_nh(sigma, sigma) ≈ 0.

@test_throws ArgumentError tracedistance(sparse(rho), sparse(rho))
@test_throws ArgumentError tracedistance_h(sparse(rho), sparse(rho))
@test_throws ArgumentError tracedistance_nh(sparse(rho), sparse(rho))

# tracedistance
@test tracedistance(rho, sigma) ≈ 1.
@test tracedistance(rho, rho) ≈ 0.
@test tracedistance(sigma, sigma) ≈ 0.

rho = spinup(b1) ⊗ dagger(coherentstate(b2, 0.1))
@test_throws ArgumentError tracedistance(rho, rho)
@test_throws ArgumentError tracedistance_h(rho, rho)

@test tracedistance_nh(rho, rho) ≈ 0.

# entropy_vn
rho_mix = dense(identityoperator(b1))/2.
@test entropy_vn(rho_mix)/log(2) ≈ 1
psi = coherentstate(FockBasis(20), 2.0)
@test isapprox(entropy_vn(psi), 0.0, atol=1e-8)

# entropy_renyi
rho_mix = dense(identityoperator(b1))/2.
@test entropy_renyi(rho_mix, 2)/log(2) ≈ 1
psi = coherentstate(FockBasis(20), 2.0)
@test isapprox(entropy_renyi(psi), 0.0, atol=1e-8)
@test_throws ArgumentError entropy_renyi(psi, 1)

# fidelity
rho = tensor(psi1, dagger(psi1))
@test fidelity(rho, rho) ≈ 1
@test 1e-20 > abs2(fidelity(rho, sigma))

# ptranspose
  
b1 = SpinBasis(1//2)
b2 = SpinBasis(1)
b3 = FockBasis(3)

# some tests for ptranspose only, on randomly generated tripartite operators 
# consisting of `nterm` linear combinations of simply seperable operators
nterm = 3
coefs = rand(nterm)
As = [DenseOperator(b1, rand(2,2)) for i = 1 : nterm]
Bs = [DenseOperator(b2, rand(3,3)) for i = 1 : nterm]
Cs = [DenseOperator(b3, rand(4,4)) for i = 1 : nterm]

rho = sum([coefs[i]*As[i]⊗Bs[i]⊗Cs[i] for i = 1 : nterm]);

@test ptranspose(rho,(1,3)) == sum([coefs[i]*transpose(As[i])⊗Bs[i]⊗transpose(Cs[i]) for i = 1 : nterm])
@test ptranspose(rho,[2]) == transpose(ptranspose(rho,[1,3]))
@test ptranspose(rho,1) == sum([coefs[i]*transpose(As[i])⊗Bs[i]⊗Cs[i] for i = 1 : nterm])
  
e = spinup(b1)
g = spindown(b1)
psi3 = (e ⊗ g - g ⊗ e)/sqrt(2)

rho = dm(psi3)  
rho_pT1 = ptranspose(rho, 1)
rho_pT1_an = 0.5*(dm(e ⊗ g) + dm(g ⊗ e) - (e ⊗ e) ⊗ dagger(g ⊗ g) - (g ⊗ g) ⊗ dagger(e ⊗ e))
rho_pT2 = ptranspose(rho, 2)
@test rho_pT1.data ≈ rho_pT1_an.data
@test rho_pT2.data ≈ rho_pT1_an.data
        
@test_throws MethodError ptranspose(e ⊗ dagger(psi1))
@test_throws MethodError ptranspose(dm(e))

rho = rho ⊗ dm(g)
@test PPT(rho, 1) == PPT(rho, 2) == false
@test PPT(rho, 3)

@test negativity(rho, 1) == negativity(rho, 2) ≈ 0.5
@test isapprox(negativity(rho, 3), 0.0, atol=1e-15)

@test logarithmic_negativity(rho, 1) == logarithmic_negativity(rho, 2) ≈ 1.0
@test isapprox(logarithmic_negativity(rho, 3), 0.0, atol=1e-15)

# Entanglement Entropy
b1 = SpinBasis(1//2)
psi = 1/sqrt(2)*(spinup(b1)⊗spindown(b1) + spindown(b1)⊗spinup(b1))
rho_ent = dm(psi)
rho_mix = DenseOperator(rho_ent.basis_l, diagm(ComplexF64[1.0,1.0,1.0,1.0]))
@test entanglement_entropy(rho_mix, 1) ≈ 0.0
@test entanglement_entropy(rho_ent, 1, entropy_vn) ≈ 2 * log(2)
@test entanglement_entropy(rho_ent, 1) ≈ 2 * entanglement_entropy(psi, 1)
@test_throws ArgumentError entanglement_entropy(rho_mix, (1,2))
@test_throws ArgumentError entanglement_entropy(rho_mix, 3)

CNOT = dm(spinup(b1))⊗identityoperator(b1) + dm(spindown(b1))⊗sigmax(b1)
CNOT_sop = SuperOperator(CNOT)
CNOT_chi = ChiMatrix(CNOT)
CNOT_ptm = PauliTransferMatrix(CNOT)

@test avg_gate_fidelity(CNOT_sop, CNOT_sop) == 1
@test avg_gate_fidelity(CNOT_chi, CNOT_chi) == 1
@test avg_gate_fidelity(CNOT_ptm, CNOT_ptm) == 1

@test_throws MethodError avg_gate_fidelity(CNOT_sop, CNOT_chi)
@test_throws MethodError avg_gate_fidelity(CNOT_sop, CNOT_ptm)
@test_throws MethodError avg_gate_fidelity(CNOT_chi, CNOT_ptm)

end # testset
end

# Test parameters
const test_sizes = [2, 4, 8]
const max_rows = 16
const round_count = 2
const block_sizes = fill(64, round_count)
const batch_sizes = fill(1, round_count)

# Helper function for distance comparison
D(op1::AbstractOperator, op2::AbstractOperator) = abs(tracedistance_nh(dense(op1), dense(op2)))
D(x1::StateVector, x2::StateVector) = norm(x2-x1)

# Test tolerances for GPU computations
const GPU_TOL = 1e-10

@testitem "test_pauli" begin
using LinearAlgebra
using Test

using QuantumOpticsBase

@testset "pauli" begin

b = SpinBasis(1//2)
# Test conversion of unitary matrices to superoperators.
q2 = b^2
q3 = b^3

@testset "Pauli multiplication helper" begin
    paulis = (
        ComplexF64[1 0; 0 1],
        ComplexF64[0 1; 1 0],
        ComplexF64[0 -im; im 0],
        ComplexF64[1 0; 0 -1],
    )
    for left in 0:3, right in 0:3
        product, phase = @inferred QuantumOpticsBase.multiply_pauli_matrices(
            string(left), string(right),
        )
        product_digit = xor(left, right)
        @test product == string(product_digit)
        @test phase * paulis[product_digit+1] == paulis[left+1] * paulis[right+1]
    end

    @test QuantumOpticsBase.multiply_pauli_matrices("010", "023") == ("033", 1im)
    @test QuantumOpticsBase.multiply_pauli_matirices("010", "023") == ("033", 1im)
    @test_throws ArgumentError QuantumOpticsBase.multiply_pauli_matrices("", "")
    @test_throws ArgumentError QuantumOpticsBase.multiply_pauli_matrices("0", "00")
    @test_throws ArgumentError QuantumOpticsBase.multiply_pauli_matrices("4", "0")
    @test_throws ArgumentError QuantumOpticsBase.multiply_pauli_matrices("0", "x")
end

@testset "Concurrent Chi-matrix composition" begin
    left_data = reshape(ComplexF64.(1:16), 4, 4)
    right_data = reshape(ComplexF64.(16:-1:1), 4, 4)
    left = DenseChiMatrix((b, b), (b, b), left_data)
    right = DenseChiMatrix((b, b), (b, b), right_data)
    left_before = copy(left.data)
    right_before = copy(right.data)
    num_compositions = max(8, 4 * min(Threads.nthreads(), 8))
    tasks = [Threads.@spawn(left * right) for _ in 1:num_compositions]
    results = fetch.(tasks)

    @test all(result -> result == first(results), results)
    @test left.data == left_before
    @test right.data == right_before
end

CZ = DenseOperator(q2, q2, diagm(0 => [1,1,1,-1]))
CZ_sop = SuperOperator(CZ)

# Test conversion of unitary matrices to superoperators.
@test diag(CZ_sop.data) ==  ComplexF64[1,1,1,-1,1,1,1,-1,1,1,1,-1,-1,-1,-1,1]
@test CZ_sop.basis_l == CZ_sop.basis_r == (q2, q2)

# Test conversion of superoperator to Pauli transfer matrix.
CZ_ptm = PauliTransferMatrix(CZ_sop)

# Test DensePauliTransferMatrix constructor.
@test_throws DimensionMismatch DensePauliTransferMatrix((q2, q2), (q3, q3), CZ_ptm.data)
@test DensePauliTransferMatrix((q2, q2), (q2, q2), CZ_ptm.data) == CZ_ptm

@test all(isapprox.(CZ_ptm.data[[1,30,47,52,72,91,117,140,166,185,205,210,227,256]], 1))
@test all(isapprox.(CZ_ptm.data[[106,151]], -1))

@test CZ_ptm == PauliTransferMatrix(ChiMatrix(CZ))

# Test construction of non-symmetric unitary.
CNOT = DenseOperator(q2, q2, diagm(0 => [1,1,0,0], 1 => [0,0,1], -1 => [0,0,1]))
CNOT_sop = SuperOperator(CNOT)
CNOT_chi = @inferred ChiMatrix(CNOT)
CNOT_ptm = @inferred PauliTransferMatrix(CNOT)

pauli_vectors = @inferred QuantumOpticsBase.pauli_basis_vectors(2)
@test pauli_vectors' * pauli_vectors ≈ 4I
@test_throws ArgumentError QuantumOpticsBase.pauli_basis_vectors(0)

@test CNOT_sop.basis_l == CNOT_sop.basis_r == (q2, q2)
@test CNOT_chi.basis_l == CNOT_chi.basis_r == (q2, q2)
@test CNOT_ptm.basis_l == CNOT_ptm.basis_r == (q2, q2)

@test all(isapprox.(imag.(CNOT_sop.data), 0))
@test all(isapprox.(imag.(CNOT_chi.data), 0))
@test all(isapprox.(imag.(CNOT_ptm.data), 0))

@test all(isapprox.(CNOT_sop.data[[1,18,36,51,69,86,104,119,141,158,176,191,201,218,236,251]], 1))
@test all(isapprox.(CNOT_chi.data[[1,2,13,17,18,29,193,194,205,222]], 1))
@test all(isapprox.(CNOT_chi.data[[14,30,206,209,210,221]], -1))
@test all(isapprox.(CNOT_ptm.data[[1,18,47,64,70,85,108,138,153,183,205,222,227,244,]], 1))
@test all(isapprox.(CNOT_ptm.data[[123,168]], -1))

# Test DenseChiMatrix constructor.
@test_throws DimensionMismatch DenseChiMatrix((q2, q2), (q3, q3), CNOT_chi.data)
@test DenseChiMatrix((q2, q2), (q2, q2), CNOT_chi.data) == CNOT_chi

# Test equality and conversion among all three bases.
ident = Complex{Float64}[1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1]

IDENT = DenseOperator(q2, ident)

IDENT_sop = SuperOperator(IDENT)
IDENT_chi = ChiMatrix(IDENT)
IDENT_ptm = PauliTransferMatrix(IDENT)

@test ChiMatrix(IDENT_sop) == IDENT_chi
@test ChiMatrix(IDENT_ptm) == IDENT_chi
@test SuperOperator(IDENT_chi) == IDENT_sop
@test SuperOperator(IDENT_ptm) == IDENT_sop
@test PauliTransferMatrix(IDENT_sop) == IDENT_ptm
@test PauliTransferMatrix(IDENT_chi) == IDENT_ptm

# Test approximate equality and conversion among all three bases.
cphase = Complex{Float64}[1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 exp(1im*.6)]

CPHASE = DenseOperator(q2, cphase)

CPHASE_sop = SuperOperator(CPHASE)
CPHASE_chi = ChiMatrix(CPHASE)
CPHASE_ptm = PauliTransferMatrix(CPHASE)

@test isapprox(ChiMatrix(CPHASE_sop), CPHASE_chi)
@test isapprox(ChiMatrix(CPHASE_ptm), CPHASE_chi)
@test isapprox(SuperOperator(CPHASE_chi), CPHASE_sop)
@test isapprox(SuperOperator(CPHASE_ptm), CPHASE_sop)
@test isapprox(PauliTransferMatrix(CPHASE_sop), CPHASE_ptm)
@test isapprox(PauliTransferMatrix(CPHASE_chi), CPHASE_ptm)

# Test composition.
one_qubit_left_data = zeros(ComplexF64, 4, 4)
one_qubit_left_data[2, 2] = 2
one_qubit_right_data = zeros(ComplexF64, 4, 4)
one_qubit_right_data[3, 3] = 2
one_qubit_expected_data = zeros(ComplexF64, 4, 4)
one_qubit_expected_data[4, 4] = 2
one_qubit_left = DenseChiMatrix((b, b), (b, b), one_qubit_left_data)
one_qubit_right = DenseChiMatrix((b, b), (b, b), one_qubit_right_data)
one_qubit_expected = DenseChiMatrix((b, b), (b, b), one_qubit_expected_data)
one_qubit_left_before = copy(one_qubit_left.data)
one_qubit_right_before = copy(one_qubit_right.data)
one_qubit_composition = @inferred(one_qubit_left * one_qubit_right)
@test one_qubit_composition == one_qubit_expected
@test one_qubit_left.data == one_qubit_left_before
@test one_qubit_right.data == one_qubit_right_before

two_qubit_composition = @inferred(CPHASE_chi * CNOT_chi)
@test isapprox(two_qubit_composition, ChiMatrix(CPHASE * CNOT))
@test isapprox(PauliTransferMatrix(CPHASE) * PauliTransferMatrix(CNOT), PauliTransferMatrix(CPHASE * CNOT))

@testset "Three-qubit Chi-matrix composition" begin
    left_pauli = dense(sigmax(b)) ⊗ dense(sigmay(b)) ⊗ dense(sigmaz(b))
    right_pauli = dense(sigmaz(b)) ⊗ dense(identityoperator(b)) ⊗ dense(sigmax(b))
    left_chi = ChiMatrix(left_pauli)
    right_chi = ChiMatrix(right_pauli)
    @test count(x -> !iszero(x), left_chi.data) == 1
    @test count(x -> !iszero(x), right_chi.data) == 1

    composition = left_chi * right_chi
    @test size(composition.data) == (64, 64)
    @test composition.basis_l == left_chi.basis_l
    @test composition.basis_r == left_chi.basis_r
    @test isapprox(composition, ChiMatrix(left_pauli * right_pauli))
end

end # testset
end

# Introduction

The documentation found here is just the lightweight version of the full docs. It lists all types and functions as well as their [API](@ref) included in the **QuantumOpticsBase.jl** module. The full documentation of **QuantumOptics.jl** can be found [here](http://qojulia.org/documentation).

# API


## [Types](@id API: Quantum objects types)

* General basis types. Specialized bases can be found in the section [API: Quantum-systems](@ref).

```@docs
Basis
```

```@docs
GenericBasis
```

```@docs
CompositeBasis
```

* States

```@docs
StateVector
```

```@docs
Bra
```

```@docs
Ket
```

* General purpose operators. A few more specialized operators are implemented in [API: Quantum-systems](@ref).

```@docs
AbstractOperator
```

```@docs
DataOperator
```

```@docs
Operator
```

```@docs
DenseOperator
```

```@docs
SparseOperator
```

```@docs
LazyKet
```

```@docs
LazyTensor
```

```@docs
LazySum
```

```@docs
LazyProduct
```

* Time-dependent operators.

```@docs
AbstractTimeDependentOperator
```

```@docs
TimeDependentSum
```

* Super operators:

```@docs
SuperOperator
```

```@docs
DenseSuperOperator
```

```@docs
SparseSuperOperator
```


### [Functions](@id API: Quantum objects functions)

* Functions to generate general states, operators and super-operators

```@docs
basisstate
```

```@docs
sparsebasisstate
```

```@docs
identityoperator
```

```@docs
diagonaloperator
```

```@docs
randoperator
```

```@docs
randunitary_haar
```

```@docs
spre
```

```@docs
spost
```

```@docs
sprepost
```

```@docs
liouvillian
```

* As far as it makes sense the same functions are implemented for bases, states, operators and superoperators.

```@docs
QuantumOpticsBase.samebases
```

```@docs
QuantumOpticsBase.check_samebases
```

```@docs
@samebases
```

```@docs
QuantumOpticsBase.multiplicable
```

```@docs
QuantumOpticsBase.check_multiplicable
```

```@docs
QuantumOpticsBase.basis
```

```@docs
dagger
```

```@docs
tensor
```

```@docs
projector(a::Ket, b::Bra)
projector(a::Ket)
projector(a::Bra)
```

```@docs
sparseprojector
```

```@docs
dm
```

```@docs
QuantumOpticsBase.norm(x::StateVector)
```

```@docs
tr
```

```@docs
ptrace
```

```@docs
normalize(x::StateVector)
normalize(op::AbstractOperator)
```

```@docs
normalize!(x::StateVector)
normalize!(op::AbstractOperator)
```

```@docs
expect
```

```@docs
variance
```

```@docs
embed
```

```@docs
permutesystems
```

```@docs
exp(op::AbstractOperator)
```

* Conversion of operators

```@docs
dense
```

```@docs
sparse(::AbstractOperator)
```

* Time-dependent operators.

```@docs
current_time
```

```@docs
static_operator
```

```@docs
set_time!
```

```@docs
time_shift
```

```@docs
time_stretch
```

```@docs
time_restrict
```

### [Exceptions](@id API: Quantum objects exceptions)

```@docs
QuantumOpticsBase.IncompatibleBases
```


## [Quantum systems](@id API: Quantum systems)

### [Fock](@id API: Fock)

```@docs
FockBasis
```

```@docs
number(::Type{T}, ::FockBasis) where T
```

```@docs
destroy(::Type{C}, ::FockBasis) where C
```

```@docs
create(::Type{C}, ::FockBasis) where C
```

```@docs
displace
```

```@docs
displace_analytical
```

```@docs
displace_analytical!
```

```@docs
squeeze
```

```@docs
fockstate
```

```@docs
coherentstate
```

```@docs
coherentstate!
```

### [Charge](@id API: Charge)

```@docs
ChargeBasis
```

```@docs
ShiftedChargeBasis
```

```@docs
chargestate
```

```@docs
chargeop
```

```@docs
expiφ
```

```@docs
cosφ
```

```@docs
sinφ
```

### [N-level](@id API: N-level)

```@docs
NLevelBasis
```

```@docs
transition(::Type{T}, ::NLevelBasis, ::Integer, ::Integer) where T
```

```@docs
nlevelstate
```

```@docs
paulix
```

```@docs
pauliy
```

```@docs
pauliz
```


### [Spin](@id API: Spin)

```@docs
SpinBasis
```

```@docs
sigmax
```

```@docs
sigmay
```

```@docs
sigmaz
```

```@docs
sigmap
```

```@docs
sigmam
```

```@docs
spinup
```

```@docs
spindown
```

### [Particle](@id API: Particle)

```@docs
PositionBasis
```

```@docs
MomentumBasis
```

```@docs
spacing
```

```@docs
samplepoints
```

```@docs
position(::Type{T}, b::PositionBasis) where T
position(::Type{T}, b::MomentumBasis) where T
```

```@docs
momentum(::Type{T}, b::PositionBasis) where T
momentum(::Type{T}, b::MomentumBasis) where T
```

```@docs
potentialoperator
```

```@docs
gaussianstate
```

```@docs
QuantumOpticsBase.FFTOperator
```

```@docs
QuantumOpticsBase.FFTOperators
```

```@docs
QuantumOpticsBase.FFTKets
```

```@docs
transform
```

### [Subspace bases](@id API: Subspace bases)

```@docs
SubspaceBasis
```

```@docs
QuantumOpticsBase.orthonormalize
```

```@docs
projector(::Type{T}, b1::SubspaceBasis, b2::SubspaceBasis) where T
```

### [Many-body](@id API: Many-body)

```@docs
ManyBodyBasis
```

```@docs
FermionBitstring
```

```@docs
fermionstates
```

```@docs
bosonstates
```

```@docs
number(::Type{T}, ::ManyBodyBasis, index) where T
number(::Type{T}, ::ManyBodyBasis) where T
```

```@docs
destroy(::Type{T}, ::ManyBodyBasis, index) where T
```

```@docs
create(::Type{T}, ::ManyBodyBasis, index) where T
```

```@docs
transition(::Type{T}, ::ManyBodyBasis, i, j) where T
```

```@docs
manybodyoperator
```

```@docs
onebodyexpect
```

## [Direct sum](@id API: Direct-sum)

```@docs
SumBasis
```

```@docs
directsum
```

```@docs
LazyDirectSum
```

```@docs
getblock
```

```@docs
setblock!
```

## [Metrics](@id API: Metrics)

```@docs
tracenorm
```

```@docs
tracenorm_h
```

```@docs
tracenorm_nh
```

```@docs
tracedistance
```

```@docs
tracedistance_h
```

```@docs
tracedistance_nh
```

```@docs
entropy_vn
```

```@docs
entropy_renyi
```

```@docs
fidelity
```

```@docs
ptranspose
```

```@docs
PPT
```

```@docs
negativity
```

```@docs
logarithmic_negativity
```

```@docs
entanglement_entropy
```

```@docs
avg_gate_fidelity
```

## [State definitions](@id API: State definitions)

```@docs
randstate
```

```@docs
randstate_haar
```

```@docs
thermalstate
```

```@docs
coherentthermalstate
```

```@docs
phase_average
```

```@docs
passive_state
```

## [Pauli](@id API: Pauli)

```@docs
PauliTransferMatrix
```

```@docs
DensePauliTransferMatrix
```

```@docs
ChiMatrix
```

```@docs
DenseChiMatrix
```

## [Visualization](@id API: Visualization)

```@docs
blochsphereplot
blochsphereplot!
blochsphereplot_axis
```

## [Printing](@id API: Printing)

```@docs
QuantumOpticsBase.set_printing
```

## [LazyTensor functions](@id API: LazyTensor functions)

```@docs
lazytensor_enable_cache
```

```@docs
lazytensor_disable_cache
```

```@docs
lazytensor_cachesize
```

```@docs
lazytensor_clear_cache
```

# QuantumOpticsBase.jl

QuantumOpticsBase.jl provides the base functionality for QuantumOptics.jl. It implements fundamental types such as different bases, states and operators defined on these bases, and core operations (such as multiplication) on these states/operators.

## Project Structure

- `src/` - Main source code
  - `QuantumOpticsBase.jl` - Main module file
  - `bases.jl` - Different quantum bases (Fock, Spin, NLevel, etc.)
  - `states.jl` - Quantum state implementations
  - `operators*.jl` - Various operator implementations (dense, sparse, lazy)
  - `metrics.jl` - Distance metrics and measurements
  - `phasespace.jl` - Phase space functions
  - `transformations.jl` - Basis transformations
- `test/` - Comprehensive test suite
- `docs/` - Documentation source files

## Development Commands

### Running Tests
```bash
# Run all tests
julia --project=. -e "using Pkg; Pkg.test()"

# Run with only specific GPU backend tests
CUDA_TEST=true julia --project=. -e "using Pkg; Pkg.test()"
AMDGPU_TEST=true julia --project=. -e "using Pkg; Pkg.test()"
OpenCL_TEST=true julia --project=. -e "using Pkg; Pkg.test()"
```

### Building Documentation
```bash
# Install documentation dependencies
julia --project=docs -e "using Pkg; Pkg.develop(PackageSpec(path=pwd())); Pkg.instantiate()"

# Build documentation
julia --project=docs docs/make.jl
```

### Package Management
```bash
# Instantiate project dependencies
julia --project=. -e "using Pkg; Pkg.instantiate()"

# Update dependencies
julia --project=. -e "using Pkg; Pkg.update()"

# Check package status
julia --project=. -e "using Pkg; Pkg.status()"
```

## Testing Information

The test suite uses TestItemRunner and includes:

- Unit tests for all quantum bases (Fock, Spin, NLevel, Charge, Particle)
- Operator tests (dense, sparse, lazy implementations)
- State manipulation and transformation tests
- Metrics and measurement tests
- Integration tests with other quantum packages
- Code quality tests (Aqua.jl, JET.jl, doctests)

Special test configurations:
- JET tests run when `JET_TEST=true` environment variable is set
- Aqua and doctest checks require Julia 1.10+

## Key Dependencies

- `QuantumInterface.jl` - Provides common quantum computing interfaces
- `LinearAlgebra` - Core linear algebra operations
- `SparseArrays` - Sparse matrix implementations
- `FFTW` - Fast Fourier transforms for phase space calculations
- `FastExpm` - Efficient matrix exponentials

## Development Notes

- Minimum Julia version: 1.10
- Uses semantic versioning
- Extensive test coverage with multiple CI platforms
- Documentation auto-deploys on releases
- Compatible with GPU acceleration through Adapt.jl (converting main memory arrays to GPU arrays)

## Related Packages

- `QuantumOptics.jl` - Main package that builds on this base
- `QuantumInterface.jl` - Common interfaces
- See the @qojulia organization for the full ecosystem

## Code Formatting

### Removing Trailing Whitespaces
Before committing, ensure there are no trailing whitespaces in Julia files. Do not format files that are not part of the specific feature under development.

```bash
# Remove trailing whitespaces from all .jl files (requires gnu tools)
find . -type f -name '*.jl' -exec sed --in-place 's/[[:space:]]\+$//' {} \+
```

### Ensuring Files End with Newlines
Ensure all Julia files end with a newline to avoid misbehaving CLI tools. Do not format files that are not part of the specific feature under development.

```bash
# Add newline to end of all .jl files that don't have one
find . -type f -name '*.jl' -exec sed -i '$a\' {} \+
```

### General Formatting Guidelines
- Use 4 spaces for indentation (no tabs)
- Remove trailing whitespaces from all lines
- Ensure files end with a single newline
- Follow Julia standard naming conventions
- Keep lines under 100 characters when reasonable

## Contributing

This package follows standard Julia development practices:
- **Always pull latest changes first**: Before creating any new feature or starting work, ensure you have the latest version by running `git pull origin master` (or `git pull origin main`)
- **Pull before continuing work**: Other maintainers might have modified the branch you are working on. Always call `git pull` before continuing work on an existing branch
- **Push changes to remote**: Always push your local changes to the remote branch to keep the PR up to date: `git push origin <branch-name>`
- **Run all tests before submitting**: Before creating or updating a PR, always run the full test suite to ensure nothing is broken: `julia --project=. -e "using Pkg; Pkg.test()"`
- Fork and create feature branches
- Write tests for new functionality
- Ensure documentation builds successfully
- Follow code formatting guidelines above
- All tests must pass before merging
- **Keep PRs focused**: A PR should implement one self-contained change. Avoid mixing feature work with formatting changes to unrelated files, even for improvements like adding missing newlines. Format unrelated files in separate commits or PRs.
